
DROP TABLE IF EXISTS `#__assets`;
CREATE TABLE `#__assets` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `parent_id` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set parent.',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `level` int(10) unsigned NOT NULL COMMENT 'The cached level in the nested tree.',
  `name` varchar(50) NOT NULL COMMENT 'The unique name for the asset.\n',
  `title` varchar(100) NOT NULL COMMENT 'The descriptive title for the asset.',
  `rules` varchar(5120) NOT NULL COMMENT 'JSON encoded access control.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_asset_name` (`name`),
  KEY `idx_lft_rgt` (`lft`,`rgt`),
  KEY `idx_parent_id` (`parent_id`)
) ENGINE=MyISAM ;

INSERT INTO `#__assets` (`id`, `parent_id`, `lft`, `rgt`, `level`, `name`, `title`, `rules`) VALUES
(1, 0, 1, 532, 0, 'root.1', 'Root Asset', '{"core.login.site":{"6":1,"2":1},"core.login.admin":{"6":1},"core.login.offline":[],"core.admin":{"8":1},"core.manage":{"7":1},"core.create":{"6":1,"3":1},"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"core.edit.own":{"6":1,"3":1}}'),
(2, 1, 2, 3, 1, 'com_admin', 'com_admin', '{}'),
(3, 1, 4, 11, 1, 'com_banners', 'com_banners', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(4, 1, 12, 13, 1, 'com_cache', 'com_cache', '{"core.admin":{"7":1},"core.manage":{"7":1}}'),
(5, 1, 14, 15, 1, 'com_checkin', 'com_checkin', '{"core.admin":{"7":1},"core.manage":{"7":1}}'),
(6, 1, 16, 17, 1, 'com_config', 'com_config', '{}'),
(7, 1, 18, 87, 1, 'com_contact', 'com_contact', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(8, 1, 88, 407, 1, 'com_content', 'com_content', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":{"3":1},"core.delete":[],"core.edit":{"4":1},"core.edit.state":{"5":1},"core.edit.own":[]}'),
(9, 1, 408, 409, 1, 'com_cpanel', 'com_cpanel', '{}'),
(10, 1, 410, 411, 1, 'com_installer', 'com_installer', '{"core.admin":{"7":1},"core.manage":{"7":1},"core.create":[],"core.delete":[],"core.edit.state":[]}'),
(11, 1, 412, 413, 1, 'com_languages', 'com_languages', '{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(12, 1, 414, 415, 1, 'com_login', 'com_login', '{}'),
(13, 1, 416, 417, 1, 'com_mailto', 'com_mailto', '{}'),
(14, 1, 418, 419, 1, 'com_massmail', 'com_massmail', '{}'),
(15, 1, 420, 421, 1, 'com_media', 'com_media', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":{"3":1},"core.delete":{"5":1},"core.edit":[],"core.edit.state":[]}'),
(16, 1, 422, 423, 1, 'com_menus', 'com_menus', '{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(17, 1, 37, 38, 1, 'com_messages', 'com_messages', '{"core.admin":{"7":1},"core.manage":{"7":1}}'),
(18, 1, 426, 427, 1, 'com_modules', 'com_modules', '{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(19, 1, 428, 435, 1, 'com_newsfeeds', 'com_newsfeeds', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(20, 1, 436, 437, 1, 'com_plugins', 'com_plugins', '{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(21, 1, 438, 439, 1, 'com_redirect', 'com_redirect', '{"core.admin":{"7":1},"core.manage":[]}'),
(22, 1, 440, 441, 1, 'com_search', 'com_search', '{"core.admin":{"7":1},"core.manage":{"6":1}}'),
(23, 1, 442, 443, 1, 'com_templates', 'com_templates', '{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(24, 1, 444, 445, 1, 'com_users', 'com_users', '{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.own":{"6":1},"core.edit.state":[]}'),
(25, 1, 446, 463, 1, 'com_weblinks', 'com_weblinks', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":{"3":1,"10":0,"12":0},"core.delete":[],"core.edit":{"4":1},"core.edit.state":{"5":1}}'),
(26, 1, 464, 465, 1, 'com_wrapper', 'com_wrapper', '{}'),
(39, 8, 111, 296, 2, 'com_content.category.14', 'Sample Data-Articles', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(38, 25, 453, 454, 2, 'com_weblinks.category.13', 'Uncategorised', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(37, 19, 431, 432, 2, 'com_newsfeeds.category.12', 'Uncategorised', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(36, 7, 23, 24, 2, 'com_contact.category.11', 'Uncategorised', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(35, 3, 7, 8, 2, 'com_banners.category.10', 'Uncategorised', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(34, 8, 105, 110, 2, 'com_content.category.9', 'Uncategorised', '{"core.create":{"10":0,"12":0},"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(40, 3, 9, 10, 2, 'com_banners.category.15', 'Sample Data-Banners', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(41, 7, 25, 86, 2, 'com_contact.category.16', 'Sample Data-Contact', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(42, 19, 433, 434, 2, 'com_newsfeeds.category.17', 'Sample Data-Newsfeeds', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(43, 25, 455, 462, 2, 'com_weblinks.category.18', 'Sample Data-Weblinks', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(44, 39, 112, 245, 3, 'com_content.category.19', 'Joomla!', '{"core.create":{"10":0,"12":0},"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(45, 44, 113, 220, 4, 'com_content.category.20', 'Extensions', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(46, 45, 114, 129, 5, 'com_content.category.21', 'Components', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(47, 45, 130, 189, 5, 'com_content.category.22', 'Modules', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(48, 45, 190, 201, 5, 'com_content.category.23', 'Templates', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(49, 45, 202, 203, 5, 'com_content.category.24', 'Languages', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(50, 45, 204, 219, 5, 'com_content.category.25', 'Plugins', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(51, 39, 246, 277, 3, 'com_content.category.26', 'Park Site', '{"core.create":{"10":0,"12":0},"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(52, 51, 247, 252, 4, 'com_content.category.27', 'Park Blog', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(53, 51, 253, 274, 4, 'com_content.category.28', 'Photo Gallery', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(54, 39, 278, 291, 3, 'com_content.category.29', 'Fruit Shop Site', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(55, 54, 279, 284, 4, 'com_content.category.30', 'Growers', '{"core.create":{"12":0},"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":{"10":1}}'),
(56, 43, 456, 457, 3, 'com_weblinks.category.31', 'Park Links', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(57, 43, 458, 461, 3, 'com_weblinks.category.32', 'Joomla! Specific Links', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(58, 57, 459, 460, 4, 'com_weblinks.category.33', 'Other Resources', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(59, 41, 26, 27, 3, 'com_contact.category.34', 'Park Site', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(60, 41, 28, 85, 3, 'com_contact.category.35', 'Shop Site', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(61, 60, 29, 30, 4, 'com_contact.category.36', 'Staff', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(62, 60, 31, 84, 4, 'com_contact.category.37', 'Fruit Encyclopedia', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(63, 62, 32, 33, 5, 'com_contact.category.38', 'A', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(64, 62, 34, 35, 5, 'com_contact.category.39', 'B', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(65, 62, 36, 37, 5, 'com_contact.category.40', 'C', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(66, 62, 38, 39, 5, 'com_contact.category.41', 'D', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(67, 62, 40, 41, 5, 'com_contact.category.42', 'E', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(68, 62, 42, 43, 5, 'com_contact.category.43', 'F', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(69, 62, 44, 45, 5, 'com_contact.category.44', 'G', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(70, 62, 46, 47, 5, 'com_contact.category.45', 'H', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(71, 62, 48, 49, 5, 'com_contact.category.46', 'I', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(72, 62, 50, 51, 5, 'com_contact.category.47', 'J', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(73, 62, 52, 53, 5, 'com_contact.category.48', 'K', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(74, 62, 54, 55, 5, 'com_contact.category.49', 'L', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(75, 62, 56, 57, 5, 'com_contact.category.50', 'M', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(76, 62, 58, 59, 5, 'com_contact.category.51', 'N', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(77, 62, 60, 61, 5, 'com_contact.category.52', 'O', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(78, 62, 62, 63, 5, 'com_contact.category.53', 'P', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(79, 62, 64, 65, 5, 'com_contact.category.54', 'Q', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(80, 62, 66, 67, 5, 'com_contact.category.55', 'R', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(81, 62, 68, 69, 5, 'com_contact.category.56', 'S', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(82, 62, 70, 71, 5, 'com_contact.category.57', 'T', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(83, 62, 72, 73, 5, 'com_contact.category.58', 'U', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(84, 62, 74, 75, 5, 'com_contact.category.59', 'V', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(85, 62, 76, 77, 5, 'com_contact.category.60', 'W', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(86, 62, 78, 79, 5, 'com_contact.category.61', 'X', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(87, 62, 80, 81, 5, 'com_contact.category.62', 'Y', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(88, 62, 82, 83, 5, 'com_contact.category.63', 'Z', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(89, 46, 115, 116, 6, 'com_content.article.1', 'Administrator Components', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(90, 93, 132, 133, 7, 'com_content.article.2', 'Archive Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(91, 93, 134, 135, 7, 'com_content.article.3', 'Article Categories Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(92, 93, 136, 137, 7, 'com_content.article.4', 'Articles Category Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(93, 47, 131, 146, 6, 'com_content.category.64', 'Content Modules', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(94, 47, 147, 154, 6, 'com_content.category.65', 'User Modules', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(95, 47, 155, 168, 6, 'com_content.category.66', 'Display Modules', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(96, 47, 169, 180, 6, 'com_content.category.67', 'Utility Modules', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(97, 48, 191, 192, 6, 'com_content.category.68', 'Atomic', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(98, 48, 193, 194, 6, 'com_content.category.69', 'Beez 20', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(99, 48, 195, 196, 6, 'com_content.category.70', 'Beez5', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(100, 48, 197, 198, 6, 'com_content.category.71', 'Milky Way', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(101, 50, 205, 206, 6, 'com_content.article.5', 'Authentication', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(102, 51, 275, 276, 4, 'com_content.article.6', 'Australian Parks ', '{"core.delete":[],"core.edit":{"2":1},"core.edit.state":[]}'),
(103, 95, 156, 157, 7, 'com_content.article.7', 'Banner Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(104, 44, 221, 222, 4, 'com_content.article.8', 'Beginners', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(105, 46, 117, 118, 6, 'com_content.article.9', 'Contact', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(106, 46, 119, 120, 6, 'com_content.article.10', 'Content', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(107, 109, 265, 266, 6, 'com_content.article.11', 'Cradle Mountain', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(108, 53, 254, 263, 5, 'com_content.category.72', 'Animals', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(109, 53, 264, 273, 5, 'com_content.category.73', 'Scenery', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(110, 95, 158, 159, 7, 'com_content.article.12', 'Custom HTML Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(111, 54, 285, 286, 4, 'com_content.article.13', 'Directions', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(112, 50, 207, 208, 6, 'com_content.article.14', 'Editors', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(113, 50, 209, 210, 6, 'com_content.article.15', 'Editors-xtd', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(114, 95, 160, 161, 7, 'com_content.article.16', 'Feed Display', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(115, 52, 248, 249, 5, 'com_content.article.17', 'First Blog Post', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(116, 52, 250, 251, 5, 'com_content.article.18', 'Second Blog Post', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(117, 95, 162, 163, 7, 'com_content.article.19', 'Footer Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(118, 54, 287, 288, 4, 'com_content.article.20', 'Fruit Shop', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(119, 44, 223, 224, 4, 'com_content.article.21', 'Getting Help', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(120, 44, 225, 226, 4, 'com_content.article.22', 'Getting Started', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(121, 55, 280, 281, 5, 'com_content.article.23', 'Happy Orange Orchard', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(122, 44, 227, 228, 4, 'com_content.article.24', 'Joomla!', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(123, 108, 255, 256, 6, 'com_content.article.25', 'Koala', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(124, 96, 170, 171, 7, 'com_content.article.26', 'Language Switcher', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(125, 93, 138, 139, 7, 'com_content.article.27', 'Latest Articles Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(126, 94, 148, 149, 7, 'com_content.article.28', 'Login Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(127, 166, 184, 185, 7, 'com_content.article.29', 'Menu Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(128, 93, 140, 141, 7, 'com_content.article.30', 'Most Read Content', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(129, 93, 142, 143, 7, 'com_content.article.31', 'News Flash', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(130, 44, 229, 230, 4, 'com_content.article.32', 'Parameters', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(131, 108, 257, 258, 6, 'com_content.article.33', 'Phyllopteryx', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(132, 109, 267, 268, 6, 'com_content.article.34', 'Pinnacles', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(133, 44, 231, 232, 4, 'com_content.article.35', 'Professionals', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(134, 95, 164, 165, 7, 'com_content.article.36', 'Random Image Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(135, 93, 144, 145, 7, 'com_content.article.37', 'Related Items Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(136, 44, 233, 234, 4, 'com_content.article.38', 'Sample Sites', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(137, 46, 121, 122, 6, 'com_content.article.39', 'Search', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(138, 96, 172, 173, 7, 'com_content.article.40', 'Search Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(139, 50, 211, 212, 6, 'com_content.article.41', 'Search ', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(140, 39, 292, 293, 3, 'com_content.article.42', 'Site Map', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(141, 108, 259, 260, 6, 'com_content.article.43', 'Spotted Quoll', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(142, 96, 174, 175, 7, 'com_content.article.44', 'Statistics Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(143, 96, 176, 177, 7, 'com_content.article.45', 'Syndicate Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(144, 50, 213, 214, 6, 'com_content.article.46', 'System', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(145, 44, 235, 236, 4, 'com_content.article.47', 'The Joomla! Community', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(146, 44, 237, 238, 4, 'com_content.article.48', 'The Joomla! Project', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(147, 48, 199, 200, 6, 'com_content.article.49', 'Typography', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(148, 44, 239, 240, 4, 'com_content.article.50', 'Upgraders', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(149, 50, 215, 216, 6, 'com_content.article.51', 'User', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(150, 46, 123, 124, 6, 'com_content.article.52', 'Users', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(151, 44, 241, 242, 4, 'com_content.article.53', 'Using Joomla!', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(152, 46, 125, 126, 6, 'com_content.article.54', 'Weblinks', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(153, 95, 166, 167, 7, 'com_content.article.55', 'Weblinks Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(154, 94, 150, 151, 7, 'com_content.article.56', 'Who''s Online', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(155, 108, 261, 262, 6, 'com_content.article.57', 'Wobbegone', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(156, 55, 282, 283, 5, 'com_content.article.58', 'Wonderful Watermelon', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(157, 96, 178, 179, 7, 'com_content.article.59', 'Wrapper Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(158, 46, 127, 128, 6, 'com_content.article.60', 'News Feeds', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(159, 166, 186, 187, 7, 'com_content.article.61', 'Breadcrumbs Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(160, 50, 217, 218, 6, 'com_content.article.62', 'Content', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(162, 109, 269, 270, 6, 'com_content.article.64', 'Blue Mountain Rain Forest', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(163, 109, 271, 272, 6, 'com_content.article.65', 'Ormiston Pound', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(165, 94, 152, 153, 7, 'com_content.article.66', 'Latest Users Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(166, 47, 183, 188, 6, 'com_content.category.75', 'Navigation Modules', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(167, 54, 289, 290, 4, 'com_content.category.76', 'Recipes', '{"core.create":{"12":1,"10":1},"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":{"12":1,"10":1}}'),
(168, 34, 106, 107, 3, 'com_content.article.67', 'What''s New in 1.5?', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(169, 1, 528, 529, 1, 'com_jaextmanager', 'jaextmanager', '{}'),
(170, 8, 297, 406, 2, 'com_content.category.77', 'Demo section', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(171, 170, 298, 307, 3, 'com_content.category.78', 'Demo category', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(172, 170, 308, 317, 3, 'com_content.category.79', 'SlideShow', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(173, 170, 318, 335, 3, 'com_content.category.80', 'Blog category', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(174, 170, 336, 337, 3, 'com_content.category.81', 'Testimonials', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(175, 170, 352, 359, 3, 'com_content.category.82', 'Movie news', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(176, 170, 338, 351, 3, 'com_content.category.83', 'Slidenews', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(177, 171, 299, 300, 4, 'com_content.article.68', 'Avatar', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(178, 34, 108, 109, 3, 'com_content.article.69', 'Who we are ?', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(179, 171, 301, 302, 4, 'com_content.article.70', 'Clash of Titans coz'' J! 2.5 template ', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(180, 171, 303, 304, 4, 'com_content.article.71', 'Iron Man says Joomla 2.5 is No 1', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(181, 171, 305, 306, 4, 'com_content.article.72', '3D Film Template 2.5 ', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(182, 172, 309, 310, 4, 'com_content.article.73', 'Solutions and Ideas', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(183, 172, 311, 312, 4, 'com_content.article.74', 'Overview', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(184, 172, 313, 314, 4, 'com_content.article.75', 'Work with Us', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(185, 172, 315, 316, 4, 'com_content.article.76', 'Contact', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(186, 173, 319, 320, 4, 'com_content.article.77', 'Convallis Maecenas Nam quis Sed venenatis', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(187, 173, 321, 322, 4, 'com_content.article.78', 'Aliquam Curabitur molestie dolor', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(188, 173, 323, 324, 4, 'com_content.article.79', 'Scelerisque et leo', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(189, 173, 325, 326, 4, 'com_content.article.80', 'Elit nulla nibh id', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(190, 173, 327, 328, 4, 'com_content.article.81', 'Tincidunt et dui In condimentum', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(191, 173, 329, 330, 4, 'com_content.article.82', 'Libero purus tortor vel Mauris et nec Pellentesque', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(192, 173, 331, 332, 4, 'com_content.article.83', 'Eget elit lacinia nunc consequat ullamcorper', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(193, 173, 333, 334, 4, 'com_content.article.84', 'Metus habitasse sed interdum Nulla', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(194, 175, 357, 358, 4, 'com_content.article.85', 'Robin Hood', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(195, 175, 355, 356, 4, 'com_content.article.86', 'Restrepo', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(196, 175, 353, 354, 4, 'com_content.article.87', 'MacGruber', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(197, 176, 339, 340, 4, 'com_content.article.88', 'Cop Out', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(198, 176, 341, 342, 4, 'com_content.article.89', 'Shutter Island', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(199, 176, 343, 344, 4, 'com_content.article.90', 'The Lightning Thief', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(200, 176, 345, 346, 4, 'com_content.article.91', 'Winter''s Bone', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(201, 176, 347, 348, 4, 'com_content.article.92', 'Nowhere Boy', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(202, 176, 349, 350, 4, 'com_content.article.93', 'Jonah Hex', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(203, 170, 360, 361, 3, 'com_content.article.94', 'JA Anion''s Typography', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(204, 44, 243, 244, 4, 'com_content.article.95', 'Content Layouts', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(206, 170, 362, 405, 3, 'com_content.category.84', 'All Categories', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(207, 206, 363, 376, 4, 'com_content.category.85', 'Actions', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(208, 206, 377, 390, 4, 'com_content.category.86', 'Romance', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(209, 206, 391, 404, 4, 'com_content.category.87', 'Family', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(210, 207, 364, 365, 5, 'com_content.article.96', 'Inception', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(211, 207, 366, 367, 5, 'com_content.article.97', 'MacGruber ', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(212, 207, 368, 369, 5, 'com_content.article.98', 'From Paris With Love', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(213, 207, 370, 371, 5, 'com_content.article.99', 'District 13: Ultimatum', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(214, 207, 372, 373, 5, 'com_content.article.100', 'Avatar', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(215, 207, 374, 375, 5, 'com_content.article.101', 'The A-Team', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(216, 208, 378, 379, 5, 'com_content.article.102', 'Spring Fever ', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(217, 208, 380, 381, 5, 'com_content.article.103', 'Charlie St. Cloud', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(218, 208, 382, 383, 5, 'com_content.article.104', 'Just Wright', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(219, 208, 384, 385, 5, 'com_content.article.105', 'Letters To Juliet', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(220, 208, 386, 387, 5, 'com_content.article.106', 'Kites', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(221, 208, 388, 389, 5, 'com_content.article.107', 'Leap Year', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(222, 209, 392, 393, 5, 'com_content.article.108', 'Our Family Wedding', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(223, 209, 394, 395, 5, 'com_content.article.109', 'Family Guy: Some...', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(224, 209, 396, 397, 5, 'com_content.article.110', 'The Family That Preys', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(225, 209, 398, 399, 5, 'com_content.article.111', 'Family Law', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(226, 209, 400, 401, 5, 'com_content.article.112', 'Rolling Family', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(227, 209, 402, 403, 5, 'com_content.article.113', 'Madea’s Family...', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}');

DROP TABLE IF EXISTS `#__associations`;
CREATE TABLE `#__associations` (
  `id` varchar(50) NOT NULL COMMENT 'A reference to the associated item.',
  `context` varchar(50) NOT NULL COMMENT 'The context of the associated item.',
  `key` char(32) NOT NULL COMMENT 'The key for the association computed from an md5 on associated ids.',
  PRIMARY KEY (`context`,`id`),
  KEY `idx_key` (`key`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__banner_clients`;
CREATE TABLE `#__banner_clients` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `contact` varchar(255) NOT NULL DEFAULT '',
  `email` varchar(255) NOT NULL DEFAULT '',
  `extrainfo` text NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `metakey` text NOT NULL,
  `own_prefix` tinyint(4) NOT NULL DEFAULT '0',
  `metakey_prefix` varchar(255) NOT NULL DEFAULT '',
  `purchase_type` tinyint(4) NOT NULL DEFAULT '-1',
  `track_clicks` tinyint(4) NOT NULL DEFAULT '-1',
  `track_impressions` tinyint(4) NOT NULL DEFAULT '-1',
  PRIMARY KEY (`id`),
  KEY `idx_own_prefix` (`own_prefix`),
  KEY `idx_metakey_prefix` (`metakey_prefix`)
) ENGINE=MyISAM ;

INSERT INTO `#__banner_clients` (`id`, `name`, `contact`, `email`, `extrainfo`, `state`, `checked_out`, `checked_out_time`, `metakey`, `own_prefix`, `metakey_prefix`, `purchase_type`, `track_clicks`, `track_impressions`) VALUES
(1, 'Joomla!', 'Administrator', 'email@email.com', '', 1, 0, '0000-00-00 00:00:00', '', 0, '', -1, -1, -1);

DROP TABLE IF EXISTS `#__banner_tracks`;
CREATE TABLE `#__banner_tracks` (
  `track_date` datetime NOT NULL,
  `track_type` int(10) unsigned NOT NULL,
  `banner_id` int(10) unsigned NOT NULL,
  `count` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`track_date`,`track_type`,`banner_id`),
  KEY `idx_track_date` (`track_date`),
  KEY `idx_track_type` (`track_type`),
  KEY `idx_banner_id` (`banner_id`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__banners`;
CREATE TABLE `#__banners` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `cid` int(11) NOT NULL DEFAULT '0',
  `type` int(11) NOT NULL DEFAULT '0',
  `name` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) binary NOT NULL DEFAULT '',
  `imptotal` int(11) NOT NULL DEFAULT '0',
  `impmade` int(11) NOT NULL DEFAULT '0',
  `clicks` int(11) NOT NULL DEFAULT '0',
  `clickurl` varchar(200) NOT NULL DEFAULT '',
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `description` text NOT NULL,
  `custombannercode` varchar(2048) NOT NULL,
  `sticky` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `params` text NOT NULL,
  `own_prefix` tinyint(1) NOT NULL DEFAULT '0',
  `metakey_prefix` varchar(255) NOT NULL DEFAULT '',
  `purchase_type` tinyint(4) NOT NULL DEFAULT '-1',
  `track_clicks` tinyint(4) NOT NULL DEFAULT '-1',
  `track_impressions` tinyint(4) NOT NULL DEFAULT '-1',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `reset` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `language` char(7) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `idx_state` (`state`),
  KEY `idx_own_prefix` (`own_prefix`),
  KEY `idx_metakey_prefix` (`metakey_prefix`),
  KEY `idx_banner_catid` (`catid`),
  KEY `idx_language` (`language`)
) ENGINE=MyISAM ;

INSERT INTO `#__banners` (`id`, `cid`, `type`, `name`, `alias`, `imptotal`, `impmade`, `clicks`, `clickurl`, `state`, `catid`, `description`, `custombannercode`, `sticky`, `ordering`, `metakey`, `params`, `own_prefix`, `metakey_prefix`, `purchase_type`, `track_clicks`, `track_impressions`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `reset`, `created`, `language`) VALUES
(2, 1, 0, 'Shop 1', 'shop-1', 0, 16, 0, 'http://shop.joomla.org/amazoncom-bookstores.html', 1, 15, 'Get books about Joomla! at the Joomla! book shop.', '', 0, 1, '', '{"imageurl":"images\\/banners\\/shop-ad-books.jpg","width":"","height":"","alt":"Joomla! Books"}', 0, '', -1, 0, 0, 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '2010-01-12 00:25:24', 'en-GB'),
(3, 1, 0, 'Shop 2', 'shop-2', 0, 22, 0, 'http://shop.joomla.org', 1, 15, 'T Shirts, caps and more from the Joomla! Shop.', '', 0, 2, '', '{"imageurl":"images\\/banners\\/shop-ad.jpg","width":"","height":"","alt":"Joomla! Shop"}', 0, '', -1, 0, 0, 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '2010-01-12 00:35:30', 'en-GB'),
(4, 1, 0, 'Support Joomla!', 'support-joomla', 0, 19, 0, 'http://contribute.joomla.org', 1, 15, 'Your contributions of time, talent and money make Joomla! possible.', '', 0, 3, '', '{"imageurl":"images\\/banners\\/white.png","width":"","height":"","alt":""}', 0, '', -1, 0, 0, 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '2010-01-12 00:55:54', 'en-GB');

DROP TABLE IF EXISTS `#__categories`;
CREATE TABLE `#__categories` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to the #__assets table.',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0',
  `lft` int(11) NOT NULL DEFAULT '0',
  `rgt` int(11) NOT NULL DEFAULT '0',
  `level` int(10) unsigned NOT NULL DEFAULT '0',
  `path` varchar(255) NOT NULL DEFAULT '',
  `extension` varchar(50) NOT NULL DEFAULT '',
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) binary NOT NULL DEFAULT '',
  `note` varchar(255) NOT NULL DEFAULT '',
  `description` mediumtext,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `access` int(10) unsigned DEFAULT NULL,
  `params` text,
  `metadesc` varchar(1024) NOT NULL COMMENT 'The meta description for the page.',
  `metakey` varchar(1024) NOT NULL COMMENT 'The meta keywords for the page.',
  `metadata` varchar(2048) NOT NULL COMMENT 'JSON encoded metadata properties.',
  `created_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `created_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `modified_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `cat_idx` (`extension`,`published`,`access`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_path` (`path`),
  KEY `idx_left_right` (`lft`,`rgt`),
  KEY `idx_alias` (`alias`),
  KEY `idx_language` (`language`)
) ENGINE=MyISAM ;

INSERT INTO `#__categories` (`id`, `asset_id`, `parent_id`, `lft`, `rgt`, `level`, `path`, `extension`, `title`, `alias`, `note`, `description`, `published`, `checked_out`, `checked_out_time`, `access`, `params`, `metadesc`, `metakey`, `metadata`, `created_user_id`, `created_time`, `modified_user_id`, `modified_time`, `hits`, `language`) VALUES
(1, 0, 0, 0, 157, 0, '', 'system', 'ROOT', 'root', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{}', '', '', '', 0, '2009-10-18 16:07:09', 0, '0000-00-00 00:00:00', 0, '*'),
(9, 34, 1, 133, 134, 1, 'uncategorised', 'com_content', 'Uncategorised', 'uncategorised', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 13:52:03', 42, '2010-07-12 16:09:07', 0, '*'),
(10, 35, 1, 131, 132, 1, 'uncategorised', 'com_banners', 'Uncategorised', 'uncategorised', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":"","foobar":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 13:52:16', 0, '0000-00-00 00:00:00', 0, '*'),
(11, 36, 1, 127, 128, 1, 'uncategorised', 'com_contact', 'Uncategorised', 'uncategorised', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 13:53:00', 0, '0000-00-00 00:00:00', 0, '*'),
(12, 37, 1, 63, 64, 1, 'uncategorised', 'com_newsfeeds', 'Uncategorised', 'uncategorised', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 13:53:28', 0, '0000-00-00 00:00:00', 0, '*'),
(13, 38, 1, 59, 60, 1, 'uncategorised', 'com_weblinks', 'Uncategorised', 'uncategorised', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 13:53:59', 0, '0000-00-00 00:00:00', 0, '*'),
(14, 39, 1, 9, 58, 1, 'sample-data-articles', 'com_content', 'Sample Data-Articles', 'sample-data-articles', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 14:21:35', 0, '0000-00-00 00:00:00', 0, '*'),
(15, 40, 1, 129, 130, 1, 'sample-data-banners', 'com_banners', 'Sample Data-Banners', 'sample-data-banners', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":"","foobar":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 14:22:27', 0, '0000-00-00 00:00:00', 0, '*'),
(16, 41, 1, 65, 126, 1, 'sample-data-contact', 'com_contact', 'Sample Data-Contact', 'sample-data-contact', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 14:23:15', 0, '0000-00-00 00:00:00', 0, '*'),
(17, 42, 1, 61, 62, 1, 'sample-data-newsfeeds', 'com_newsfeeds', 'Sample Data-Newsfeeds', 'sample-data-newsfeeds', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 14:24:14', 0, '0000-00-00 00:00:00', 0, '*'),
(18, 43, 1, 1, 8, 1, 'sample-data-weblinks', 'com_weblinks', 'Sample Data-Weblinks', 'sample-data-weblinks', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 14:26:42', 0, '0000-00-00 00:00:00', 0, '*'),
(19, 44, 14, 10, 41, 2, 'sample-data-articles/joomla', 'com_content', 'Joomla!', 'joomla', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 15:19:05', 42, '2010-07-12 18:08:51', 0, '*'),
(20, 45, 19, 11, 40, 3, 'sample-data-articles/joomla/extensions', 'com_content', 'Extensions', 'extensions', '', '<p>The Joomla! content management system lets you create webpages of various types using extensions. There are 5 basic types of extensions: components, modules, templates, languages, and plugins. Your website includes the extensions you need to create a basic website in English, but thousands of additional extensions of all types are available. The <a href="http://extensions.joomla.org" style="color: #1b57b1; text-decoration: none; font-weight: normal;">Joomla! Extensions Directory</a> is the largest directory of Joomla! extensions.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 15:19:42', 42, '2010-07-11 12:21:46', 0, '*'),
(21, 46, 20, 12, 13, 4, 'sample-data-articles/joomla/extensions/components', 'com_content', 'Components', 'components', '', '<p><img src="administrator/templates/bluestork/images/header/icon-48-component.png" class="image-left" alt="Component Image" ="==" /"="/"" ="" />Components are larger extensions that produce the major content for your site. Each component has one or more "views" that control how content is displayed.In the Joomla! administrator there are additional extensions suce as Menus, Redirection, and the extension managers.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 15:20:18', 42, '2010-09-14 00:29:05', 0, '*'),
(22, 47, 20, 14, 25, 4, 'sample-data-articles/joomla/extensions/modules', 'com_content', 'Modules', 'modules', '', '<p><img src="administrator/templates/bluestork/images/header/icon-48-module.png" alt="Media Image" class="image-left" />Modules are small blocks of content that can be displayed in positions on a web page. The menus on this site are displayed in modules. The core of Joomla! includes 17 separate modules ranging from login to search to random images. Each module has a name that starts mod_ but when it displays it has a title. In the descriptions in this section, the titles are the same as the names.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 15:20:49', 42, '2010-09-14 00:29:37', 0, '*'),
(23, 48, 20, 26, 35, 4, 'sample-data-articles/joomla/extensions/templates', 'com_content', 'Templates', 'templates', '', '<p><img src="administrator/templates/bluestork/images/header/icon-48-themes.png" border="0" alt="Media Image" align="left" />Templates give your site its look and feel. They determine layout, colors, type faces, graphics and other aspects of design that make your site unique. Your installation of Joomla comes prepackaged with four templates.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 15:21:27', 42, '2010-07-12 01:02:27', 0, '*'),
(75, 166, 22, 23, 24, 5, 'sample-data-articles/joomla/extensions/modules/navigation-modules', 'com_content', 'Navigation Modules', 'navigation-modules', '', '<p>Navigation modules help your visitors move through your site and find what they need.</p>\r\n<p>Menus provide your site with structure and help your visitors navigate your site.  Although they are all based on the same menu module, the variety of ways menus are used in the sample data show how flexible this module is.</p>\r\n<p>A menu can range from extremely simple (for example the top menu or the menu for the Australian Parks sample site) to extremely complex (for example the About Joomla! menu with its many levels). They can also be used for other types of presentation such as the site map linked from the "This Site" menu.</p>\r\n<p>Breadcrumbs provide users with information about where they are in a site.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-07-11 14:52:30', 42, '2010-11-15 09:14:34', 0, '*'),
(24, 49, 20, 36, 37, 4, 'sample-data-articles/joomla/extensions/languages', 'com_content', 'Languages', 'languages', '', '<p><img src="administrator/templates/bluestork/images/header/icon-48-language.png" border="0" alt="Languages Image" align="left" />Joomla! installs in English, but translations of the interfaces, sample data and help screens are available in dozens of languages.</p>\r\n<p><a href="http://community.joomla.org/translations.html">Translation information</a></p>\r\n<p>If there is no language pack available for your language, instructions are available for creating your own translation, which you can also contribute to the community by starting a translation team to create an accredited translation.</p>\r\n<p>Translations of the interfaces are installed using the extensions manager in the site administrator and then managed using the language manager.</p>\r\n<p>If you have two or more languages installed you may enable the language switcher plugin and module. They should always be used together. If you create multilingual content and mark your content, menu items or modules as in specific languages and follow <a href="http://docs.joomla.org/Language_Switcher_Tutorial_for_Joomla_1.6">the complete instructions</a> your users will be able to select a specific content language using the module. By default both the plugin and module are disabled.</p>\r\n<p>There are a number of extensions that can help you manage translations of content available in the<a href="http://extensions.joomla.org"> Joomla! Extensions Directory</a>.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 15:22:27', 42, '2010-07-12 01:08:26', 0, '*'),
(25, 50, 20, 38, 39, 4, 'sample-data-articles/joomla/extensions/plugins', 'com_content', 'Plugins', 'plugins', '', '<p><img src="administrator/templates/bluestork/images/header/icon-48-plugin.png" border="0" alt="Plugin Image" align="left" />Plugins are small task oriented extensions that enhance the Joomla! framework. Some are associated with particular extensions and others, such as editors, are used across all of Joomla!. Most beginning users do not need to change any of the plugins that install with Joomla!.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 15:23:22', 42, '2010-07-12 01:07:01', 0, '*'),
(26, 51, 14, 42, 51, 2, 'sample-data-articles/park-site', 'com_content', 'Park Site', 'park-site', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 15:26:53', 42, '2010-07-12 16:50:51', 0, 'en-GB'),
(27, 52, 26, 43, 44, 3, 'sample-data-articles/park-site/park-blog', 'com_content', 'Park Blog', 'park-blog', '', '<p><span style="font-size: 12px;">Here is where I will blog all about the parks of Australia.</span></p>\r\n<p><em>You can make a blog on your website by creating a category to write you blog posts in (this one is called Park Blog). Each blog post will be an article in that category. If you make a category blog menu link with 1 column it will look like this page, if you display the category description (this part) displayed. </em></p>\r\n<p><em>To enhance your blog you may want to add  extensions for <a href="http://extensions.joomla.org/extensions/contacts-and-feedback/articles-comments" style="color: #1b57b1; text-decoration: none; font-weight: normal;">comments</a>,<a href="http://extensions.joomla.org/extensions/social-web" style="color: #1b57b1; text-decoration: none; font-weight: normal;"> interacting with social network sites</a>, <a href="http://extensions.joomla.org/extensions/content-sharing" style="color: #1b57b1; text-decoration: none; font-weight: normal;">tagging</a>, and <a href="http://extensions.joomla.org/extensions/content-sharing" style="color: #1b57b1; text-decoration: none; font-weight: normal;">keeping in contact with your readers</a>.   You will also enable the syndication that is included in Joomla! (in the Integration Options set Show Feed Link to Show an make sure to display the syndication module on the page).</em></p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":"images\\/sampledata\\/parks\\/banner_cradle.jpg"}', '', '', '{"author":"","robots":""}', 42, '2010-07-10 15:29:34', 42, '2010-11-15 09:38:57', 0, 'en-GB'),
(28, 53, 26, 45, 50, 3, 'sample-data-articles/park-site/photo-gallery', 'com_content', 'Photo Gallery', 'photo-gallery', '', '<p><img src="images/sampledata/parks/banner_cradle.jpg" border="0" /></p>\r\n<p>These are my photos from parks I have visited (I didn''t take them, they are all from <a href="http://commons.wikimedia.org/wiki/Main_Page">Wikimedia Commons</a>).</p>\r\n<p><em>This shows you how to make a simple image gallery using articles in com_content. </em></p>\r\n<p><em>In each article put a thumbnail image before a "readmore" and the fiull size image after it. Set the article to Show Intro Text: Hide. </em></p>', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 15:36:24', 42, '2010-07-11 22:39:39', 0, 'en-GB'),
(29, 54, 14, 52, 57, 2, 'sample-data-articles/fruit-shop-site', 'com_content', 'Fruit Shop Site', 'fruit-shop-site', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:07:22', 42, '2010-07-12 19:39:19', 0, '*'),
(30, 55, 29, 53, 54, 3, 'sample-data-articles/fruit-shop-site/growers', 'com_content', 'Growers', 'growers', '', '<p>We search the whole countryside for the best fruit growers.</p>\r\n<p><em>You can let each supplier have a page that he or she can edit. To see this in action you will need to create a users who is in the suppliers group.  <br />Create one page in the growers category for that user and make that supplier the author of the page.  That user will be able to edit his or her page. </em></p>\r\n<p><em>This illustrates the use of the Edit Own permission. </em></p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-07-10 16:15:26', 42, '2010-11-15 08:42:33', 0, '*'),
(31, 56, 18, 2, 3, 2, 'sample-data-weblinks/park-links', 'com_weblinks', 'Park Links', 'park-links', '', '<p>Here are links to some of my favorite parks.</p>\r\n<p><em>The weblinks component provides an easy way to make links to external sites that are consistently formatted and categorised. You can create weblinks from the front end of your site.</em></p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":"images\\/sampledata\\/parks\\/banner_cradle.jpg"}', '', '', '{"author":"","robots":""}', 42, '2010-07-10 16:21:00', 42, '2010-11-15 09:39:35', 0, 'en-GB'),
(32, 57, 18, 4, 7, 2, 'sample-data-weblinks/joomla-specific-links', 'com_weblinks', 'Joomla! Specific Links', 'joomla-specific-links', '', '<p><div style="font-family: Tahoma, Helvetica, Arial, sans-serif; font-size: 76%; background-color: #ffffff; background-image: initial; background-attachment: initial; background-origin: initial; background-clip: initial; line-height: 1.3em; color: #333333;"><p>A selection of links that are all related to the Joomla! Project.</p></div></p>', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:22:39', 0, '0000-00-00 00:00:00', 0, '*'),
(33, 58, 32, 5, 6, 3, 'sample-data-weblinks/joomla-specific-links/other-resources', 'com_weblinks', 'Other Resources', 'other-resources', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:24:17', 0, '0000-00-00 00:00:00', 0, '*'),
(34, 59, 16, 66, 67, 2, 'sample-data-contact/park-site', 'com_contact', 'Park Site', 'park-site', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:28:06', 42, '2010-07-11 22:35:55', 0, 'en-GB'),
(35, 60, 16, 68, 125, 2, 'sample-data-contact/shop-site', 'com_contact', 'Shop Site', 'shop-site', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:28:20', 0, '0000-00-00 00:00:00', 0, '*'),
(36, 61, 35, 69, 70, 3, 'sample-data-contact/shop-site/staff', 'com_contact', 'Staff', 'staff', '', '<p>Please feel free to contact our staff at any time should you need assistance.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:29:22', 0, '0000-00-00 00:00:00', 0, '*'),
(37, 62, 35, 71, 124, 3, 'sample-data-contact/shop-site/fruit-encyclopedia', 'com_contact', 'Fruit Encyclopedia', 'fruit-encyclopedia', '', '<p> </p><p>Our directory of information about different kinds of fruit.</p><p>We love fruit and want the world to know more about all of its many varieties.</p><p>Although it is small now, we work on it whenever we have a chance.</p><p>All of the images can be found in <a href="http://commons.wikimedia.org/wiki/Main_Page">Wikimedia Commons</a>.</p><p><img src="images/sampledata/fruitshop/apple.jpg" border="0" alt="Apples" title="Apples" /></p><p><em>This encyclopedia is implemented using the contact component, each fruit a separate contact and a category for each letter. A CSS style is used to create the horizontal layout of the alphabet headings. </em></p><p><em>If you wanted to, you could allow some users (such as your growers) to have access to just this category in the contact component and let them help you to create new content for the encyclopedia.</em></p><p> </p>', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:41:12', 0, '0000-00-00 00:00:00', 0, '*'),
(38, 63, 37, 72, 73, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/a', 'com_contact', 'A', 'a', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:43:24', 0, '0000-00-00 00:00:00', 0, '*'),
(39, 64, 37, 74, 75, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/b', 'com_contact', 'B', 'b', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:44:46', 0, '0000-00-00 00:00:00', 0, '*'),
(40, 65, 37, 76, 77, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/c', 'com_contact', 'C', 'c', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:45:10', 0, '0000-00-00 00:00:00', 0, '*'),
(41, 66, 37, 78, 79, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/d', 'com_contact', 'D', 'd', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:45:23', 0, '0000-00-00 00:00:00', 0, '*'),
(42, 67, 37, 80, 81, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/e', 'com_contact', 'E', 'e', '', '', 0, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:45:32', 0, '0000-00-00 00:00:00', 0, '*'),
(43, 68, 37, 82, 83, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/f', 'com_contact', 'F', 'f', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:45:42', 0, '0000-00-00 00:00:00', 0, '*'),
(44, 69, 37, 84, 85, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/g', 'com_contact', 'G', 'g', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:45:58', 0, '0000-00-00 00:00:00', 0, '*'),
(45, 70, 37, 86, 87, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/h', 'com_contact', 'H', 'h', '', '', 0, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:46:08', 0, '0000-00-00 00:00:00', 0, '*'),
(46, 71, 37, 88, 89, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/i', 'com_contact', 'I', 'i', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:46:21', 0, '0000-00-00 00:00:00', 0, '*'),
(47, 72, 37, 90, 91, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/j', 'com_contact', 'J', 'j', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:46:34', 0, '0000-00-00 00:00:00', 0, '*'),
(48, 73, 37, 92, 93, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/k', 'com_contact', 'K', 'k', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:46:45', 0, '0000-00-00 00:00:00', 0, '*'),
(49, 74, 37, 94, 95, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/l', 'com_contact', 'L', 'l', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:46:57', 0, '0000-00-00 00:00:00', 0, '*'),
(50, 75, 37, 96, 97, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/m', 'com_contact', 'M', 'm', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:47:11', 0, '0000-00-00 00:00:00', 0, '*'),
(51, 76, 37, 98, 99, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/n', 'com_contact', 'N', 'n', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:47:22', 0, '0000-00-00 00:00:00', 0, '*'),
(52, 77, 37, 100, 101, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/o', 'com_contact', 'O', 'o', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:47:33', 0, '0000-00-00 00:00:00', 0, '*'),
(53, 78, 37, 102, 103, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/p', 'com_contact', 'P', 'p', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:47:44', 0, '0000-00-00 00:00:00', 0, '*'),
(54, 79, 37, 104, 105, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/q', 'com_contact', 'Q', 'q', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:47:54', 0, '0000-00-00 00:00:00', 0, '*'),
(55, 80, 37, 106, 107, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/r', 'com_contact', 'R', 'r', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:48:34', 0, '0000-00-00 00:00:00', 0, '*'),
(56, 81, 37, 108, 109, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/s', 'com_contact', 'S', 's', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:48:45', 0, '0000-00-00 00:00:00', 0, '*'),
(57, 82, 37, 110, 111, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/t', 'com_contact', 'T', 't', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:48:56', 0, '0000-00-00 00:00:00', 0, '*'),
(58, 83, 37, 112, 113, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/u', 'com_contact', 'U', 'u', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:49:08', 0, '0000-00-00 00:00:00', 0, '*'),
(59, 84, 37, 114, 115, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/v', 'com_contact', 'V', 'v', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:49:33', 0, '0000-00-00 00:00:00', 0, '*'),
(60, 85, 37, 116, 117, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/w', 'com_contact', 'W', 'w', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:49:52', 0, '0000-00-00 00:00:00', 0, '*'),
(61, 86, 37, 118, 119, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/x', 'com_contact', 'X', 'x', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:50:08', 0, '0000-00-00 00:00:00', 0, '*'),
(62, 87, 37, 120, 121, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/y', 'com_contact', 'Y', 'y', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:50:22', 0, '0000-00-00 00:00:00', 0, '*'),
(63, 88, 37, 122, 123, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/z', 'com_contact', 'Z', 'z', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:51:09', 0, '0000-00-00 00:00:00', 0, '*'),
(64, 93, 22, 15, 16, 5, 'sample-data-articles/joomla/extensions/modules/articles-modules', 'com_content', 'Content Modules', 'articles-modules', '', '<p>Content modules display article and other information from the content component.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 18:32:13', 42, '2010-07-11 13:34:00', 0, '*'),
(65, 94, 22, 17, 18, 5, 'sample-data-articles/joomla/extensions/modules/user-modules', 'com_content', 'User Modules', 'user-modules', '', '<p>User modules interact with the user system, allowing users to login, showing who is logged in, and showing the most recently registered users.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 18:33:19', 0, '0000-00-00 00:00:00', 0, '*'),
(66, 95, 22, 19, 20, 5, 'sample-data-articles/joomla/extensions/modules/display-modules', 'com_content', 'Display Modules', 'display-modules', '', '<p>These modules display information from components other than content and user. These include weblinks, news feeds and the media manager.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 18:34:49', 0, '0000-00-00 00:00:00', 0, '*'),
(67, 96, 22, 21, 22, 5, 'sample-data-articles/joomla/extensions/modules/utility-modules', 'com_content', 'Utility Modules', 'utility-modules', '', '<p>Utility modules provide useful functionality such as search, syndication, and statistics.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 18:36:18', 0, '0000-00-00 00:00:00', 0, '*'),
(68, 97, 23, 31, 32, 5, 'sample-data-articles/joomla/extensions/templates/atomic', 'com_content', 'Atomic', 'atomic', '', '<p>Atomic is a minimal template designed to be a skeleton for making your own template and to learn about Joomla! templating.</p>\r\n<p><img src="templates/atomic/template_thumbnail.png" border="0" alt="The Atomic Template" style="border: 0; float: right;" /></p>\r\n<p> </p>\r\n<ul>\r\n<li><a href="index.php?Itemid=285">Home Page</a></li>\r\n<li><a href="index.php?Itemid=316">Typography</a></li>\r\n</ul>\r\n<p> </p>\r\n<p> </p>\r\n<p><br /><br /></p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-07-10 19:03:11', 42, '2010-11-21 19:24:25', 0, '*'),
(69, 98, 23, 27, 28, 5, 'sample-data-articles/joomla/extensions/templates/beez-20', 'com_content', 'Beez 20', 'beez-20', '', '<p><img src="templates/beez_20/template_thumbnail.png" border="0" alt="Beez_20 thumbnail" align="right" style="float: right; margin: 5px,80px,5px,25px;" /></p>\r\n<p>Beez 2.0 is a versatile, easy to customize template that works for a variety of sites. It meets major accessibility standards and demonstrates a range of css and javascript techniques. It is the default template that installs with Joomla!</p>\r\n<ul>\r\n<li><a href="index.php?Itemid=424">Home Page</a></li>\r\n<li><a href="index.php?Itemid=423">Typography</a></li>\r\n</ul>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-07-10 19:06:19', 42, '2010-11-15 10:02:37', 0, '*'),
(70, 99, 23, 29, 30, 5, 'sample-data-articles/joomla/extensions/templates/beez5', 'com_content', 'Beez5', 'beez5', '', '<p><img src="templates/beez5/template_thumbnail.png" border="0" alt="Beez5 Thumbnail" align="right" style="float: right;" /></p>\r\n<p> </p>\r\n<p>Beez 5 is an html5 implementation of a Joomla! template. It uses a number of html5 techniques to enhance the presentation of a site. It is used as the template for the Fruit Shop sample site.</p>\r\n<ul>\r\n<li><a href="index.php?Itemid=458">Home Page</a></li>\r\n<li><a href="index.php?Itemid=457">Typography</a></li>\r\n</ul>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-07-10 19:10:16', 42, '2010-11-15 10:06:07', 0, '*'),
(71, 100, 23, 33, 34, 5, 'sample-data-articles/joomla/extensions/templates/milky-way', 'com_content', 'Milky Way', 'milky-way', '', '<p><img src="templates/rhuk_milkyway/template_thumbnail.png" border="0" alt="Milky Way Image" width="206" height="150" align="right" style="float: right;" /></p>\r\n<p>Milky Way is the default template for Joomla! 1.5. You can find all of the 1.5 component layouts in the _html folder if you need them for your upgraded sites.</p>\r\n<ul>\r\n<li><a href="index.php?Itemid=286">Typography</a></li>\r\n<li><a href="index.php?Itemid=451">Home Page</a></li>\r\n</ul>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-07-10 19:15:13', 42, '2010-11-15 10:13:28', 0, '*'),
(72, 108, 28, 46, 47, 4, 'sample-data-articles/park-site/photo-gallery/animals', 'com_content', 'Animals', 'animals', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 20:04:21', 42, '2010-07-11 22:31:53', 0, 'en-GB'),
(73, 109, 28, 48, 49, 4, 'sample-data-articles/park-site/photo-gallery/scenery', 'com_content', 'Scenery', 'scenery', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 20:04:44', 42, '2010-07-11 22:32:00', 0, 'en-GB'),
(76, 167, 29, 55, 56, 3, 'sample-data-articles/fruit-shop-site/recipes', 'com_content', 'Recipes', 'recipes', '', '<p>Customers and suppliers can post their favorite recipes for fruit here.</p>\r\n<p>A good idea is to promote the use of metadata keywords to make finding other recipes for the same fruit easier.</p>\r\n<p><em>To see this in action, create a user assigned to the customer group and a user assigned to the suppliers group. These users will be able to create their own recipe pages and edit those pages. The will not be able to edit other users'' pages.</em><br /><br /></p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-07-12 14:52:59', 42, '2010-11-15 08:44:11', 0, '*'),
(77, 170, 1, 135, 156, 1, 'demo-section', 'com_content', 'Demo section', 'demo-section', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-09 22:08:55', 0, '0000-00-00 00:00:00', 0, '*'),
(78, 171, 77, 136, 137, 2, 'demo-section/demo-category', 'com_content', 'Demo category', 'demo-category', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-09 22:10:03', 0, '0000-00-00 00:00:00', 0, '*'),
(79, 172, 77, 138, 139, 2, 'demo-section/slideshow', 'com_content', 'SlideShow', 'slideshow', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-09 22:11:04', 0, '0000-00-00 00:00:00', 0, '*'),
(80, 173, 77, 140, 141, 2, 'demo-section/blog-category', 'com_content', 'Blog category', 'blog-category', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-09 22:14:58', 0, '0000-00-00 00:00:00', 0, '*'),
(81, 174, 77, 142, 143, 2, 'demo-section/testimonials', 'com_content', 'Testimonials', 'testimonials', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-09 22:17:58', 0, '0000-00-00 00:00:00', 0, '*'),
(82, 175, 77, 146, 147, 2, 'demo-section/movie-news', 'com_content', 'Movie news', 'movie-news', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-09 22:18:30', 42, '2010-12-09 22:19:50', 0, '*'),
(83, 176, 77, 144, 145, 2, 'demo-section/slidenews', 'com_content', 'Slidenews', 'slidenews', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-09 22:19:18', 0, '0000-00-00 00:00:00', 0, '*'),
(84, 206, 77, 148, 155, 2, 'demo-section/all-categories', 'com_content', 'All Categories', 'all-categories', '', '<p>Elit lacinia Sed sagittis metus Lorem id tincidunt Proin adipiscing elit. Et tempus feugiat wisi gravida pede rhoncus tristique semper Sed eu. Nam tellus magna eros vel nibh laoreet vel Curabitur neque et. Vel Vestibulum Morbi feugiat vitae id sed magna at tellus senectus. Malesuada. Elit lacinia Sed sagittis metus Lorem id tincidunt Proin adipiscing elit. Et tempus feugiat wisi gravida pede rhoncus tristique semper Sed eu. Nam tellus magna eros vel nibh laoreet vel Curabitur neque et. Vel Vestibulum Morbi feugiat vitae id sed magna at tellus senectus. Malesuada.</p>', -2, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2011-08-22 07:20:40', 42, '2011-08-22 07:21:34', 0, '*'),
(85, 207, 84, 149, 150, 3, 'demo-section/all-categories/actions', 'com_content', 'Actions', 'actions', '', '<p><img src="images/stories/demo/thub-3.jpg" border="0" alt="Sample Image" />Quis ut Sed et Nunc felis Maecenas sed felis augue rhoncus. In ultrices habitant odio Aliquam pellentesque pellentesque et Integer Curabitur a. Nisl Nam lacus condimentum Donec neque convallis Sed et mauris a. Wisi Suspendisse Vestibulum velit tellus dui consequat sapien suscipit felis dui. Est id at Nam pede wisi odio sapien sollicitudin.</p>', -2, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2011-08-22 07:21:59', 42, '2011-08-22 08:25:28', 0, '*'),
(86, 208, 84, 151, 152, 3, 'demo-section/all-categories/romance', 'com_content', 'Romance', 'romance', '', '<p><img src="images/stories/demo/thub-4.jpg" border="0" alt="Sample Image" />Quis ut Sed et Nunc felis Maecenas sed felis augue rhoncus. In ultrices habitant odio Aliquam pellentesque pellentesque et Integer Curabitur a. Nisl Nam lacus condimentum Donec neque convallis Sed et mauris a. Wisi Suspendisse Vestibulum velit tellus dui consequat sapien suscipit felis dui. Est id at Nam pede wisi odio sapien sollicitudin.</p>', -2, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2011-08-22 07:22:23', 42, '2011-08-22 08:25:46', 0, '*'),
(87, 209, 84, 153, 154, 3, 'demo-section/all-categories/family', 'com_content', 'Family', 'family', '', '<p><img src="images/stories/demo/thub-5.jpg" border="0" alt="Sample Image" />Quis ut Sed et Nunc felis Maecenas sed felis augue rhoncus. In ultrices habitant odio Aliquam pellentesque pellentesque et Integer Curabitur a. Nisl Nam lacus condimentum Donec neque convallis Sed et mauris a. Wisi Suspendisse Vestibulum velit tellus dui consequat sapien suscipit felis dui. Est id at Nam pede wisi odio sapien sollicitudin.</p>', -2, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2011-08-22 07:23:01', 42, '2011-08-22 08:26:14', 0, '*');

DROP TABLE IF EXISTS `#__contact_details`;
CREATE TABLE `#__contact_details` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) binary NOT NULL DEFAULT '',
  `con_position` varchar(255) DEFAULT NULL,
  `address` text,
  `suburb` varchar(100) DEFAULT NULL,
  `state` varchar(100) DEFAULT NULL,
  `country` varchar(100) DEFAULT NULL,
  `postcode` varchar(100) DEFAULT NULL,
  `telephone` varchar(255) DEFAULT NULL,
  `fax` varchar(255) DEFAULT NULL,
  `misc` mediumtext,
  `image` varchar(255) DEFAULT NULL,
  `imagepos` varchar(20) DEFAULT NULL,
  `email_to` varchar(255) DEFAULT NULL,
  `default_con` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `user_id` int(11) NOT NULL DEFAULT '0',
  `catid` int(11) NOT NULL DEFAULT '0',
  `access` int(10) unsigned DEFAULT NULL,
  `mobile` varchar(255) NOT NULL DEFAULT '',
  `webpage` varchar(255) NOT NULL DEFAULT '',
  `sortname1` varchar(255) NOT NULL,
  `sortname2` varchar(255) NOT NULL,
  `sortname3` varchar(255) NOT NULL,
  `language` char(7) NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if article is featured.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`published`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=MyISAM ;

INSERT INTO `#__contact_details` (`id`, `name`, `alias`, `con_position`, `address`, `suburb`, `state`, `country`, `postcode`, `telephone`, `fax`, `misc`, `image`, `imagepos`, `email_to`, `default_con`, `published`, `checked_out`, `checked_out_time`, `ordering`, `params`, `user_id`, `catid`, `access`, `mobile`, `webpage`, `sortname1`, `sortname2`, `sortname3`, `language`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `metakey`, `metadesc`, `metadata`, `featured`, `xreference`, `publish_up`, `publish_down`) VALUES
(1, 'Contact Name Here', 'name', 'Position', 'Street Address', 'Suburb', 'State', 'Country', 'Zip Code', 'Telephone', 'Fax', '<p>Information about or by the contact.</p>', 'images/powered_by.png', 'top', 'email@email.com', 1, 1, 0, '0000-00-00 00:00:00', 1, '{"show_contact_category":"","show_contact_list":"","presentation_style":"plain","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_profile":"","show_links":"","linka_name":"Twitter","linka":"http:\\/\\/twitter.com\\/joomla","linkb_name":"YouTube","linkb":"http:\\/\\/www.youtube.com\\/user\\/joomla","linkc_name":"Ustream","linkc":"http:\\/\\/www.ustream.tv\\/joomla","linkd_name":"FriendFeed","linkd":"http:\\/\\/friendfeed.com\\/joomla","linke_name":"Scribed","linke":"http:\\/\\/www.scribd.com\\/people\\/view\\/504592-joomla","contact_layout":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":""}', 0, 16, 1, '', '', 'last', 'first', 'middle', 'en-GB', '0000-00-00 00:00:00', 0, '', '2011-08-26 09:18:50', 42, '', '', '{"robots":"","rights":""}', 1, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(2, 'Webmaster', 'webmaster', '', '', '', '', '', '', '', '', '', '', NULL, 'webmaster@example.com', 0, 1, 0, '0000-00-00 00:00:00', 1, '{"show_contact_category":"","show_contact_list":"","presentation_style":"","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_profile":"","show_links":"","linka_name":"","linka":"","linkb_name":"","linkb":"","linkc_name":"","linkc":"","linkd_name":"","linkd":"","linke_name":"","linke":"","show_email_form":"1","show_email_copy":"1","banned_email":"","banned_subject":"","banned_text":"","validate_session":"1","custom_reply":"","redirect":""}', 0, 34, 1, '', '', '', '', '', 'en-GB', '0000-00-00 00:00:00', 0, '', '2010-08-23 03:03:54', 42, '', '', '{"robots":"","rights":""}', 1, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(3, 'Owner', 'owner', '', '', '', '', '', '', '', '', '<p>I''m the owner of this store.</p>', '', NULL, '', 0, 1, 0, '0000-00-00 00:00:00', 2, '{"show_contact_category":"","show_contact_list":"","presentation_style":"","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_profile":"","show_links":"","linka_name":"","linka":"","linkb_name":"","linkb":"","linkc_name":"","linkc":"","linkd_name":"","linkd":"","linke_name":"","linke":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":""}', 0, 36, 1, '', '', '', '', '', '*', '0000-00-00 00:00:00', 0, '', '2010-07-11 13:07:22', 42, '', '', '{"robots":"","rights":""}', 1, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(4, 'Buyer', 'buyer', '', '', '', '', '', '', '', '', '<p>I am in charge of buying fruit. If you sell good fruit, contact me.</p>', '', NULL, '', 0, 1, 0, '0000-00-00 00:00:00', 1, '{"show_contact_category":"","show_contact_list":"","presentation_style":"","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_profile":"","show_links":"0","linka_name":"","linka":"","linkb_name":"","linkb":"","linkc_name":"","linkc":"","linkd_name":"","linkd":"","linke_name":"","linke":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":""}', 0, 36, 1, '', '', '', '', '', '*', '0000-00-00 00:00:00', 0, '', '2010-07-10 23:48:49', 42, '', '', '{"robots":"","rights":""}', 1, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(5, 'Bananas', 'bananas', 'Scientific Name: Musa', 'Image Credit: Enzik\r\nRights: Creative Commons Share Alike Unported 3.0\r\nSource: http://commons.wikimedia.org/wiki/File:Bananas_-_Morocco.jpg', '', 'Type: Herbaceous', 'Large Producers: India, China, Brasil', '', '', '', '<p>Bananas are a great source of potassium.</p>\r\n<p> </p>', 'images/sampledata/fruitshop/bananas_2.jpg', NULL, '', 0, 1, 0, '0000-00-00 00:00:00', 1, '{"show_contact_category":"show_with_link","show_contact_list":"","presentation_style":"plain","show_name":"","show_position":"1","show_email":"","show_street_address":"","show_suburb":"","show_state":"1","show_postcode":"","show_country":"1","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_profile":"","show_links":"1","linka_name":"Wikipedia: Banana English","linka":"http:\\/\\/en.wikipedia.org\\/wiki\\/Banana","linkb_name":"Wikipedia:  \\u0939\\u093f\\u0928\\u094d\\u0926\\u0940 \\u0915\\u0947\\u0932\\u093e","linkb":"http:\\/\\/hi.wikipedia.org\\/wiki\\/%E0%A4%95%E0%A5%87%E0%A4%B2%E0%A4%BE","linkc_name":"Wikipedia:Banana Portugu\\u00eas","linkc":"http:\\/\\/pt.wikipedia.org\\/wiki\\/Banana","linkd_name":"Wikipedia: \\u0411\\u0430\\u043d\\u0430\\u043d  \\u0420\\u0443\\u0441\\u0441\\u043a\\u0438\\u0439","linkd":"http:\\/\\/ru.wikipedia.org\\/\\u0411\\u0430\\u043d\\u0430\\u043d","linke_name":"","linke":"","contact_layout":"beez5:encyclopedia"}', 0, 39, 1, '', '', '', '', '', '*', '0000-00-00 00:00:00', 0, '', '2010-11-28 20:35:48', 42, '', '', '{"robots":"","rights":""}', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(6, 'Apples', 'apples', 'Scientific Name: Malus domestica', 'Image Credit: Fievet\r\nRights: Public Domain\r\nSource: http://commons.wikimedia.org/wiki/File:Pommes_vertes.JPG', '', 'Family: Rosaceae', 'Large: Producers: China, United States', '', '', '', '<p>Apples are a versatile fruit, used for eating, cooking, and preserving.</p>\r\n<p>There are more that 7500 different kinds of apples grown around the world.</p>', 'images/sampledata/fruitshop/apple.jpg', NULL, '', 0, 1, 0, '0000-00-00 00:00:00', 1, '{"show_contact_category":"","show_contact_list":"","presentation_style":"plain","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_profile":"","show_links":"1","linka_name":"Wikipedia: Apples English","linka":"http:\\/\\/en.wikipedia.org\\/wiki\\/Apple","linkb_name":"Wikipedia: Manzana Espa\\u00f1ol ","linkb":"http:\\/\\/es.wikipedia.org\\/wiki\\/Manzana","linkc_name":"Wikipedia: \\u82f9\\u679c \\u4e2d\\u6587","linkc":"http:\\/\\/zh.wikipedia.org\\/zh\\/\\u82f9\\u679c","linkd_name":"Wikipedia: Tofaa Kiswahili","linkd":"http:\\/\\/sw.wikipedia.org\\/wiki\\/Tofaa","linke_name":"","linke":"","contact_layout":"beez5:encyclopedia"}', 0, 38, 1, '', '', '', '', '', '*', '0000-00-00 00:00:00', 0, '', '2010-11-28 23:19:39', 42, '', '', '{"robots":"","rights":""}', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(7, 'Tamarind', 'tamarind', 'Scientific Name: Tamarindus indica', 'Image Credit: Franz Eugen Köhler, Köhler''s Medizinal-Pflanzen \r\nRights: Public Domain\r\nSource:http://commons.wikimedia.org/wiki/File:Koeh-134.jpg', '', 'Family: Fabaceae', 'Large Producers: India, United States', '', '', '', '<p>Tamarinds are a versatile fruit used around the world. In its young form it is used in hot sauces; ripened it is the basis for many refreshing drinks.</p>\r\n<p> </p>', 'images/sampledata/fruitshop/tamarind.jpg', NULL, '', 0, 1, 0, '0000-00-00 00:00:00', 1, '{"show_contact_category":"","show_contact_list":"","presentation_style":"plain","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_profile":"","show_links":"1","linka_name":"Wikipedia: Tamarind English","linka":"http:\\/\\/en.wikipedia.org\\/wiki\\/Tamarind","linkb_name":"Wikipedia: \\u09a4\\u09c7\\u0981\\u09a4\\u09c1\\u09b2  \\u09ac\\u09be\\u0982\\u09b2\\u09be  ","linkb":"http:\\/\\/bn.wikipedia.org\\/wiki\\/\\u09a4\\u09c7\\u0981\\u09a4\\u09c1\\u09b2 ","linkc_name":"Wikipedia: Tamarinier Fran\\u00e7ais","linkc":"http:\\/\\/fr.wikipedia.org\\/wiki\\/Tamarinier","linkd_name":"Wikipedia:Tamaline lea faka-Tonga","linkd":"http:\\/\\/to.wikipedia.org\\/wiki\\/Tamaline","linke_name":"","linke":"","contact_layout":"beez5:encyclopedia"}', 0, 57, 1, '', '', '', '', '', '*', '0000-00-00 00:00:00', 0, '', '2010-11-28 20:25:34', 42, '', '', '{"robots":"","rights":""}', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(8, 'Shop Address', 'shop-address', '', '', 'Our City', 'Our Province', 'Our Country', '', '555-555-5555', '', '<p>Here are directions for how to get to our shop.</p>', '', NULL, '', 0, 1, 0, '0000-00-00 00:00:00', 1, '{"show_contact_category":"","show_contact_list":"","presentation_style":"","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_profile":"","show_links":"","linka_name":"","linka":"","linkb_name":"","linkb":"","linkc_name":"","linkc":"","linkd_name":"","linkd":"","linke_name":"","linke":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":""}', 0, 35, 1, '', '', '', '', '', '*', '0000-00-00 00:00:00', 0, '', '2010-08-23 03:03:54', 42, '', '', '{"robots":"","rights":""}', 1, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00');

DROP TABLE IF EXISTS `#__content`;
CREATE TABLE `#__content` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to the #__assets table.',
  `title` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) binary NOT NULL DEFAULT '',
  `title_alias` varchar(255) binary NOT NULL DEFAULT '',
  `introtext` mediumtext NOT NULL,
  `fulltext` mediumtext NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `sectionid` int(10) unsigned NOT NULL DEFAULT '0',
  `mask` int(10) unsigned NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `images` text NOT NULL,
  `urls` text NOT NULL,
  `attribs` varchar(5120) NOT NULL,
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  `parentid` int(10) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if article is featured.',
  `language` char(7) NOT NULL COMMENT 'The language code for the article.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`state`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=MyISAM ;

INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `title_alias`, `introtext`, `fulltext`, `state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(1, 89, 'Administrator Components', 'administrator-components', '', '<p>All components also are used in the administrator area of your website. In addition to the ones listed here, there are components in the administrator that do not have direct front end displays, but do help shape your site. The most important ones for most users are</p><ul><li>Media Manager</li><li>Extensions Manager</li><li>Menu Manager</li><li>Configuration</li><li>Banners</li></ul><hr title="Media Manager" alt="Media Manager" class="system-pagebreak" style="color: gray; border: 1px dashed gray;" /><p> </p><h3>Media Manager</h3><p>The media manager component lets you upload and insert images into content throughout your site. Optionally, you can enable the flash uploader which will allow you to to upload multiple images. Help</p><hr title="Extensions Manager" alt="Extensions Manager" class="system-pagebreak" style="color: gray; border: 1px dashed gray;" /><h3>Extensions Manager</h3><p>The extensions manager lets you install, update, uninstall and manage all of your extensions. The extensions manager has been extensively redesigned for Joomla! 1.6, although the core install and uninstall functionality remains the same as in Joomla 1.5. Help</p><hr title="Menu Manager" alt="Menu Manager" class="system-pagebreak" style="color: gray; border: 1px dashed gray;" /><h3>Menu Manager</h3><p>The menu manager lets you create the menus you see displayed on your site. It also allows you to assign modules and template styles to specific menu links.  Help</p><hr title="Global Configuration" alt="Global Configuration" class="system-pagebreak" style="color: gray; border: 1px dashed gray;" /><h3>Global Configuration</h3><p>The global configuration is where the site administrator configures things such as whether search engine friendly urls are enabled, the site meta data (descriptive text used by search engines an indexers) and other functions. For many beginning users simply leaving the settings on default is a good way to begin, although when your site is ready for the public you will want to change the meta data to match its content. Help</p><hr title="Banners" alt="Banners" class="system-pagebreak" style="color: gray; border: 1px dashed gray;" /><h3>Banners</h3><p>The banners component provides a simple way to display a rotating image in a module and, if you wish to have advertising, a way to track the number of times an image is viewed and clicked. Help</p>', '', 1, 0, 0, 21, '2010-07-10 18:03:52', 42, 'Joomla!', '2010-08-23 03:00:39', 42, 0, '0000-00-00 00:00:00', '2010-07-10 18:03:52', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 5, 0, 7, '', '', 1, 8, '', 0, '*', ''),
(8, 104, 'Beginners', 'beginners', '', '<p>If this is your first Joomla site or your first web site, you have come to the right place. Joomla will help you get your website up and running quickly and easily.</p><p>Start off using your site by logging in using the administrator account you created when you installed Joomla!.</p>', '<p>Explore the articles and other resources right here on your site data to learn more about how Joomla works.(When you''re done reading, you can delete or archive all of this.) You will also probably want to visit the beginners'' areas of the <a href="http://docs.joomla.org">Joomla documentation</a> and <a href="http://forum.joomla.org">support forums</a>.</p><p>You''ll also want to sign up for the Joomla Security Mailing list and the Announcements mailing list. For inspiration visit the Joomla Site Showcase to see an amazing array of ways people use Joomla to tell their stories on the web.</p><p>The basic Joomla! installation will let you get a great site up and running, but when you are ready for more features the power of Joomla! is in the creative ways that developers have extended it to do all kinds of things. Visit the Joomla! Extensions Directory to see thousands of extensions that can do almost anything you could want on a website. Can''t find what you need? You may want to find a Joomla professional on the Joomla! Resources Directory.</p><p>Want to learn more? Consider attending a Joomla! Day or other event or joining a local Joomla! Users Group. Can''t find one near you? Start one yourself.</p>', 0, 0, 0, 19, '2010-07-10 19:50:02', 42, 'Joomla!', '2010-08-23 03:02:28', 42, 0, '0000-00-00 00:00:00', '2010-07-10 19:50:53', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 3, 0, 3, '', '', 1, 1, '', 1, '*', ''),
(2, 90, 'Archive Module', 'archive-module', '', '<p>This module shows a list of the calendar months containing archived articles. After you have changed the status of an article to archived, this list will be automatically generated. <a href="http://docs.joomla.org/Screen.modulessite.edit.15#Archived_Content" title="Archive Module">Help</a></p>\r\n<p>{loadposition archiveload}</p>', '', 1, 0, 0, 64, '2010-07-10 18:05:32', 42, 'Joomla!', '2010-09-14 11:22:24', 42, 0, '0000-00-00 00:00:00', '2010-07-10 18:37:13', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","page_title":"","alternative_readmore":"","layout":""}', 7, 0, 5, 'modules, content', '', 1, 3, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(7, 103, 'Banner Module', 'banner-module', '', '<p>The banner module is used to display the banners that are managed by the banners component in the site administrator.</p><p>{loadposition bannersload}</p>', '', 1, 0, 0, 66, '2010-07-10 19:47:47', 42, 'Joomla!', '2010-08-23 03:00:39', 42, 0, '0000-00-00 00:00:00', '2010-07-10 19:47:47', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 3, 0, 6, '', '', 1, 4, '', 0, '*', ''),
(3, 91, 'Article Categories Module', 'article-categories-module', '', '<p>This module displays a list of categories from one parent category. <a href="http://docs.joomla.org/Help15:Screen.modulessite.edit.15#Categories" title="Categories Module">Help</a></p>\r\n<p>{loadposition articlescategoriesload}</p>\r\n<p> </p>', '', 1, 0, 0, 64, '2010-07-10 18:12:46', 42, '', '2010-09-14 11:22:06', 42, 0, '0000-00-00 00:00:00', '2010-07-10 18:14:22', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","page_title":"","alternative_readmore":"","layout":""}', 7, 0, 6, 'modules, content', '', 1, 2, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(4, 92, 'Articles Category Module', 'articles-category-module', '', '<p>This module allows you to display the articles in a specific category. Help.</p>\r\n<p>{loadposition articlescategoryload}</p>', '', 1, 0, 0, 64, '2010-07-10 18:14:09', 42, 'Joomla!', '2010-09-14 11:20:05', 42, 0, '0000-00-00 00:00:00', '2010-07-10 18:14:09', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","page_title":"","alternative_readmore":"","layout":""}', 6, 0, 7, '', 'articles,content', 1, 5, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(5, 101, 'Authentication', 'authentication', '', '<p>The authentication plugins operate when users login to your site or administrator. The Joomla! authentication is in operation by default but you can enable Gmail or LDAP or install a plugin for a different system. An example is included that may be used to create a new authentication plugin.</p><p>Default on:</p><ul><li>Joomla</li></ul><p>Default off:</p><ul><li>Gmail</li><li>LDAP</li></ul>', '', 1, 0, 0, 25, '2010-07-10 19:19:17', 42, 'Joomla!', '2010-07-10 19:51:19', 42, 0, '0000-00-00 00:00:00', '2010-07-10 19:39:58', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 4, 0, 3, '', '', 1, 2, '', 0, '*', ''),
(6, 102, 'Australian Parks ', 'australian-parks', '', '<p><img src="images/sampledata/parks/banner_cradle.jpg" border="0" alt="Cradle Park Banner" /></p>\r\n<p>Welcome!</p>\r\n<p>This is a basic site about the beautiful and fascinating parks of Australia.</p>\r\n<p>On this site you can read all about my travels to different parks, see photos, and find links to park websites.</p>\r\n<p><em>This sample site is an example of using the core of Joomla! to create a basic website, whether a "brochure site,"  a personal blog, or as a way to present information on a topic you are interested in.</em></p>\r\n<p><em> Read more about the site in the About Parks module.</em></p>\r\n<p> </p>', '', 1, 0, 0, 26, '2010-07-10 19:24:58', 42, 'Parks webmaster', '2010-11-21 20:10:59', 42, 0, '0000-00-00 00:00:00', '2010-07-10 19:39:52', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 6, 0, 1, '', '', 1, 7, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(9, 105, 'Contact', 'contact', '', '<p>The contact component provides a way to provide contact forms and information for your site or to create a complex directory that can be used for many different purposes. Help</p>', '', 1, 0, 0, 21, '2010-07-10 19:54:09', 42, 'Joomla!', '2010-09-14 11:42:23', 42, 0, '0000-00-00 00:00:00', '2010-07-10 23:13:05', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 4, 0, 2, '', '', 1, 5, '', 0, '*', ''),
(10, 106, 'Content', 'content', '', '<p>The content component (com_content) is what you use to write articles. It is extremely flexible and has the largest number of built in views. Articles can be created an edited from the front end, making content the easiest component to use to create your site content. Help</p>', '', 1, 0, 0, 21, '2010-07-10 19:56:38', 42, '', '2010-07-10 23:13:20', 42, 0, '0000-00-00 00:00:00', '2010-07-10 23:13:20', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 4, 0, 1, '', '', 1, 14, '', 0, '*', ''),
(11, 107, 'Cradle Mountain', 'cradle-mountain', '', '<p><img src="images/sampledata/parks/landscape/250px_cradle_mountain_seen_from_barn_bluff.jpg" border="0" alt="Cradle Mountain" style="vertical-align: middle;" /></p>', '<p><img src="images/sampledata/parks/landscape/800px_cradle_mountain_seen_from_barn_bluff.jpg" border="0" alt="Cradle Mountain" style="vertical-align: middle;" /></p><p> </p><p class="caption">Source: http://commons.wikimedia.org/wiki/File:Rainforest,bluemountainsNSW.jpg</p><p class="caption">Author: Alan J.W.C.</p><p class="caption">License: GNU Free Documentation License v . 1.2 or later</p>', 1, 0, 0, 73, '2010-07-10 20:01:42', 42, 'Parks Webmaster', '2010-08-23 02:58:49', 42, 0, '0000-00-00 00:00:00', '2010-07-10 20:06:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 4, 0, 1, '', '', 1, 0, '', 0, '*', ''),
(12, 110, 'Custom HTML Module', 'custom-html-module', '', '<p>This Module allows you to create your own HTML Module using a WYSIWYG editor. <a href="http://docs.joomla.org/Help15:Screen.modulessite.edit.15#Custom_HTML" title="Custom HTML Module">Help</a></p><p>{loadposition customload}</p>', '', 1, 0, 0, 66, '2010-07-10 20:07:23', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2010-07-10 20:07:23', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 0, 1, '', '', 1, 5, '', 0, '*', ''),
(13, 111, 'Directions', 'directions', '', '<p>Here''s how to find our shop.</p><p>By car</p><p>Drive along Main Street to the intersection with First Avenue.  Look for our sign.</p><p>By foot</p><p>From the center of town, walk north on Main Street until you see our sign.</p><p>By bus</p><p>Take the #73 Bus to the last stop. We are on the north east corner.</p>', '', 1, 0, 0, 29, '2010-07-10 20:12:32', 42, 'Fruit Shop Webmaster', '2010-08-23 03:02:28', 42, 0, '0000-00-00 00:00:00', '2010-07-10 20:12:32', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 3, 0, 2, '', '', 1, 3, '', 0, '*', ''),
(14, 112, 'Editors', 'editors', '', '<p>Editors are used thoughout Joomla! where content is created. TinyMCE is the default choice in most locations although CodeMirror is used in the template manager. No Editor provides a text box for html content.</p><p>Default on:</p><ul><li>CodeMirror Help</li><li>TinyMCE Help</li><li>No Editor Help</li></ul><p>Default off:</p><ul><li>None</li></ul>', '', 1, 0, 0, 25, '2010-07-10 20:26:06', 42, 'Joomla!', '2010-08-23 02:58:49', 42, 0, '0000-00-00 00:00:00', '2010-07-10 20:26:06', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 4, 0, 5, '', '', 1, 3, '', 0, '*', ''),
(15, 113, 'Editors-xtd', 'editors-xtd', '', '<p>These plugins are behind the buttons found beneath your editor. They only run when an editor plugin runs.</p><p>Default on:</p><ul><li>Editor Button: Image</li><li>Editor Button: Readmore</li><li>Editor Button: Page Break</li><li>Editor Button: Article</li></ul><p>Default off:</p><ul><li>None</li></ul>', '', 1, 0, 0, 25, '2010-07-10 20:27:20', 42, 'Joomla!', '2010-08-23 02:58:49', 42, 0, '0000-00-00 00:00:00', '2010-07-10 20:27:20', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 0, 6, '', '', 1, 2, '', 0, '*', ''),
(16, 114, 'Feed Display', 'feed-display', '', '<p>This module allows the displaying of a syndicated feed. <a href="http://docs.joomla.org/Help15:Screen.modulessite.edit.15#Feed_Display" title="Feed Display Module">Help</a></p><p>{loadposition feeddisplayload}</p>', '', 1, 0, 0, 66, '2010-07-10 20:29:29', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 0, 2, '', '', 1, 5, '', 0, '*', ''),
(17, 115, 'First Blog Post', 'first-blog-post', '', '<p><em>Lorem Ipsum is filler text that is commonly used by designers before the content for a new site is ready.</em></p><p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed faucibus purus vitae diam posuere nec eleifend elit dictum. Aenean sit amet erat purus, id fermentum lorem. Integer elementum tristique lectus, non posuere quam pretium sed. Quisque scelerisque erat at urna condimentum euismod. Fusce vestibulum facilisis est, a accumsan massa aliquam in. In auctor interdum mauris a luctus. Morbi euismod tempor dapibus. Duis dapibus posuere quam. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. In eu est nec erat sollicitudin hendrerit. Pellentesque sed turpis nunc, sit amet laoreet velit. Praesent vulputate semper nulla nec varius. Aenean aliquam, justo at blandit sodales, mauris leo viverra orci, sed sodales mauris orci vitae magna.</p>', '<p>Quisque a massa sed libero tristique suscipit. Morbi tristique molestie metus, vel vehicula nisl ultrices pretium. Sed sit amet est et sapien condimentum viverra. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Phasellus viverra tortor porta orci convallis ac cursus erat sagittis. Vivamus aliquam, purus non luctus adipiscing, orci urna imperdiet eros, sed tincidunt neque sapien et leo. Cras fermentum, dolor id tempor vestibulum, neque lectus luctus mauris, nec congue tellus arcu nec augue. Nulla quis mi arcu, in bibendum quam. Sed placerat laoreet fermentum. In varius lobortis consequat. Proin vulputate felis ac arcu lacinia adipiscing. Morbi molestie, massa id sagittis luctus, sem sapien sollicitudin quam, in vehicula quam lectus quis augue. Integer orci lectus, bibendum in fringilla sit amet, rutrum eget enim. Curabitur at libero vitae lectus gravida luctus. Nam mattis, ligula sit amet vestibulum feugiat, eros sem sodales mi, nec dignissim ante elit quis nisi. Nulla nec magna ut leo convallis sagittis ac non erat. Etiam in augue nulla, sed tristique orci. Vestibulum quis eleifend sapien.</p><p>Nam ut orci vel felis feugiat posuere ut eu lorem. In risus tellus, sodales eu eleifend sed, imperdiet id nulla. Nunc at enim lacus. Etiam dignissim, arcu quis accumsan varius, dui dui faucibus erat, in molestie mauris diam ac lacus. Sed sit amet egestas nunc. Nam sollicitudin lacinia sapien, non gravida eros convallis vitae. Integer vehicula dui a elit placerat venenatis. Nullam tincidunt ligula aliquet dui interdum feugiat. Maecenas ultricies, lacus quis facilisis vehicula, lectus diam consequat nunc, euismod eleifend metus felis eu mauris. Aliquam dapibus, ipsum a dapibus commodo, dolor arcu accumsan neque, et tempor metus arcu ut massa. Curabitur non risus vitae nisl ornare pellentesque. Pellentesque nec ipsum eu dolor sodales aliquet. Vestibulum egestas scelerisque tincidunt. Integer adipiscing ultrices erat vel rhoncus.</p><p>Integer ac lectus ligula. Nam ornare nisl id magna tincidunt ultrices. Phasellus est nisi, condimentum at sollicitudin vel, consequat eu ipsum. In venenatis ipsum in ligula tincidunt bibendum id et leo. Vivamus quis purus massa. Ut enim magna, pharetra ut condimentum malesuada, auctor ut ligula. Proin mollis, urna a aliquam rutrum, risus erat cursus odio, a convallis enim lectus ut lorem. Nullam semper egestas quam non mattis. Vestibulum venenatis aliquet arcu, consectetur pretium erat pulvinar vel. Vestibulum in aliquet arcu. Ut dolor sem, pellentesque sit amet vestibulum nec, tristique in orci. Sed lacinia metus vel purus pretium sit amet commodo neque condimentum.</p><p>Aenean laoreet aliquet ullamcorper. Nunc tincidunt luctus tellus, eu lobortis sapien tincidunt sed. Donec luctus accumsan sem, at porttitor arcu vestibulum in. Sed suscipit malesuada arcu, ac porttitor orci volutpat in. Vestibulum consectetur vulputate eros ut porttitor. Aenean dictum urna quis erat rutrum nec malesuada tellus elementum. Quisque faucibus, turpis nec consectetur vulputate, mi enim semper mi, nec porttitor libero magna ut lacus. Quisque sodales, leo ut fermentum ullamcorper, tellus augue gravida magna, eget ultricies felis dolor vitae justo. Vestibulum blandit placerat neque, imperdiet ornare ipsum malesuada sed. Quisque bibendum quam porta diam molestie luctus. Sed metus lectus, ornare eu vulputate vel, eleifend facilisis augue. Maecenas eget urna velit, ac volutpat velit. Nam id bibendum ligula. Donec pellentesque, velit eu convallis sodales, nisi dui egestas nunc, et scelerisque lectus quam ut ipsum.</p>', 1, 0, 0, 27, '2010-07-10 20:31:31', 42, '', '2010-07-10 20:34:02', 42, 0, '0000-00-00 00:00:00', '2010-07-10 20:33:58', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 4, 0, 0, '', '', 1, 8, '', 0, '*', ''),
(18, 116, 'Second Blog Post', 'second-blog-post', '', '<p><em>Lorem Ipsum is text that is traditionally used by designers when working on a site before the content is ready.</em></p><p>Pellentesque bibendum metus ut dolor fermentum ut pulvinar tortor hendrerit. Nam vel odio vel diam tempus iaculis in non urna. Curabitur scelerisque, nunc id interdum vestibulum, felis elit luctus dui, ac dapibus tellus mauris tempus augue. Duis congue facilisis lobortis. Phasellus neque erat, tincidunt non lacinia sit amet, rutrum vitae nunc. Sed placerat lacinia fermentum. Integer justo sem, cursus id tristique eget, accumsan vel sapien. Curabitur ipsum neque, elementum vel vestibulum ut, lobortis a nisl. Fusce malesuada mollis purus consectetur auctor. Morbi tellus nunc, dapibus sit amet rutrum vel, laoreet quis mauris. Aenean nec sem nec purus bibendum venenatis. Mauris auctor commodo libero, in adipiscing dui adipiscing eu. Praesent eget orci ac nunc sodales varius.</p>', '<p>Nam eget venenatis lorem. Vestibulum a interdum sapien. Suspendisse potenti. Quisque auctor purus nec sapien venenatis vehicula malesuada velit vehicula. Fusce vel diam dolor, quis facilisis tortor. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Pellentesque libero nisi, pellentesque quis cursus sit amet, vehicula vitae nisl. Curabitur nec nunc ac sem tincidunt auctor. Phasellus in mattis magna. Donec consequat orci eget tortor ultricies rutrum. Mauris luctus vulputate molestie. Proin tincidunt vehicula euismod. Nam congue leo non erat cursus a adipiscing ipsum congue. Nulla iaculis purus sit amet turpis aliquam sit amet dapibus odio tincidunt. Ut augue diam, congue ut commodo pellentesque, fermentum mattis leo. Sed iaculis urna id enim dignissim sodales at a ipsum. Quisque varius lobortis mollis. Nunc purus magna, pellentesque pellentesque convallis sed, varius id ipsum. Etiam commodo mi mollis erat scelerisque fringilla. Nullam bibendum massa sagittis diam ornare rutrum.</p><p>Praesent convallis metus ut elit faucibus tempus in quis dui. Donec fringilla imperdiet nibh, sit amet fringilla velit congue et. Quisque commodo luctus ligula, vitae porttitor eros venenatis in. Praesent aliquet commodo orci id varius. Nulla nulla nibh, varius id volutpat nec, sagittis nec eros. Cras et dui justo. Curabitur malesuada facilisis neque, sed tempus massa tincidunt ut. Sed suscipit odio in lacus auctor vehicula non ut lacus. In hac habitasse platea dictumst. Sed nulla nisi, lacinia in viverra at, blandit vel tellus. Nulla metus erat, ultrices non pretium vel, varius nec sem. Morbi sollicitudin mattis lacus quis pharetra. Donec tincidunt mollis pretium. Proin non libero justo, vitae mattis diam. Integer vel elit in enim varius posuere sed vitae magna. Duis blandit tempor elementum. Vestibulum molestie dui nisi.</p><p>Curabitur volutpat interdum lorem sed tempus. Sed placerat quam non ligula lacinia sodales. Cras ultrices justo at nisi luctus hendrerit. Quisque sit amet placerat justo. In id sapien eu neque varius pharetra sed in sapien. Etiam nisl nunc, suscipit sed gravida sed, scelerisque ut nisl. Mauris quis massa nisl, aliquet posuere ligula. Etiam eget tortor mauris. Sed pellentesque vestibulum commodo. Mauris vitae est a libero dapibus dictum fringilla vitae magna.</p><p>Nulla facilisi. Praesent eget elit et mauris gravida lobortis ac nec risus. Ut vulputate ullamcorper est, volutpat feugiat lacus convallis non. Maecenas quis sem odio, et aliquam libero. Integer vel tortor eget orci tincidunt pulvinar interdum at erat. Integer ullamcorper consequat eros a pellentesque. Cras sagittis interdum enim in malesuada. Etiam non nunc neque. Fusce non ligula at tellus porta venenatis. Praesent tortor orci, fermentum sed tincidunt vel, varius vel dui. Duis pulvinar luctus odio, eget porta justo vulputate ac. Nulla varius feugiat lorem sed tempor. Phasellus pulvinar dapibus magna eget egestas. In malesuada lectus at justo pellentesque vitae rhoncus nulla ultrices. Proin ut sem sem. Donec eu suscipit ipsum. Cras eu arcu porttitor massa feugiat aliquet at quis nisl.</p>', 1, 0, 0, 27, '2010-07-10 20:33:28', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2010-07-10 20:33:28', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 0, 0, '', '', 1, 0, '', 0, '*', ''),
(19, 117, 'Footer Module', 'footer-module', '', '<p>This module shows the Joomla! copyright information. <a href="http://docs.joomla.org/Help15:Screen.modulessite.edit.15#Footer" title="Footer Module">Help</a></p><p>{loadposition footerload}</p>', '', 1, 0, 0, 66, '2010-07-10 20:53:39', 42, 'Joomla!', '2010-07-10 20:56:22', 42, 0, '0000-00-00 00:00:00', '2010-07-10 20:56:22', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 3, 0, 3, '', '', 1, 2, '', 0, '*', ''),
(20, 118, 'Fruit Shop', 'fruit-shop', '', '<h2>Welcome to the Fruit Shop</h2><p>We sell fruits from around the world. Please use our website to learn more about our business. We hope you will come to our shop and buy some fruit.</p><p ><em>This mini site will show you how you might want to set up a site for a business, in this case one selling fruit. It shows how to use access controls to manage your site content. If you were building a real site, you would might want to extend it with e-commerce, a catalog, mailing lists or other enhancements, many of which are available through the</em><a href="http://extensions.joomla.org"><em> Joomla! Extensions Directory</em></a>.</p><p><em>To understand this site you will probably want to make one user with groups set to customer and one with group set to grower. By logging in with different privileges  you can see how access control works.</em></p>', '', 1, 0, 0, 29, '2010-07-10 20:54:54', 42, 'Fruit Shop Webmaster', '2010-08-23 03:02:28', 42, 0, '0000-00-00 00:00:00', '2010-07-10 20:56:32', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 3, 0, 1, '', '', 1, 4, '', 0, '*', ''),
(21, 119, 'Getting Help', 'getting-help', '', '<p>There are lots of places you can get help with Joomla!.</p><p>In many places you will see the help icon [image]. Click on this for more information about the options and functions of items on your screen.</p><ul><li><a href="http://forum.joomla.org">Support Forums</a></li><li><a href="http://docs.joomla.org">Documentation</a></li><li><a href="http://resources.joomla.org">Professionals</a></li><li><a href="http://shop.joomla.org/amazoncom-bookstores.html">Books</a></li></ul>', '', 1, 0, 0, 19, '2010-07-10 20:55:56', 42, 'Joomla!', '2010-08-23 03:02:28', 42, 0, '0000-00-00 00:00:00', '2010-07-10 20:55:56', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 3, 0, 8, '', '', 1, 10, '', 0, '*', ''),
(22, 120, 'Getting Started', 'getting-started', '', '<p>It''s easy to get started creating your website. Knowing some of the basics will help.</p><h3>What is a Content Management System?</h3><p>A content management system is software that allows you to create and manage webpages easily by separating the creation of your content from the mechanics required to present it on the web.</p><p>In this site, the content is stored in a <em>database</em>. The look and feel are created by a <em>template</em>. The Joomla! software brings together the template and the content to create web pages.</p><h3>Site and Administrator</h3><p>Your site actually has two separate sites. The site (also called the front end) is what visitors to your site will see.  The administrator (also called the back end) is only used by people managing your site. You can access the administrator by clicking the "Site Administrator" link on the "This Site" menu or by adding /administrator to the end of you domain name.</p><p>Log in to the administrator using the username and password created during the installation of Joomla!.</p><h3>Logging in</h3><p>To login to the front end of your site use the login form or the login menu link on the "This Site" menu. Use the user name an password that were created as part of the installation process. Once logged in you will be able to create and edit articles.</p><p>In managing your site, you will be able to create content that only logged in users are able to see.</p><h3>Creating an article</h3><p>Once you are logged in, a new menu will be visible.  To create a new article, click on the "submit article" link on that menu.</p><p>The new article interface gives you a lot of options, but all you need to do is add a title an put something in the content area. To make it easy to find, set the state to published an put it in the Joomla! category.</p><div>You can edit an existing article by  clicking on the edit icon (if available).</div><h3>Learn more</h3><p>There is much more to learn about how to use Joomla! to create the web site you envision. You can learn much more at the <a href="http://docs.joomla.org">Joomla! documentation site</a> and on the<a href="http://forum.joomla.org"> Joomla! forums</a>.</p>', '', 1, 0, 0, 19, '2010-07-10 20:57:51', 42, 'Joomla!', '2010-08-23 03:02:28', 42, 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 0, 9, '', '', 1, 9, '', 0, '*', ''),
(23, 121, 'Happy Orange Orchard', 'happy-orange-orchard', '', '<p>At our orchard we grow the world''s best oranges as well as other citrus fruit such as lemons and grapefruit. Our family has been tending this orchard for generations.</p>', '', 1, 0, 0, 30, '2010-07-10 20:58:46', 42, 'Fruit Shop Webmaster', '2010-08-23 03:02:28', 42, 0, '0000-00-00 00:00:00', '2010-07-10 20:58:46', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 0, 2, '', '', 1, 1, '', 0, '*', ''),
(24, 122, 'Joomla!', 'joomla', '', '<p>Congratulations! You have a Joomla! site! Joomla! makes your site easy to build a website just the way you want it and keep it simple to update and maintain.</p>\r\n<p>Joomla! is a flexible and powerful platform, whether you are building a small site for yourself or a huge site with hundreds of thousands of visitors. Joomla is open source, which means you can make it work just the way you want it to.</p>', '', 0, 0, 0, 19, '2010-07-10 21:00:06', 42, 'Joomla!', '2010-09-14 04:49:09', 42, 0, '0000-00-00 00:00:00', '2010-07-10 21:00:06', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 4, 0, 2, '', '', 1, 5, '', 1, '*', ''),
(25, 123, 'Koala', 'koala', '', '<p><img src="images/sampledata/parks/animals/180px_koala_ag1.jpg" border="0" alt="Koala  Thumbnail" width="180" height="123" style="vertical-align: middle; border: 0;" /></p>', '<p><img src="images/sampledata/parks/animals/800px_koala_ag1.jpg" border="0" alt="Koala Climbing Tree" width="500" height="341" style="vertical-align: middle; border: 0;" /></p><p> </p><p> </p><p class="caption">Source: http://commons.wikimedia.org/wiki/File:Koala-ag1.jpg</p><p class="caption">Author: Arnaud Gaillard</p><p><span class="caption">License: Creative Commons Share Alike Attribution Generic 1.0</span></p>', 1, 0, 0, 72, '2010-07-10 21:02:10', 42, 'Parks Webmaster', '2010-08-23 03:00:39', 42, 0, '0000-00-00 00:00:00', '2010-07-10 21:02:28', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 3, 0, 2, '', '', 1, 0, '', 0, '*', ''),
(26, 124, 'Language Switcher', 'language-switcher', '', '<p>The language switcher module allows you to take advantage of the language tags that are available when content, modules and menu links are created.</p><p>This module displays a list of available Content Languages for switching between them.</p><p>When switching languages, it redirects to the Home page defined for the chosen language. Thereafter, the navigation will be the one defined for that language.</p><p><strong>The language filter plugin must be enabled for this module to work properly.</strong></p><p><strong></strong> <a href="http://docs.joomla.org/Help15:Screen.modulessite.edit.15#Language_Switcher" title="Language Switcher Module">Help</a></p><p>To view an example of the language switch moduler module, go to the site administrator and enable the language filter plugin and the language switcher module labellled "language switcher" and visit the fruit shop or park sample sites. Then follow<a href="http://docs.joomla.org/Language_Switcher_Tutorial_for_Joomla_1.6"> the instructions in this tutorial</a>.</p>', '', 1, 0, 0, 67, '2010-07-10 21:07:16', 42, 'Joomla!', '2010-08-23 02:58:49', 42, 0, '0000-00-00 00:00:00', '2010-07-10 21:07:16', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 0, 3, '', '', 1, 3, '', 0, '*', ''),
(27, 125, 'Latest Articles Module', 'latest-articles-module', '', '<p>This Module shows a list of the most recently published and current Articles. Some that are shown may have expired even though they are the most recent. <a href="http://docs.joomla.org/Help15:Screen.modulessite.edit.15#Latest_News" title="Latest Articles">Help</a></p>\r\n<p>{loadposition articleslatestload}</p>', '', 1, 0, 0, 64, '2010-07-10 21:08:42', 42, '', '2010-09-14 11:21:33', 42, 0, '0000-00-00 00:00:00', '2010-09-14 11:21:23', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","page_title":"","alternative_readmore":"","layout":""}', 4, 0, 1, 'modules, content', '', 1, 5, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(28, 126, 'Login Module', 'login-module', '', '<p>This module displays a username and password login form. It also displays a link to retrieve a forgotten password. If user registration is enabled (in the Global Configuration settings), another link will be shown to enable self-registration for users. <a href="http://docs.joomla.org/Help15:Screen.modulessite.edit.15#Login" title="Login">Help</a></p><p>{loadposition loginload}</p>', '', 1, 0, 0, 65, '2010-07-10 21:10:16', 42, 'Joomla!', '2010-08-23 02:58:49', 42, 0, '0000-00-00 00:00:00', '2010-07-10 21:10:16', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 3, 0, 2, '', '', 1, 4, '', 0, '*', ''),
(29, 127, 'Menu Module', 'menu-module', '', '<p>This module displays a menu on the site (frontend).  Menus can be displayed in a wide variety of ways by using the menu options and css menu styles.</p>\r\n<p>{loadposition menuload}</p>', '', 1, 0, 0, 75, '2010-07-10 21:21:52', 42, 'Joomla!', '2010-08-23 03:02:54', 42, 0, '0000-00-00 00:00:00', '2010-07-11 14:59:41', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 3, 0, 1, '', '', 1, 3, '', 0, '*', ''),
(30, 128, 'Most Read Content', 'most-read-content', '', '<p>This Module shows a list of the currently published Articles which have the highest number of page views. <a href="http://docs.joomla.org/Help15:Screen.modulessite.edit.15#Most_Read_Content" title="Most Read Content">Help</a></p>\r\n<p>{loadposition articlespopularload}</p>', '', 1, 0, 0, 64, '2010-07-10 21:25:23', 42, 'Joomla!', '2010-09-14 11:21:05', 42, 0, '0000-00-00 00:00:00', '2010-07-10 21:25:23', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","page_title":"","alternative_readmore":"","layout":""}', 5, 0, 2, 'modules, content', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(31, 129, 'News Flash', 'news-flash', '', '<p>Displays a set number of articles from a category based on date or random selection. <a href="http://docs.joomla.org/Help15:Screen.modulessite.edit.15#NewsFlash" title="News Flash Module">Help</a></p>\r\n<p>{loadposition newsflashload}</p>', '', 1, 0, 0, 64, '2010-07-10 21:28:50', 42, '', '2010-09-14 11:20:50', 42, 0, '0000-00-00 00:00:00', '2010-09-14 11:20:50', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","page_title":"","alternative_readmore":"","layout":""}', 3, 0, 3, 'modules, content', '', 1, 3, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(32, 130, 'Parameters', 'parameters', '', '<p>As you make your Joomla! site using the extension you will control the details of the display using <em>parameter</em><strong>s</strong>. Parameters control everything from whether the author''s name is displayed to who can view what to the number of items shown on a list.</p><p>Default parameters for each components are changed using the Options button on the component toolbar.</p><p>Parameters can also be set on an individual item, such as an article or contact and in menu links.</p><p>If you are happy with how your site looks, it is fine to leave all of the parameters set to the defaults that were created when your site was installed. As you become more experienced with Joomla! you will use parameters more.</p><p> </p>', '', 1, 0, 0, 19, '2010-07-10 21:35:48', 42, 'Joomla!', '2010-08-23 03:02:28', 42, 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 0, 10, '', '', 1, 16, '', 0, '*', ''),
(33, 131, 'Phyllopteryx', 'phyllopteryx', '', '<p><img src="images/sampledata/parks/animals/200px_phyllopteryx_taeniolatus1.jpg" border="0" style="vertical-align: middle;" /></p><p> </p>', '<p><img src="images/sampledata/parks/animals/800px_phyllopteryx_taeniolatus1.jpg" border="0" style="vertical-align: middle;" /></p><p> </p><p>Source: http://en.wikipedia.org/wiki/File:Phyllopteryx_taeniolatus1.jpg</p><p>Author: Richard Ling</p><p>License: GNU Free Documentation License v 1.2 or later</p>', 1, 0, 0, 72, '2010-07-10 21:37:12', 42, 'Parks Webmaster', '2010-08-23 03:00:39', 42, 0, '0000-00-00 00:00:00', '2010-07-10 21:37:12', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 0, 3, '', '', 1, 0, '', 0, '*', ''),
(34, 132, 'Pinnacles', 'pinnacles', '', '<p><img src="images/sampledata/parks/landscape/120px_pinnacles_western_australia.jpg" border="0" alt="Kings Canyon" width="120" height="90" style="vertical-align: middle; border: 0;" /></p>', '<p><img src="images/sampledata/parks/landscape/800px_pinnacles_western_australia.jpg" border="0" alt="King''s Canyon" width="500" height="374" style="vertical-align: middle; border: 0;" /></p><p> </p><p class="caption">Source: http://commons.wikimedia.org/wiki/File:Pinnacles_Western_Australia.jpg</p><p class="caption">Author: <a class="new" href="http://commons.wikimedia.org/w/index.php?title=User:Markdoe&action=edit&redlink=1" title="User:Markdoe (page does not exist)"></a>Martin Gloss</p><p class="caption">License: GNU Free Documentation license v 1.2 or later.</p>', 1, 0, 0, 73, '2010-07-10 21:38:36', 42, 'Parks Webmaster', '2010-08-23 02:58:49', 42, 0, '0000-00-00 00:00:00', '2010-07-11 07:21:29', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 3, 0, 4, '', '', 1, 1, '', 0, '*', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `title_alias`, `introtext`, `fulltext`, `state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(35, 133, 'Professionals', 'professionals', '', '<p>Joomla! 1.6 continues development of the Joomla Framework and CMS as a powerful and flexible way to bring your vision of the web to reality. With the administrator now fully MVC, the ability to control its look and the management of extensions is now complete.</p>', '<p>Working with multiple template styles and overrides for the same views, creating the design you want is easier than it has ever been. Limiting support to PHP 5.x and above and ending legacy support for Joomla 1.0 extensions makes Joomla! lighter and faster than ever. Languages files can now be overridden without having your changes lost during an upgrade.  With the proper xml your users update extensions with a single click.</p><p>Access control lists are now incorporated using a new system developed for Joomla!. The ACL system is designed with developers in mind, so it is easy to incorporate into your extensions. The new nested sets libraries allow you to incorporate infinitely deep categories but also to use nested sets in a variety of other ways.</p><p>A new forms library makes creating all kinds of user interaction simple. MooTools 1.2 provides a highly flexible javascript framework that is a major advance over MooTools 1.0.</p><p>New events throughout the core make integration of your plugins where you want them a snap.</p><p>Learn about:</p><ul><li>[Working with ACL] </li><li>[Working with nested categories] </li><li>[Using the forms library] </li><li>[Working with Mootools 1.2] </li><li>[Using the override system] </li><li>[Joomla! API]</li><li>[Using JDatabaseQuery] </li><li>[Triggers] </li><li>[Xmlrpc] </li><li>[Installing and updating extensions]</li><li>[Setting up your development environment]</li></ul>', 0, 0, 0, 19, '2010-07-10 21:47:11', 42, 'Joomla!', '2010-08-23 03:02:28', 42, 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 3, 0, 6, '', '', 1, 1, '', 1, '*', ''),
(36, 134, 'Random Image Module', 'random-image-module', '', '<p>This Module displays a random image from your chosen image directory. <a href="http://docs.joomla.org/Help15:Screen.modulessite.edit.15#Random_Image" title="Random Image Module">Help</a></p><p>{loadposition randomimageload}</p>', '', 1, 0, 0, 66, '2010-07-10 21:51:54', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 0, 4, '', '', 1, 2, '', 0, '*', ''),
(37, 135, 'Related Items Module', 'related-items-module', '', '<p>This Module displays other Articles that are related to the one currently being viewed. These relations are established by the Meta Keywords.  All the keywords of the current Article are searched against all the keywords of all other published articles. <a href="http://docs.joomla.org/Help15:Screen.modulessite.edit.15#Related_Articles" title="Related Items Module">Help</a></p>\r\n<p>{loadposition relateditemsload}</p>', '', 1, 0, 0, 64, '2010-07-10 21:53:14', 42, 'Joomla!', '2010-09-14 11:23:07', 42, 0, '0000-00-00 00:00:00', '2010-09-14 11:23:07', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","page_title":"","alternative_readmore":"","layout":""}', 3, 0, 4, 'modules, content', '', 1, 4, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(38, 136, 'Sample Sites', 'sample-sites', '', '<p>Your installation includes sample data, designed to show you some of the options you have for building your website. In addition to information about Joomla! there are two sample "sites within a site" designed to help you get started with builidng your own site.</p><p>The first site is a simple site about <a href="index.php?Itemid=243">Australian Parks</a>. It shows you you an quickly and easily build a personal site with just the building blocks that are part of Joomla!. It includes a personal blog, weblinks, and a very simple image gallery.</p><p>The second site is slightly more complex and represents what you might do if you are building a site for a small business, in this case a <a href="index.php/welcome.html"></a><a href="index.php?Itemid=429">Fruit Shop</a>.</p><p>In building either style site, or something completely different, you will probably want to add <a href="http://extensions.joomla.org">extensions</a> and either create or purchase your own template. Many Joomla! users start off by modifying the <a href="http://docs.joomla.org/How_do_you_modify_a_template%3F">templates</a> that come with the core distribution so that they include special images and other design elements that relate to their site''s focus.</p>', '', 1, 0, 0, 19, '2010-07-10 21:55:29', 42, 'Joomla!', '2010-08-23 03:02:28', 42, 0, '0000-00-00 00:00:00', '2010-07-10 21:55:41', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 3, 0, 11, '', '', 1, 8, '', 0, '*', ''),
(39, 137, 'Search', 'search-component', '', '<p>The search component proviedes basic search functionality for the information contained in your core components. Many third part extensions also can be searched by the search component. Help</p>', '', 1, 0, 0, 21, '2010-07-10 21:57:00', 42, 'Joomla!', '2010-07-10 23:14:32', 42, 0, '0000-00-00 00:00:00', '2010-07-10 21:57:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 3, 0, 3, '', '', 1, 3, '', 0, '*', ''),
(40, 138, 'Search Module', 'search-module', '', '<p>This module will display a search box. <a href="http://docs.joomla.org/Help15:Screen.modulessite.edit.15#Search" title="Search">Help</a></p><p>{loadposition searchload}</p>', '', 1, 0, 0, 67, '2010-07-10 22:00:58', 42, 'Joomla!', '2010-08-23 02:58:49', 42, 0, '0000-00-00 00:00:00', '2010-07-10 22:00:58', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 0, 4, '', '', 1, 2, '', 0, '*', ''),
(41, 139, 'Search ', 'search-plugin', '', '<p>The search component uses plugins to control which parts of your Joomla! site are searched. You may choose to turn off some areas to improve performance or for other reasons. Many third party Joomla! extensions have search plugins that extend where search takes place.</p><p>Default On:</p><ul><li>Content Help</li><li>Contacts Help</li><li>Weblinks Help</li><li>News Feeds Help</li><li>Categories Help</li></ul>', '', 1, 0, 0, 25, '2010-07-10 22:02:17', 42, 'Joomla!', '2010-07-10 23:15:44', 42, 0, '0000-00-00 00:00:00', '2010-07-10 23:15:44', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 3, 0, 1, '', '', 1, 2, '', 0, '*', ''),
(42, 140, 'Site Map', 'site-map', '', '<p>{loadposition sitemapload}</p><p><em>By putting all of your content into nested categories you can give users and search engines access to everything using a menu.</em></p>', '', 1, 0, 0, 14, '2010-07-10 22:03:35', 42, 'Joomla!', '2010-08-23 02:58:49', 42, 0, '0000-00-00 00:00:00', '2010-07-10 22:03:35', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 0, 1, '', '', 1, 2, '', 0, '*', ''),
(43, 141, 'Spotted Quoll', 'spotted-quoll', '', '<p><img src="images/sampledata/parks/animals/220px_spottedquoll_2005_seanmcclean.jpg" border="0" alt="Spotted Quoll" style="vertical-align: middle; border: 0;" /></p>', '<p><img src="images/sampledata/parks/animals/789px_spottedquoll_2005_seanmcclean.jpg" border="0" alt="Spotted Quoll" style="vertical-align: middle;" /></p><p> </p><p>Source: http://en.wikipedia.org/wiki/File:SpottedQuoll_2005_SeanMcClean.jpg</p><p>Author: Sean McClean</p><p>License: GNU Free Documentation License v 1.2 or later</p>', 1, 0, 0, 72, '2010-07-10 22:04:40', 42, 'Parks Webmaster', '2010-08-23 03:00:39', 42, 0, '0000-00-00 00:00:00', '2010-07-10 22:04:40', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 0, 4, '', '', 1, 0, '', 0, '*', ''),
(44, 142, 'Statistics Module', 'statistics', '', '<p>The Statistics Module shows information about your server installation together with statistics on the Web site users, number of Articles in your database and the number of Web links you provide.</p><p>{loadposition statisticsload}</p>', '', 1, 0, 0, 67, '2010-07-10 22:05:45', 42, 'Joomla!', '2010-08-23 02:58:49', 42, 0, '0000-00-00 00:00:00', '2010-07-10 22:06:09', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 3, 0, 5, '', '', 1, 2, '', 0, '*', ''),
(45, 143, 'Syndicate Module', 'syndicate-module', '', '<p>The syndicate module allows you to display a link that allows users to take a feed from your site. It will only display on pages for which feeds are possible. That means it will not display on single article, contact or weblinks pages, such as this one. <a href="http://docs.joomla.org/Help15:Screen.modulessite.edit.15#Syndicate" title="Synicate Module">Help</a></p><p>{loadposition syndicateload}</p>', '', 1, 0, 0, 67, '2010-07-10 22:07:51', 42, '', '2010-08-23 02:58:49', 42, 0, '0000-00-00 00:00:00', '2010-07-10 22:07:51', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 0, 6, '', '', 1, 3, '', 0, '*', ''),
(46, 144, 'System', 'system', '', '<p>System plugins operate every time a page on your site loads. They control such things as your URLS, whether users can check a "remember me" box on the login module, and whether caching is enabled.  New in 1.6 is the redirect plugin that with the redirect component assist you in managing changes in URLs.</p><p>Default on:</p><ul><li>Remember me Help</li><li>SEF Help</li><li>Debug Help</li></ul><p>Default off:</p><ul><li>Cache Help</li><li>Log Help</li><li>Redirect Help</li></ul>', '', 1, 0, 0, 25, '2010-07-10 22:09:41', 42, 'Joomla!', '2010-07-10 23:15:54', 42, 0, '0000-00-00 00:00:00', '2010-07-10 22:09:41', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 3, 0, 2, '', '', 1, 2, '', 0, '*', ''),
(47, 145, 'The Joomla! Community', 'the-joomla-community', '', '<p>Joomla! means All Together, and it is a community of people all working and having fun together that makes Joomla! possible. Thousands of people each year participate in the Joomla! community, and we hope you will be one of them.<a href="index.php?option=com_content&view=article&catid=40&id=27">Archive Module</a></p><p>People with all kinds of skills, of all skill levels and from around the world are welcome to join in. Participate in the <a href="http://joomla.org">Joomla.org</a> family of websites (the<a href="http://forum.joomla.org"> forum </a>is a great place to start). Come to a <a href="http://community.joomla.org/events.html">Joomla! event</a>. Join or start a <a href="http://community.joomla.org/user-groups.html">Joomla! Users Group</a>. Whether you are a developer, site administrator, designer, end user or fan, there are ways for you to participate and contribute.</p>', '', 1, 0, 0, 19, '2010-07-10 22:11:09', 42, 'Joomla!', '2010-08-23 03:02:28', 42, 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 0, 4, '', '', 1, 37, '', 0, '*', ''),
(48, 146, 'The Joomla! Project', 'the-joomla-project', '', '<p>The Joomla! Project consists of all of the people who make and support the Joomla! Web Platform and Content Management System.</p><p>Our mission is to provide a flexible platform for digital publishing and collaboration.</p><p>The core values are:</p><ul><li>Freedom</li><li>Equality</li><li>Trust</li><li>Community</li><li>Collaboration</li><li>Usability</li></ul><p>In our vision, we see:</p><ul><li>People publishing and collaborating in their communities and around the world</li><li>Software that is free, secure, and high-quality</li><li>A community that is enjoyable and rewarding to participate in</li><li>People around the world using their preferred languages</li><li>A project that acts autonomously</li><li>A project that is socially responsible</li><li>A project dedicated to maintaining the trust of its users</li></ul><p>There are millions of users around the world and thousands of people who contribute to the Joomla! Project. They work in three main groups: the Production Working Group, responsible for everything that goes into software and documentation; the Community Working Group, responsible for creating a nurturing the community; and Open Source Matters, the non profit organization responsible for managing legal, financial and organizational issues.</p><p>Joomla! is a free and open source project, which uses the GNU General Public License version 2 or later.</p>', '', 1, 0, 0, 19, '2010-07-10 22:20:16', 42, '', '2010-08-23 03:02:28', 42, 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 3, 0, 1, '', '', 1, 38, '', 0, '*', ''),
(49, 147, 'Typography', 'typography', '', '<h1>H1 ABCDEFGHIJKLMNOPQRSTUVWXYZ abcdefghijklmonpqrstuvwzyz</h1><h2>H2 ABCDEFGHIJKLMNOPQRSTUVWXYZ abcdefghijklmonpqrstuvwzyz</h2><h3>H3 ABCDEFGHIJKLMNOPQRSTUVWXYZ abcdefghijklmonpqrstuvwzyz</h3><h4>H4 ABCDEFGHIJKLMNOPQRSTUVWXYZ abcdefghijklmonpqrstuvwzyz</h4><h5>H5 ABCDEFGHIJKLMNOPQRSTUVWXYZ abcdefghijklmonpqrstuvwzyz</h5><h6>H6 ABCDEFGHIJKLMNOPQRSTUVWXYZ abcdefghijklmonpqrstuvwzyz</h6><p>P The quick brown fox ran over the lazy dog. THE QUICK BROWN FOX RAN OVER THE LAZY DOG.</p><ul><li>Item</li><li>Item</li><li>Item<br /> <ul><li>Item</li><li>Item</li><li>Item<br /> <ul><li>Item</li><li>Item</li><li>Item</li></ul></li></ul></li></ul><ol><li>tem</li><li>Item</li><li>Item<br /> <ol><li>Item</li><li>Item</li><li>Item<br /><ol><li>Item</li><li>Item</li><li>Item</li></ol></li></ol> </li></ol>', '', -2, 0, 0, 23, '2010-07-10 22:22:26', 42, 'Joomla!', '2010-08-23 02:59:04', 42, 0, '0000-00-00 00:00:00', '2010-07-10 22:22:26', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 0, 1, '', '', 1, 14, '', 0, '*', ''),
(50, 148, 'Upgraders', 'upgraders', '', '<p>If you are an experienced Joomla! 1.5 user, 1.6 will seem very familiar. There are new templates and improved user interfaces, but most functionality is the same. The biggest changes are improved access control (ACL) and nested categories.</p>', '<p>The new user manager which will let you manage who has access to what in your site. You can leave access groups exactly the way you had them in Joomla 1.5 or make them as complicated as you want. You can learn more about<a href="http://docs.joomla.org/ACL_Tutorial_for_Joomla_1.6"> how access control works</a> in on the <a href="http://docs.joomla.org">Joomla! Documentation sit</a></p><p>In Joomla 1.5 and 1.0 content was organized into sections and categories. In 1.6 sections are gone, and you can create categories within categories, going as deep as you want. The sample data provides many examples of the use of nested categories.</p><p>All layouts have been redesigned to improve accessibility and flexibility. If you would like to keep the 1.5 layouts, you can find them in the html folder of the MilkyWay template. Simply copy the layouts you want to the html folder of your template.</p><p>Updating your site and extensions when needed is easier than ever thanks to installer improvements.</p><p>To learn more about how to<a href="http://docs.joomla.org/Migrating_from_1.5_to_1.6"> move a Joomla! 1.5 site to a Joomla! 1.6 installation read this article</a>.</p>', 0, 0, 0, 19, '2010-07-10 22:38:22', 42, '', '2010-08-23 03:02:28', 42, 0, '0000-00-00 00:00:00', '2010-07-10 22:38:22', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 0, 5, '', '', 1, 0, '', 1, '*', ''),
(51, 149, 'User', 'user-plugins', '', '<p>Default on:</p><ul><li>Joomla Help</li></ul><p>Default off:</p><p>Two new plugins are available in 1.6 but are disabled by default.</p><ul><li>Contact Creator Help<br />Creates a new linked contact record for each new user created. </li><li>Profile Help<br />This example profile plugin allows you to insert additional fields into user registration and profile display. This is intended as an example of the types of extensions to the profile you might want to create. </li></ul>', '', 1, 0, 0, 25, '2010-07-10 22:43:34', 42, 'Joomla!', '2010-08-23 02:58:49', 42, 0, '0000-00-00 00:00:00', '2010-07-10 23:16:15', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 3, 0, 4, '', '', 1, 2, '', 0, '*', ''),
(52, 150, 'Users', 'users-component', '', '<p>The users extension lets your site visitors register, login and logout, change their passwords and other information, and recover lost passwords. In the administrator it allows you to create, block and manage users and create user groups and access levels. Help</p>\r\n<p>Please note that some of the user views will not display if you are not logged in to the site.</p>', '', 1, 0, 0, 21, '2010-07-10 22:46:05', 42, 'Joomla!', '2010-08-23 03:00:39', 42, 0, '0000-00-00 00:00:00', '2010-07-10 23:13:53', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 4, 0, 5, '', '', 1, 3, '', 0, '*', ''),
(53, 151, 'Using Joomla!', 'using-joomla', '', '<p>With Joomla! You can create anything from a simple personal website to a complex ecommerce or social site with millions of visitors.</p><p>This section of the sample data provides you with a brief introduction to Joomla! concepts and reference material to help you understand how Joomla! works.</p><p><em>When you not longer need the sample data, you can can simply unpublish the sample data category found within each extension in the site administrator or you may completely delete each item and all of the categories. </em></p>', '', 1, 0, 0, 19, '2010-07-10 23:00:59', 42, 'Joomla!', '2010-08-23 03:02:28', 42, 0, '0000-00-00 00:00:00', '2010-07-10 23:00:59', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 0, 7, '', '', 1, 25, '', 0, '*', ''),
(54, 152, 'Weblinks', 'weblinks', '', '<p>Weblinks (com_weblinks) is a component that provides a structured way to organize external links and present them in a visually attractive, consistent and informative way. Help</p>', '', 1, 0, 0, 21, '2010-07-10 23:02:42', 42, 'Joomla!', '2010-08-23 03:00:39', 42, 0, '0000-00-00 00:00:00', '2010-07-10 23:02:42', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 3, 0, 6, '', '', 1, 10, '', 0, '*', ''),
(55, 153, 'Weblinks Module', 'weblinks-module', '', '<p>This module displays the list of weblinks in a category.  <a href="http://docs.joomla.org/Help15:Screen.modulessite.edit.15#Weblinks" title="Weblinks Module">Help</a></p><p>{loadposition weblinksload}</p>', '', 1, 0, 0, 66, '2010-07-10 23:04:41', 42, 'Joomla!', '2010-08-23 03:00:39', 42, 0, '0000-00-00 00:00:00', '2010-07-10 23:04:41', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 0, 5, '', '', 1, 3, '', 0, '*', ''),
(56, 154, 'Who''s Online', 'whos-online', '', '<p>The Who''s Online Module displays the number of Anonymous Users (e.g. Guests) and Registered Users (ones logged in) that are currently accessing the Web site. <a href="http://docs.joomla.org/Help15:Screen.modulessite.edit.15#Who.27s_Online" title="Who''s Online">Help</a></p><p>{loadposition whosonlineload}</p>', '', 1, 0, 0, 65, '2010-07-10 23:06:16', 42, 'Joomla!', '2010-08-23 02:58:49', 42, 0, '0000-00-00 00:00:00', '2010-07-10 23:06:16', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 0, 1, '', '', 1, 3, '', 0, '*', ''),
(57, 155, 'Wobbegone', 'wobbegone', '', '<p><img src="images/sampledata/parks/animals/180px_wobbegong.jpg" border="0" alt="Wobbegone" style="vertical-align: middle; border: 0;" /></p>', '<p><img src="images/sampledata/parks/animals/800px_wobbegong.jpg" border="0" style="vertical-align: middle; border: 0;" /></p><p>Source: http://en.wikipedia.org/wiki/File:Wobbegong.jpg</p><p>Author: Richard Ling</p><p>Rights: GNU Free Documentation License v 1.2 or later</p>', 1, 0, 0, 72, '2010-07-10 23:07:30', 42, 'Parks Webmaster', '2010-08-23 03:00:39', 42, 0, '0000-00-00 00:00:00', '2010-07-10 23:07:29', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 0, 1, '', '', 1, 0, '', 0, '*', ''),
(58, 156, 'Wonderful Watermelon', 'wonderful-watermelon', '', '<p>Watermelon is a wonderful and healthy treat. We grow the world''s sweetest watermelon. We have the largest watermelon patch in our country.</p>', '', 1, 0, 0, 30, '2010-07-10 23:09:14', 42, 'Fruit Shop Webmaster', '2010-08-23 03:02:28', 42, 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 0, 1, '', '', 1, 0, '', 0, '*', ''),
(59, 157, 'Wrapper Module', 'wrapper-module', '', '<p>This module shows an iFrame window to specified location. <a href="http://docs.joomla.org/Help15:Screen.modulessite.edit.15#Wrapper" title="Wrapper Module">Help</a></p><p>{loadposition wrapperload}</p>', '', 1, 0, 0, 67, '2010-07-10 23:10:10', 42, 'Joomla!', '2010-08-23 02:58:49', 42, 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 0, 1, '', '', 1, 1, '', 0, '*', ''),
(60, 158, 'News Feeds', 'news-feeds', '', '<p>News Feeds (com_newsfeeds) provides a way to organize and present news feeds. News feeds are a way that you present information from another site on your site. For example, the joomla.org website has numerous feeds that you an incorporate on your site. You an use menus to present a single feed, a list of feeds in a category, or or a list of all feed categories. Help</p>', '', 1, 0, 0, 21, '2010-07-11 00:28:23', 42, 'Joomla!', '2010-08-23 03:00:39', 42, 0, '0000-00-00 00:00:00', '2010-07-11 00:28:23', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 0, 4, '', '', 1, 3, '', 0, '*', ''),
(61, 159, 'Breadcrumbs Module', 'breadcrumbs-module', '', '<p>Breadcrumbs provide a pathway for users to navigate through the site. <a href="http://docs.joomla.org/Help15:Screen.modulessite.edit.15#Breadcrumbs" title="Breacrumbs Module">Help</a></p>\r\n<p>{loadposition breadcrumbsload}</p>', '', 1, 0, 0, 75, '2010-07-11 01:30:25', 42, 'Joomla!', '2010-11-15 09:15:41', 42, 0, '0000-00-00 00:00:00', '2010-07-11 01:30:25', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 3, 0, 2, '', '', 1, 3, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(62, 160, 'Content', 'content-plugins', '', '<p>Content plugins run when specific kinds of pages are loaded. They do things ranging from protecting email addresses from harvesters to creating page breaks.</p><p>Default on:</p><ul><li>Email Cloaking Help</li><li>Load Module Help</li><li>Page Break Help</li><li>Page Navigation Help</li><li>Rating Help</li></ul><p>Default off:</p><ul><li>Code Highlighting (Geshi) Help</li></ul>', '', 1, 0, 0, 25, '2010-07-11 06:19:31', 42, 'Joomla!', '2010-08-23 02:58:49', 42, 0, '0000-00-00 00:00:00', '2010-07-11 06:19:31', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 0, 7, '', '', 1, 3, '', 0, '*', ''),
(64, 162, 'Blue Mountain Rain Forest', 'blue-mountain-rain-forest', '', '<p><img src="images/sampledata/parks/landscape/120px_rainforest_bluemountainsnsw.jpg" border="0" alt="Rain Forest Blue Mountrains" /></p>', '<p><img src="images/sampledata/parks/landscape/727px_rainforest_bluemountainsnsw.jpg" border="0" alt="Rain Forest Blue Mountrains" style="vertical-align: middle;" /></p><p> </p><p class="caption">Source: http://commons.wikimedia.org/wiki/File:Rainforest,bluemountainsNSW.jpg</p><p class="caption">Author: Adam J.W.C.</p><p class="caption">License: GNU Free Documentation License</p>', 1, 0, 0, 73, '2010-07-11 07:19:35', 42, 'Parks Webmaster', '2010-08-23 02:58:49', 42, 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 0, 2, '', '', 1, 0, '', 0, '*', ''),
(65, 163, 'Ormiston Pound', 'ormiston-pound', '', '<p><img src="images/sampledata/parks/landscape/180px_ormiston_pound.jpg" border="0" alt="Ormiston Pound" style="border: 0;" /></p>', '<p><img src="images/sampledata/parks/landscape/800px_ormiston_pound.jpg" border="0" alt="Ormiston Pound" height="375" style="vertical-align: middle; border: 0;" /></p><p> </p><p class="caption">Source: http://commons.wikimedia.org/wiki/File:Ormiston_Pound.JPG</p><p class="caption">Author:</p><p class="caption">License: GNU Free Public Documentation License</p>', 1, 0, 0, 73, '2010-07-11 07:21:18', 42, 'Parks Webmaster', '2010-08-23 02:58:49', 42, 0, '0000-00-00 00:00:00', '2010-07-11 07:21:18', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 3, 0, 3, '', '', 1, 0, '', 0, '*', ''),
(66, 165, 'Latest Users Module', 'latest-users-module', '', '<p>This module displays the latest registered users. Help</p>\r\n<p>{loadposition userslatestload}</p>', '', 1, 0, 0, 65, '2010-07-11 13:54:30', 42, 'Joomla!', '2010-08-23 02:58:49', 42, 0, '0000-00-00 00:00:00', '2010-07-11 13:55:19', '0000-00-00 00:00:00', '', '', '{"show_title":"1","link_titles":"","show_intro":"","show_category":"1","link_category":"1","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 3, 0, 3, '', '', 1, 4, '', 0, '*', ''),
(67, 168, 'What''s New in 1.5?', 'whats-new-in-15', '', '<p>As with previous releases, Joomla! provides a unified and easy-to-use framework for delivering content for Web sites of all kinds. To support the changing nature of the Internet and emerging Web technologies, Joomla! required substantial restructuring of its core functionality and we also used this effort to simplify many challenges within the current user interface. Joomla! 1.5 has many new features.</p>\r\n<p style="margin-bottom: 0in;">In Joomla! 1.5, you''''ll notice:</p>\r\n<ul>\r\n<li>Substantially improved usability, manageability, and scalability far beyond the original Mambo foundations</li>\r\n<li>Expanded accessibility to support internationalisation, double-byte characters and right-to-left support for Arabic, Farsi, and Hebrew languages among others</li>\r\n<li>Extended integration of external applications through Web services</li>\r\n<li>Enhanced content delivery, template and presentation capabilities to support accessibility standards and content delivery to any destination</li>\r\n<li>A more sustainable and flexible framework for Component and Extension developers</li>\r\n<li>Backward compatibility with previous releases of Components, Templates, Modules, and other Extensions</li>\r\n</ul>', '', 2, 0, 0, 9, '2010-08-23 00:35:57', 42, 'Joomla! 1.5', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 1, 0, 0, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(68, 177, 'Avatar', 'avatar', '', '<p><img class="caption" src="images/stories/demo/sam-1.jpg" border="0" alt="Demo image" align="left" /></p>\r\n<p>Lorem ipsum dolor sit amet consectetuer urna quis vel convallis  tincidunt. Nam in sed ultrices tristique mi non ut facilisi id non. Et  Sed egestas tristique lacinia nibh ridiculus <a href="http://dev.joomlart.com/jadev2_data/sites/auto/qs.anion.1291867237/" title="Sample link">adipiscing faucibus amet sed</a> Condimentum Nam iaculis Nam tincidunt.</p>\r\n', '\r\n<p>Lorem ipsum dolor sit amet consectetuer urna quis vel convallis  tincidunt. Nam in sed ultrices tristique mi non ut facilisi id non. Et  Sed egestas tristique lacinia nibh ridiculus adipiscing faucibus amet  sed. Lacinia consectetuer Donec Vestibulum dui Duis ligula at amet Morbi  nonummy. Laoreet Lorem sapien tincidunt auctor In mauris id Suspendisse  risus id. Et non gravida vel nibh.</p>\r\n<p>Laoreet magnis in Proin felis in venenatis Sed nunc sapien  condimentum. Vestibulum Morbi id Nam tellus Quisque nunc nunc ut Morbi  Aenean. Suspendisse et tellus vitae In Nam platea aliquet tincidunt nisl  vitae. Suscipit felis orci dui Nam Sed orci wisi vitae velit urna.  Sagittis nunc id Aliquam Vivamus cursus consectetuer vel quis sed  pellentesque. Justo Aliquam risus Nam tellus risus Quisque Quisque  augue.</p>\r\n<p>Sed dui Praesent nibh Curabitur ipsum nunc facilisi risus elit eget.  Pharetra commodo elit nulla suscipit nunc eros nec lacus odio tortor.  Suscipit semper felis Integer dui porttitor ac eu consequat id metus.  Dui Cras congue ac ante et Nam nunc tempus habitant quis. Tincidunt elit  sollicitudin risus ut libero In justo fames elit facilisi. Lorem Aenean  vitae lacus vel semper laoreet aliquet turpis.</p>\r\n<h3>Pharetra commodo elit nulla suscipit</h3>\r\n<ul>\r\n<li><strong>Step 1: </strong>Nam in sed ultrices tristique</li>\r\n<li><strong>Step 2: </strong>Tortor turpis justo nulla tempus</li>\r\n<li><strong>Step 3: </strong>Dolor orci In Aenean Aenean Sed tellus</li>\r\n<li><strong>Step 4: </strong>Lorem vitae quis gravida dapibus nibh felis malesuada non tristique.</li>\r\n<li><strong>Step 5: </strong>At penatibus leo laoreet tempus.</li>\r\n</ul>\r\n<p>Tortor turpis justo nulla tempus sem consequat id sed elit tincidunt.  Dolor orci In Aenean Aenean Sed tellus Pellentesque Pellentesque mauris  Cum. Lorem lacinia felis Quisque elit Vestibulum pellentesque amet wisi  Curabitur In. Aliquam Lorem vitae quis gravida dapibus nibh felis  malesuada non tristique. Elit Phasellus dui feugiat mauris dictum  hendrerit tincidunt volutpat purus id. At penatibus leo laoreet tempus.</p>', 1, 0, 0, 78, '2010-12-09 22:26:59', 42, '', '2010-12-10 18:56:32', 42, 0, '0000-00-00 00:00:00', '2010-12-09 22:26:59', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 4, '', '', 1, 151, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(69, 178, 'Who we are ?', 'who-we-are', '', '<p><img class="caption noborder" src="images/stories/demo/sam-1.png" border="0" alt="Demo image" align="right" /></p>\r\n<p>Ante at metus vitae vitae habitant In justo Pellentesque sapien ipsum. Ipsum Pellentesque Donec fermentum feugiat gravida.</p>\r\n', '\r\n<p>Congue Vestibulum Curabitur quis Suspendisse accumsan egestas et orci  convallis id. Malesuada lobortis eu adipiscing sit est In dictumst  dignissim id velit. Nec amet vel et Vivamus vestibulum eu convallis  laoreet lobortis lacinia. Aenean eget amet Suspendisse Nulla id felis at  risus Curabitur lobortis. Risus accumsan ac malesuada tincidunt neque  Sed fermentum Vivamus.</p>\r\n<p>Pellentesque pretium Ut congue tellus consectetuer nisl orci Vivamus a  vel. Et Duis elit nisl at egestas dolor Fusce porttitor sagittis dui.  Eros felis ornare ipsum a adipiscing urna aliquet semper augue  Pellentesque. Id turpis mauris sociis natoque lacus lacus nec sem id  parturient. Lorem Phasellus habitant tincidunt Praesent adipiscing ut  neque Phasellus ipsum.</p>', 1, 0, 0, 9, '2010-12-09 22:29:50', 42, '', '2011-01-11 04:25:22', 42, 0, '0000-00-00 00:00:00', '2010-12-09 22:29:50', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 3, 0, 3, '', '', 1, 6, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(70, 179, 'Clash of Titans coz'' J! 2.5 template ', 'clash-of-titans-coz-j-2-5-template', '', '<p><img class="caption" src="images/stories/demo/sam-2.jpg" border="0" alt="Demo image" align="left" /></p>\r\n<p>Even knowing the technique is important in this kind of design, is more about creativity and experimentation. You will learn how to use the Art History Brush and combine it with watercolor custom. Tellus turpis mauris dui euismod sit nibh id at semper vitae.</p>\r\n', '\r\n<p>Lorem ipsum dolor sit amet consectetuer urna quis vel convallis tincidunt. Nam in sed ultrices tristique mi non ut facilisi id non. Et Sed egestas tristique lacinia nibh ridiculus adipiscing faucibus amet sed. Lacinia consectetuer Donec Vestibulum dui Duis ligula at amet Morbi nonummy. Laoreet Lorem sapien tincidunt auctor In mauris id Suspendisse risus id. Et non gravida vel nibh.</p>\r\n<p>Laoreet magnis in Proin felis in venenatis Sed nunc sapien condimentum. Vestibulum Morbi id Nam tellus Quisque nunc nunc ut Morbi Aenean. Suspendisse et tellus vitae In Nam platea aliquet tincidunt nisl vitae. Suscipit felis orci dui Nam Sed orci wisi vitae velit urna. Sagittis nunc id Aliquam Vivamus cursus consectetuer vel quis sed pellentesque. Justo Aliquam risus Nam tellus risus Quisque Quisque augue.</p>\r\n<p>Sed dui Praesent nibh Curabitur ipsum nunc facilisi risus elit eget. Pharetra commodo elit nulla suscipit nunc eros nec lacus odio tortor. Suscipit semper felis Integer dui porttitor ac eu consequat id metus. Dui Cras congue ac ante et Nam nunc tempus habitant quis. Tincidunt elit sollicitudin risus ut libero In justo fames elit facilisi. Lorem Aenean vitae lacus vel semper laoreet aliquet turpis.</p>\r\n<p>Tortor turpis justo nulla tempus sem consequat id sed elit tincidunt. Dolor orci In Aenean Aenean Sed tellus Pellentesque Pellentesque mauris Cum. Lorem lacinia felis Quisque elit Vestibulum pellentesque amet wisi Curabitur In. Aliquam Lorem vitae quis gravida dapibus nibh felis malesuada non tristique. Elit Phasellus dui feugiat mauris dictum hendrerit tincidunt volutpat purus id. At penatibus leo laoreet tempus.</p>', 1, 0, 0, 78, '2010-12-09 22:30:55', 42, '', '2012-02-10 07:02:14', 42, 0, '0000-00-00 00:00:00', '2010-12-09 22:30:55', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 4, 0, 2, 'film   2.5 Joomla template, movie   2.5 template Joomla, DVD   2.5 Joomla template, template   2.5 actor Joomla, trailer   2.5 template Joomla, 3D film', 'Installation of Joomla 2.5 templates for hottest films', 1, 19, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(71, 180, 'Iron Man says Joomla 2.5 is No 1', 'iron-man-says-joomla-2-5-is-no-1', '', '<p><img class="caption" src="images/stories/demo/sam-3.jpg" border="0" alt="Source: joomlart.com" align="left" /></p>\r\n<p>In id, mauris viverra asperiores, bibendum in id. Eu molestie. Uc sit eu. Id iaculis id, pulvinar ut imperdiet. Gravida vivamus adipiscing, vitae ut ac, neque venenatis cras tincidunt, ut tellus et. Gravida scelerisque. Tellus turpis mauris dui euismod sit nibh id at semper vitae.</p>\r\n', '\r\n<p>Lorem ipsum dolor sit amet consectetuer urna quis vel convallis tincidunt. Nam in sed ultrices tristique mi non ut facilisi id non. Et Sed egestas tristique lacinia nibh ridiculus adipiscing faucibus amet sed. Lacinia consectetuer Donec Vestibulum dui Duis ligula at amet Morbi nonummy. Laoreet Lorem sapien tincidunt auctor In mauris id Suspendisse risus id. Et non gravida vel nibh.</p>\r\n<p>Laoreet magnis in Proin felis in venenatis Sed nunc sapien condimentum. Vestibulum Morbi id Nam tellus Quisque nunc nunc ut Morbi Aenean. Suspendisse et tellus vitae In Nam platea aliquet tincidunt nisl vitae. Suscipit felis orci dui Nam Sed orci wisi vitae velit urna. Sagittis nunc id Aliquam Vivamus cursus consectetuer vel quis sed pellentesque. Justo Aliquam risus Nam tellus risus Quisque Quisque augue.</p>\r\n<p>Sed dui Praesent nibh Curabitur ipsum nunc facilisi risus elit eget. Pharetra commodo elit nulla suscipit nunc eros nec lacus odio tortor. Suscipit semper felis Integer dui porttitor ac eu consequat id metus. Dui Cras congue ac ante et Nam nunc tempus habitant quis. Tincidunt elit sollicitudin risus ut libero In justo fames elit facilisi. Lorem Aenean vitae lacus vel semper laoreet aliquet turpis.</p>\r\n<h3>This is an Heading 3</h3>\r\n<ul>\r\n<li>Laoreet magnis in Proin felis</li>\r\n<li>Lorem ipsum dolor sit amet consectetuer urna quis vel convallis tincidunt.</li>\r\n<li>Tortor turpis justo nulla tempus sem consequat</li>\r\n<li>Tincidunt elit sollicitudin risus ut libero In justo fames elit facilisi.</li>\r\n</ul>\r\n<p>Tortor turpis justo nulla tempus sem consequat id sed elit tincidunt. Dolor orci In Aenean Aenean Sed tellus Pellentesque Pellentesque mauris Cum. Lorem lacinia felis Quisque elit Vestibulum pellentesque amet wisi Curabitur In. Aliquam Lorem vitae quis gravida dapibus nibh felis malesuada non tristique. Elit Phasellus dui feugiat mauris dictum hendrerit tincidunt volutpat purus id. At penatibus leo laoreet tempus.</p>', 1, 0, 0, 78, '2010-12-09 22:31:54', 42, '', '2012-02-10 06:59:00', 42, 42, '2012-02-10 06:59:00', '2010-12-09 22:31:54', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 4, 0, 1, 'film Joomla template  2.5, movie template Joomla 2.5, DVD Joomla 2.5 template, template actor Joomla 2.5, trailer template Joomla 2.5, 3D film', 'Templates update for Joomla 2.5 movie, trailer film, 3D film.', 1, 12, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `title_alias`, `introtext`, `fulltext`, `state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(72, 181, '3D Film Template 2.5 ', '3d-film-template-2-5', '', '<p><img class="caption" src="images/stories/demo/sam-4.jpg" border="0" alt="Demo image" align="left" /></p>\r\n<p>Lorem ipsum dolor sit amet consectetuer urna quis vel convallis tincidunt. Nam in sed ultrices tristique mi non ut facilisi id non. Et Sed egestas tristique lacinia nibh ridiculus adipiscing faucibus amet sed. Tellus turpis mauris dui euismod sit nibh id at semper vitae.</p>\r\n', '\r\n<p>Laoreet magnis in Proin felis in venenatis Sed nunc sapien condimentum. Vestibulum Morbi id Nam tellus Quisque nunc nunc ut Morbi Aenean. Suspendisse et tellus vitae In Nam platea aliquet tincidunt nisl vitae. Suscipit felis orci dui Nam Sed orci wisi vitae velit urna. Sagittis nunc id Aliquam Vivamus cursus consectetuer vel quis sed pellentesque. Justo Aliquam risus Nam tellus risus Quisque Quisque augue.</p>\r\n<p>Sed dui Praesent nibh Curabitur ipsum nunc facilisi risus elit eget. Pharetra commodo elit nulla suscipit nunc eros nec lacus odio tortor. Suscipit semper felis Integer dui porttitor ac eu consequat id metus. Dui Cras congue ac ante et Nam nunc tempus habitant quis. Tincidunt elit sollicitudin risus ut libero In justo fames elit facilisi. Lorem Aenean vitae lacus vel semper laoreet aliquet turpis.</p>\r\n<p>Tortor turpis justo nulla tempus sem consequat id sed elit tincidunt. Dolor orci In Aenean Aenean Sed tellus Pellentesque Pellentesque mauris Cum. Lorem lacinia felis Quisque elit Vestibulum pellentesque amet wisi Curabitur In. Aliquam Lorem vitae quis gravida dapibus nibh felis malesuada non tristique. Elit Phasellus dui feugiat mauris dictum hendrerit tincidunt volutpat purus id. At penatibus leo laoreet tempus.</p>', 1, 0, 0, 78, '2010-12-09 22:32:50', 42, '', '2012-02-10 06:52:35', 42, 42, '2012-02-10 06:52:35', '2010-12-09 22:32:50', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 4, 0, 0, 'film Joomla template  2.5, movie template Joomla 2.5, DVD Joomla 2.5 template, template actor Joomla 2.5, trailer template Joomla 2.5, 3D film', 'Joomla template 2.5 3D film update', 1, 108, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(73, 182, 'Solutions and Ideas', 'solutions-a-ideas', '', '<!-- {jaimage main="images/stories/slideshow/sl-2.jpg" thumb="images/stories/slideshow/sl-2.jpg"} -->', '\r\n<p>Ut nullam leo imperdiet arcu aliquam, a id massa anim molestie at, amet libero tellus, fames nam erat pretium mattis volutpat leo, aliquam nulla. Neque eget ipsum suspendisse massa, ut tempor elit In id.</p>\r\n<p>Elit felis porttitor semper ipsum habitasse mauris congue vel lacinia iaculis. Mauris Fusce tellus velit mauris et dictum laoreet quis nulla ornare. Felis convallis consequat parturient gravida et et pede id rutrum et. Dui lacinia Suspendisse faucibus In justo nunc ac augue Phasellus sit. Lacus ullamcorper sit Vivamus ante quis elit tortor cursus ligula pretium. Vestibulum cursus.</p>\r\n<p>Accumsan turpis eros metus interdum et et neque amet et justo. Neque justo ipsum Morbi facilisi quis pretium cursus sagittis enim dapibus. Libero et et elit ut Sed Vestibulum condimentum semper ut ut. Sagittis velit ut volutpat eget convallis convallis tortor augue tincidunt congue. Gravida enim pretium Curabitur dui Nulla orci semper pede nibh nibh. Nam dictumst id Sed semper turpis Suspendisse risus convallis ut consectetuer. Rhoncus.</p>\r\n<p>Vestibulum nibh consectetuer amet lacus orci neque eros metus a augue. Adipiscing pulvinar Mauris amet nec ac Vivamus magnis tempus nunc ut. Interdum massa sagittis Mauris orci Nulla at feugiat Suspendisse ac cursus. Sit adipiscing Nulla nunc tellus wisi Praesent Nam sollicitudin Quisque Cum. Pretium ipsum nec felis Duis habitasse orci dapibus sapien hendrerit venenatis. Fringilla eget Integer ac vel gravida ante et mauris vel ultrices.</p>\r\n<p>Pellentesque urna mauris semper nascetur Curabitur vitae eu Quisque libero interdum. Sagittis sit amet lacus tellus magna fringilla ac risus interdum velit. Nec eget tellus urna ante in pellentesque Mauris orci Phasellus metus. Feugiat Ut sed at Sed in mus metus nibh et interdum. Vitae quis lacus sem vitae at eget tempus tristique.</p>\r\n<p>Condimentum et convallis elit libero id Sed Vestibulum quis habitasse nunc. Id volutpat elit id mauris semper amet amet elit gravida vel. Vestibulum elit urna elit faucibus habitant In id at eget nibh. Tempus venenatis sapien quis rhoncus Nam orci nonummy purus Quisque orci. Pellentesque tortor arcu semper Donec Maecenas enim non Cum odio tortor. Sed cursus amet condimentum sed tempus.</p>', 1, 0, 0, 79, '2010-12-09 22:34:22', 42, '', '2011-08-25 07:30:58', 42, 0, '0000-00-00 00:00:00', '2010-12-09 22:34:22', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 3, 0, 3, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(74, 183, 'Overview', 'overview', '', '<p>Mus congue tempus egestas sem in Suspendisse pretium orci suscipit semper. Curabitur pretium justo feugiat lacinia lacus Suspendisse eros nibh urna id. Vestibulum lacus lacinia justo enim sed cursus tellus id dis malesuada</p>\r\n<div class="btlink clearfix"><a href="#" title="Sample link">Take a Tour</a> <span>or</span> <a class="Sample link" href="#">Buy Now</a></div>\r\n', '\r\n<p>Tincidunt velit fermentum sem Nullam dapibus justo id condimentum dui est. Sociis risus Vestibulum consequat congue scelerisque pretium nunc fermentum vitae leo. Ridiculus et consequat nec augue vitae pede interdum Praesent neque pede. Auctor Vestibulum dui eget velit dictumst tempor laoreet Ut amet accumsan. Ipsum lorem velit id quis Sed dui ipsum lorem eu Cum. Sed gravida felis vitae metus vitae id Aenean et libero et.</p>\r\n<p>Faucibus justo porta lacinia cursus nunc sollicitudin metus Pellentesque laoreet Vestibulum. Tempus pulvinar cursus iaculis mus condimentum laoreet Ut habitasse porta ante. Id Maecenas eget justo augue et convallis Donec Morbi interdum sem. Augue orci semper velit laoreet aliquam Morbi nonummy lorem at velit. Morbi consequat neque euismod congue Nulla Vestibulum Phasellus auctor senectus Donec.</p>\r\n<p>Feugiat mauris turpis at Nullam tincidunt laoreet sem lobortis sagittis arcu. Penatibus eu a ridiculus at ac Aenean ipsum tristique Curabitur venenatis. Diam lorem malesuada sed Maecenas lacus nunc urna Curabitur egestas ligula. Massa Sed dolor orci justo lacinia auctor Aliquam Morbi id interdum. Nec neque augue Nulla Curabitur tellus cursus.</p>\r\n<p>Elit felis porttitor semper ipsum habitasse mauris congue vel lacinia iaculis. Mauris Fusce tellus velit mauris et dictum laoreet quis nulla ornare. Felis convallis consequat parturient gravida et et pede id rutrum et. Dui lacinia Suspendisse faucibus In justo nunc ac augue Phasellus sit. Lacus ullamcorper sit Vivamus ante quis elit tortor cursus ligula pretium. Vestibulum cursus.</p>\r\n<p>Accumsan turpis eros metus interdum et et neque amet et justo. Neque justo ipsum Morbi facilisi quis pretium cursus sagittis enim dapibus. Libero et et elit ut Sed Vestibulum condimentum semper ut ut. Sagittis velit ut volutpat eget convallis convallis tortor augue tincidunt congue. Gravida enim pretium Curabitur dui Nulla orci semper pede nibh nibh. Nam dictumst id Sed semper turpis Suspendisse risus convallis ut consectetuer. Rhoncus.</p>\r\n<p>Vestibulum nibh consectetuer amet lacus orci neque eros metus a augue. Adipiscing pulvinar Mauris amet nec ac Vivamus magnis tempus nunc ut. Interdum massa sagittis Mauris orci Nulla at feugiat Suspendisse ac cursus. Sit adipiscing Nulla nunc tellus wisi Praesent Nam sollicitudin Quisque Cum. Pretium ipsum nec felis Duis habitasse orci dapibus sapien hendrerit venenatis. Fringilla eget Integer ac vel gravida ante et mauris vel ultrices.</p>', -2, 0, 0, 79, '2010-12-09 22:35:26', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2010-12-09 22:35:26', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 2, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(75, 184, 'Work with Us', 'work-with-us', '', '<!-- {jaimage main="images/stories/slideshow/sl-1.jpg" thumb="images/stories/slideshow/sl-1.jpg"} -->', '\r\n<p>Vitae fringilla sapien Nulla ornare ut nisl scelerisque tortor wisi ut. Nec ipsum pede id magna Nulla sed Lorem leo semper consequat. Curabitur id id consectetuer auctor id ultrices Pellentesque ultrices Curabitur sem.</p>\r\n<p>Feugiat mauris turpis at Nullam tincidunt laoreet sem lobortis sagittis arcu. Penatibus eu a ridiculus at ac Aenean ipsum tristique Curabitur venenatis. Diam lorem malesuada sed Maecenas lacus nunc urna Curabitur egestas ligula. Massa Sed dolor orci justo lacinia auctor Aliquam Morbi id interdum. Nec neque augue Nulla Curabitur tellus cursus.</p>\r\n<p>Elit felis porttitor semper ipsum habitasse mauris congue vel lacinia iaculis. Mauris Fusce tellus velit mauris et dictum laoreet quis nulla ornare. Felis convallis consequat parturient gravida et et pede id rutrum et. Dui lacinia Suspendisse faucibus In justo nunc ac augue Phasellus sit. Lacus ullamcorper sit Vivamus ante quis elit tortor cursus ligula pretium. Vestibulum cursus.</p>\r\n<p>Accumsan turpis eros metus interdum et et neque amet et justo. Neque justo ipsum Morbi facilisi quis pretium cursus sagittis enim dapibus. Libero et et elit ut Sed Vestibulum condimentum semper ut ut. Sagittis velit ut volutpat eget convallis convallis tortor augue tincidunt congue. Gravida enim pretium Curabitur dui Nulla orci semper pede nibh nibh. Nam dictumst id Sed semper turpis Suspendisse risus convallis ut consectetuer. Rhoncus.</p>\r\n<p>Vestibulum nibh consectetuer amet lacus orci neque eros metus a augue. Adipiscing pulvinar Mauris amet nec ac Vivamus magnis tempus nunc ut. Interdum massa sagittis Mauris orci Nulla at feugiat Suspendisse ac cursus. Sit adipiscing Nulla nunc tellus wisi Praesent Nam sollicitudin Quisque Cum. Pretium ipsum nec felis Duis habitasse orci dapibus sapien hendrerit venenatis. Fringilla eget Integer ac vel gravida ante et mauris vel ultrices.</p>\r\n<p>Pellentesque urna mauris semper nascetur Curabitur vitae eu Quisque libero interdum. Sagittis sit amet lacus tellus magna fringilla ac risus interdum velit. Nec eget tellus urna ante in pellentesque Mauris orci Phasellus metus. Feugiat Ut sed at Sed in mus metus nibh et interdum. Vitae quis lacus sem vitae at eget tempus tristique.</p>\r\n<p>Condimentum et convallis elit libero id Sed Vestibulum quis habitasse nunc. Id volutpat elit id mauris semper amet amet elit gravida vel. Vestibulum elit urna elit faucibus habitant In id at eget nibh. Tempus venenatis sapien quis rhoncus Nam orci nonummy purus Quisque orci. Pellentesque tortor arcu semper Donec Maecenas enim non Cum odio tortor. Sed cursus amet condimentum sed tempus.</p>', 1, 0, 0, 79, '2010-12-09 22:36:21', 42, '', '2011-08-25 07:30:46', 42, 0, '0000-00-00 00:00:00', '2010-12-09 22:36:21', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 3, 0, 1, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(76, 185, 'Contact', 'contact', '', '<p>A quis fringilla In lacinia ligula nonummy dui Nam at feugiat. Metus ac ipsum convallis eleifend accumsan neque Aenean Suspendisse enim ut. Sed auctor Nunc Nam convallis justo sit a et tempor at. Id aliquam wisi</p>\r\n<div class="btlink clearfix"><a href="#" title="Sample link">Take a Tour</a> <span>or</span> <a class="Sample link" href="#">Buy Now</a></div>\r\n', '\r\n<p>Lorem ipsum dolor sit amet consectetuer vitae libero dui Vestibulum montes. Phasellus vitae tincidunt id fames Aliquam est accumsan leo lorem consectetuer. Consequat Curabitur at ullamcorper rutrum ipsum est mauris dolor a semper. Duis id hendrerit tempor semper cursus wisi tincidunt dictumst Sed netus. Lobortis augue Maecenas id dapibus tincidunt id et consequat Sed.</p>\r\n<p>Tincidunt velit fermentum sem Nullam dapibus justo id condimentum dui est. Sociis risus Vestibulum consequat congue scelerisque pretium nunc fermentum vitae leo. Ridiculus et consequat nec augue vitae pede interdum Praesent neque pede. Auctor Vestibulum dui eget velit dictumst tempor laoreet Ut amet accumsan. Ipsum lorem velit id quis Sed dui ipsum lorem eu Cum. Sed gravida felis vitae metus vitae id Aenean et libero et.</p>\r\n<p>Faucibus justo porta lacinia cursus nunc sollicitudin metus Pellentesque laoreet Vestibulum. Tempus pulvinar cursus iaculis mus condimentum laoreet Ut habitasse porta ante. Id Maecenas eget justo augue et convallis Donec Morbi interdum sem. Augue orci semper velit laoreet aliquam Morbi nonummy lorem at velit. Morbi consequat neque euismod congue Nulla Vestibulum Phasellus auctor senectus Donec.</p>\r\n<p>Feugiat mauris turpis at Nullam tincidunt laoreet sem lobortis sagittis arcu. Penatibus eu a ridiculus at ac Aenean ipsum tristique Curabitur venenatis. Diam lorem malesuada sed Maecenas lacus nunc urna Curabitur egestas ligula. Massa Sed dolor orci justo lacinia auctor Aliquam Morbi id interdum. Nec neque augue Nulla Curabitur tellus cursus.</p>\r\n<p>Elit felis porttitor semper ipsum habitasse mauris congue vel lacinia iaculis. Mauris Fusce tellus velit mauris et dictum laoreet quis nulla ornare. Felis convallis consequat parturient gravida et et pede id rutrum et. Dui lacinia Suspendisse faucibus In justo nunc ac augue Phasellus sit. Lacus ullamcorper sit Vivamus ante quis elit tortor cursus ligula pretium. Vestibulum cursus.</p>\r\n<p>Accumsan turpis eros metus interdum et et neque amet et justo. Neque justo ipsum Morbi facilisi quis pretium cursus sagittis enim dapibus. Libero et et elit ut Sed Vestibulum condimentum semper ut ut. Sagittis velit ut volutpat eget convallis convallis tortor augue tincidunt congue. Gravida enim pretium Curabitur dui Nulla orci semper pede nibh nibh. Nam dictumst id Sed semper turpis Suspendisse risus convallis ut consectetuer. Rhoncus.</p>', -2, 0, 0, 79, '2010-12-09 22:37:02', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2010-12-09 22:37:02', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 0, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(77, 186, 'Convallis Maecenas Nam quis Sed venenatis', 'convallis-maecenas-nam-quis-sed-venenatis', '', '<p><img class="caption" src="images/stories/demo/sam-5.jpg" border="0" alt="sample image" title="Sample image" align="left" /></p>\r\n<p>Libero purus tortor vel Mauris et nec Pellentesque ut volutpat nec. Non et rhoncus Nulla Suspendisse dui ultrices in vel egestas ipsum. Sem porta non Phasellus scelerisque vitae dolor tortor tellus et libero. Non et rhoncus Nulla Suspendisse dui ultrices in vel egestas ipsum. <a href="#" title="Sample link">Sem porta non Phasellus scelerisque</a> vitae dolor tortor tellus et libero.</p>\r\n', '\r\n<p>Metus habitasse sed interdum Nulla Donec justo ipsum dolor dui Donec. Non Donec aliquam at hac Curabitur Maecenas Sed sed euismod nibh. Ut Ut lacinia mollis ullamcorper dui sem in ligula Morbi faucibus. Interdum Vestibulum nibh augue metus urna Curabitur eu Morbi vel et. Quam vitae ac Lorem at ante dolor mus Donec Maecenas elit. Nunc leo consequat.</p>\r\n<p>Sed ornare adipiscing enim felis sed elit Lorem quis lacinia urna. Condimentum tincidunt nibh adipiscing et volutpat a Nulla at Nulla eleifend. Tincidunt et dui In condimentum platea accumsan Nam lobortis tempus dui. Condimentum nonummy Curabitur nunc non tincidunt orci consequat libero laoreet sapien. Nulla convallis ligula et ornare fames commodo Aliquam mauris ipsum in. Metus suscipit senectus condimentum Maecenas lacus pellentesque Vestibulum.</p>\r\n<p>Convallis Maecenas Nam quis Sed venenatis Nullam Curabitur Morbi montes natoque. Wisi pretium laoreet ante quis quis tincidunt ut Ut Integer wisi. Facilisi nibh sed consectetuer commodo orci feugiat eros Maecenas habitasse sagittis. Ullamcorper mus ac nisl Curabitur aliquam sed lacinia mattis Vestibulum scelerisque. In eu nonummy Duis Morbi fringilla auctor est tincidunt.</p>\r\n<p>Augue cursus sit purus id vel Vivamus at dapibus pretium ridiculus. Praesent justo lacus malesuada faucibus faucibus tempus Nulla amet lobortis Phasellus. Dui orci fringilla natoque Lorem laoreet dui tempus pede enim fringilla. Dictumst pretium a Aenean tempus elit Nam Ut ligula Ut Sed. Elit nulla nibh id lacinia Morbi malesuada a tortor senectus eget. Nibh.</p>\r\n<p class="download">Mi pellentesque augue pellentesque accumsan est odio ut Aliquam nulla eget. Condimentum Maecenas mi tempus convallis ac tellus mattis condimentum facilisis adipiscing.</p>', 0, 0, 0, 80, '2010-12-09 22:39:34', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2010-12-09 22:39:34', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 7, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(78, 187, 'Aliquam Curabitur molestie dolor', 'aliquam-curabitur-molestie-dolor', '', '<p><img class="caption" src="images/stories/demo/sam-10.jpg" border="0" alt="sample image" title="Sample image" align="left" /></p>\r\n<p>Sed ornare adipiscing enim felis sed elit Lorem quis lacinia urna. Condimentum tincidunt nibh adipiscing et volutpat a Nulla at Nulla eleifend. Tincidunt et dui In condimentum platea accumsan Nam lobortis tempus dui. Condimentum nonummy Curabitur nunc non tincidunt orci consequat libero laoreet sapien.</p>\r\n', '\r\n<p>Convallis Maecenas Nam quis Sed venenatis Nullam Curabitur Morbi montes natoque. Wisi pretium laoreet ante quis quis tincidunt ut Ut Integer wisi. Facilisi nibh sed consectetuer commodo orci feugiat eros Maecenas habitasse sagittis. Ullamcorper mus ac nisl Curabitur aliquam sed lacinia mattis Vestibulum scelerisque. In eu nonummy Duis Morbi fringilla auctor est tincidunt.</p>\r\n<p>Augue cursus sit purus id vel Vivamus at dapibus pretium ridiculus. Praesent justo lacus malesuada faucibus faucibus tempus Nulla amet lobortis Phasellus. Dui orci fringilla natoque Lorem laoreet dui tempus pede enim fringilla. Dictumst pretium a Aenean tempus elit Nam Ut ligula Ut Sed. Elit nulla nibh id lacinia Morbi malesuada a tortor senectus eget. Nibh.</p>\r\n<p>Mi pellentesque augue pellentesque accumsan est odio ut Aliquam nulla eget. Condimentum Maecenas mi tempus convallis ac tellus mattis condimentum facilisis adipiscing. Aliquam Curabitur molestie dolor leo augue dui sagittis id id mauris. Ut Curabitur pharetra elit sodales at Nam dictum auctor est augue. Nunc orci urna dolor mollis in velit tincidunt justo nibh venenatis. Pretium tempus arcu In Nullam Aenean Lorem felis sollicitudin tristique magnis.</p>\r\n<p>Eget nibh id magna nascetur semper Integer venenatis mauris Curabitur enim. Lorem massa Vestibulum Integer nibh Sed Aenean sed metus pretium amet. Curabitur sit Pellentesque neque Phasellus dolor sed cursus accumsan venenatis condimentum. Sed tellus consequat nulla Ut convallis at lacinia consectetuer a ante. Augue semper feugiat eget et et eros semper Praesent nulla ipsum. Amet porttitor Praesent Nulla et felis ante eget eleifend senectus elit. Wisi.</p>\r\n<p>Rutrum id dui Mauris tincidunt Quisque et tortor orci Sed augue. Faucibus id dapibus congue hendrerit orci tellus ac convallis habitasse tellus. Libero auctor elit et venenatis natoque molestie convallis quis ac Curabitur. Mauris pede Vestibulum ac risus eget turpis elit adipiscing dolor nibh. Morbi felis at id elit urna montes gravida nibh nibh quis. Tellus.</p>\r\n<p>Eget elit lacinia nunc consequat ullamcorper In massa nibh malesuada lorem. Nam mollis feugiat tincidunt at semper hendrerit sit porttitor pellentesque senectus. Augue Nulla scelerisque quis vitae in porta faucibus elit vitae Morbi. Curabitur nibh magna wisi Nam Ut sem turpis ac faucibus Vestibulum. Auctor malesuada Nam non tortor condimentum et magna In convallis.</p>', 0, 0, 0, 80, '2010-12-09 22:42:18', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2010-12-09 22:42:18', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 6, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(79, 188, 'Scelerisque et leo', 'scelerisque-et-leo', '', '<p><img class="caption" src="images/stories/demo/sam-11.jpg" border="0" alt="sample image" title="Sample image" align="left" /></p>\r\n<p>Lorem ipsum dolor sit amet consectetuer mattis sociis Phasellus tellus ac. Lorem tristique pretium ornare facilisis Aenean lorem justo at Phasellus pede. Amet amet sed suscipit vel porta non dui tempus Aenean libero. Cursus Suspendisse orci egestas tincidunt vel auctor Nam facilisi id risus. Lorem nibh vitae iaculis nibh scelerisque Vivamus.</p>\r\n', '\r\n<p>Libero purus tortor vel Mauris et nec Pellentesque ut volutpat nec. Non et rhoncus Nulla Suspendisse dui ultrices in vel egestas ipsum. Sem porta non Phasellus scelerisque vitae dolor tortor tellus et libero. Cursus mi vel ipsum ante tincidunt diam in id Aliquam tristique. Nam quis est massa tellus Nam Curabitur rutrum quis volutpat sed. Scelerisque et leo Pellentesque purus sit nibh cursus Nulla.</p>\r\n<ul class="star">\r\n<li><span class="icon"> </span>Metus habitasse sed interdum Nulla Donec</li>\r\n<li><span class="icon"> </span>Justo ipsum dolor dui Donec.</li>\r\n<li><span class="icon"> </span>Non Donec aliquam at hac Curabitur</li>\r\n<li><span class="icon"> </span>Maecenas Sed sed euismod nibh.</li>\r\n</ul>\r\n<p>Sed ornare adipiscing enim felis sed elit Lorem quis lacinia urna. Condimentum tincidunt nibh adipiscing et volutpat a Nulla at Nulla eleifend. Tincidunt et dui In condimentum platea accumsan Nam lobortis tempus dui. Condimentum nonummy Curabitur nunc non tincidunt orci consequat libero laoreet sapien. Nulla convallis ligula et ornare fames commodo Aliquam mauris ipsum in. Metus suscipit senectus condimentum Maecenas lacus pellentesque Vestibulum.</p>\r\n<p>Augue cursus sit purus id vel Vivamus at dapibus pretium ridiculus. Praesent justo lacus malesuada faucibus faucibus tempus Nulla amet lobortis Phasellus.</p>', 1, 0, 0, 80, '2010-12-09 22:44:01', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2010-12-09 22:44:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 5, '', '', 1, 28, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(80, 189, 'Elit nulla nibh id', 'elit-nulla-nibh-id', '', '<p><img class="caption" src="images/stories/demo/sam-12.jpg" border="0" alt="sample image" title="Sample image" align="left" /></p>\r\n<p>Libero purus tortor vel Mauris et nec Pellentesque ut volutpat nec. Non et rhoncus Nulla Suspendisse dui ultrices in vel egestas ipsum. Sem porta non Phasellus scelerisque vitae dolor tortor tellus et libero. Non et rhoncus Nulla Suspendisse dui ultrices in vel egestas ipsum. <a href="#" title="Sample link">Sem porta non Phasellus scelerisque</a> vitae dolor tortor tellus et libero.</p>\r\n', '\r\n<p>Metus habitasse sed interdum Nulla Donec justo ipsum dolor dui Donec. Non Donec aliquam at hac Curabitur Maecenas Sed sed euismod nibh. Ut Ut lacinia mollis ullamcorper dui sem in ligula Morbi faucibus. Interdum Vestibulum nibh augue metus urna Curabitur eu Morbi vel et. Quam vitae ac Lorem at ante dolor mus Donec Maecenas elit. Nunc leo consequat.</p>\r\n<p>Sed ornare adipiscing enim felis sed elit Lorem quis lacinia urna. Condimentum tincidunt nibh adipiscing et volutpat a Nulla at Nulla eleifend. Tincidunt et dui In condimentum platea accumsan Nam lobortis tempus dui. Condimentum nonummy Curabitur nunc non tincidunt orci consequat libero laoreet sapien. Nulla convallis ligula et ornare fames commodo Aliquam mauris ipsum in. Metus suscipit senectus condimentum Maecenas lacus pellentesque Vestibulum.</p>\r\n<p>Convallis Maecenas Nam quis Sed venenatis Nullam Curabitur Morbi montes natoque. Wisi pretium laoreet ante quis quis tincidunt ut Ut Integer wisi. Facilisi nibh sed consectetuer commodo orci feugiat eros Maecenas habitasse sagittis. Ullamcorper mus ac nisl Curabitur aliquam sed lacinia mattis Vestibulum scelerisque. In eu nonummy Duis Morbi fringilla auctor est tincidunt.</p>\r\n<p>Augue cursus sit purus id vel Vivamus at dapibus pretium ridiculus. Praesent justo lacus malesuada faucibus faucibus tempus Nulla amet lobortis Phasellus. Dui orci fringilla natoque Lorem laoreet dui tempus pede enim fringilla. Dictumst pretium a Aenean tempus elit Nam Ut ligula Ut Sed. Elit nulla nibh id lacinia Morbi malesuada a tortor senectus eget. Nibh.</p>\r\n<p class="download">Mi pellentesque augue pellentesque accumsan est odio ut Aliquam nulla eget. Condimentum Maecenas mi tempus convallis ac tellus mattis condimentum facilisis adipiscing.</p>', 0, 0, 0, 80, '2010-12-09 22:44:42', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2010-12-09 22:44:42', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 4, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(81, 190, 'Tincidunt et dui In condimentum', 'tincidunt-et-dui-in-condimentum', '', '<p><img class="caption" src="images/stories/demo/sam-9.jpg" border="0" alt="sample image" title="Sample image" align="left" /></p>\r\n<p>Metus habitasse sed interdum Nulla Donec justo ipsum dolor dui Donec. Non Donec aliquam at hac Curabitur Maecenas Sed sed euismod nibh. Ut Ut lacinia mollis ullamcorper dui sem in ligula Morbi faucibus. Interdum Vestibulum nibh augue metus urna Curabitur eu Morbi vel et. Quam vitae ac Lorem at ante dolor mus Donec Maecenas elit. Nunc leo consequat. Interdum Vestibulum nibh augue metus urna Curabitur eu Morbi vel et. Quam vitae ac Lorem at ante dolor mus Donec Maecenas elit. Nunc leo consequat.</p>\r\n', '\r\n<p>Sed ornare adipiscing enim felis sed elit Lorem quis lacinia urna. Condimentum tincidunt nibh adipiscing et volutpat a Nulla at Nulla eleifend. Tincidunt et dui In condimentum platea accumsan Nam lobortis tempus dui. Condimentum nonummy Curabitur nunc non tincidunt orci consequat libero laoreet sapien. Nulla convallis ligula et ornare fames commodo Aliquam mauris ipsum in. Metus suscipit senectus condimentum Maecenas lacus pellentesque Vestibulum.</p>\r\n<p>Convallis Maecenas Nam quis Sed venenatis Nullam Curabitur Morbi montes natoque. Wisi pretium laoreet ante quis quis tincidunt ut Ut Integer wisi. Facilisi nibh sed consectetuer commodo orci feugiat eros Maecenas habitasse sagittis. Ullamcorper mus ac nisl Curabitur aliquam sed lacinia mattis Vestibulum scelerisque. In eu nonummy Duis Morbi fringilla auctor est tincidunt.</p>\r\n<p>Augue cursus sit purus id vel Vivamus at dapibus pretium ridiculus. Praesent justo lacus malesuada faucibus faucibus tempus Nulla amet lobortis Phasellus. Dui orci fringilla natoque Lorem laoreet dui tempus pede enim fringilla. Dictumst pretium a Aenean tempus elit Nam Ut ligula Ut Sed. Elit nulla nibh id lacinia Morbi malesuada a tortor senectus eget. Nibh.</p>\r\n<p>Mi pellentesque augue pellentesque accumsan est odio ut Aliquam nulla eget. Condimentum Maecenas mi tempus convallis ac tellus mattis condimentum facilisis adipiscing. Aliquam Curabitur molestie dolor leo augue dui sagittis id id mauris. Ut Curabitur pharetra elit sodales at Nam dictum auctor est augue. Nunc orci urna dolor mollis in velit tincidunt justo nibh venenatis. Pretium tempus arcu In Nullam Aenean Lorem felis sollicitudin tristique magnis.</p>\r\n<p>Eget nibh id magna nascetur semper Integer venenatis mauris Curabitur enim. Lorem massa Vestibulum Integer nibh Sed Aenean sed metus pretium amet. Curabitur sit Pellentesque neque Phasellus dolor sed cursus accumsan venenatis condimentum. Sed tellus consequat nulla Ut convallis at lacinia consectetuer a ante. Augue semper feugiat eget et et eros semper Praesent nulla ipsum. Amet porttitor Praesent Nulla et felis ante eget eleifend senectus elit. Wisi.</p>\r\n<p>Rutrum id dui Mauris tincidunt Quisque et tortor orci Sed augue. Faucibus id dapibus congue hendrerit orci tellus ac convallis habitasse tellus. Libero auctor elit et venenatis natoque molestie convallis quis ac Curabitur. Mauris pede Vestibulum ac risus eget turpis elit adipiscing dolor nibh. Morbi felis at id elit urna montes gravida nibh nibh quis. Tellus.</p>\r\n<p>Eget elit lacinia nunc consequat ullamcorper In massa nibh malesuada lorem. Nam mollis feugiat tincidunt at semper hendrerit sit porttitor pellentesque senectus. Augue Nulla scelerisque quis vitae in porta faucibus elit vitae Morbi. Curabitur nibh magna wisi Nam Ut sem turpis ac faucibus Vestibulum. Auctor malesuada Nam non tortor condimentum et magna In convallis.</p>', 1, 0, 0, 80, '2010-12-09 22:45:35', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2010-12-09 22:45:35', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 3, '', '', 1, 8, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(82, 191, 'Libero purus tortor vel Mauris et nec Pellentesque', 'libero-purus-tortor-vel-mauris-et-nec-pellentesque', '', '<p><img class="caption" src="images/stories/demo/sam-6.jpg" border="0" alt="sample image" title="Sample image" align="left" /></p>\r\n<p>Lorem ipsum dolor sit amet consectetuer mattis sociis Phasellus tellus ac. Lorem tristique pretium ornare facilisis Aenean lorem justo at Phasellus pede. Amet amet sed suscipit vel porta non dui tempus Aenean libero. Cursus Suspendisse orci egestas tincidunt vel auctor Nam facilisi id risus. Lorem nibh vitae iaculis nibh scelerisque Vivamus.</p>\r\n', '\r\n<p>Libero purus tortor vel Mauris et nec Pellentesque ut volutpat nec. Non et rhoncus Nulla Suspendisse dui ultrices in vel egestas ipsum. Sem porta non Phasellus scelerisque vitae dolor tortor tellus et libero. Cursus mi vel ipsum ante tincidunt diam in id Aliquam tristique. Nam quis est massa tellus Nam Curabitur rutrum quis volutpat sed. Scelerisque et leo Pellentesque purus sit nibh cursus Nulla.</p>\r\n<ul class="star">\r\n<li><span class="icon"> </span>Metus habitasse sed interdum Nulla Donec</li>\r\n<li><span class="icon"> </span>Justo ipsum dolor dui Donec.</li>\r\n<li><span class="icon"> </span>Non Donec aliquam at hac Curabitur</li>\r\n<li><span class="icon"> </span>Maecenas Sed sed euismod nibh.</li>\r\n</ul>\r\n<p>Sed ornare adipiscing enim felis sed elit Lorem quis lacinia urna. Condimentum tincidunt nibh adipiscing et volutpat a Nulla at Nulla eleifend. Tincidunt et dui In condimentum platea accumsan Nam lobortis tempus dui. Condimentum nonummy Curabitur nunc non tincidunt orci consequat libero laoreet sapien. Nulla convallis ligula et ornare fames commodo Aliquam mauris ipsum in. Metus suscipit senectus condimentum Maecenas lacus pellentesque Vestibulum.</p>\r\n<p>Augue cursus sit purus id vel Vivamus at dapibus pretium ridiculus. Praesent justo lacus malesuada faucibus faucibus tempus Nulla amet lobortis Phasellus.</p>', 0, 0, 0, 80, '2010-12-09 22:46:20', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2010-12-09 22:46:20', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 2, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(83, 192, 'Eget elit lacinia nunc consequat ullamcorper', 'eget-elit-lacinia-nunc-consequat-ullamcorper', '', '<p><img class="caption" src="images/stories/demo/sam-7.jpg" border="0" alt="sample image" title="Sample image" align="left" /></p>\r\n<p>Sed ornare adipiscing enim felis sed elit Lorem quis lacinia urna. Condimentum tincidunt nibh adipiscing et volutpat a Nulla at Nulla eleifend. Tincidunt et dui In condimentum platea accumsan Nam lobortis tempus dui. Condimentum nonummy Curabitur nunc non tincidunt orci consequat libero laoreet sapien.</p>\r\n', '\r\n<p>Convallis Maecenas Nam quis Sed venenatis Nullam Curabitur Morbi montes natoque. Wisi pretium laoreet ante quis quis tincidunt ut Ut Integer wisi. Facilisi nibh sed consectetuer commodo orci feugiat eros Maecenas habitasse sagittis. Ullamcorper mus ac nisl Curabitur aliquam sed lacinia mattis Vestibulum scelerisque. In eu nonummy Duis Morbi fringilla auctor est tincidunt.</p>\r\n<p>Augue cursus sit purus id vel Vivamus at dapibus pretium ridiculus. Praesent justo lacus malesuada faucibus faucibus tempus Nulla amet lobortis Phasellus. Dui orci fringilla natoque Lorem laoreet dui tempus pede enim fringilla. Dictumst pretium a Aenean tempus elit Nam Ut ligula Ut Sed. Elit nulla nibh id lacinia Morbi malesuada a tortor senectus eget. Nibh.</p>\r\n<p>Mi pellentesque augue pellentesque accumsan est odio ut Aliquam nulla eget. Condimentum Maecenas mi tempus convallis ac tellus mattis condimentum facilisis adipiscing. Aliquam Curabitur molestie dolor leo augue dui sagittis id id mauris. Ut Curabitur pharetra elit sodales at Nam dictum auctor est augue. Nunc orci urna dolor mollis in velit tincidunt justo nibh venenatis. Pretium tempus arcu In Nullam Aenean Lorem felis sollicitudin tristique magnis.</p>\r\n<p>Eget nibh id magna nascetur semper Integer venenatis mauris Curabitur enim. Lorem massa Vestibulum Integer nibh Sed Aenean sed metus pretium amet. Curabitur sit Pellentesque neque Phasellus dolor sed cursus accumsan venenatis condimentum. Sed tellus consequat nulla Ut convallis at lacinia consectetuer a ante. Augue semper feugiat eget et et eros semper Praesent nulla ipsum. Amet porttitor Praesent Nulla et felis ante eget eleifend senectus elit. Wisi.</p>\r\n<p>Rutrum id dui Mauris tincidunt Quisque et tortor orci Sed augue. Faucibus id dapibus congue hendrerit orci tellus ac convallis habitasse tellus. Libero auctor elit et venenatis natoque molestie convallis quis ac Curabitur. Mauris pede Vestibulum ac risus eget turpis elit adipiscing dolor nibh. Morbi felis at id elit urna montes gravida nibh nibh quis. Tellus.</p>\r\n<p>Eget elit lacinia nunc consequat ullamcorper In massa nibh malesuada lorem. Nam mollis feugiat tincidunt at semper hendrerit sit porttitor pellentesque senectus. Augue Nulla scelerisque quis vitae in porta faucibus elit vitae Morbi. Curabitur nibh magna wisi Nam Ut sem turpis ac faucibus Vestibulum. Auctor malesuada Nam non tortor condimentum et magna In convallis.</p>', 0, 0, 0, 80, '2010-12-09 22:47:26', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2010-12-09 22:47:26', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 1, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(84, 193, 'Metus habitasse sed interdum Nulla', 'metus-habitasse-sed-interdum-nulla', '', '<p><img class="caption" src="images/stories/demo/sam-8.jpg" border="0" alt="sample image" title="Sample image" align="left" /></p>\r\n<p>Metus habitasse sed interdum Nulla Donec justo ipsum dolor dui Donec. Non Donec aliquam at hac Curabitur Maecenas Sed sed euismod nibh. Ut Ut lacinia mollis ullamcorper dui sem in ligula Morbi faucibus. Interdum Vestibulum nibh augue metus urna Curabitur eu Morbi vel et. Quam vitae ac Lorem at ante dolor mus Donec Maecenas elit. Nunc leo consequat. Interdum Vestibulum nibh augue metus urna Curabitur eu Morbi vel et. Quam vitae ac Lorem at ante dolor mus Donec Maecenas elit. Nunc leo consequat.</p>\r\n', '\r\n<p>Sed ornare adipiscing enim felis sed elit Lorem quis lacinia urna. Condimentum tincidunt nibh adipiscing et volutpat a Nulla at Nulla eleifend. Tincidunt et dui In condimentum platea accumsan Nam lobortis tempus dui. Condimentum nonummy Curabitur nunc non tincidunt orci consequat libero laoreet sapien. Nulla convallis ligula et ornare fames commodo Aliquam mauris ipsum in. Metus suscipit senectus condimentum Maecenas lacus pellentesque Vestibulum.</p>\r\n<p>Convallis Maecenas Nam quis Sed venenatis Nullam Curabitur Morbi montes natoque. Wisi pretium laoreet ante quis quis tincidunt ut Ut Integer wisi. Facilisi nibh sed consectetuer commodo orci feugiat eros Maecenas habitasse sagittis. Ullamcorper mus ac nisl Curabitur aliquam sed lacinia mattis Vestibulum scelerisque. In eu nonummy Duis Morbi fringilla auctor est tincidunt.</p>\r\n<p>Augue cursus sit purus id vel Vivamus at dapibus pretium ridiculus. Praesent justo lacus malesuada faucibus faucibus tempus Nulla amet lobortis Phasellus. Dui orci fringilla natoque Lorem laoreet dui tempus pede enim fringilla. Dictumst pretium a Aenean tempus elit Nam Ut ligula Ut Sed. Elit nulla nibh id lacinia Morbi malesuada a tortor senectus eget. Nibh.</p>\r\n<p>Mi pellentesque augue pellentesque accumsan est odio ut Aliquam nulla eget. Condimentum Maecenas mi tempus convallis ac tellus mattis condimentum facilisis adipiscing. Aliquam Curabitur molestie dolor leo augue dui sagittis id id mauris. Ut Curabitur pharetra elit sodales at Nam dictum auctor est augue. Nunc orci urna dolor mollis in velit tincidunt justo nibh venenatis. Pretium tempus arcu In Nullam Aenean Lorem felis sollicitudin tristique magnis.</p>\r\n<p>Eget nibh id magna nascetur semper Integer venenatis mauris Curabitur enim. Lorem massa Vestibulum Integer nibh Sed Aenean sed metus pretium amet. Curabitur sit Pellentesque neque Phasellus dolor sed cursus accumsan venenatis condimentum. Sed tellus consequat nulla Ut convallis at lacinia consectetuer a ante. Augue semper feugiat eget et et eros semper Praesent nulla ipsum. Amet porttitor Praesent Nulla et felis ante eget eleifend senectus elit. Wisi.</p>\r\n<p>Rutrum id dui Mauris tincidunt Quisque et tortor orci Sed augue. Faucibus id dapibus congue hendrerit orci tellus ac convallis habitasse tellus. Libero auctor elit et venenatis natoque molestie convallis quis ac Curabitur. Mauris pede Vestibulum ac risus eget turpis elit adipiscing dolor nibh. Morbi felis at id elit urna montes gravida nibh nibh quis. Tellus.</p>\r\n<p>Eget elit lacinia nunc consequat ullamcorper In massa nibh malesuada lorem. Nam mollis feugiat tincidunt at semper hendrerit sit porttitor pellentesque senectus. Augue Nulla scelerisque quis vitae in porta faucibus elit vitae Morbi. Curabitur nibh magna wisi Nam Ut sem turpis ac faucibus Vestibulum. Auctor malesuada Nam non tortor condimentum et magna In convallis.</p>', 1, 0, 0, 80, '2010-12-09 22:48:29', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2010-12-09 22:48:29', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 0, '', '', 1, 14, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(85, 194, 'Robin Hood', 'robin-hood', '', '<p><img class="caption" src="images/stories/demo/thub-mv03.jpg" border="0" alt="Cop Out" align="left" /></p>\r\n<p>Integer sed auctor felis est leo platea Sed tortor quis Nullam. Justo fermentum turpis elit id auctor Sed tincidunt justo pellentesque sollicitudin. Faucibus enim felis Maecenas urna nibh gravida nibh Nunc In justo. Curabitur neque pede sem augue Sed nibh nunc facilisi Nulla Phasellus. Dictumst ornare porttitor Aenean vitae quis et sed sapien tellus Nullam.</p>\r\n', '\r\n<p>Vitae dictum vitae non interdum sed hendrerit wisi sagittis condimentum condimentum. Metus condimentum orci hendrerit sit neque Nam tellus Phasellus neque vitae. Nam Curabitur quam Curabitur neque Curabitur libero tempor ac consectetuer Suspendisse. Tellus rhoncus felis auctor at tempus interdum nulla augue et Aenean. Curabitur dignissim lorem tristique eros sapien turpis Nunc mauris.</p>\r\n<p>Sed dui Praesent nibh Curabitur ipsum nunc facilisi risus elit eget. Pharetra commodo elit nulla suscipit nunc eros nec lacus odio tortor. Suscipit semper felis Integer dui porttitor ac eu consequat id metus. Dui Cras congue ac ante et Nam nunc tempus habitant quis. Tincidunt elit sollicitudin risus ut libero In justo fames elit facilisi. Lorem Aenean vitae lacus vel semper laoreet aliquet turpis.</p>\r\n<p>Tortor turpis justo nulla tempus sem consequat id sed elit tincidunt. Dolor orci In Aenean Aenean Sed tellus Pellentesque Pellentesque mauris Cum. Lorem lacinia felis Quisque elit Vestibulum pellentesque amet wisi Curabitur In. Aliquam Lorem vitae quis gravida dapibus nibh felis malesuada non tristique. Elit Phasellus dui feugiat mauris dictum hendrerit tincidunt volutpat purus id. At penatibus leo laoreet tempus.</p>', 1, 0, 0, 82, '2010-12-09 22:49:51', 42, '', '2010-12-09 22:53:02', 42, 0, '0000-00-00 00:00:00', '2010-12-09 22:49:51', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 2, '', '', 1, 17, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(86, 195, 'Restrepo', 'restrepo', '', '<p><img class="caption" src="images/stories/demo/thub-mv01.jpg" border="0" alt="Shutter Island" align="left" /></p>\r\n<p>At habitant Aenean mollis libero volutpat orci dignissim eros nibh suscipit. Porta pharetra porta Vestibulum commodo quis enim Maecenas sit et Vestibulum. Nulla Nulla egestas semper convallis ligula Aenean Quisque justo quis vel. Gravida enim Curabitur condimentum at eu ac magna Nunc at Maecenas.</p>\r\n', '\r\n<p>Laoreet magnis in Proin felis in venenatis Sed nunc sapien condimentum. Vestibulum Morbi id Nam tellus Quisque nunc nunc ut Morbi Aenean. Suspendisse et tellus vitae In Nam platea aliquet tincidunt nisl vitae. Suscipit felis orci dui Nam Sed orci wisi vitae velit urna. Sagittis nunc id Aliquam Vivamus cursus consectetuer vel quis sed pellentesque. Justo Aliquam risus Nam tellus risus Quisque Quisque augue.</p>\r\n<p>Sed dui Praesent nibh Curabitur ipsum nunc facilisi risus elit eget. Pharetra commodo elit nulla suscipit nunc eros nec lacus odio tortor. Suscipit semper felis Integer dui porttitor ac eu consequat id metus. Dui Cras congue ac ante et Nam nunc tempus habitant quis. Tincidunt elit sollicitudin risus ut libero In justo fames elit facilisi. Lorem Aenean vitae lacus vel semper laoreet aliquet turpis.</p>\r\n<p>Tortor turpis justo nulla tempus sem consequat id sed elit tincidunt. Dolor orci In Aenean Aenean Sed tellus Pellentesque Pellentesque mauris Cum. Lorem lacinia felis Quisque elit Vestibulum pellentesque amet wisi Curabitur In. Aliquam Lorem vitae quis gravida dapibus nibh felis malesuada non tristique. Elit Phasellus dui feugiat mauris dictum hendrerit tincidunt volutpat purus id. At penatibus leo laoreet tempus.</p>', 1, 0, 0, 82, '2010-12-09 22:50:45', 42, '', '2010-12-09 22:52:28', 42, 0, '0000-00-00 00:00:00', '2010-12-09 22:50:45', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 1, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `title_alias`, `introtext`, `fulltext`, `state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(87, 196, 'MacGruber', 'macgruber', '', '<p><img class="caption" src="images/stories/demo/thub-mv02.jpg" border="0" alt="Cop Out" align="left" /></p>\r\n<p>Integer sed auctor felis est leo platea Sed tortor quis Nullam. Justo fermentum turpis elit id auctor Sed tincidunt justo pellentesque sollicitudin. Faucibus enim felis Maecenas urna nibh gravida nibh Nunc In justo. Curabitur neque pede sem augue Sed nibh nunc facilisi Nulla Phasellus. Dictumst ornare porttitor Aenean vitae quis et sed sapien tellus Nullam.</p>\r\n', '\r\n<p>Vitae dictum vitae non interdum sed hendrerit wisi sagittis condimentum condimentum. Metus condimentum orci hendrerit sit neque Nam tellus Phasellus neque vitae. Nam Curabitur quam Curabitur neque Curabitur libero tempor ac consectetuer Suspendisse. Tellus rhoncus felis auctor at tempus interdum nulla augue et Aenean. Curabitur dignissim lorem tristique eros sapien turpis Nunc mauris.</p>\r\n<p>Sed dui Praesent nibh Curabitur ipsum nunc facilisi risus elit eget. Pharetra commodo elit nulla suscipit nunc eros nec lacus odio tortor. Suscipit semper felis Integer dui porttitor ac eu consequat id metus. Dui Cras congue ac ante et Nam nunc tempus habitant quis. Tincidunt elit sollicitudin risus ut libero In justo fames elit facilisi. Lorem Aenean vitae lacus vel semper laoreet aliquet turpis.</p>\r\n<p>Tortor turpis justo nulla tempus sem consequat id sed elit tincidunt. Dolor orci In Aenean Aenean Sed tellus Pellentesque Pellentesque mauris Cum. Lorem lacinia felis Quisque elit Vestibulum pellentesque amet wisi Curabitur In. Aliquam Lorem vitae quis gravida dapibus nibh felis malesuada non tristique. Elit Phasellus dui feugiat mauris dictum hendrerit tincidunt volutpat purus id. At penatibus leo laoreet tempus.</p>', 1, 0, 0, 82, '2010-12-09 22:51:31', 42, '', '2010-12-09 22:52:09', 42, 0, '0000-00-00 00:00:00', '2010-12-09 22:51:31', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 0, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(88, 197, 'Cop Out', 'cop-out', '', '<p><img class="caption" src="images/stories/demo/thub-3.jpg" border="0" alt="Cop Out" align="left" /></p>\r\n<p>Integer sed auctor felis est leo platea Sed tortor quis Nullam. Justo fermentum turpis elit id auctor Sed tincidunt justo pellentesque sollicitudin. Faucibus enim felis Maecenas urna nibh gravida nibh Nunc In justo. Curabitur neque pede sem augue Sed nibh nunc facilisi Nulla Phasellus. Dictumst ornare porttitor Aenean vitae quis et sed sapien tellus Nullam.</p>\r\n', '\r\n<p>Vitae dictum vitae non interdum sed hendrerit wisi sagittis condimentum condimentum. Metus condimentum orci hendrerit sit neque Nam tellus Phasellus neque vitae. Nam Curabitur quam Curabitur neque Curabitur libero tempor ac consectetuer Suspendisse. Tellus rhoncus felis auctor at tempus interdum nulla augue et Aenean. Curabitur dignissim lorem tristique eros sapien turpis Nunc mauris.</p>\r\n<p>Sed dui Praesent nibh Curabitur ipsum nunc facilisi risus elit eget. Pharetra commodo elit nulla suscipit nunc eros nec lacus odio tortor. Suscipit semper felis Integer dui porttitor ac eu consequat id metus. Dui Cras congue ac ante et Nam nunc tempus habitant quis. Tincidunt elit sollicitudin risus ut libero In justo fames elit facilisi. Lorem Aenean vitae lacus vel semper laoreet aliquet turpis.</p>\r\n<p>Tortor turpis justo nulla tempus sem consequat id sed elit tincidunt. Dolor orci In Aenean Aenean Sed tellus Pellentesque Pellentesque mauris Cum. Lorem lacinia felis Quisque elit Vestibulum pellentesque amet wisi Curabitur In. Aliquam Lorem vitae quis gravida dapibus nibh felis malesuada non tristique. Elit Phasellus dui feugiat mauris dictum hendrerit tincidunt volutpat purus id. At penatibus leo laoreet tempus.</p>', 1, 0, 0, 83, '2010-12-09 22:56:12', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2010-12-09 22:56:12', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 5, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(89, 198, 'Shutter Island', 'shutter-island', '', '<p><img class="caption" src="images/stories/demo/thub-1.jpg" border="0" alt="Shutter Island" align="left" /></p>\r\n<p>At habitant Aenean mollis libero volutpat orci dignissim eros nibh suscipit. Porta pharetra porta Vestibulum commodo quis enim Maecenas sit et Vestibulum. Nulla Nulla egestas semper convallis ligula Aenean Quisque justo quis vel. Gravida enim Curabitur condimentum at eu ac magna Nunc at Maecenas.</p>\r\n', '\r\n<p>Laoreet magnis in Proin felis in venenatis Sed nunc sapien condimentum. Vestibulum Morbi id Nam tellus Quisque nunc nunc ut Morbi Aenean. Suspendisse et tellus vitae In Nam platea aliquet tincidunt nisl vitae. Suscipit felis orci dui Nam Sed orci wisi vitae velit urna. Sagittis nunc id Aliquam Vivamus cursus consectetuer vel quis sed pellentesque. Justo Aliquam risus Nam tellus risus Quisque Quisque augue.</p>\r\n<p>Sed dui Praesent nibh Curabitur ipsum nunc facilisi risus elit eget. Pharetra commodo elit nulla suscipit nunc eros nec lacus odio tortor. Suscipit semper felis Integer dui porttitor ac eu consequat id metus. Dui Cras congue ac ante et Nam nunc tempus habitant quis. Tincidunt elit sollicitudin risus ut libero In justo fames elit facilisi. Lorem Aenean vitae lacus vel semper laoreet aliquet turpis.</p>\r\n<p>Tortor turpis justo nulla tempus sem consequat id sed elit tincidunt. Dolor orci In Aenean Aenean Sed tellus Pellentesque Pellentesque mauris Cum. Lorem lacinia felis Quisque elit Vestibulum pellentesque amet wisi Curabitur In. Aliquam Lorem vitae quis gravida dapibus nibh felis malesuada non tristique. Elit Phasellus dui feugiat mauris dictum hendrerit tincidunt volutpat purus id. At penatibus leo laoreet tempus.</p>', 1, 0, 0, 83, '2010-12-09 22:57:36', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2010-12-09 22:57:36', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 4, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(90, 199, 'The Lightning Thief', 'the-lightning-thief', '', '<p><img class="caption" src="images/stories/demo/thub-2.jpg" border="0" alt="The Lightning Thief" align="left" /></p>\r\n<p>Vel nec Duis felis neque mauris mollis semper sodales ut Phasellus. Vel libero nascetur Morbi eget massa nisl amet quis volutpat sagittis. Et nascetur pretium orci Phasellus elit dolor Morbi sit tellus purus. Habitasse fringilla Vivamus felis dolor ornare pellentesque urna nunc ac nibh.</p>\r\n', '\r\n<p>Vitae dictum vitae non interdum sed hendrerit wisi sagittis condimentum condimentum. Metus condimentum orci hendrerit sit neque Nam tellus Phasellus neque vitae. Nam Curabitur quam Curabitur neque Curabitur libero tempor ac consectetuer Suspendisse. Tellus rhoncus felis auctor at tempus interdum nulla augue et Aenean. Curabitur dignissim lorem tristique eros sapien turpis Nunc mauris.</p>\r\n<p>Sed dui Praesent nibh Curabitur ipsum nunc facilisi risus elit eget. Pharetra commodo elit nulla suscipit nunc eros nec lacus odio tortor. Suscipit semper felis Integer dui porttitor ac eu consequat id metus. Dui Cras congue ac ante et Nam nunc tempus habitant quis. Tincidunt elit sollicitudin risus ut libero In justo fames elit facilisi. Lorem Aenean vitae lacus vel semper laoreet aliquet turpis.</p>\r\n<p>Tortor turpis justo nulla tempus sem consequat id sed elit tincidunt. Dolor orci In Aenean Aenean Sed tellus Pellentesque Pellentesque mauris Cum. Lorem lacinia felis Quisque elit Vestibulum pellentesque amet wisi Curabitur In. Aliquam Lorem vitae quis gravida dapibus nibh felis malesuada non tristique. Elit Phasellus dui feugiat mauris dictum hendrerit tincidunt volutpat purus id. At penatibus leo laoreet tempus.</p>', 1, 0, 0, 83, '2010-12-09 22:58:16', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2010-12-09 22:58:16', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 3, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(91, 200, 'Winter''s Bone', 'winters-bone', '', '<p><img class="caption" src="images/stories/demo/thub-4.jpg" border="0" alt="Winter''s Bone" align="left" /></p>\r\n<p>Rutrum Nunc pede Mauris urna tristique dolor convallis sed nibh et. Consectetuer et nibh id purus libero Nulla nisl dolor nulla Curabitur. Mollis Nullam dolor iaculis non ligula nunc Nulla laoreet In urna. Convallis Curabitur nisl tempus id porta et vitae Mauris quis Integer.</p>\r\n', '\r\n<p>Vitae dictum vitae non interdum sed hendrerit wisi sagittis condimentum condimentum. Metus condimentum orci hendrerit sit neque Nam tellus Phasellus neque vitae. Nam Curabitur quam Curabitur neque Curabitur libero tempor ac consectetuer Suspendisse. Tellus rhoncus felis auctor at tempus interdum nulla augue et Aenean. Curabitur dignissim lorem tristique eros sapien turpis Nunc mauris.</p>\r\n<p>Sed dui Praesent nibh Curabitur ipsum nunc facilisi risus elit eget. Pharetra commodo elit nulla suscipit nunc eros nec lacus odio tortor. Suscipit semper felis Integer dui porttitor ac eu consequat id metus. Dui Cras congue ac ante et Nam nunc tempus habitant quis. Tincidunt elit sollicitudin risus ut libero In justo fames elit facilisi. Lorem Aenean vitae lacus vel semper laoreet aliquet turpis.</p>\r\n<p>Tortor turpis justo nulla tempus sem consequat id sed elit tincidunt. Dolor orci In Aenean Aenean Sed tellus Pellentesque Pellentesque mauris Cum. Lorem lacinia felis Quisque elit Vestibulum pellentesque amet wisi Curabitur In. Aliquam Lorem vitae quis gravida dapibus nibh felis malesuada non tristique. Elit Phasellus dui feugiat mauris dictum hendrerit tincidunt volutpat purus id. At penatibus leo laoreet tempus.</p>', 1, 0, 0, 83, '2010-12-09 22:59:04', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2010-12-09 22:59:04', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 2, '', '', 1, 8, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(92, 201, 'Nowhere Boy', 'nowhere-boy', '', '<p><img class="caption" src="images/stories/demo/thub-5.jpg" border="0" alt="Nowhere Boy" align="left" /></p>\r\n<p>Urna pretium ligula Pellentesque laoreet eu malesuada Fusce id malesuada leo. Parturient nunc Nunc et mauris nulla et sit urna tincidunt nunc. Wisi wisi id elit et Vestibulum Phasellus et sapien ipsum eu. Amet quam congue congue Nulla tincidunt tortor orci lacus felis eu.</p>\r\n', '\r\n<p>Laoreet magnis in Proin felis in venenatis Sed nunc sapien condimentum. Vestibulum Morbi id Nam tellus Quisque nunc nunc ut Morbi Aenean. Suspendisse et tellus vitae In Nam platea aliquet tincidunt nisl vitae. Suscipit felis orci dui Nam Sed orci wisi vitae velit urna. Sagittis nunc id Aliquam Vivamus cursus consectetuer vel quis sed pellentesque. Justo Aliquam risus Nam tellus risus Quisque Quisque augue.</p>\r\n<p>Sed dui Praesent nibh Curabitur ipsum nunc facilisi risus elit eget. Pharetra commodo elit nulla suscipit nunc eros nec lacus odio tortor. Suscipit semper felis Integer dui porttitor ac eu consequat id metus. Dui Cras congue ac ante et Nam nunc tempus habitant quis. Tincidunt elit sollicitudin risus ut libero In justo fames elit facilisi. Lorem Aenean vitae lacus vel semper laoreet aliquet turpis.</p>\r\n<p>Tortor turpis justo nulla tempus sem consequat id sed elit tincidunt. Dolor orci In Aenean Aenean Sed tellus Pellentesque Pellentesque mauris Cum. Lorem lacinia felis Quisque elit Vestibulum pellentesque amet wisi Curabitur In. Aliquam Lorem vitae quis gravida dapibus nibh felis malesuada non tristique. Elit Phasellus dui feugiat mauris dictum hendrerit tincidunt volutpat purus id. At penatibus leo laoreet tempus.</p>', 1, 0, 0, 83, '2010-12-09 22:59:49', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2010-12-09 22:59:49', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 1, '', '', 1, 2, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(93, 202, 'Jonah Hex', 'jonah-hex', '', '<p><img class="caption" src="images/stories/demo/thub-6.jpg" border="0" alt="Jonah Hex" align="left" /></p>\r\n<p>Quis convallis et id Aliquam leo Vestibulum lobortis lorem fames orci. In in Curabitur nec neque dolor sem amet Phasellus Curabitur Curabitur. Nulla mattis Curabitur eget dolor Quisque pellentesque orci Sed et semper. Quis et at consequat leo Curabitur at hendrerit quis id consectetuer. Nibh nibh congue Vestibulum pretium id In wisi porttitor libero nisl.</p>\r\n', '\r\n<p>Vitae dictum vitae non interdum sed hendrerit wisi sagittis condimentum condimentum. Metus condimentum orci hendrerit sit neque Nam tellus Phasellus neque vitae. Nam Curabitur quam Curabitur neque Curabitur libero tempor ac consectetuer Suspendisse. Tellus rhoncus felis auctor at tempus interdum nulla augue et Aenean. Curabitur dignissim lorem tristique eros sapien turpis Nunc mauris.</p>\r\n<p>Sed dui Praesent nibh Curabitur ipsum nunc facilisi risus elit eget. Pharetra commodo elit nulla suscipit nunc eros nec lacus odio tortor. Suscipit semper felis Integer dui porttitor ac eu consequat id metus. Dui Cras congue ac ante et Nam nunc tempus habitant quis. Tincidunt elit sollicitudin risus ut libero In justo fames elit facilisi. Lorem Aenean vitae lacus vel semper laoreet aliquet turpis.</p>\r\n<p>Tortor turpis justo nulla tempus sem consequat id sed elit tincidunt. Dolor orci In Aenean Aenean Sed tellus Pellentesque Pellentesque mauris Cum. Lorem lacinia felis Quisque elit Vestibulum pellentesque amet wisi Curabitur In. Aliquam Lorem vitae quis gravida dapibus nibh felis malesuada non tristique. Elit Phasellus dui feugiat mauris dictum hendrerit tincidunt volutpat purus id. At penatibus leo laoreet tempus.</p>', 1, 0, 0, 83, '2010-12-09 23:00:30', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2010-12-09 23:00:30', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 0, '', '', 1, 43, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `title_alias`, `introtext`, `fulltext`, `state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(94, 203, 'JA Anion''s Typography', 'ja-anions-typography', '', '<div id="ja-typo">\r\n<p>This page presents most of typographical aspects of JA T3v2 Framework. <span class="highlight">Make your readers happy</span> with great Typography and User Experience!</p>\r\n<div class="ja-typo-blockswrap clearfix">\r\n<h1 class="ja-typo-title"><span>Preformatted text</span></h1>\r\n<div class="ja-typo-blockrow cols-1 clearfix">\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Headings</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<h1>This is a sample Heading 1. Lorem ipsum.</h1>\r\n<h2>This is a sample Heading 2. Lorem ipsum.</h2>\r\n<h3>This is a sample Heading 3. Lorem ipsum.</h3>\r\n<h4>This is a sample Heading 4. Lorem ipsum.</h4>\r\n<h5>This is a sample Heading 5. Lorem ipsum.</h5>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-blockrow cols-1 clearfix">\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Special Content</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<p>Below is a sample of <strong>pre</strong> tag or <strong>code</strong> class:</p>\r\n<pre>#ja-rightcol {\r\n  width: 180px;\r\n  float: right;\r\n  color: #EEEEEE;\r\n}\r\n</pre>\r\n<p>This is a <span class="highlight">highlight phrase</span>. Use <strong>class="highlight"</strong>.</p>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Blockquote</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<blockquote><span class="open">T</span>his is a sample <strong>Blockquote</strong>. Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</blockquote>\r\n<blockquote><span class="open">T</span>his is a sample Blockquote. Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.<span class="close">!</span></blockquote>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Dropcaps</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<p><span class="dropcap">T</span>his is a Magazine Style Drop Cap. The first  letter in this paragraph is big. JA Templates bring into your Jooomla  template the magazine drop cap technique and CSS2 includes the  first-letter pseudo class.</p>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-blockswrap clearfix">\r\n<h1 class="ja-typo-title"><span>Lists Style</span></h1>\r\n<div class="ja-typo-blockrow cols-3 clearfix">\r\n<div class="ja-typo-block first clearfix">\r\n<h2 class="ja-typo-title"><span>Ordered List</span></h2>\r\n<div class="ja-typo-blockct clearfix"><ol>\r\n<li>This is a sample <strong>Ordered List</strong>.</li>\r\n<li>Lorem ipsum dolor sit amet consectetur</li>\r\n<li>Lorem ipsum dolor sit amet consectetur</li>\r\n<li>Lorem ipsum dolor sit amet consectetur</li>\r\n</ol></div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Un-Ordered List</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<ul>\r\n<li>This is a sample <strong>Unordered List</strong>.</li>\r\n<li>Lorem ipsum dolor sit amet consectetur</li>\r\n<li>Lorem ipsum dolor sit amet consectetur</li>\r\n<li>Lorem ipsum dolor sit amet consectetur</li>\r\n</ul>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block last clearfix">\r\n<h2 class="ja-typo-title"><span>Definition List</span></h2>\r\n<div class="ja-typo-blockct clearfix"><dl> <dt>This is a sample <strong>Definition List</strong>.</dt> <dd>Condimentum quis.</dd> <dd>Congue Quisque augue elit dolor.</dd> <dd>Congue Quisque augue elit dolor.</dd> </dl></div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-blockrow cols-3 clearfix">\r\n<h2 class="ja-typo-title"><span>Special Unordered Lists</span></h2>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<ul class="ja-typo-list list-arrow">\r\n<li><span class="icon"> </span>This is a sample <strong>Arrow list</strong>.</li>\r\n<li><span class="icon"> </span>Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</li>\r\n<li><span class="icon"> </span>This is a sample Arrowlist.</li>\r\n</ul>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<ul class="ja-typo-list list-star">\r\n<li><span class="icon"> </span>This is a sample <strong>Star list</strong>.</li>\r\n<li><span class="icon"> </span>Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</li>\r\n<li><span class="icon"> </span>This is a sample Starlist.</li>\r\n</ul>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<ul class="ja-typo-list list-check">\r\n<li><span class="icon"> </span>This is a sample <strong>Check list</strong>.</li>\r\n<li><span class="icon"> </span>Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</li>\r\n<li><span class="icon"> </span>This is a sample Checklist.</li>\r\n</ul>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-blockrow cols-3 clearfix">\r\n<h2 class="ja-typo-title"><span>Block Number</span></h2>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<p class="blocknumber blocknumber-1"><span class="bignumber">01</span>Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n<p class="blocknumber blocknumber-1"><span class="bignumber">02</span>Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n<p class="blocknumber blocknumber-1"><span class="bignumber">03</span>Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<p class="blocknumber blocknumber-2"><span class="bignumber">A</span>Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n<p class="blocknumber blocknumber-2"><span class="bignumber">B</span>Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n<p class="blocknumber blocknumber-2"><span class="bignumber">C</span>Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<p class="blocknumber blocknumber-3"><span class="bignumber">a</span>Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n<p class="blocknumber blocknumber-3"><span class="bignumber">b</span>Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n<p class="blocknumber blocknumber-3"><span class="bignumber">c</span>Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-blockswrap clearfix">\r\n<h1 class="ja-typo-title"><span>Icons Style</span></h1>\r\n<div class="ja-typo-blockrow cols-2 clearfix">\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<p class="ja-typo-icon icon-error"><span class="icon"> </span>Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n<p class="ja-typo-icon icon-message"><span class="icon"> </span>Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n<p class="ja-typo-icon icon-tips"><span class="icon"> </span>Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n<p class="ja-typo-icon icon-key"><span class="icon"> </span>Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n<p class="ja-typo-icon icon-tag"><span class="icon"> </span>Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<p class="ja-typo-icon icon-cart"><span class="icon"> </span>Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n<p class="ja-typo-icon icon-doc"><span class="icon"> </span>Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n<p class="ja-typo-icon icon-note"><span class="icon"> </span>Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n<p class="ja-typo-icon icon-photo"><span class="icon"> </span>Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n<p class="ja-typo-icon icon-mobi"><span class="icon"> </span>Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-blockswrap clearfix">\r\n<h1 class="ja-typo-title"><span>Bubbles</span></h1>\r\n<div class="ja-typo-blockrow cols-3 clearfix">\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Grey Bubbles</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<div class="ja-typo-bubble bubble-1">\r\n<div class="ja-typo-bubblect">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla dapibus sapien vel mauris viverra quis euismod dui tincidunt. Phasellus laoreet mattis est, eu vulputate sapien.</div>\r\n<p class="ja-typo-bubble-meta"><span class="ja-typo-bubble-arrow"> </span> <span class="ja-typo-bubble-author">Author Name</span></p>\r\n</div>\r\n<div class="ja-typo-bubble bubble-2">\r\n<div class="ja-typo-bubblect">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla dapibus sapien vel mauris viverra quis euismod dui tincidunt. Phasellus laoreet mattis est, eu vulputate sapien.</div>\r\n<p class="ja-typo-bubble-meta"><span class="ja-typo-bubble-arrow"> </span> <span class="ja-typo-bubble-author">Author Name</span></p>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Blue Bubbles</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<div class="ja-typo-bubble bubble-3">\r\n<div class="ja-typo-bubblect">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla dapibus sapien vel mauris viverra quis euismod dui tincidunt. Phasellus laoreet mattis est, eu vulputate sapien.</div>\r\n<p class="ja-typo-bubble-meta"><span class="ja-typo-bubble-arrow"> </span> <span class="ja-typo-bubble-author">Author Name</span></p>\r\n</div>\r\n<div class="ja-typo-bubble bubble-4">\r\n<div class="ja-typo-bubblect">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla dapibus sapien vel mauris viverra quis euismod dui tincidunt. Phasellus laoreet mattis est, eu vulputate sapien.</div>\r\n<p class="ja-typo-bubble-meta"><span class="ja-typo-bubble-arrow"> </span> <span class="ja-typo-bubble-author">Author Name</span></p>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Black Bubbles</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<div class="ja-typo-bubble bubble-5">\r\n<div class="ja-typo-bubblect">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla dapibus sapien vel mauris viverra quis euismod dui tincidunt. Phasellus laoreet mattis est, eu vulputate sapien.</div>\r\n<p class="ja-typo-bubble-meta"><span class="ja-typo-bubble-arrow"> </span> <span class="ja-typo-bubble-author">Author Name</span></p>\r\n</div>\r\n<div class="ja-typo-bubble bubble-6">\r\n<div class="ja-typo-bubblect">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla dapibus sapien vel mauris viverra quis euismod dui tincidunt. Phasellus laoreet mattis est, eu vulputate sapien.</div>\r\n<p class="ja-typo-bubble-meta"><span class="ja-typo-bubble-arrow"> </span> <span class="ja-typo-bubble-author">Author Name</span></p>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-blockrow cols-3 clearfix">\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Rounded Grey Bubbles</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<div class="ja-typo-bubble bubble-rounded bubble-1">\r\n<div class="ja-typo-bubblect">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla dapibus sapien vel mauris viverra quis euismod dui tincidunt. Phasellus laoreet mattis est, eu vulputate sapien.</div>\r\n<p class="ja-typo-bubble-meta"><span class="ja-typo-bubble-arrow"> </span> <span class="ja-typo-bubble-author">Author Name</span></p>\r\n</div>\r\n<div class="ja-typo-bubble bubble-rounded bubble-2">\r\n<div class="ja-typo-bubblect">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla dapibus sapien vel mauris viverra quis euismod dui tincidunt. Phasellus laoreet mattis est, eu vulputate sapien.</div>\r\n<p class="ja-typo-bubble-meta"><span class="ja-typo-bubble-arrow"> </span> <span class="ja-typo-bubble-author">Author Name</span></p>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Rounded Blue Bubbles</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<div class="ja-typo-bubble bubble-rounded bubble-3">\r\n<div class="ja-typo-bubblect">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla dapibus sapien vel mauris viverra quis euismod dui tincidunt. Phasellus laoreet mattis est, eu vulputate sapien.</div>\r\n<p class="ja-typo-bubble-meta"><span class="ja-typo-bubble-arrow"> </span> <span class="ja-typo-bubble-author">Author Name</span></p>\r\n</div>\r\n<div class="ja-typo-bubble bubble-rounded bubble-4">\r\n<div class="ja-typo-bubblect">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla dapibus sapien vel mauris viverra quis euismod dui tincidunt. Phasellus laoreet mattis est, eu vulputate sapien.</div>\r\n<p class="ja-typo-bubble-meta"><span class="ja-typo-bubble-arrow"> </span> <span class="ja-typo-bubble-author">Author Name</span></p>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Rounded Black Bubbles</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<div class="ja-typo-bubble bubble-rounded bubble-5">\r\n<div class="ja-typo-bubblect">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla dapibus sapien vel mauris viverra quis euismod dui tincidunt. Phasellus laoreet mattis est, eu vulputate sapien.</div>\r\n<p class="ja-typo-bubble-meta"><span class="ja-typo-bubble-arrow"> </span> <span class="ja-typo-bubble-author">Author Name</span></p>\r\n</div>\r\n<div class="ja-typo-bubble bubble-rounded bubble-6">\r\n<div class="ja-typo-bubblect">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla dapibus sapien vel mauris viverra quis euismod dui tincidunt. Phasellus laoreet mattis est, eu vulputate sapien.</div>\r\n<p class="ja-typo-bubble-meta"><span class="ja-typo-bubble-arrow"> </span> <span class="ja-typo-bubble-author">Author Name</span></p>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-blockswrap clearfix">\r\n<h1 class="ja-typo-title"><span>Message Boxes &amp; Legend Styles</span></h1>\r\n<div class="ja-typo-blockrow cols-3 clearfix">\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Message Boxes with Icons</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<p class="ja-typo-box box-sticky"><strong>This is a sticky</strong>. Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n<p class="ja-typo-box box-download"><strong>This is a download box</strong>. Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Message Boxes - Style 1</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<p class="ja-typo-box box-grey-1"><strong>This is a grey box</strong>. Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n<p class="ja-typo-box box-hilite-1"><strong>This is a hilite box</strong>. Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Message Boxes - Style 2</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<p class="ja-typo-box box-grey-2"><strong>This is a grey box</strong>. Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n<p class="ja-typo-box box-hilite-2"><strong>This is a hilite box</strong>. Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-blockrow cols-3 clearfix">\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Rounded Message Boxes with Icons</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<p class="ja-typo-box box-rounded box-sticky"><strong>This is a sticky</strong>. Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n<p class="ja-typo-box box-rounded box-download"><strong>This is a download box</strong>. Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Rounded Message Boxes - Style 1</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<p class="ja-typo-box box-rounded box-grey-1"><strong>This is a grey box</strong>. Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n<p class="ja-typo-box box-rounded box-hilite-1"><strong>This is a hilite box</strong>. Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Rounded Message Boxes - Style 2</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<p class="ja-typo-box box-rounded box-grey-2"><strong>This is a grey box</strong>. Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n<p class="ja-typo-box box-rounded box-hilite-2"><strong>This is a hilite box</strong>. Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-blockrow cols-2 clearfix">\r\n<h2 class="ja-typo-title"><span>Legends</span></h2>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<div class="ja-typo-legend legend-1">\r\n<h3 class="legend-title">Legend - Style 1</h3>\r\nLorem ipsum dolor sit amet consectetuer at elit augue In lorem. Quis Donec libero at Vivamus mi fringilla neque commodo at vitae.</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<div class="ja-typo-legend legend-2">\r\n<h3 class="legend-title">Legend - Style 2</h3>\r\nLorem ipsum dolor sit amet consectetuer at elit augue In lorem. Quis Donec libero at Vivamus mi fringilla neque commodo at vitae.</div>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-blockrow cols-2 clearfix">\r\n<h2 class="ja-typo-title"><span>Rounded Legends</span></h2>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<div class="ja-typo-legend legend-rounded legend-1">\r\n<h3 class="legend-title">Rounded Legend - Style 1</h3>\r\nLorem ipsum dolor sit amet consectetuer at elit augue In lorem. Quis Donec libero at Vivamus mi fringilla neque commodo at vitae.</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<div class="ja-typo-legend legend-rounded legend-2">\r\n<h3 class="legend-title">Rounded Legend - Style 2</h3>\r\nLorem ipsum dolor sit amet consectetuer at elit augue In lorem. Quis Donec libero at Vivamus mi fringilla neque commodo at vitae.</div>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-blockswrap clearfix">\r\n<h1 class="ja-typo-title"><span>Buttons &amp; Tags</span></h1>\r\n<div class="ja-typo-blockrow cols-1 clearfix">\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Big Buttons</span></h2>\r\n<div class="ja-typo-blockct clearfix"><a class="ja-typo-btn btn-blue ja-typo-btn-big btn-big-blue" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-green ja-typo-btn-big btn-big-green" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-red ja-typo-btn-big btn-big-red" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-orange ja-typo-btn-big btn-big-orange" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-black ja-typo-btn-big btn-big-black" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-grey ja-typo-btn-big btn-big-grey" href="#"><span>Button Text</span></a></div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Icon Buttons</span></h2>\r\n<div class="ja-typo-blockct clearfix"><a class="ja-typo-btn ja-typo-btn-icn btn-icn-save" href="#"><span><span>Button Text</span></span></a> <a class="ja-typo-btn ja-typo-btn-icn btn-icn-tip" href="#"><span><span>Button Text</span></span></a> <a class="ja-typo-btn ja-typo-btn-icn btn-icn-warning" href="#"><span><span>Button Text</span></span></a> <a class="ja-typo-btn ja-typo-btn-icn btn-icn-info" href="#"><span><span>Button Text</span></span></a> <a class="ja-typo-btn ja-typo-btn-icn btn-icn-ok" href="#"><span><span>Button Text</span></span></a></div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Small Buttons</span></h2>\r\n<div class="ja-typo-blockct clearfix"><a class="ja-typo-btn btn-blue ja-typo-btn-sm btn-sm-blue" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-green ja-typo-btn-sm btn-sm-green" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-red ja-typo-btn-sm btn-sm-red" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-orange ja-typo-btn-sm btn-sm-orange" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-black ja-typo-btn-sm btn-sm-black" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-grey ja-typo-btn-sm btn-sm-grey" href="#"><span>Button Text</span></a></div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-blockrow cols-1 clearfix">\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Rounded Big Buttons</span></h2>\r\n<div class="ja-typo-blockct clearfix"><a class="ja-typo-btn btn-rounded-big btn-blue ja-typo-btn-big btn-big-blue" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-rounded-big btn-green ja-typo-btn-big btn-big-green" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-rounded-big btn-red ja-typo-btn-big btn-big-red" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-rounded-big btn-orange ja-typo-btn-big btn-big-orange" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-rounded-big btn-black ja-typo-btn-big btn-big-black" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-rounded-big btn-grey ja-typo-btn-big btn-big-grey" href="#"><span>Button Text</span></a></div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Rounded Icon Buttons</span></h2>\r\n<div class="ja-typo-blockct clearfix"><a class="ja-typo-btn btn-rounded-icn ja-typo-btn-icn btn-icn-save" href="#"><span><span>Button Text</span></span></a> <a class="ja-typo-btn btn-rounded-icn ja-typo-btn-icn btn-icn-tip" href="#"><span><span>Button Text</span></span></a> <a class="ja-typo-btn btn-rounded-icn ja-typo-btn-icn btn-icn-warning" href="#"><span><span>Button Text</span></span></a> <a class="ja-typo-btn btn-rounded-icn ja-typo-btn-icn btn-icn-info" href="#"><span><span>Button Text</span></span></a> <a class="ja-typo-btn btn-rounded-icn ja-typo-btn-icn btn-icn-ok" href="#"><span><span>Button Text</span></span></a></div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Rounded Small Buttons</span></h2>\r\n<div class="ja-typo-blockct clearfix"><a class="ja-typo-btn btn-rounded-sm btn-blue ja-typo-btn-sm btn-sm-blue" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-rounded-sm btn-green ja-typo-btn-sm btn-sm-green" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-rounded-sm btn-red ja-typo-btn-sm btn-sm-red" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-rounded-sm btn-orange ja-typo-btn-sm btn-sm-orange" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-rounded-sm btn-black ja-typo-btn-sm btn-sm-black" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-rounded-sm btn-grey ja-typo-btn-sm btn-sm-grey" href="#"><span>Button Text</span></a></div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-blockrow cols-2 clearfix">\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Squared Tags</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<p>This is a sample <span class="ja-typo-tag tag-grey">Inline Tag</span>. Use this to provide useful information.</p>\r\n<p>This is a sample <span class="ja-typo-tag tag-blue">Inline Tag</span>. Use this to provide useful information.</p>\r\n<p>This is a sample <span class="ja-typo-tag tag-green">Inline Tag</span>. Use this to provide useful information.</p>\r\n<p>This is a sample <span class="ja-typo-tag tag-red">Inline Tag</span>. Use this to provide useful information.</p>\r\n<p>This is a sample <span class="ja-typo-tag tag-orange">Inline Tag</span>. Use this to provide useful information.</p>\r\n<p>This is a sample <span class="ja-typo-tag tag-black">Inline Tag</span>. Use this to provide useful information.</p>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Rounded Tags</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<p>This is a sample <span class="ja-typo-tag tag-rounded tag-grey">Inline Tag</span>. Use this to provide useful information.</p>\r\n<p>This is a sample <span class="ja-typo-tag tag-rounded tag-blue">Inline Tag</span>. Use this to provide useful information.</p>\r\n<p>This is a sample <span class="ja-typo-tag tag-rounded tag-green">Inline Tag</span>. Use this to provide useful information.</p>\r\n<p>This is a sample <span class="ja-typo-tag tag-rounded tag-red">Inline Tag</span>. Use this to provide useful information.</p>\r\n<p>This is a sample <span class="ja-typo-tag tag-rounded tag-orange">Inline Tag</span>. Use this to provide useful information.</p>\r\n<p>This is a sample <span class="ja-typo-tag tag-rounded tag-black">Inline Tag</span>. Use this to provide useful information.</p>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-blockswrap clearfix">\r\n<h1 class="ja-typo-title"><span>Special Module Style</span></h1>\r\n<div class="ja-typo-blockrow cols-4 clearfix">\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<div class="moduletable moduletable_badge badge-top"><span class="badge"> </span>\r\n<div class="ja-box-ct">Use module suffix: <strong>_badge badge-top</strong> to put this badge on any module you like!</div>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<div class="moduletable moduletable_badge badge-new"><span class="badge"> </span>\r\n<div class="ja-box-ct">Use module suffix: <strong>_badge badge-new</strong> to put this badge on any module you like!</div>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<div class="moduletable moduletable_badge badge-pick"><span class="badge"> </span>\r\n<div class="ja-box-ct">Use module suffix: <strong>_badge badge-pick</strong> to put this badge on any module you like!</div>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<div class="moduletable moduletable_badge badge-hot" style="margin-right: 0;"><span class="badge"> </span>\r\n<div class="ja-box-ct">Use module suffix: <strong>_badge badge-hot</strong> to put this badge on any module you like!</div>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-blockswrap clearfix">\r\n<h1 class="ja-typo-title"><span>Forms</span></h1>\r\n<div class="ja-typo-blockrow cols-3 clearfix">\r\n<h2 class="ja-typo-title"><span>Form Fieldset</span></h2>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix"><fieldset> <legend>Templates Fieldset</legend> Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla dapibus sapien vel mauris viverra quis euismod dui tincidunt. Phasellus laoreet mattis est, eu vulputate sapien suscipit ac. </fieldset></div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix"><fieldset class="ja-typo-fieldset fieldset-1"> <legend>Special Fieldset - Style 1</legend> Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla dapibus sapien vel mauris viverra quis euismod dui tincidunt. Phasellus laoreet mattis est. </fieldset></div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix"><fieldset class="ja-typo-fieldset fieldset-2"> <legend>Special Fieldset - Style 2</legend> Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla dapibus sapien vel mauris viverra quis euismod dui tincidunt. Phasellus laoreet mattis est. </fieldset></div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-blockrow cols-1 clearfix">\r\n<h2 class="ja-typo-title"><span>Form Elements</span></h2>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix"><form>\r\n<p><label for="input">Sample Input 1</label> <br /> <input class="inputbox" name="input" type="input" /></p>\r\n<p><label for="input">Sample Input 2</label> <br /> <input class="inputbox" name="input" type="input" /></p>\r\n<p><input type="radio" /><label for="radio">Sample Radio Input</label> <input type="checkbox" /><label for="checkbox">Sample CheckBox Input</label></p>\r\n<p><label for="select">Sample Select Field:</label><br /> <select id="select"><option>Option One</option><option>Option Two</option></select></p>\r\n<p><label for="textarea">Sample Textarea Field:</label><br /> <textarea class="inputbox" cols="80" rows="5">Textarea text</textarea></p>\r\n<p><button>Submit Button</button> <button>Reset Button</button></p>\r\n</form></div>\r\n</div>\r\n</div>\r\n</div>\r\n</div>', '', 1, 0, 0, 77, '2010-12-10 00:52:58', 42, '', '2011-06-01 09:29:17', 42, 42, '2011-06-01 09:32:30', '2010-12-10 00:52:58', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 15, 0, 0, '', '', 1, 120, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(95, 204, 'Content Layouts', 'content-layouts', '', '<p>Joomla! provides plenty of flexibility when displaying your Web content. Whether you are using Joomla! for a blog site, news or a Web site for a company, you''ll find one or more content styles to showcase your information. You can also change the style of content dynamically depending on your preferences. Joomla! calls how a page is laid out a <strong>layout</strong>. Use the guide below to understand which layouts are available and how you might use them.</p>\r\n', '\r\n<h2>Content</h2>\r\n<p>Joomla! makes it extremely easy to add and display content. All content  is placed where your mainbody tag in your template is located. There are three main types of layouts available in Joomla! and all of them can be customised via parameters. The display and parameters are set in the Menu Item used to display the content your working on. You create these layouts by creating a Menu Item and choosing how you want the content to display.</p>\r\n<h3>Blog Layout</h3>\r\n<p>Blog layout will show a listing of all Articles of the selected blog type (Section or Category) in the mainbody position of your template. It will give you the standard title, and Intro of each Article in that particular Category and/or Section. You can customise this layout via the use of the Preferences and Parameters, (See Article Parameters) this is done from the Menu not the Section Manager!</p>\r\n<h3>Blog Archive Layout</h3>\r\n<p>A Blog Archive layout will give you a similar output of Articles as the normal Blog Display but will add, at the top, two drop down lists for month and year plus a search button to allow Users to search for all Archived Articles from a specific month and year.</p>\r\n<h3>List Layout</h3>\r\n<p>Table layout will simply give you a <em>tabular </em>list<em> </em>of all the titles in that particular Section or Category. No Intro text will be displayed just the titles. You can set how many titles will be displayed in this table by Parameters. The table layout will also provide a filter Section so that Users can reorder, filter, and set how many titles are listed on a single page (up to 50)</p>\r\n<h2>Wrapper</h2>\r\n<p>Wrappers allow you to place stand alone applications and Third Party Web sites inside your Joomla! site. The content within a Wrapper appears within the primary content area defined by the "mainbody" tag and allows you to display their content as a part of your own site. A Wrapper will place an IFRAME into the content Section of your Web site and wrap your standard template navigation around it so it appears in the same way an Article would.</p>\r\n<h2>Content Parameters</h2>\r\n<p>The parameters for each layout type can be found on the right hand side of the editor boxes in the Menu Item configuration screen. The parameters available depend largely on what kind of layout you are configuring.</p>', 1, 0, 0, 19, '2010-12-11 17:50:00', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2010-12-11 17:50:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 0, '', '', 1, 8, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(96, 210, 'Inception', 'inception', '', '<p><img class="img-border" src="images/stories/demo/sam-20.jpg" border="0" alt="Sample Image" />Dolor Vestibulum vel tortor consequat a convallis et nibh Quisque semper. Pretium interdum at Pellentesque a et netus morbi auctor vitae Phasellus. Montes pulvinar urna semper nec Aenean dictumst orci condimentum nibh amet dictumst orci...</p>\r\n', '\r\n<p>Rutrum consequat Mauris Suspendisse nibh eget vel Lorem cursus justo nunc. Vestibulum Morbi Lorem orci Donec commodo tellus egestas ornare leo pretium. Morbi lacinia interdum nulla penatibus amet nibh adipiscing semper ligula Nunc. Vestibulum vitae molestie Vestibulum malesuada orci quis libero et adipiscing faucibus. Augue justo ligula est Nam neque Maecenas convallis nibh nisl condimentum. Cursus Morbi Proin convallis hac lorem pede mi ut consequat vitae.</p>\r\n<p>Et orci nascetur rutrum Aliquam vitae ac eleifend justo ipsum Aenean. Justo enim lobortis libero ullamcorper Vestibulum semper metus egestas porta tellus. Lobortis in id lorem orci quis pede sem mi Curabitur laoreet. Habitasse at et Phasellus Curabitur turpis consequat vel elit eros non. Dui nibh Morbi velit nec elit nibh nec dapibus laoreet libero. Fames laoreet tristique risus enim quis a.</p>\r\n<p>Dignissim ac et tellus Pellentesque wisi sed eget mollis neque Maecenas. Tellus sem et Nunc elit Curabitur laoreet consectetuer Nulla fames ante. Risus habitant justo pellentesque Aenean Curabitur non volutpat ut sed et. Nunc orci egestas justo leo Proin sapien lacinia senectus Quisque id. Elit Pellentesque porttitor lobortis dolor lobortis justo elit Nam velit tellus. Ac enim Sed justo.</p>\r\n<p>Magna convallis Nam consequat urna Aenean at dictumst ut Curabitur Cum. Sagittis et elit Vestibulum tincidunt Sed nibh pellentesque ante Pellentesque nibh. Risus Sed lacus Nam hendrerit netus odio hac nulla hac wisi. Donec facilisi mauris nec parturient In nibh tellus sodales at auctor. Orci turpis Nam nibh neque Nunc eros vel sem ac libero. Elit vitae orci mauris sed pharetra sociis neque orci dolor consectetuer. Ac lobortis.</p>\r\n<p>Mauris nibh tristique nulla libero tincidunt Pellentesque mollis interdum neque tristique. Nec non Vivamus tincidunt orci Sed ligula nisl eget wisi auctor. A consequat Vestibulum tellus id Nullam gravida sem neque mauris Nam. Quis orci dictum lacus adipiscing Nam Maecenas risus fringilla eget tincidunt. Tincidunt interdum nibh Nam orci turpis nibh Duis nunc ipsum egestas. Commodo Aenean vel volutpat justo id ac at adipiscing eu.</p>\r\n<p>Nullam ut tempor id elit orci Donec mus magna quam ligula. Vestibulum at pretium Quisque magnis Nulla semper velit Sed malesuada a. Felis tellus dolor at mus ipsum ante Vestibulum nec ut nascetur. Consequat sit Aenean ut metus laoreet risus malesuada hendrerit fames rhoncus. Vitae pede orci Sed ultrices iaculis metus urna elit ante Phasellus. Nunc.</p>', 1, 0, 0, 85, '2011-08-22 07:35:29', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2011-08-22 07:35:29', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 5, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(97, 211, 'MacGruber ', 'macgruber', '', '<p><img class="img-border" src="images/stories/demo/sam-21.jpg" border="0" alt="Sample Image" />Eros laoreet orci urna euismod augue pretium eget Suspendisse dolor convallis. Congue ac justo ut interdum libero a sollicitudin Vestibulum a mauris. Aenean tincidunt at id ac sociis nibh turpis Vestibulum In platea. Vitae Aliquam ante...</p>\r\n', '\r\n<p>Rutrum consequat Mauris Suspendisse nibh eget vel Lorem cursus justo nunc. Vestibulum Morbi Lorem orci Donec commodo tellus egestas ornare leo pretium. Morbi lacinia interdum nulla penatibus amet nibh adipiscing semper ligula Nunc. Vestibulum vitae molestie Vestibulum malesuada orci quis libero et adipiscing faucibus. Augue justo ligula est Nam neque Maecenas convallis nibh nisl condimentum. Cursus Morbi Proin convallis hac lorem pede mi ut consequat vitae.</p>\r\n<p>Et orci nascetur rutrum Aliquam vitae ac eleifend justo ipsum Aenean. Justo enim lobortis libero ullamcorper Vestibulum semper metus egestas porta tellus. Lobortis in id lorem orci quis pede sem mi Curabitur laoreet. Habitasse at et Phasellus Curabitur turpis consequat vel elit eros non. Dui nibh Morbi velit nec elit nibh nec dapibus laoreet libero. Fames laoreet tristique risus enim quis a.</p>\r\n<p>Dignissim ac et tellus Pellentesque wisi sed eget mollis neque Maecenas. Tellus sem et Nunc elit Curabitur laoreet consectetuer Nulla fames ante. Risus habitant justo pellentesque Aenean Curabitur non volutpat ut sed et. Nunc orci egestas justo leo Proin sapien lacinia senectus Quisque id. Elit Pellentesque porttitor lobortis dolor lobortis justo elit Nam velit tellus. Ac enim Sed justo.</p>\r\n<p>Magna convallis Nam consequat urna Aenean at dictumst ut Curabitur Cum. Sagittis et elit Vestibulum tincidunt Sed nibh pellentesque ante Pellentesque nibh. Risus Sed lacus Nam hendrerit netus odio hac nulla hac wisi. Donec facilisi mauris nec parturient In nibh tellus sodales at auctor. Orci turpis Nam nibh neque Nunc eros vel sem ac libero. Elit vitae orci mauris sed pharetra sociis neque orci dolor consectetuer. Ac lobortis.</p>\r\n<p>Mauris nibh tristique nulla libero tincidunt Pellentesque mollis interdum neque tristique. Nec non Vivamus tincidunt orci Sed ligula nisl eget wisi auctor. A consequat Vestibulum tellus id Nullam gravida sem neque mauris Nam. Quis orci dictum lacus adipiscing Nam Maecenas risus fringilla eget tincidunt. Tincidunt interdum nibh Nam orci turpis nibh Duis nunc ipsum egestas. Commodo Aenean vel volutpat justo id ac at adipiscing eu.</p>\r\n<p>Nullam ut tempor id elit orci Donec mus magna quam ligula. Vestibulum at pretium Quisque magnis Nulla semper velit Sed malesuada a. Felis tellus dolor at mus ipsum ante Vestibulum nec ut nascetur. Consequat sit Aenean ut metus laoreet risus malesuada hendrerit fames rhoncus. Vitae pede orci Sed ultrices iaculis metus urna elit ante Phasellus. Nunc.</p>', 1, 0, 0, 85, '2011-08-22 07:37:15', 42, '', '2011-08-22 07:40:47', 42, 0, '0000-00-00 00:00:00', '2011-08-22 07:37:15', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 4, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(98, 212, 'From Paris With Love', 'from-paris-with-love', '', '<p><img class="img-border" src="images/stories/demo/sam-22.jpg" border="0" alt="Sample Image" />Eu Sed Nunc ipsum purus penatibus iaculis Vivamus Mauris lorem mi. Libero quis odio Nulla Pellentesque sit id id cursus orci quis. Nibh Nunc fames et tincidunt risus vel mauris ipsum congue dignissim. Hendrerit sollicitudin ante Curabitur sem...</p>\r\n', '\r\n<p>Rutrum consequat Mauris Suspendisse nibh eget vel Lorem cursus justo nunc. Vestibulum Morbi Lorem orci Donec commodo tellus egestas ornare leo pretium. Morbi lacinia interdum nulla penatibus amet nibh adipiscing semper ligula Nunc. Vestibulum vitae molestie Vestibulum malesuada orci quis libero et adipiscing faucibus. Augue justo ligula est Nam neque Maecenas convallis nibh nisl condimentum. Cursus Morbi Proin convallis hac lorem pede mi ut consequat vitae.</p>\r\n<p>Et orci nascetur rutrum Aliquam vitae ac eleifend justo ipsum Aenean. Justo enim lobortis libero ullamcorper Vestibulum semper metus egestas porta tellus. Lobortis in id lorem orci quis pede sem mi Curabitur laoreet. Habitasse at et Phasellus Curabitur turpis consequat vel elit eros non. Dui nibh Morbi velit nec elit nibh nec dapibus laoreet libero. Fames laoreet tristique risus enim quis a.</p>\r\n<p>Dignissim ac et tellus Pellentesque wisi sed eget mollis neque Maecenas. Tellus sem et Nunc elit Curabitur laoreet consectetuer Nulla fames ante. Risus habitant justo pellentesque Aenean Curabitur non volutpat ut sed et. Nunc orci egestas justo leo Proin sapien lacinia senectus Quisque id. Elit Pellentesque porttitor lobortis dolor lobortis justo elit Nam velit tellus. Ac enim Sed justo.</p>\r\n<p>Magna convallis Nam consequat urna Aenean at dictumst ut Curabitur Cum. Sagittis et elit Vestibulum tincidunt Sed nibh pellentesque ante Pellentesque nibh. Risus Sed lacus Nam hendrerit netus odio hac nulla hac wisi. Donec facilisi mauris nec parturient In nibh tellus sodales at auctor. Orci turpis Nam nibh neque Nunc eros vel sem ac libero. Elit vitae orci mauris sed pharetra sociis neque orci dolor consectetuer. Ac lobortis.</p>\r\n<p>Mauris nibh tristique nulla libero tincidunt Pellentesque mollis interdum neque tristique. Nec non Vivamus tincidunt orci Sed ligula nisl eget wisi auctor. A consequat Vestibulum tellus id Nullam gravida sem neque mauris Nam. Quis orci dictum lacus adipiscing Nam Maecenas risus fringilla eget tincidunt. Tincidunt interdum nibh Nam orci turpis nibh Duis nunc ipsum egestas. Commodo Aenean vel volutpat justo id ac at adipiscing eu.</p>\r\n<p>Nullam ut tempor id elit orci Donec mus magna quam ligula. Vestibulum at pretium Quisque magnis Nulla semper velit Sed malesuada a. Felis tellus dolor at mus ipsum ante Vestibulum nec ut nascetur. Consequat sit Aenean ut metus laoreet risus malesuada hendrerit fames rhoncus. Vitae pede orci Sed ultrices iaculis metus urna elit ante Phasellus. Nunc.</p>', 1, 0, 0, 85, '2011-08-22 07:40:22', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2011-08-22 07:40:22', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 3, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `title_alias`, `introtext`, `fulltext`, `state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(99, 213, 'District 13: Ultimatum', 'district-13-ultimatum', '', '<p><img class="img-border" src="images/stories/demo/sam-23.jpg" border="0" alt="Sample Image" />Consectetuer pretium hendrerit Morbi Curabitur tincidunt enim tempus et nisl Maecenas. Elit In tellus turpis Aliquam laoreet venenatis elit velit Nulla Quisque. Arcu In volutpat Vestibulum Sed ac condimentum Nam amet Curabitur Donec. Curabitur sed...</p>\r\n', '\r\n<p>Rutrum consequat Mauris Suspendisse nibh eget vel Lorem cursus justo nunc. Vestibulum Morbi Lorem orci Donec commodo tellus egestas ornare leo pretium. Morbi lacinia interdum nulla penatibus amet nibh adipiscing semper ligula Nunc. Vestibulum vitae molestie Vestibulum malesuada orci quis libero et adipiscing faucibus. Augue justo ligula est Nam neque Maecenas convallis nibh nisl condimentum. Cursus Morbi Proin convallis hac lorem pede mi ut consequat vitae.</p>\r\n<p>Et orci nascetur rutrum Aliquam vitae ac eleifend justo ipsum Aenean. Justo enim lobortis libero ullamcorper Vestibulum semper metus egestas porta tellus. Lobortis in id lorem orci quis pede sem mi Curabitur laoreet. Habitasse at et Phasellus Curabitur turpis consequat vel elit eros non. Dui nibh Morbi velit nec elit nibh nec dapibus laoreet libero. Fames laoreet tristique risus enim quis a.</p>\r\n<p>Dignissim ac et tellus Pellentesque wisi sed eget mollis neque Maecenas. Tellus sem et Nunc elit Curabitur laoreet consectetuer Nulla fames ante. Risus habitant justo pellentesque Aenean Curabitur non volutpat ut sed et. Nunc orci egestas justo leo Proin sapien lacinia senectus Quisque id. Elit Pellentesque porttitor lobortis dolor lobortis justo elit Nam velit tellus. Ac enim Sed justo.</p>\r\n<p>Magna convallis Nam consequat urna Aenean at dictumst ut Curabitur Cum. Sagittis et elit Vestibulum tincidunt Sed nibh pellentesque ante Pellentesque nibh. Risus Sed lacus Nam hendrerit netus odio hac nulla hac wisi. Donec facilisi mauris nec parturient In nibh tellus sodales at auctor. Orci turpis Nam nibh neque Nunc eros vel sem ac libero. Elit vitae orci mauris sed pharetra sociis neque orci dolor consectetuer. Ac lobortis.</p>\r\n<p>Mauris nibh tristique nulla libero tincidunt Pellentesque mollis interdum neque tristique. Nec non Vivamus tincidunt orci Sed ligula nisl eget wisi auctor. A consequat Vestibulum tellus id Nullam gravida sem neque mauris Nam. Quis orci dictum lacus adipiscing Nam Maecenas risus fringilla eget tincidunt. Tincidunt interdum nibh Nam orci turpis nibh Duis nunc ipsum egestas. Commodo Aenean vel volutpat justo id ac at adipiscing eu.</p>\r\n<p>Nullam ut tempor id elit orci Donec mus magna quam ligula. Vestibulum at pretium Quisque magnis Nulla semper velit Sed malesuada a. Felis tellus dolor at mus ipsum ante Vestibulum nec ut nascetur. Consequat sit Aenean ut metus laoreet risus malesuada hendrerit fames rhoncus. Vitae pede orci Sed ultrices iaculis metus urna elit ante Phasellus. Nunc.</p>', 1, 0, 0, 85, '2011-08-22 07:42:19', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2011-08-22 07:42:19', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 2, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(100, 214, 'Avatar', 'avatar', '', '<p><img class="img-border" src="images/stories/demo/sam-24.jpg" border="0" alt="Sample Image" />Adipiscing condimentum dictum interdum mauris pulvinar Morbi turpis suscipit nec condimentum. Sapien dolor et eu metus ornare ut Nam Ut libero risus. Ut at elit Suspendisse mauris orci ultrices Nam et vitae ornare ultrices Nam et vitae ornare...</p>\r\n', '\r\n<p>Rutrum consequat Mauris Suspendisse nibh eget vel Lorem cursus justo nunc. Vestibulum Morbi Lorem orci Donec commodo tellus egestas ornare leo pretium. Morbi lacinia interdum nulla penatibus amet nibh adipiscing semper ligula Nunc. Vestibulum vitae molestie Vestibulum malesuada orci quis libero et adipiscing faucibus. Augue justo ligula est Nam neque Maecenas convallis nibh nisl condimentum. Cursus Morbi Proin convallis hac lorem pede mi ut consequat vitae.</p>\r\n<p>Et orci nascetur rutrum Aliquam vitae ac eleifend justo ipsum Aenean. Justo enim lobortis libero ullamcorper Vestibulum semper metus egestas porta tellus. Lobortis in id lorem orci quis pede sem mi Curabitur laoreet. Habitasse at et Phasellus Curabitur turpis consequat vel elit eros non. Dui nibh Morbi velit nec elit nibh nec dapibus laoreet libero. Fames laoreet tristique risus enim quis a.</p>\r\n<p>Dignissim ac et tellus Pellentesque wisi sed eget mollis neque Maecenas. Tellus sem et Nunc elit Curabitur laoreet consectetuer Nulla fames ante. Risus habitant justo pellentesque Aenean Curabitur non volutpat ut sed et. Nunc orci egestas justo leo Proin sapien lacinia senectus Quisque id. Elit Pellentesque porttitor lobortis dolor lobortis justo elit Nam velit tellus. Ac enim Sed justo.</p>\r\n<p>Magna convallis Nam consequat urna Aenean at dictumst ut Curabitur Cum. Sagittis et elit Vestibulum tincidunt Sed nibh pellentesque ante Pellentesque nibh. Risus Sed lacus Nam hendrerit netus odio hac nulla hac wisi. Donec facilisi mauris nec parturient In nibh tellus sodales at auctor. Orci turpis Nam nibh neque Nunc eros vel sem ac libero. Elit vitae orci mauris sed pharetra sociis neque orci dolor consectetuer. Ac lobortis.</p>\r\n<p>Mauris nibh tristique nulla libero tincidunt Pellentesque mollis interdum neque tristique. Nec non Vivamus tincidunt orci Sed ligula nisl eget wisi auctor. A consequat Vestibulum tellus id Nullam gravida sem neque mauris Nam. Quis orci dictum lacus adipiscing Nam Maecenas risus fringilla eget tincidunt. Tincidunt interdum nibh Nam orci turpis nibh Duis nunc ipsum egestas. Commodo Aenean vel volutpat justo id ac at adipiscing eu.</p>\r\n<p>Nullam ut tempor id elit orci Donec mus magna quam ligula. Vestibulum at pretium Quisque magnis Nulla semper velit Sed malesuada a. Felis tellus dolor at mus ipsum ante Vestibulum nec ut nascetur. Consequat sit Aenean ut metus laoreet risus malesuada hendrerit fames rhoncus. Vitae pede orci Sed ultrices iaculis metus urna elit ante Phasellus. Nunc.</p>', 1, 0, 0, 85, '2011-08-22 07:43:30', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2011-08-22 07:43:30', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 1, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(101, 215, 'The A-Team', 'the-a-team', '', '<p><img class="img-border" src="images/stories/demo/sam-25.jpg" border="0" alt="Sample Image" />Aenean Phasellus semper tellus semper augue tellus urna tortor lorem  quis. Laoreet sem adipiscing metus massa hendrerit id Vestibulum  lobortis neque eget. Justo congue nunc convallis tempus tempus nunc.  Justo congue nunc convallis...</p>\r\n', '\r\n<p>Rutrum consequat Mauris Suspendisse nibh eget vel Lorem cursus justo  nunc. Vestibulum Morbi Lorem orci Donec commodo tellus egestas ornare  leo pretium. Morbi lacinia interdum nulla penatibus amet nibh adipiscing  semper ligula Nunc. Vestibulum vitae molestie Vestibulum malesuada orci  quis libero et adipiscing faucibus. Augue justo ligula est Nam neque  Maecenas convallis nibh nisl condimentum. Cursus Morbi Proin convallis  hac lorem pede mi ut consequat vitae.</p>\r\n<p>Et orci nascetur rutrum Aliquam vitae ac eleifend justo ipsum Aenean.  Justo enim lobortis libero ullamcorper Vestibulum semper metus egestas  porta tellus. Lobortis in id lorem orci quis pede sem mi Curabitur  laoreet. Habitasse at et Phasellus Curabitur turpis consequat vel elit  eros non. Dui nibh Morbi velit nec elit nibh nec dapibus laoreet libero.  Fames laoreet tristique risus enim quis a.</p>\r\n<p>Dignissim ac et tellus Pellentesque wisi sed eget mollis neque  Maecenas. Tellus sem et Nunc elit Curabitur laoreet consectetuer Nulla  fames ante. Risus habitant justo pellentesque Aenean Curabitur non  volutpat ut sed et. Nunc orci egestas justo leo Proin sapien lacinia  senectus Quisque id. Elit Pellentesque porttitor lobortis dolor lobortis  justo elit Nam velit tellus. Ac enim Sed justo.</p>\r\n<p>Magna convallis Nam consequat urna Aenean at dictumst ut Curabitur  Cum. Sagittis et elit Vestibulum tincidunt Sed nibh pellentesque ante  Pellentesque nibh. Risus Sed lacus Nam hendrerit netus odio hac nulla  hac wisi. Donec facilisi mauris nec parturient In nibh tellus sodales at  auctor. Orci turpis Nam nibh neque Nunc eros vel sem ac libero. Elit  vitae orci mauris sed pharetra sociis neque orci dolor consectetuer. Ac  lobortis.</p>\r\n<p>Mauris nibh tristique nulla libero tincidunt Pellentesque mollis  interdum neque tristique. Nec non Vivamus tincidunt orci Sed ligula nisl  eget wisi auctor. A consequat Vestibulum tellus id Nullam gravida sem  neque mauris Nam. Quis orci dictum lacus adipiscing Nam Maecenas risus  fringilla eget tincidunt. Tincidunt interdum nibh Nam orci turpis nibh  Duis nunc ipsum egestas. Commodo Aenean vel volutpat justo id ac at  adipiscing eu.</p>\r\n<p>Nullam ut tempor id elit orci Donec mus magna quam ligula. Vestibulum  at pretium Quisque magnis Nulla semper velit Sed malesuada a. Felis  tellus dolor at mus ipsum ante Vestibulum nec ut nascetur. Consequat sit  Aenean ut metus laoreet risus malesuada hendrerit fames rhoncus. Vitae  pede orci Sed ultrices iaculis metus urna elit ante Phasellus. Nunc.</p>', 1, 0, 0, 85, '2011-08-22 07:44:56', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2011-08-22 07:44:56', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 0, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(102, 216, 'Spring Fever ', 'spring-fever', '', '<p><img class="img-border" src="images/stories/demo/sam-26.jpg" border="0" alt="Sample Image" />Adipiscing condimentum dictum interdum mauris pulvinar Morbi turpis  suscipit nec condimentum. Sapien dolor et eu metus ornare ut Nam Ut  libero risus. Ut at elit Suspendisse mauris orci ultrices Nam et vitae  ornare ultrices Nam et vitae ornare...</p>\r\n', '\r\n<p>Rutrum consequat Mauris Suspendisse nibh eget vel Lorem cursus justo  nunc. Vestibulum Morbi Lorem orci Donec commodo tellus egestas ornare  leo pretium. Morbi lacinia interdum nulla penatibus amet nibh adipiscing  semper ligula Nunc. Vestibulum vitae molestie Vestibulum malesuada orci  quis libero et adipiscing faucibus. Augue justo ligula est Nam neque  Maecenas convallis nibh nisl condimentum. Cursus Morbi Proin convallis  hac lorem pede mi ut consequat vitae.</p>\r\n<p>Et orci nascetur rutrum Aliquam vitae ac eleifend justo ipsum Aenean.  Justo enim lobortis libero ullamcorper Vestibulum semper metus egestas  porta tellus. Lobortis in id lorem orci quis pede sem mi Curabitur  laoreet. Habitasse at et Phasellus Curabitur turpis consequat vel elit  eros non. Dui nibh Morbi velit nec elit nibh nec dapibus laoreet libero.  Fames laoreet tristique risus enim quis a.</p>\r\n<p>Dignissim ac et tellus Pellentesque wisi sed eget mollis neque  Maecenas. Tellus sem et Nunc elit Curabitur laoreet consectetuer Nulla  fames ante. Risus habitant justo pellentesque Aenean Curabitur non  volutpat ut sed et. Nunc orci egestas justo leo Proin sapien lacinia  senectus Quisque id. Elit Pellentesque porttitor lobortis dolor lobortis  justo elit Nam velit tellus. Ac enim Sed justo.</p>\r\n<p>Magna convallis Nam consequat urna Aenean at dictumst ut Curabitur  Cum. Sagittis et elit Vestibulum tincidunt Sed nibh pellentesque ante  Pellentesque nibh. Risus Sed lacus Nam hendrerit netus odio hac nulla  hac wisi. Donec facilisi mauris nec parturient In nibh tellus sodales at  auctor. Orci turpis Nam nibh neque Nunc eros vel sem ac libero. Elit  vitae orci mauris sed pharetra sociis neque orci dolor consectetuer. Ac  lobortis.</p>\r\n<p>Mauris nibh tristique nulla libero tincidunt Pellentesque mollis  interdum neque tristique. Nec non Vivamus tincidunt orci Sed ligula nisl  eget wisi auctor. A consequat Vestibulum tellus id Nullam gravida sem  neque mauris Nam. Quis orci dictum lacus adipiscing Nam Maecenas risus  fringilla eget tincidunt. Tincidunt interdum nibh Nam orci turpis nibh  Duis nunc ipsum egestas. Commodo Aenean vel volutpat justo id ac at  adipiscing eu.</p>\r\n<p>Nullam ut tempor id elit orci Donec mus magna quam ligula. Vestibulum  at pretium Quisque magnis Nulla semper velit Sed malesuada a. Felis  tellus dolor at mus ipsum ante Vestibulum nec ut nascetur. Consequat sit  Aenean ut metus laoreet risus malesuada hendrerit fames rhoncus. Vitae  pede orci Sed ultrices iaculis metus urna elit ante Phasellus. Nunc.</p>', 1, 0, 0, 86, '2011-08-22 07:47:18', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2011-08-22 07:47:18', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 5, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(103, 217, 'Charlie St. Cloud', 'charlie-st-cloud', '', '<p><img class="img-border" src="images/stories/demo/sam-27.jpg" border="0" alt="Sample Image" />Consectetuer pretium hendrerit Morbi Curabitur tincidunt enim tempus  et nisl Maecenas. Elit In tellus turpis Aliquam laoreet venenatis elit  velit Nulla Quisque. Arcu In volutpat Vestibulum Sed ac condimentum Nam  amet Curabitur Donec. Curabitur sed...</p>\r\n', '\r\n<p>Rutrum consequat Mauris Suspendisse nibh eget vel Lorem cursus justo  nunc. Vestibulum Morbi Lorem orci Donec commodo tellus egestas ornare  leo pretium. Morbi lacinia interdum nulla penatibus amet nibh adipiscing  semper ligula Nunc. Vestibulum vitae molestie Vestibulum malesuada orci  quis libero et adipiscing faucibus. Augue justo ligula est Nam neque  Maecenas convallis nibh nisl condimentum. Cursus Morbi Proin convallis  hac lorem pede mi ut consequat vitae.</p>\r\n<p>Et orci nascetur rutrum Aliquam vitae ac eleifend justo ipsum Aenean.  Justo enim lobortis libero ullamcorper Vestibulum semper metus egestas  porta tellus. Lobortis in id lorem orci quis pede sem mi Curabitur  laoreet. Habitasse at et Phasellus Curabitur turpis consequat vel elit  eros non. Dui nibh Morbi velit nec elit nibh nec dapibus laoreet libero.  Fames laoreet tristique risus enim quis a.</p>\r\n<p>Dignissim ac et tellus Pellentesque wisi sed eget mollis neque  Maecenas. Tellus sem et Nunc elit Curabitur laoreet consectetuer Nulla  fames ante. Risus habitant justo pellentesque Aenean Curabitur non  volutpat ut sed et. Nunc orci egestas justo leo Proin sapien lacinia  senectus Quisque id. Elit Pellentesque porttitor lobortis dolor lobortis  justo elit Nam velit tellus. Ac enim Sed justo.</p>\r\n<p>Magna convallis Nam consequat urna Aenean at dictumst ut Curabitur  Cum. Sagittis et elit Vestibulum tincidunt Sed nibh pellentesque ante  Pellentesque nibh. Risus Sed lacus Nam hendrerit netus odio hac nulla  hac wisi. Donec facilisi mauris nec parturient In nibh tellus sodales at  auctor. Orci turpis Nam nibh neque Nunc eros vel sem ac libero. Elit  vitae orci mauris sed pharetra sociis neque orci dolor consectetuer. Ac  lobortis.</p>\r\n<p>Mauris nibh tristique nulla libero tincidunt Pellentesque mollis  interdum neque tristique. Nec non Vivamus tincidunt orci Sed ligula nisl  eget wisi auctor. A consequat Vestibulum tellus id Nullam gravida sem  neque mauris Nam. Quis orci dictum lacus adipiscing Nam Maecenas risus  fringilla eget tincidunt. Tincidunt interdum nibh Nam orci turpis nibh  Duis nunc ipsum egestas. Commodo Aenean vel volutpat justo id ac at  adipiscing eu.</p>\r\n<p>Nullam ut tempor id elit orci Donec mus magna quam ligula. Vestibulum  at pretium Quisque magnis Nulla semper velit Sed malesuada a. Felis  tellus dolor at mus ipsum ante Vestibulum nec ut nascetur. Consequat sit  Aenean ut metus laoreet risus malesuada hendrerit fames rhoncus. Vitae  pede orci Sed ultrices iaculis metus urna elit ante Phasellus. Nunc.</p>', 1, 0, 0, 86, '2011-08-22 07:49:57', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2011-08-22 07:49:57', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 4, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(104, 218, 'Just Wright', 'just-wright', '', '<p><img class="img-border" src="images/stories/demo/sam-28.jpg" border="0" alt="Sample Image" />Eu Sed Nunc ipsum purus penatibus iaculis Vivamus Mauris lorem mi.  Libero quis odio Nulla Pellentesque sit id id cursus orci quis. Nibh  Nunc fames et tincidunt risus vel mauris ipsum congue dignissim.  Hendrerit sollicitudin ante Curabitur sem...</p>\r\n', '\r\n<p>Rutrum consequat Mauris Suspendisse nibh eget vel Lorem cursus justo  nunc. Vestibulum Morbi Lorem orci Donec commodo tellus egestas ornare  leo pretium. Morbi lacinia interdum nulla penatibus amet nibh adipiscing  semper ligula Nunc. Vestibulum vitae molestie Vestibulum malesuada orci  quis libero et adipiscing faucibus. Augue justo ligula est Nam neque  Maecenas convallis nibh nisl condimentum. Cursus Morbi Proin convallis  hac lorem pede mi ut consequat vitae.</p>\r\n<p>Et orci nascetur rutrum Aliquam vitae ac eleifend justo ipsum Aenean.  Justo enim lobortis libero ullamcorper Vestibulum semper metus egestas  porta tellus. Lobortis in id lorem orci quis pede sem mi Curabitur  laoreet. Habitasse at et Phasellus Curabitur turpis consequat vel elit  eros non. Dui nibh Morbi velit nec elit nibh nec dapibus laoreet libero.  Fames laoreet tristique risus enim quis a.</p>\r\n<p>Dignissim ac et tellus Pellentesque wisi sed eget mollis neque  Maecenas. Tellus sem et Nunc elit Curabitur laoreet consectetuer Nulla  fames ante. Risus habitant justo pellentesque Aenean Curabitur non  volutpat ut sed et. Nunc orci egestas justo leo Proin sapien lacinia  senectus Quisque id. Elit Pellentesque porttitor lobortis dolor lobortis  justo elit Nam velit tellus. Ac enim Sed justo.</p>\r\n<p>Magna convallis Nam consequat urna Aenean at dictumst ut Curabitur  Cum. Sagittis et elit Vestibulum tincidunt Sed nibh pellentesque ante  Pellentesque nibh. Risus Sed lacus Nam hendrerit netus odio hac nulla  hac wisi. Donec facilisi mauris nec parturient In nibh tellus sodales at  auctor. Orci turpis Nam nibh neque Nunc eros vel sem ac libero. Elit  vitae orci mauris sed pharetra sociis neque orci dolor consectetuer. Ac  lobortis.</p>\r\n<p>Mauris nibh tristique nulla libero tincidunt Pellentesque mollis  interdum neque tristique. Nec non Vivamus tincidunt orci Sed ligula nisl  eget wisi auctor. A consequat Vestibulum tellus id Nullam gravida sem  neque mauris Nam. Quis orci dictum lacus adipiscing Nam Maecenas risus  fringilla eget tincidunt. Tincidunt interdum nibh Nam orci turpis nibh  Duis nunc ipsum egestas. Commodo Aenean vel volutpat justo id ac at  adipiscing eu.</p>\r\n<p>Nullam ut tempor id elit orci Donec mus magna quam ligula. Vestibulum  at pretium Quisque magnis Nulla semper velit Sed malesuada a. Felis  tellus dolor at mus ipsum ante Vestibulum nec ut nascetur. Consequat sit  Aenean ut metus laoreet risus malesuada hendrerit fames rhoncus. Vitae  pede orci Sed ultrices iaculis metus urna elit ante Phasellus. Nunc.</p>', 1, 0, 0, 86, '2011-08-22 07:50:52', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2011-08-22 07:50:52', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 3, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(105, 219, 'Letters To Juliet', 'letters-to-juliet', '', '<p><img class="img-border" src="images/stories/demo/sam-29.jpg" border="0" alt="Sample Image" />Eros laoreet orci urna euismod augue pretium eget Suspendisse dolor  convallis. Congue ac justo ut interdum libero a sollicitudin Vestibulum a  mauris. Aenean tincidunt at id ac sociis nibh turpis Vestibulum In  platea. Vitae Aliquam ante...</p>\r\n', '\r\n<p>Rutrum consequat Mauris Suspendisse nibh eget vel Lorem cursus justo  nunc. Vestibulum Morbi Lorem orci Donec commodo tellus egestas ornare  leo pretium. Morbi lacinia interdum nulla penatibus amet nibh adipiscing  semper ligula Nunc. Vestibulum vitae molestie Vestibulum malesuada orci  quis libero et adipiscing faucibus. Augue justo ligula est Nam neque  Maecenas convallis nibh nisl condimentum. Cursus Morbi Proin convallis  hac lorem pede mi ut consequat vitae.</p>\r\n<p>Et orci nascetur rutrum Aliquam vitae ac eleifend justo ipsum Aenean.  Justo enim lobortis libero ullamcorper Vestibulum semper metus egestas  porta tellus. Lobortis in id lorem orci quis pede sem mi Curabitur  laoreet. Habitasse at et Phasellus Curabitur turpis consequat vel elit  eros non. Dui nibh Morbi velit nec elit nibh nec dapibus laoreet libero.  Fames laoreet tristique risus enim quis a.</p>\r\n<p>Dignissim ac et tellus Pellentesque wisi sed eget mollis neque  Maecenas. Tellus sem et Nunc elit Curabitur laoreet consectetuer Nulla  fames ante. Risus habitant justo pellentesque Aenean Curabitur non  volutpat ut sed et. Nunc orci egestas justo leo Proin sapien lacinia  senectus Quisque id. Elit Pellentesque porttitor lobortis dolor lobortis  justo elit Nam velit tellus. Ac enim Sed justo.</p>\r\n<p>Magna convallis Nam consequat urna Aenean at dictumst ut Curabitur  Cum. Sagittis et elit Vestibulum tincidunt Sed nibh pellentesque ante  Pellentesque nibh. Risus Sed lacus Nam hendrerit netus odio hac nulla  hac wisi. Donec facilisi mauris nec parturient In nibh tellus sodales at  auctor. Orci turpis Nam nibh neque Nunc eros vel sem ac libero. Elit  vitae orci mauris sed pharetra sociis neque orci dolor consectetuer. Ac  lobortis.</p>\r\n<p>Mauris nibh tristique nulla libero tincidunt Pellentesque mollis  interdum neque tristique. Nec non Vivamus tincidunt orci Sed ligula nisl  eget wisi auctor. A consequat Vestibulum tellus id Nullam gravida sem  neque mauris Nam. Quis orci dictum lacus adipiscing Nam Maecenas risus  fringilla eget tincidunt. Tincidunt interdum nibh Nam orci turpis nibh  Duis nunc ipsum egestas. Commodo Aenean vel volutpat justo id ac at  adipiscing eu.</p>\r\n<p>Nullam ut tempor id elit orci Donec mus magna quam ligula. Vestibulum  at pretium Quisque magnis Nulla semper velit Sed malesuada a. Felis  tellus dolor at mus ipsum ante Vestibulum nec ut nascetur. Consequat sit  Aenean ut metus laoreet risus malesuada hendrerit fames rhoncus. Vitae  pede orci Sed ultrices iaculis metus urna elit ante Phasellus. Nunc.</p>', 1, 0, 0, 86, '2011-08-22 07:53:02', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2011-08-22 07:53:02', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 2, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(106, 220, 'Kites', 'kites', '', '<p><img class="img-border" src="images/stories/demo/sam-30.jpg" border="0" alt="Sample Image" />Dolor Vestibulum vel tortor consequat a convallis et nibh Quisque  semper. Pretium interdum at Pellentesque a et netus morbi auctor vitae  Phasellus. Montes pulvinar urna semper nec Aenean dictumst orci  condimentum nibh amet dictumst orci...</p>\r\n', '\r\n<p>Rutrum consequat Mauris Suspendisse nibh eget vel Lorem cursus justo  nunc. Vestibulum Morbi Lorem orci Donec commodo tellus egestas ornare  leo pretium. Morbi lacinia interdum nulla penatibus amet nibh adipiscing  semper ligula Nunc. Vestibulum vitae molestie Vestibulum malesuada orci  quis libero et adipiscing faucibus. Augue justo ligula est Nam neque  Maecenas convallis nibh nisl condimentum. Cursus Morbi Proin convallis  hac lorem pede mi ut consequat vitae.</p>\r\n<p>Et orci nascetur rutrum Aliquam vitae ac eleifend justo ipsum Aenean.  Justo enim lobortis libero ullamcorper Vestibulum semper metus egestas  porta tellus. Lobortis in id lorem orci quis pede sem mi Curabitur  laoreet. Habitasse at et Phasellus Curabitur turpis consequat vel elit  eros non. Dui nibh Morbi velit nec elit nibh nec dapibus laoreet libero.  Fames laoreet tristique risus enim quis a.</p>\r\n<p>Dignissim ac et tellus Pellentesque wisi sed eget mollis neque  Maecenas. Tellus sem et Nunc elit Curabitur laoreet consectetuer Nulla  fames ante. Risus habitant justo pellentesque Aenean Curabitur non  volutpat ut sed et. Nunc orci egestas justo leo Proin sapien lacinia  senectus Quisque id. Elit Pellentesque porttitor lobortis dolor lobortis  justo elit Nam velit tellus. Ac enim Sed justo.</p>\r\n<p>Magna convallis Nam consequat urna Aenean at dictumst ut Curabitur  Cum. Sagittis et elit Vestibulum tincidunt Sed nibh pellentesque ante  Pellentesque nibh. Risus Sed lacus Nam hendrerit netus odio hac nulla  hac wisi. Donec facilisi mauris nec parturient In nibh tellus sodales at  auctor. Orci turpis Nam nibh neque Nunc eros vel sem ac libero. Elit  vitae orci mauris sed pharetra sociis neque orci dolor consectetuer. Ac  lobortis.</p>\r\n<p>Mauris nibh tristique nulla libero tincidunt Pellentesque mollis  interdum neque tristique. Nec non Vivamus tincidunt orci Sed ligula nisl  eget wisi auctor. A consequat Vestibulum tellus id Nullam gravida sem  neque mauris Nam. Quis orci dictum lacus adipiscing Nam Maecenas risus  fringilla eget tincidunt. Tincidunt interdum nibh Nam orci turpis nibh  Duis nunc ipsum egestas. Commodo Aenean vel volutpat justo id ac at  adipiscing eu.</p>\r\n<p>Nullam ut tempor id elit orci Donec mus magna quam ligula. Vestibulum  at pretium Quisque magnis Nulla semper velit Sed malesuada a. Felis  tellus dolor at mus ipsum ante Vestibulum nec ut nascetur. Consequat sit  Aenean ut metus laoreet risus malesuada hendrerit fames rhoncus. Vitae  pede orci Sed ultrices iaculis metus urna elit ante Phasellus. Nunc.</p>', 1, 0, 0, 86, '2011-08-22 07:54:25', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2011-08-22 07:54:25', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 1, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(107, 221, 'Leap Year', 'leap-year', '', '<p><img class="img-border" src="images/stories/demo/sam-31.jpg" border="0" alt="Sample Image" />Urna porta vitae elit vel quis orci justo Morbi urna eu. Sed ac  cursus tincidunt pede Aenean fames pulvinar lacinia montes orci. Nec ac  id et nibh orci tempus neque convallis tellus Praesent. Elit et  condimentum sodales at auctor sodales at auctor</p>\r\n', '\r\n<p>Magna convallis Nam consequat urna Aenean at dictumst ut Curabitur  Cum. Sagittis et elit Vestibulum tincidunt Sed nibh pellentesque ante  Pellentesque nibh. Risus Sed lacus Nam hendrerit netus odio hac nulla  hac wisi. Donec facilisi mauris nec parturient In nibh tellus sodales at  auctor. Orci turpis Nam nibh neque Nunc eros vel sem ac libero. Elit  vitae orci mauris sed pharetra sociis neque orci dolor consectetuer. Ac  lobortis.</p>\r\n<p>Mauris nibh tristique nulla libero tincidunt Pellentesque mollis  interdum neque tristique. Nec non Vivamus tincidunt orci Sed ligula nisl  eget wisi auctor. A consequat Vestibulum tellus id Nullam gravida sem  neque mauris Nam. Quis orci dictum lacus adipiscing Nam Maecenas risus  fringilla eget tincidunt. Tincidunt interdum nibh Nam orci turpis nibh  Duis nunc ipsum egestas. Commodo Aenean vel volutpat justo id ac at  adipiscing eu.</p>\r\n<p>Nullam ut tempor id elit orci Donec mus magna quam ligula. Vestibulum  at pretium Quisque magnis Nulla semper velit Sed malesuada a. Felis  tellus dolor at mus ipsum ante Vestibulum nec ut nascetur. Consequat sit  Aenean ut metus laoreet risus malesuada hendrerit fames rhoncus. Vitae  pede orci Sed ultrices iaculis metus urna elit ante Phasellus. Nunc.</p>\r\n<p>Curabitur condimentum quis consectetuer volutpat Pellentesque nulla  Lorem pretium ac dui. Et ligula sagittis eros lacinia consequat  habitasse Morbi orci tellus dictumst. Sit in amet pretium vel semper  nibh quis pretium facilisis urna. Nisl quis fames sem lacus pellentesque  nec Ut Curabitur Sed elit. Ut ac hendrerit vitae Phasellus dis quis leo  condimentum dictumst Vestibulum. Fringilla In metus natoque Aenean  Fusce et sed tempor libero felis.</p>', 1, 0, 0, 86, '2011-08-22 08:00:45', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2011-08-22 08:00:45', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 0, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(108, 222, 'Our Family Wedding', 'our-family-wedding', '', '<p><img class="img-border" src="images/stories/demo/sam-32.jpg" border="0" alt="Sample Image" />Congue ac justo ut interdum libero a sollicitudin Vestibulum a  mauris. Aenean tincidunt at id ac sociis nibh turpis Vestibulum In  platea. Vitae Aliquam ante...</p>\r\n', '\r\n<p>Rutrum consequat Mauris Suspendisse nibh eget vel Lorem cursus justo  nunc. Vestibulum Morbi Lorem orci Donec commodo tellus egestas ornare  leo pretium. Morbi lacinia interdum nulla penatibus amet nibh adipiscing  semper ligula Nunc. Vestibulum vitae molestie Vestibulum malesuada orci  quis libero et adipiscing faucibus. Augue justo ligula est Nam neque  Maecenas convallis nibh nisl condimentum. Cursus Morbi Proin convallis  hac lorem pede mi ut consequat vitae.</p>\r\n<p>Et orci nascetur rutrum Aliquam vitae ac eleifend justo ipsum Aenean.  Justo enim lobortis libero ullamcorper Vestibulum semper metus egestas  porta tellus. Lobortis in id lorem orci quis pede sem mi Curabitur  laoreet. Habitasse at et Phasellus Curabitur turpis consequat vel elit  eros non. Dui nibh Morbi velit nec elit nibh nec dapibus laoreet libero.  Fames laoreet tristique risus enim quis a.</p>\r\n<p>Dignissim ac et tellus Pellentesque wisi sed eget mollis neque  Maecenas. Tellus sem et Nunc elit Curabitur laoreet consectetuer Nulla  fames ante. Risus habitant justo pellentesque Aenean Curabitur non  volutpat ut sed et. Nunc orci egestas justo leo Proin sapien lacinia  senectus Quisque id. Elit Pellentesque porttitor lobortis dolor lobortis  justo elit Nam velit tellus. Ac enim Sed justo.</p>\r\n<p>Magna convallis Nam consequat urna Aenean at dictumst ut Curabitur  Cum. Sagittis et elit Vestibulum tincidunt Sed nibh pellentesque ante  Pellentesque nibh. Risus Sed lacus Nam hendrerit netus odio hac nulla  hac wisi. Donec facilisi mauris nec parturient In nibh tellus sodales at  auctor. Orci turpis Nam nibh neque Nunc eros vel sem ac libero. Elit  vitae orci mauris sed pharetra sociis neque orci dolor consectetuer. Ac  lobortis.</p>\r\n<p>Mauris nibh tristique nulla libero tincidunt Pellentesque mollis  interdum neque tristique. Nec non Vivamus tincidunt orci Sed ligula nisl  eget wisi auctor. A consequat Vestibulum tellus id Nullam gravida sem  neque mauris Nam. Quis orci dictum lacus adipiscing Nam Maecenas risus  fringilla eget tincidunt. Tincidunt interdum nibh Nam orci turpis nibh  Duis nunc ipsum egestas. Commodo Aenean vel volutpat justo id ac at  adipiscing eu.</p>\r\n<p>Nullam ut tempor id elit orci Donec mus magna quam ligula. Vestibulum  at pretium Quisque magnis Nulla semper velit Sed malesuada a. Felis  tellus dolor at mus ipsum ante Vestibulum nec ut nascetur. Consequat sit  Aenean ut metus laoreet risus malesuada hendrerit fames rhoncus. Vitae  pede orci Sed ultrices iaculis metus urna elit ante Phasellus. Nunc.</p>', 1, 0, 0, 87, '2011-08-22 08:06:34', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2011-08-22 08:06:34', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 5, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(109, 223, 'Family Guy: Some...', 'family-guy-some', '', '<p><img class="img-border" src="images/stories/demo/sam-33.jpg" border="0" alt="Sample Image" />Nulla Sed pretium mauris accumsan Aenean turpis nunc Vestibulum Sed  feugiat. In nibh turpis tempus Nulla nulla Nam Pellentesque Integer...</p>\r\n', '\r\n<p>Rutrum consequat Mauris Suspendisse nibh eget vel Lorem cursus justo  nunc. Vestibulum Morbi Lorem orci Donec commodo tellus egestas ornare  leo pretium. Morbi lacinia interdum nulla penatibus amet nibh adipiscing  semper ligula Nunc. Vestibulum vitae molestie Vestibulum malesuada orci  quis libero et adipiscing faucibus. Augue justo ligula est Nam neque  Maecenas convallis nibh nisl condimentum. Cursus Morbi Proin convallis  hac lorem pede mi ut consequat vitae.</p>\r\n<p>Et orci nascetur rutrum Aliquam vitae ac eleifend justo ipsum Aenean.  Justo enim lobortis libero ullamcorper Vestibulum semper metus egestas  porta tellus. Lobortis in id lorem orci quis pede sem mi Curabitur  laoreet. Habitasse at et Phasellus Curabitur turpis consequat vel elit  eros non. Dui nibh Morbi velit nec elit nibh nec dapibus laoreet libero.  Fames laoreet tristique risus enim quis a.</p>\r\n<p>Dignissim ac et tellus Pellentesque wisi sed eget mollis neque  Maecenas. Tellus sem et Nunc elit Curabitur laoreet consectetuer Nulla  fames ante. Risus habitant justo pellentesque Aenean Curabitur non  volutpat ut sed et. Nunc orci egestas justo leo Proin sapien lacinia  senectus Quisque id. Elit Pellentesque porttitor lobortis dolor lobortis  justo elit Nam velit tellus. Ac enim Sed justo.</p>\r\n<p>Magna convallis Nam consequat urna Aenean at dictumst ut Curabitur  Cum. Sagittis et elit Vestibulum tincidunt Sed nibh pellentesque ante  Pellentesque nibh. Risus Sed lacus Nam hendrerit netus odio hac nulla  hac wisi. Donec facilisi mauris nec parturient In nibh tellus sodales at  auctor. Orci turpis Nam nibh neque Nunc eros vel sem ac libero. Elit  vitae orci mauris sed pharetra sociis neque orci dolor consectetuer. Ac  lobortis.</p>\r\n<p>Mauris nibh tristique nulla libero tincidunt Pellentesque mollis  interdum neque tristique. Nec non Vivamus tincidunt orci Sed ligula nisl  eget wisi auctor. A consequat Vestibulum tellus id Nullam gravida sem  neque mauris Nam. Quis orci dictum lacus adipiscing Nam Maecenas risus  fringilla eget tincidunt. Tincidunt interdum nibh Nam orci turpis nibh  Duis nunc ipsum egestas. Commodo Aenean vel volutpat justo id ac at  adipiscing eu.</p>\r\n<p>Nullam ut tempor id elit orci Donec mus magna quam ligula. Vestibulum  at pretium Quisque magnis Nulla semper velit Sed malesuada a. Felis  tellus dolor at mus ipsum ante Vestibulum nec ut nascetur. Consequat sit  Aenean ut metus laoreet risus malesuada hendrerit fames rhoncus. Vitae  pede orci Sed ultrices iaculis metus urna elit ante Phasellus. Nunc.</p>', 1, 0, 0, 87, '2011-08-22 08:07:36', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2011-08-22 08:07:36', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 4, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(110, 224, 'The Family That Preys', 'the-family-that-preys', '', '<p><img class="img-border" src="images/stories/demo/sam-34.jpg" border="0" alt="Sample Image" />Turpis Aenean malesuada natoque libero id lacus convallis euismod sed  ligula. Rutrum vel libero Praesent vel tempus urna semper justo sociis  id...</p>\r\n', '\r\n<p>Rutrum consequat Mauris Suspendisse nibh eget vel Lorem cursus justo  nunc. Vestibulum Morbi Lorem orci Donec commodo tellus egestas ornare  leo pretium. Morbi lacinia interdum nulla penatibus amet nibh adipiscing  semper ligula Nunc. Vestibulum vitae molestie Vestibulum malesuada orci  quis libero et adipiscing faucibus. Augue justo ligula est Nam neque  Maecenas convallis nibh nisl condimentum. Cursus Morbi Proin convallis  hac lorem pede mi ut consequat vitae.</p>\r\n<p>Et orci nascetur rutrum Aliquam vitae ac eleifend justo ipsum Aenean.  Justo enim lobortis libero ullamcorper Vestibulum semper metus egestas  porta tellus. Lobortis in id lorem orci quis pede sem mi Curabitur  laoreet. Habitasse at et Phasellus Curabitur turpis consequat vel elit  eros non. Dui nibh Morbi velit nec elit nibh nec dapibus laoreet libero.  Fames laoreet tristique risus enim quis a.</p>\r\n<p>Dignissim ac et tellus Pellentesque wisi sed eget mollis neque  Maecenas. Tellus sem et Nunc elit Curabitur laoreet consectetuer Nulla  fames ante. Risus habitant justo pellentesque Aenean Curabitur non  volutpat ut sed et. Nunc orci egestas justo leo Proin sapien lacinia  senectus Quisque id. Elit Pellentesque porttitor lobortis dolor lobortis  justo elit Nam velit tellus. Ac enim Sed justo.</p>\r\n<p>Magna convallis Nam consequat urna Aenean at dictumst ut Curabitur  Cum. Sagittis et elit Vestibulum tincidunt Sed nibh pellentesque ante  Pellentesque nibh. Risus Sed lacus Nam hendrerit netus odio hac nulla  hac wisi. Donec facilisi mauris nec parturient In nibh tellus sodales at  auctor. Orci turpis Nam nibh neque Nunc eros vel sem ac libero. Elit  vitae orci mauris sed pharetra sociis neque orci dolor consectetuer. Ac  lobortis.</p>\r\n<p>Mauris nibh tristique nulla libero tincidunt Pellentesque mollis  interdum neque tristique. Nec non Vivamus tincidunt orci Sed ligula nisl  eget wisi auctor. A consequat Vestibulum tellus id Nullam gravida sem  neque mauris Nam. Quis orci dictum lacus adipiscing Nam Maecenas risus  fringilla eget tincidunt. Tincidunt interdum nibh Nam orci turpis nibh  Duis nunc ipsum egestas. Commodo Aenean vel volutpat justo id ac at  adipiscing eu.</p>\r\n<p>Nullam ut tempor id elit orci Donec mus magna quam ligula. Vestibulum  at pretium Quisque magnis Nulla semper velit Sed malesuada a. Felis  tellus dolor at mus ipsum ante Vestibulum nec ut nascetur. Consequat sit  Aenean ut metus laoreet risus malesuada hendrerit fames rhoncus. Vitae  pede orci Sed ultrices iaculis metus urna elit ante Phasellus. Nunc.</p>', 1, 0, 0, 87, '2011-08-22 08:08:39', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2011-08-22 08:08:39', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 3, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(111, 225, 'Family Law', 'family-law', '', '<p><img class="img-border" src="images/stories/demo/sam-35.jpg" border="0" alt="Sample Image" />Nullam ut tempor id elit orci Donec mus magna quam ligula. Vestibulum  at pretium Quisque magnis Nulla semper velit Sed malesuada a. Felis  tellus dolor at mus ipsum ante Vestibulum...</p>\r\n', '\r\n<p>Rutrum consequat Mauris Suspendisse nibh eget vel Lorem cursus justo  nunc. Vestibulum Morbi Lorem orci Donec commodo tellus egestas ornare  leo pretium. Morbi lacinia interdum nulla penatibus amet nibh adipiscing  semper ligula Nunc. Vestibulum vitae molestie Vestibulum malesuada orci  quis libero et adipiscing faucibus. Augue justo ligula est Nam neque  Maecenas convallis nibh nisl condimentum. Cursus Morbi Proin convallis  hac lorem pede mi ut consequat vitae.</p>\r\n<p>Et orci nascetur rutrum Aliquam vitae ac eleifend justo ipsum Aenean.  Justo enim lobortis libero ullamcorper Vestibulum semper metus egestas  porta tellus. Lobortis in id lorem orci quis pede sem mi Curabitur  laoreet. Habitasse at et Phasellus Curabitur turpis consequat vel elit  eros non. Dui nibh Morbi velit nec elit nibh nec dapibus laoreet libero.  Fames laoreet tristique risus enim quis a.</p>\r\n<p>Dignissim ac et tellus Pellentesque wisi sed eget mollis neque  Maecenas. Tellus sem et Nunc elit Curabitur laoreet consectetuer Nulla  fames ante. Risus habitant justo pellentesque Aenean Curabitur non  volutpat ut sed et. Nunc orci egestas justo leo Proin sapien lacinia  senectus Quisque id. Elit Pellentesque porttitor lobortis dolor lobortis  justo elit Nam velit tellus. Ac enim Sed justo.</p>\r\n<p>Magna convallis Nam consequat urna Aenean at dictumst ut Curabitur  Cum. Sagittis et elit Vestibulum tincidunt Sed nibh pellentesque ante  Pellentesque nibh. Risus Sed lacus Nam hendrerit netus odio hac nulla  hac wisi. Donec facilisi mauris nec parturient In nibh tellus sodales at  auctor. Orci turpis Nam nibh neque Nunc eros vel sem ac libero. Elit  vitae orci mauris sed pharetra sociis neque orci dolor consectetuer. Ac  lobortis.</p>\r\n<p>Mauris nibh tristique nulla libero tincidunt Pellentesque mollis  interdum neque tristique. Nec non Vivamus tincidunt orci Sed ligula nisl  eget wisi auctor. A consequat Vestibulum tellus id Nullam gravida sem  neque mauris Nam. Quis orci dictum lacus adipiscing Nam Maecenas risus  fringilla eget tincidunt. Tincidunt interdum nibh Nam orci turpis nibh  Duis nunc ipsum egestas. Commodo Aenean vel volutpat justo id ac at  adipiscing eu.</p>\r\n<p>Nullam ut tempor id elit orci Donec mus magna quam ligula. Vestibulum  at pretium Quisque magnis Nulla semper velit Sed malesuada a. Felis  tellus dolor at mus ipsum ante Vestibulum nec ut nascetur. Consequat sit  Aenean ut metus laoreet risus malesuada hendrerit fames rhoncus. Vitae  pede orci Sed ultrices iaculis metus urna elit ante Phasellus. Nunc.</p>', 1, 0, 0, 87, '2011-08-22 08:09:57', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2011-08-22 08:09:57', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 2, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(112, 226, 'Rolling Family', 'rolling-family', '', '<p><img class="img-border" src="images/stories/demo/sam-36.jpg" border="0" alt="Sample Image" />A consequat Vestibulum tellus id Nullam gravida sem neque mauris Nam.  Quis orci dictum lacus adipiscing Nam Maecenas risus fringilla eget  tincidunt. Nec non Vivamus tincidunt orci Sed...</p>\r\n', '\r\n<p>Rutrum consequat Mauris Suspendisse nibh eget vel Lorem cursus justo  nunc. Vestibulum Morbi Lorem orci Donec commodo tellus egestas ornare  leo pretium. Morbi lacinia interdum nulla penatibus amet nibh adipiscing  semper ligula Nunc. Vestibulum vitae molestie Vestibulum malesuada orci  quis libero et adipiscing faucibus. Augue justo ligula est Nam neque  Maecenas convallis nibh nisl condimentum. Cursus Morbi Proin convallis  hac lorem pede mi ut consequat vitae.</p>\r\n<p>Et orci nascetur rutrum Aliquam vitae ac eleifend justo ipsum Aenean.  Justo enim lobortis libero ullamcorper Vestibulum semper metus egestas  porta tellus. Lobortis in id lorem orci quis pede sem mi Curabitur  laoreet. Habitasse at et Phasellus Curabitur turpis consequat vel elit  eros non. Dui nibh Morbi velit nec elit nibh nec dapibus laoreet libero.  Fames laoreet tristique risus enim quis a.</p>\r\n<p>Dignissim ac et tellus Pellentesque wisi sed eget mollis neque  Maecenas. Tellus sem et Nunc elit Curabitur laoreet consectetuer Nulla  fames ante. Risus habitant justo pellentesque Aenean Curabitur non  volutpat ut sed et. Nunc orci egestas justo leo Proin sapien lacinia  senectus Quisque id. Elit Pellentesque porttitor lobortis dolor lobortis  justo elit Nam velit tellus. Ac enim Sed justo.</p>\r\n<p>Magna convallis Nam consequat urna Aenean at dictumst ut Curabitur  Cum. Sagittis et elit Vestibulum tincidunt Sed nibh pellentesque ante  Pellentesque nibh. Risus Sed lacus Nam hendrerit netus odio hac nulla  hac wisi. Donec facilisi mauris nec parturient In nibh tellus sodales at  auctor. Orci turpis Nam nibh neque Nunc eros vel sem ac libero. Elit  vitae orci mauris sed pharetra sociis neque orci dolor consectetuer. Ac  lobortis.</p>\r\n<p>Mauris nibh tristique nulla libero tincidunt Pellentesque mollis  interdum neque tristique. Nec non Vivamus tincidunt orci Sed ligula nisl  eget wisi auctor. A consequat Vestibulum tellus id Nullam gravida sem  neque mauris Nam. Quis orci dictum lacus adipiscing Nam Maecenas risus  fringilla eget tincidunt. Tincidunt interdum nibh Nam orci turpis nibh  Duis nunc ipsum egestas. Commodo Aenean vel volutpat justo id ac at  adipiscing eu.</p>\r\n<p>Nullam ut tempor id elit orci Donec mus magna quam ligula. Vestibulum  at pretium Quisque magnis Nulla semper velit Sed malesuada a. Felis  tellus dolor at mus ipsum ante Vestibulum nec ut nascetur. Consequat sit  Aenean ut metus laoreet risus malesuada hendrerit fames rhoncus. Vitae  pede orci Sed ultrices iaculis metus urna elit ante Phasellus. Nunc.</p>', 1, 0, 0, 87, '2011-08-22 08:10:55', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2011-08-22 08:10:55', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 1, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `title_alias`, `introtext`, `fulltext`, `state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(113, 227, 'Madea’s Family...', 'madeas-family', '', '<p><img class="img-border" src="images/stories/demo/sam-37.jpg" border="0" alt="Sample Image" />Ultrices pellentesque tincidunt tempor vitae justo vel justo  tincidunt et consectetuer. Consequat volutpat ipsum condimentum risus  augue lacus Morbi quis fermentum metus...</p>\r\n', '\r\n<p>Rutrum consequat Mauris Suspendisse nibh eget vel Lorem cursus justo  nunc. Vestibulum Morbi Lorem orci Donec commodo tellus egestas ornare  leo pretium. Morbi lacinia interdum nulla penatibus amet nibh adipiscing  semper ligula Nunc. Vestibulum vitae molestie Vestibulum malesuada orci  quis libero et adipiscing faucibus. Augue justo ligula est Nam neque  Maecenas convallis nibh nisl condimentum. Cursus Morbi Proin convallis  hac lorem pede mi ut consequat vitae.</p>\r\n<p>Et orci nascetur rutrum Aliquam vitae ac eleifend justo ipsum Aenean.  Justo enim lobortis libero ullamcorper Vestibulum semper metus egestas  porta tellus. Lobortis in id lorem orci quis pede sem mi Curabitur  laoreet. Habitasse at et Phasellus Curabitur turpis consequat vel elit  eros non. Dui nibh Morbi velit nec elit nibh nec dapibus laoreet libero.  Fames laoreet tristique risus enim quis a.</p>\r\n<p>Dignissim ac et tellus Pellentesque wisi sed eget mollis neque  Maecenas. Tellus sem et Nunc elit Curabitur laoreet consectetuer Nulla  fames ante. Risus habitant justo pellentesque Aenean Curabitur non  volutpat ut sed et. Nunc orci egestas justo leo Proin sapien lacinia  senectus Quisque id. Elit Pellentesque porttitor lobortis dolor lobortis  justo elit Nam velit tellus. Ac enim Sed justo.</p>\r\n<p>Magna convallis Nam consequat urna Aenean at dictumst ut Curabitur  Cum. Sagittis et elit Vestibulum tincidunt Sed nibh pellentesque ante  Pellentesque nibh. Risus Sed lacus Nam hendrerit netus odio hac nulla  hac wisi. Donec facilisi mauris nec parturient In nibh tellus sodales at  auctor. Orci turpis Nam nibh neque Nunc eros vel sem ac libero. Elit  vitae orci mauris sed pharetra sociis neque orci dolor consectetuer. Ac  lobortis.</p>\r\n<p>Mauris nibh tristique nulla libero tincidunt Pellentesque mollis  interdum neque tristique. Nec non Vivamus tincidunt orci Sed ligula nisl  eget wisi auctor. A consequat Vestibulum tellus id Nullam gravida sem  neque mauris Nam. Quis orci dictum lacus adipiscing Nam Maecenas risus  fringilla eget tincidunt. Tincidunt interdum nibh Nam orci turpis nibh  Duis nunc ipsum egestas. Commodo Aenean vel volutpat justo id ac at  adipiscing eu.</p>\r\n<p>Nullam ut tempor id elit orci Donec mus magna quam ligula. Vestibulum  at pretium Quisque magnis Nulla semper velit Sed malesuada a. Felis  tellus dolor at mus ipsum ante Vestibulum nec ut nascetur. Consequat sit  Aenean ut metus laoreet risus malesuada hendrerit fames rhoncus. Vitae  pede orci Sed ultrices iaculis metus urna elit ante Phasellus. Nunc.</p>', 1, 0, 0, 87, '2011-08-22 08:11:52', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2011-08-22 08:11:52', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 0, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', '');

DROP TABLE IF EXISTS `#__content_frontpage`;
CREATE TABLE `#__content_frontpage` (
  `content_id` int(11) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`content_id`)
) ENGINE=MyISAM;

INSERT INTO `#__content_frontpage` (`content_id`, `ordering`) VALUES
(8, 6),
(35, 8),
(24, 1),
(50, 7),
(68, 5),
(70, 4),
(71, 3),
(72, 2);

DROP TABLE IF EXISTS `#__content_rating`;
CREATE TABLE `#__content_rating` (
  `content_id` int(11) NOT NULL DEFAULT '0',
  `rating_sum` int(10) unsigned NOT NULL DEFAULT '0',
  `rating_count` int(10) unsigned NOT NULL DEFAULT '0',
  `lastip` varchar(50) NOT NULL DEFAULT '',
  PRIMARY KEY (`content_id`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__core_log_searches`;
CREATE TABLE `#__core_log_searches` (
  `search_term` varchar(128) NOT NULL DEFAULT '',
  `hits` int(10) unsigned NOT NULL DEFAULT '0'
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__extensions`;
CREATE TABLE `#__extensions` (
  `extension_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `type` varchar(20) NOT NULL,
  `element` varchar(100) NOT NULL,
  `folder` varchar(100) NOT NULL,
  `client_id` tinyint(3) NOT NULL,
  `enabled` tinyint(3) NOT NULL DEFAULT '1',
  `access` int(10) unsigned DEFAULT NULL,
  `protected` tinyint(3) NOT NULL DEFAULT '0',
  `manifest_cache` text NOT NULL,
  `params` text NOT NULL,
  `custom_data` text NOT NULL,
  `system_data` text NOT NULL,
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) DEFAULT '0',
  `state` int(11) DEFAULT '0',
  PRIMARY KEY (`extension_id`),
  KEY `element_clientid` (`element`,`client_id`),
  KEY `element_folder_clientid` (`element`,`folder`,`client_id`),
  KEY `extension` (`type`,`element`,`folder`,`client_id`)
) ENGINE=MyISAM ;

INSERT INTO `#__extensions` (`extension_id`, `name`, `type`, `element`, `folder`, `client_id`, `enabled`, `access`, `protected`, `manifest_cache`, `params`, `custom_data`, `system_data`, `checked_out`, `checked_out_time`, `ordering`, `state`) VALUES
(1, 'com_mailto', 'component', 'com_mailto', '', 0, 1, 1, 1, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(2, 'com_wrapper', 'component', 'com_wrapper', '', 0, 1, 1, 1, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(3, 'com_admin', 'component', 'com_admin', '', 1, 1, 1, 1, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(4, 'com_banners', 'component', 'com_banners', '', 1, 1, 1, 0, '', '{"purchase_type":"3","track_impressions":"0","track_clicks":"0","metakey_prefix":""}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(5, 'com_cache', 'component', 'com_cache', '', 1, 1, 1, 1, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(6, 'com_categories', 'component', 'com_categories', '', 1, 1, 1, 1, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(7, 'com_checkin', 'component', 'com_checkin', '', 1, 1, 1, 1, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(8, 'com_contact', 'component', 'com_contact', '', 1, 1, 1, 0, '', '{"show_contact_category":"hide","show_contact_list":"0","presentation_style":"sliders","show_name":"1","show_position":"1","show_email":"0","show_street_address":"1","show_suburb":"1","show_state":"1","show_postcode":"1","show_country":"1","show_telephone":"1","show_mobile":"1","show_fax":"1","show_webpage":"1","show_misc":"1","show_image":"1","image":"","allow_vcard":"0","show_articles":"0","show_profile":"0","show_links":"0","linka_name":"","linkb_name":"","linkc_name":"","linkd_name":"","linke_name":"","contact_icons":"0","icon_address":"","icon_email":"","icon_telephone":"","icon_mobile":"","icon_fax":"","icon_misc":"","show_headings":"1","show_position_headings":"1","show_email_headings":"0","show_telephone_headings":"1","show_mobile_headings":"0","show_fax_headings":"0","allow_vcard_headings":"0","show_suburb_headings":"1","show_state_headings":"1","show_country_headings":"1","show_email_form":"1","show_email_copy":"1","banned_email":"","banned_subject":"","banned_text":"","validate_session":"1","custom_reply":"0","redirect":"","show_category_crumb":"0","metakey":"","metadesc":"","robots":"","author":"","rights":"","xreference":""}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(9, 'com_cpanel', 'component', 'com_cpanel', '', 1, 1, 1, 1, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10, 'com_installer', 'component', 'com_installer', '', 1, 1, 1, 1, '', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(11, 'com_languages', 'component', 'com_languages', '', 1, 1, 1, 1, '', '{"administrator":"en-GB","site":"en-GB"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(12, 'com_login', 'component', 'com_login', '', 1, 1, 1, 1, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(13, 'com_media', 'component', 'com_media', '', 1, 1, 0, 1, '', '{"upload_extensions":"bmp,csv,doc,gif,ico,jpg,jpeg,odg,odp,ods,odt,pdf,png,ppt,swf,txt,xcf,xls,BMP,CSV,DOC,GIF,ICO,JPG,JPEG,ODG,ODP,ODS,ODT,PDF,PNG,PPT,SWF,TXT,XCF,XLS","upload_maxsize":"10","file_path":"images","image_path":"images","restrict_uploads":"1","allowed_media_usergroup":"3","check_mime":"1","image_extensions":"bmp,gif,jpg,png","ignore_extensions":"","upload_mime":"image\\/jpeg,image\\/gif,image\\/png,image\\/bmp,application\\/x-shockwave-flash,application\\/msword,application\\/excel,application\\/pdf,application\\/powerpoint,text\\/plain,application\\/x-zip","upload_mime_illegal":"text\\/html","enable_flash":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(14, 'com_menus', 'component', 'com_menus', '', 1, 1, 1, 1, '', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(15, 'com_messages', 'component', 'com_messages', '', 1, 1, 1, 1, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(16, 'com_modules', 'component', 'com_modules', '', 1, 1, 1, 1, '', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(17, 'com_newsfeeds', 'component', 'com_newsfeeds', '', 1, 1, 1, 0, '', '{"show_feed_image":"1","show_feed_description":"1","show_item_description":"1","feed_word_count":"0","show_headings":"1","show_name":"1","show_articles":"0","show_link":"1","show_description":"1","show_description_image":"1","display_num":"","show_pagination_limit":"1","show_pagination":"1","show_pagination_results":"1","show_cat_items":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(18, 'com_plugins', 'component', 'com_plugins', '', 1, 1, 1, 1, '', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(19, 'com_search', 'component', 'com_search', '', 1, 1, 1, 1, '', '{"enabled":"0","show_date":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(20, 'com_templates', 'component', 'com_templates', '', 1, 1, 1, 1, '', '{"template_positions_display":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(21, 'com_weblinks', 'component', 'com_weblinks', '', 1, 1, 1, 0, '', '{"show_comp_description":"1","comp_description":"","show_link_hits":"1","show_link_description":"1","show_other_cats":"0","show_headings":"0","show_numbers":"0","show_report":"1","count_clicks":"1","target":"0","link_icons":""}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(22, 'com_content', 'component', 'com_content', '', 1, 1, 0, 1, '', '{"article_layout":"_:default","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"1","show_author":"1","link_author":"0","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"1","readmore_limit":"100","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"1","show_noauth":"1","category_layout":"_:blog","show_category_title":"0","show_description":"0","show_description_image":"0","maxLevel":"1","show_empty_categories":"0","show_no_articles":"1","show_subcat_desc":"1","show_cat_num_articles":"0","show_base_description":"1","maxLevelcat":"-1","show_empty_categories_cat":"0","show_subcat_desc_cat":"1","show_cat_num_articles_cat":"1","num_leading_articles":"1","num_intro_articles":"4","num_columns":"2","num_links":"4","multi_column_order":"0","show_subcategory_content":"0","orderby_pri":"order","orderby_sec":"rdate","order_date":"published","show_pagination_limit":"1","filter_field":"hide","show_headings":"1","list_show_date":"0","date_format":"","list_show_hits":"1","list_show_author":"1","show_pagination":"2","show_pagination_results":"1","show_feed_link":"1","feed_summary":"0","filters":{"1":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"6":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"7":{"filter_type":"NONE","filter_tags":"","filter_attributes":""},"2":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"3":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"4":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"5":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"8":{"filter_type":"NONE","filter_tags":"","filter_attributes":""}}}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(23, 'com_config', 'component', 'com_config', '', 1, 1, 0, 1, '', '{"filters":{"1":{"filter_tags":"","filter_attributes":"","filter_type":"BL"},"6":{"filter_tags":"","filter_attributes":"","filter_type":"BL"},"7":{"filter_tags":"","filter_attributes":"","filter_type":"NONE"},"2":{"filter_tags":"","filter_attributes":"","filter_type":"BL"},"3":{"filter_tags":"","filter_attributes":"","filter_type":"BL"},"4":{"filter_tags":"","filter_attributes":"","filter_type":"BL"},"5":{"filter_tags":"","filter_attributes":"","filter_type":"BL"},"8":{"filter_tags":"","filter_attributes":"","filter_type":"NONE"}}}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(24, 'com_redirect', 'component', 'com_redirect', '', 1, 1, 0, 1, '', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(25, 'com_users', 'component', 'com_users', '', 1, 1, 0, 1, '', '{"allowUserRegistration":"1","new_usertype":"2","useractivation":"1","frontend_userparams":"1","mailSubjectPrefix":"","mailBodySuffix":""}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(100, 'PHPMailer', 'library', 'phpmailer', '', 0, 1, 1, 1, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(101, 'SimplePie', 'library', 'simplepie', '', 0, 1, 1, 1, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(102, 'phputf8', 'library', 'phputf8', '', 0, 1, 1, 1, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(103, 'Joomla! Web Application Framework', 'library', 'joomla', '', 0, 1, 1, 1, 'a:11:{s:6:"legacy";b:0;s:4:"name";s:33:"Joomla! Web Application Framework";s:4:"type";s:7:"library";s:12:"creationDate";s:4:"2008";s:6:"author";s:6:"Joomla";s:9:"copyright";s:67:"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.";s:11:"authorEmail";s:16:"admin@joomla.org";s:9:"authorUrl";s:21:"http://www.joomla.org";s:7:"version";s:5:"1.6.0";s:11:"description";s:90:"The Joomla! Web Application Framework is the Core of the Joomla! Content Management System";s:5:"group";s:0:"";}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(200, 'mod_articles_archive', 'module', 'mod_articles_archive', '', 0, 1, 1, 1, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(201, 'mod_articles_latest', 'module', 'mod_articles_latest', '', 0, 1, 1, 1, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(202, 'mod_articles_popular', 'module', 'mod_articles_popular', '', 0, 1, 1, 0, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(203, 'mod_banners', 'module', 'mod_banners', '', 0, 1, 1, 1, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(204, 'mod_breadcrumbs', 'module', 'mod_breadcrumbs', '', 0, 1, 1, 1, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(205, 'mod_custom', 'module', 'mod_custom', '', 0, 1, 1, 1, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(206, 'mod_feed', 'module', 'mod_feed', '', 0, 1, 1, 1, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(207, 'mod_footer', 'module', 'mod_footer', '', 0, 1, 1, 1, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(208, 'mod_login', 'module', 'mod_login', '', 0, 1, 1, 1, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(209, 'mod_menu', 'module', 'mod_menu', '', 0, 1, 1, 1, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(210, 'mod_articles_news', 'module', 'mod_articles_news', '', 0, 1, 1, 0, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(211, 'mod_random_image', 'module', 'mod_random_image', '', 0, 1, 1, 0, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(212, 'mod_related_items', 'module', 'mod_related_items', '', 0, 1, 1, 0, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(213, 'mod_search', 'module', 'mod_search', '', 0, 1, 1, 0, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(214, 'mod_stats', 'module', 'mod_stats', '', 0, 1, 1, 0, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(215, 'mod_syndicate', 'module', 'mod_syndicate', '', 0, 1, 1, 1, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(216, 'mod_users_latest', 'module', 'mod_users_latest', '', 0, 1, 1, 1, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(217, 'mod_weblinks', 'module', 'mod_weblinks', '', 0, 1, 1, 0, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(218, 'mod_whosonline', 'module', 'mod_whosonline', '', 0, 1, 1, 0, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(219, 'mod_wrapper', 'module', 'mod_wrapper', '', 0, 1, 1, 0, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(220, 'mod_articles_category', 'module', 'mod_articles_category', '', 0, 1, 1, 1, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(221, 'mod_articles_categories', 'module', 'mod_articles_categories', '', 0, 1, 1, 1, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(222, 'mod_languages', 'module', 'mod_languages', '', 0, 1, 1, 1, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(300, 'mod_custom', 'module', 'mod_custom', '', 1, 1, 1, 1, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(301, 'mod_feed', 'module', 'mod_feed', '', 1, 1, 1, 0, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(302, 'mod_latest', 'module', 'mod_latest', '', 1, 1, 1, 0, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(303, 'mod_logged', 'module', 'mod_logged', '', 1, 1, 1, 0, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(304, 'mod_login', 'module', 'mod_login', '', 1, 1, 1, 1, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(305, 'mod_menu', 'module', 'mod_menu', '', 1, 1, 1, 0, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(306, 'mod_online', 'module', 'mod_online', '', 1, 1, 1, 1, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(307, 'mod_popular', 'module', 'mod_popular', '', 1, 1, 1, 0, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(308, 'mod_quickicon', 'module', 'mod_quickicon', '', 1, 1, 1, 1, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(309, 'mod_status', 'module', 'mod_status', '', 1, 1, 1, 0, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(310, 'mod_submenu', 'module', 'mod_submenu', '', 1, 1, 1, 0, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(311, 'mod_title', 'module', 'mod_title', '', 1, 1, 1, 0, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(312, 'mod_toolbar', 'module', 'mod_toolbar', '', 1, 1, 1, 1, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(313, 'mod_multilangstatus', 'module', 'mod_multilangstatus', '', 1, 1, 1, 0, '{"legacy":false,"name":"mod_multilangstatus","type":"module","creationDate":"September 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.1","description":"MOD_MULTILANGSTATUS_XML_DESCRIPTION","group":""}', '{"cache":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(400, 'plg_authentication_gmail', 'plugin', 'gmail', 'authentication', 0, 0, 1, 0, '', '{"applysuffix":"0","suffix":"","verifypeer":"1","user_blacklist":""}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(401, 'plg_authentication_joomla', 'plugin', 'joomla', 'authentication', 0, 1, 1, 1, '', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(402, 'plg_authentication_ldap', 'plugin', 'ldap', 'authentication', 0, 0, 1, 0, '', '{"host":"","port":"389","use_ldapV3":"0","negotiate_tls":"0","no_referrals":"0","auth_method":"bind","base_dn":"","search_string":"","users_dn":"","username":"admin","password":"bobby7","ldap_fullname":"fullName","ldap_email":"mail","ldap_uid":"uid"}', '', '', 0, '0000-00-00 00:00:00', 3, 0),
(404, 'plg_content_emailcloak', 'plugin', 'emailcloak', 'content', 0, 1, 1, 0, '', '{"mode":"1"}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(405, 'plg_content_geshi', 'plugin', 'geshi', 'content', 0, 0, 1, 0, '', '{}', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(406, 'plg_content_loadmodule', 'plugin', 'loadmodule', 'content', 0, 1, 1, 0, '', '{"style":"rounded"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(407, 'plg_content_pagebreak', 'plugin', 'pagebreak', 'content', 0, 1, 1, 1, '', '{"title":"1","multipage_toc":"1","showall":"1"}', '', '', 0, '0000-00-00 00:00:00', 4, 0),
(408, 'plg_content_pagenavigation', 'plugin', 'pagenavigation', 'content', 0, 1, 1, 1, '', '{"position":"1"}', '', '', 0, '0000-00-00 00:00:00', 5, 0),
(409, 'plg_content_vote', 'plugin', 'vote', 'content', 0, 1, 1, 1, '', '{}', '', '', 0, '0000-00-00 00:00:00', 6, 0),
(410, 'plg_editors_codemirror', 'plugin', 'codemirror', 'editors', 0, 1, 1, 1, '', '{"linenumbers":"0","tabmode":"indent"}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(411, 'plg_editors_none', 'plugin', 'none', 'editors', 0, 1, 1, 1, '', '{}', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(412, 'plg_editors_tinymce', 'plugin', 'tinymce', 'editors', 0, 1, 1, 1, '', '{"mode":"1","skin":"0","compressed":"0","cleanup_startup":"0","cleanup_save":"2","entity_encoding":"raw","lang_mode":"0","lang_code":"en","text_direction":"ltr","content_css":"1","content_css_custom":"","relative_urls":"1","newlines":"0","invalid_elements":"script,applet,iframe","extended_elements":"","toolbar":"top","toolbar_align":"left","html_height":"550","html_width":"750","element_path":"1","fonts":"1","paste":"1","searchreplace":"1","insertdate":"1","format_date":"%Y-%m-%d","inserttime":"1","format_time":"%H:%M:%S","colors":"1","table":"1","smilies":"1","media":"1","hr":"1","directionality":"1","fullscreen":"1","style":"1","layer":"1","xhtmlxtras":"1","visualchars":"1","nonbreaking":"1","template":"1","blockquote":"1","wordcount":"1","advimage":"1","advlink":"1","autosave":"1","contextmenu":"1","inlinepopups":"1","safari":"0","custom_plugin":"","custom_button":""}', '', '', 0, '0000-00-00 00:00:00', 3, 0),
(413, 'plg_editors-xtd_article', 'plugin', 'article', 'editors-xtd', 0, 1, 1, 1, '', '{}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(414, 'plg_editors-xtd_image', 'plugin', 'image', 'editors-xtd', 0, 1, 1, 0, '', '{}', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(415, 'plg_editors-xtd_pagebreak', 'plugin', 'pagebreak', 'editors-xtd', 0, 1, 1, 0, '', '{}', '', '', 0, '0000-00-00 00:00:00', 3, 0),
(416, 'plg_editors-xtd_readmore', 'plugin', 'readmore', 'editors-xtd', 0, 1, 1, 0, '', '{}', '', '', 0, '0000-00-00 00:00:00', 4, 0),
(417, 'plg_search_categories', 'plugin', 'categories', 'search', 0, 1, 1, 0, '', '{"search_limit":"50","search_content":"1","search_archived":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(418, 'plg_search_contacts', 'plugin', 'contacts', 'search', 0, 1, 1, 0, '', '{"search_limit":"50","search_content":"1","search_archived":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(419, 'plg_search_content', 'plugin', 'content', 'search', 0, 1, 1, 0, '', '{"search_limit":"50","search_content":"1","search_archived":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(420, 'plg_search_newsfeeds', 'plugin', 'newsfeeds', 'search', 0, 1, 1, 0, '', '{"search_limit":"50","search_content":"1","search_archived":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(421, 'plg_search_weblinks', 'plugin', 'weblinks', 'search', 0, 1, 1, 0, '', '{"search_limit":"50","search_content":"1","search_archived":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(422, 'plg_system_languagefilter', 'plugin', 'languagefilter', 'system', 0, 0, 1, 1, '', '{}', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(423, 'plg_system_p3p', 'plugin', 'p3p', 'system', 0, 1, 1, 1, '', '{"headers":"NOI ADM DEV PSAi COM NAV OUR OTRo STP IND DEM"}', '', '', 0, '0000-00-00 00:00:00', 3, 0),
(424, 'plg_system_cache', 'plugin', 'cache', 'system', 0, 0, 1, 1, '', '{"browsercache":"0","cachetime":"15"}', '', '', 0, '0000-00-00 00:00:00', 4, 0),
(425, 'plg_system_debug', 'plugin', 'debug', 'system', 0, 1, 1, 0, '', '{"profile":"1","queries":"1","memory":"1","language_files":"1","language_strings":"1","strip-first":"1","strip-prefix":"","strip-suffix":""}', '', '', 0, '0000-00-00 00:00:00', 5, 0),
(426, 'plg_system_log', 'plugin', 'log', 'system', 0, 1, 1, 1, '', '{}', '', '', 0, '0000-00-00 00:00:00', 6, 0),
(427, 'plg_system_redirect', 'plugin', 'redirect', 'system', 0, 1, 1, 1, '', '{}', '', '', 0, '0000-00-00 00:00:00', 7, 0),
(428, 'plg_system_remember', 'plugin', 'remember', 'system', 0, 1, 1, 1, '', '{}', '', '', 0, '0000-00-00 00:00:00', 8, 0),
(429, 'plg_system_sef', 'plugin', 'sef', 'system', 0, 1, 1, 0, '', '{}', '', '', 0, '0000-00-00 00:00:00', 9, 0),
(430, 'plg_system_logout', 'plugin', 'logout', 'system', 0, 1, 1, 1, '', '{}', '', '', 0, '0000-00-00 00:00:00', 10, 0),
(431, 'plg_user_contactcreator', 'plugin', 'contactcreator', 'user', 0, 0, 1, 1, '', '{"autowebpage":"","category":"34","autopublish":"0"}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(432, 'plg_user_joomla', 'plugin', 'joomla', 'user', 0, 1, 1, 0, '', '{"autoregister":"1"}', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(433, 'plg_user_profile', 'plugin', 'profile', 'user', 0, 0, 1, 1, '', '{"register-require_address1":"1","register-require_address2":"1","register-require_city":"1","register-require_region":"1","register-require_country":"1","register-require_postal_code":"1","register-require_phone":"1","register-require_website":"1","register-require_favoritebook":"1","register-require_aboutme":"1","register-require_tos":"1","register-require_dob":"1","profile-require_address1":"1","profile-require_address2":"1","profile-require_city":"1","profile-require_region":"1","profile-require_country":"1","profile-require_postal_code":"1","profile-require_phone":"1","profile-require_website":"1","profile-require_favoritebook":"1","profile-require_aboutme":"1","profile-require_tos":"1","profile-require_dob":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(434, 'plg_extension_joomla', 'plugin', 'joomla', 'extension', 0, 1, 1, 1, '', '{}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(435, 'plg_content_joomla', 'plugin', 'joomla', 'content', 0, 1, 1, 0, '', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(500, 'atomic', 'template', 'atomic', '', 0, 1, 1, 0, 'a:11:{s:6:"legacy";b:0;s:4:"name";s:6:"atomic";s:4:"type";s:8:"template";s:12:"creationDate";s:8:"10/10/09";s:6:"author";s:12:"Ron Severdia";s:9:"copyright";s:72:"Copyright (C) 2005 - 2011 Open Source Matters, Inc. All rights reserved.";s:11:"authorEmail";s:25:"contact@kontentdesign.com";s:9:"authorUrl";s:28:"http://www.kontentdesign.com";s:7:"version";s:5:"1.6.0";s:11:"description";s:26:"TPL_ATOMIC_XML_DESCRIPTION";s:5:"group";s:0:"";}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(501, 'rhuk_milkyway', 'template', 'rhuk_milkyway', '', 0, 1, 1, 0, 'a:11:{s:6:"legacy";b:0;s:4:"name";s:13:"rhuk_milkyway";s:4:"type";s:8:"template";s:12:"creationDate";s:8:"11/20/06";s:6:"author";s:11:"Andy Miller";s:9:"copyright";s:72:"Copyright (C) 2005 - 2011 Open Source Matters, Inc. All rights reserved.";s:11:"authorEmail";s:20:"rhuk@rockettheme.com";s:9:"authorUrl";s:26:"http://www.rockettheme.com";s:7:"version";s:5:"1.6.0";s:11:"description";s:33:"TPL_RHUK_MILKYWAY_XML_DESCRIPTION";s:5:"group";s:0:"";}', '{"colorVariation":"white","backgroundVariation":"blue","widthStyle":"fmax"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(502, 'bluestork', 'template', 'bluestork', '', 1, 1, 1, 1, 'a:11:{s:6:"legacy";b:0;s:4:"name";s:9:"bluestork";s:4:"type";s:8:"template";s:12:"creationDate";s:8:"07/02/09";s:6:"author";s:12:"Ron Severdia";s:9:"copyright";s:72:"Copyright (C) 2005 - 2011 Open Source Matters, Inc. All rights reserved.";s:11:"authorEmail";s:25:"contact@kontentdesign.com";s:9:"authorUrl";s:28:"http://www.kontentdesign.com";s:7:"version";s:5:"1.6.0";s:11:"description";s:29:"TPL_BLUESTORK_XML_DESCRIPTION";s:5:"group";s:0:"";}', '{"useRoundedCorners":"1","showSiteName":"0","textBig":"0","highContrast":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(503, 'beez_20', 'template', 'beez_20', '', 0, 1, 1, 1, 'a:11:{s:6:"legacy";b:0;s:4:"name";s:7:"beez_20";s:4:"type";s:8:"template";s:12:"creationDate";s:16:"25 November 2009";s:6:"author";s:12:"Angie Radtke";s:9:"copyright";s:72:"Copyright (C) 2005 - 2011 Open Source Matters, Inc. All rights reserved.";s:11:"authorEmail";s:23:"a.radtke@derauftritt.de";s:9:"authorUrl";s:26:"http://www.der-auftritt.de";s:7:"version";s:5:"1.6.0";s:11:"description";s:25:"TPL_BEEZ2_XML_DESCRIPTION";s:5:"group";s:0:"";}', '{"wrapperSmall":"53","wrapperLarge":"72","sitetitle":"","sitedescription":"","navposition":"center","templatecolor":"nature"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(504, 'hathor', 'template', 'hathor', '', 1, 1, 1, 0, 'a:11:{s:6:"legacy";b:0;s:4:"name";s:6:"hathor";s:4:"type";s:8:"template";s:12:"creationDate";s:8:"May 2010";s:6:"author";s:11:"Andrea Tarr";s:9:"copyright";s:72:"Copyright (C) 2005 - 2011 Open Source Matters, Inc. All rights reserved.";s:11:"authorEmail";s:25:"hathor@tarrconsulting.com";s:9:"authorUrl";s:29:"http://www.tarrconsulting.com";s:7:"version";s:5:"1.6.0";s:11:"description";s:26:"TPL_HATHOR_XML_DESCRIPTION";s:5:"group";s:0:"";}', '{"showSiteName":"0","colourChoice":"0","boldText":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(505, 'beez5', 'template', 'beez5', '', 0, 1, 1, 0, 'a:11:{s:6:"legacy";b:0;s:4:"name";s:5:"beez5";s:4:"type";s:8:"template";s:12:"creationDate";s:11:"21 May 2010";s:6:"author";s:12:"Angie Radtke";s:9:"copyright";s:72:"Copyright (C) 2005 - 2011 Open Source Matters, Inc. All rights reserved.";s:11:"authorEmail";s:23:"a.radtke@derauftritt.de";s:9:"authorUrl";s:26:"http://www.der-auftritt.de";s:7:"version";s:5:"1.6.0";s:11:"description";s:25:"TPL_BEEZ5_XML_DESCRIPTION";s:5:"group";s:0:"";}', '{"wrapperSmall":"53","wrapperLarge":"72","sitetitle":"","sitedescription":"","navposition":"center","html5":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(600, 'English (United Kingdom)', 'language', 'en-GB', '', 0, 1, 1, 1, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(601, 'English (United Kingdom)', 'language', 'en-GB', '', 1, 1, 1, 1, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10019, 'ArabicUnitag', 'language', 'ar-AA', '', 0, 1, 0, 0, '{"legacy":true,"name":"Arabic Unitag (\\u0627\\u0644\\u0639\\u0631\\u0628\\u064a\\u0629 \\u0627\\u0644\\u0645\\u0648\\u062d\\u062f\\u0629)","type":"language","creationDate":"2011-07-19","author":"Mahmood Alhaj Kassem\\/suneye","copyright":"Copyright (C) 2005 - 2011 Mahmood Alhaj Kassem\\/suneye and Open Source Matters. All rights reserved.","authorEmail":"","authorUrl":"","version":"1.7.0","description":"Arabic Unitag site language pack for Joomla! 1.7.0 \\u062d\\u0632\\u0645\\u0629 \\u0627\\u0644\\u0644\\u063a\\u0629 \\u0627\\u0644\\u0639\\u0631\\u0628\\u064a\\u0629 \\u0627\\u0644\\u0645\\u0648\\u062d\\u062f\\u0629\\/\\u0627\\u0644\\u0645\\u0648\\u0642\\u0639","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(700, 'Joomla! CMS', 'file', 'joomla', '', 0, 1, 1, 1, '{"version":"2.5.1"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10000, 'JA T3 Framework', 'plugin', 'jat3', 'system', 0, 1, 1, 0, 'a:11:{s:6:"legacy";b:1;s:4:"name";s:15:"JA T3 Framework";s:4:"type";s:6:"plugin";s:12:"creationDate";s:11:"16 Nov 2010";s:6:"author";s:16:"www.JoomlArt.com";s:9:"copyright";s:63:"Copyright (C), J.O.O.M Solutions Co., Ltd. All Rights Reserved.";s:11:"authorEmail";s:22:"webmaster@joomlart.com";s:9:"authorUrl";s:23:"http://www.joomlart.com";s:7:"version";s:5:"1.0.2";s:11:"description";s:57:"T3 Framework - JoomlArt Template Framework for Joomla 1.6";s:5:"group";s:0:"";}', '{}', '', '', 0, '0000-00-00 00:00:00', 11, 0),
(10002, 'ja_anion', 'template', 'ja_anion', '', 0, 1, 1, 0, 'a:11:{s:6:"legacy";b:0;s:4:"name";s:8:"ja_anion";s:4:"type";s:8:"template";s:12:"creationDate";s:8:"08/16/10";s:6:"author";s:12:"JoomlArt.com";s:9:"copyright";s:23:"J.O.O.M. Solutions Ltd.";s:11:"authorEmail";s:22:"webmaster@joomlart.com";s:9:"authorUrl";s:23:"http://www.joomlart.com";s:7:"version";s:5:"1.2.4";s:11:"description";s:20:"TEMPLATE DESCRIPTION";s:5:"group";s:0:"";}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10003, 'System - JA Tabs', 'plugin', 'jatabs', 'system', 0, 1, 1, 0, 'a:11:{s:6:"legacy";b:1;s:4:"name";s:16:"System - JA Tabs";s:4:"type";s:6:"plugin";s:12:"creationDate";s:8:"Oct 2010";s:6:"author";s:12:"JoomlArt.com";s:9:"copyright";s:27:"J.O.O.M Solutions Co., Ltd.";s:11:"authorEmail";s:22:"webmaster@joomlart.com";s:9:"authorUrl";s:16:"www.joomlart.com";s:7:"version";s:5:"1.0.0";s:11:"description";s:5275:"\n		\n			<span style="color: #008000;"><strong>JA Tabs Plugin</strong></span>\n			<p><span style="color: #ff6600;"><strong>Introduce</strong></span></p>\n			<div style="font-weight: normal">\n			<p><strong><img src=''../plugins/system/jatabs/jatabs/tabs.png'' />\n			<span style=''margin-top:10px;''>JA Tabs plugin is a plugin help you to create tabs in any positions in the Joomla!</span></strong></p>\n			\n			<ol class="checklist" style=''clear:both''>\n			<li>Support multi types of content: Module Position, Module name, HTML Content, Articles Ids, Category Id</li>\n			<li>Configurable animations: Left/right, up/down, fading...</li>\n			<li>Multi themes support</li>\n			<li>Multi Languages</li>\n			<li>Full of configuration</li>\n			</ol>\n			</div>\n			<p><span style="color: #ff6600;"><strong>Parameter Options General</strong></span></p>\n			<h3 style="color: blue">All parameter options for the Ja Tabs Plugin.</h3>\n			<div  style="font-weight: normal">\n			<ol>\n			<li><strong>type:</strong> <br /> (modules, module, content, articles). The Ja Tabs typing.</li>\n			<li><strong>position:</strong> <br /> (top, left, right, bottom). Positon of the tabs. Value default is top.</li>\n			<li><strong>style:</strong><br /> The JaTabs styling (basic). Value default is basic. </li>\n			<li><strong>width:</strong><br /> Width of the tabs. It can be fixed or automatically. Example: empty or ''100%'' or ''600''</li>\n			<li><strong>height:</strong><br /> Height of the tabs. It can be fixed or automatically. Example: empty or ''auto'' or ''400''.</li>\n			<li><strong>widthTabs:</strong><br /> Width of the tabs. It should be ''empty'' for the ''Top/Bottom'' position of tabs title and fixed (like ''150'') for the ''Left/Right'' position of tabs title.</li>\n			<li><strong>heightTabs:</strong><br /> Height of the tabs. It should be ''empty'' for ''Left/Right'' position of tabs title and fixed (like ''30'' for ''Top/Bottom'' position of tabs title.</li>\n			<li><strong>duration (ms):</strong><br /> Time interval of the transition effect when autoplay is on in milliseconds. Value default is 1000. </li>\n			<li><strong>animType:</strong><br /> (animFade, animMoveHor, animMoveVir, none). Define the transition effect for the autoplay. Value default is animMoveVir.</li>\n			<li><strong>mouseType:</strong><br /> (click, mouseover, none). Action behavior of the control panel. Value default is click. </li>\n			<li><strong>skipAnim:</strong> <br /> (true, false). Skip animation. Value default is false.</li>\n			<li><strong>ajax:</strong> <br /> (true, false). Setting "true" if you want to use ajax to load content of tabs (Not apply for HTML Content type). Value default is false.</li>\n			<li><strong>view:</strong> <br /> (introtext, fulltext). Apply for Articles.</li>\n			<li><strong>color:</strong> <br /> Input the color for each tab in format: 1:color,2:green. The supported colors depend on the tab style.</li>\n			<li><strong>module:</strong> <br /> Apply for type="modules". Input module position which will display in tabs. For example: articleslatestload</li>\n			<li><strong>modulename:</strong> <br /> Apply for type="module". Input one or more module names which are separated by comma. For example: mod_articles_news, mod_articles_latest</li>\n			<li><strong>ids:</strong> <br /> Apply for type="articles". Input one or more article IDs which are separated by comma. For example: 1, 2, 3, 4</li>\n			<li><strong>catid:</strong> <br /> Apply for type="articles". Input one catergory from which you want to display their articles in tabs. For example: 1</li>\n			<li><strong>maxitems:</strong> <br /> Maximum number of articles displaying</li>\n			\n			</div>\n			\n			<p><span style="color: #ff6600;"><strong>For Example tags:</strong></span></p>\n			<div  style="font-weight: normal">\n			<b>1. Type = modules</b>\n		\n			<p>\n{jatabs type="modules" module="position-7" position="top" \n	mouseType="click" animType="animFade"}\n{/jatabs}\n			</p>\n		\n			\n			<b>2. Type = module</b>\n		\n			<p>\n{jatabs type="module" modulename="mod_menu, mod_login" \nposition="left" widthTabs="150" animType="animMoveVir"}\n{/jatabs}\n			</p>\n	\n			\n			<b>3. Type = content</b>\n			\n			<p>\n{jatabs  type="content" position="top" height="240" mouseType="mouseover" \n	animType="animMoveHor"}\n  [tab title="Entertainment"]\n    &lt;img src="images/sampledata/fruitshop/apple.jpg" \n    alt="Sample image" align="left" class="caption" /&gt;...\n  [/tab]\n  [tab title="Travel"]\n    &lt;img src="images/sampledata/fruitshop/bananas_2.jpg" /&gt;\n  [/tab]\n  [tab title="Artist"]\n    &lt;img src="images/sampledata/fruitshop/tamarind.jpg" /&gt;\n  [/tab]\n{/jatabs}\n			</p>\n			\n			\n			<b>4. Type = articles</b>\n		\n			<p>\n{jatabs type="articles" ids="25, 26, 27" ajax=true view="introtext" position="right" \n	widthTabs=150 width=530 animType="animMoveVir"}\n{/jatabs}\n			</p>\n		\n			\n			<b>5. Type = articles</b>\n			\n			<p>\n{jatabs type="articles" catid="55" view="introtext" ajax=true position="bottom"\n	animType="animMoveHor"}\n{/jatabs}\n			</p>\n			\n			</div>\n			<style type=''text/css''>	\n			.plg-desc li,\n			.mod-desc li{\n				background: url("../plugins/system/jatabs/jatabs/arrow-level1.png") no-repeat left 12px;\n				margin-left:10px;\n				padding-left:12px;\n				line-height: 180%;\n			}\n			.plg-desc p,\n			.mod-desc p{\n				margin:15px 0;\n			}\n			</style>\n		\n	";s:5:"group";s:0:"";}', '{"disable_tab":"0","style":"default","position":"top","width":"100%","height":"auto","widthTabs":"100%","heightTabs":"30","duration":"1000","animType":"animMoveVir","skipAnim":"false","mouseType":"click","view":"introtext","colors":""}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(10004, 'jaextmanager', 'component', 'com_jaextmanager', '', 0, 1, 0, 0, 'a:11:{s:6:"legacy";b:0;s:4:"name";s:14:"JA Ext Manager";s:4:"type";s:9:"component";s:12:"creationDate";s:8:"Nov 2010";s:6:"author";s:8:"JoomlArt";s:9:"copyright";s:63:"Copyright (C), J.O.O.M Solutions Co., Ltd. All Rights Reserved.";s:11:"authorEmail";s:22:"webmaster@joomlart.com";s:9:"authorUrl";s:23:"http://www.joomlart.com";s:7:"version";s:5:"1.0.0";s:11:"description";s:59:"JA Extension Manager component version 1.0.0 for Joomla 1.6";s:5:"group";s:0:"";}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10006, 'JA Bulletin', 'module', 'mod_jabulletin', '', 0, 1, 0, 0, 'a:11:{s:6:"legacy";b:0;s:4:"name";s:11:"JA Bulletin";s:4:"type";s:6:"module";s:12:"creationDate";s:8:"Oct 2010";s:6:"author";s:12:"JoomlArt.com";s:9:"copyright";s:27:"J.O.O.M Solutions Co., Ltd.";s:11:"authorEmail";s:22:"webmaster@joomlart.com";s:9:"authorUrl";s:16:"www.joomlart.com";s:7:"version";s:5:"1.0.0";s:11:"description";s:2037:"\n	\n	   <span style="color: #008000;">\n	   	<strong>JA Bulletin Module</strong>\n	   </span>\n	   <br />\n	   <p><img alt="JA Bulletin Module" src="http://static.joomlart.com/images/stories/extensions/joomla/ja_bulletin.png" /></p>\n	   This module behaves like default joomla most read and latest modules, but supports options to show date and thumbnail images.\n	   \n	   <p style="clear:both"><span style="color: #ff6600;"><strong>Features:</strong></span></p>\n	   <ol><li>Show / hide Images in the list</li><li>Show or hide Date of the article.</li><li>Easy thumbnail generation, set your own dimensions.</li></ol>\n	   \n	   \n	   <p><strong><span style="color: #ff0000;">Important Instructions :</span></strong></p>\n	   <ol><li>Keep your module updated with the latest version</li></ol>\n	   <p><strong><span style="color: #ff0000;">Upgrade Methods :</span><br /></strong></p>\n	   <ol>\n	   	<li>Standard joomla reinstall method. OR</li><li>Module supports upgrade method. You can install new version directly over this version. Uninstallation is not required. Backup any customized file before upgrading, your settings would be saved though. OR</li>\n	   	<li>Use <strong><a href="http://extensions.joomla.org/extensions/core-enhancements/installers/12077" target="_blank">JA Extensions Manager</a></strong> Component for easy upgrades and rollbacks. <strong><a href="http://www.youtube.com/user/JoomlArt#p/c/BC9B0C0BFE98657E/2/mNAuJRmifG8" target="_blank">Watch Video.</a></strong></li>\n	   </ol>\n	   <p><span style="color: #008000;"><strong>Links :</strong></span></p>\n	   <ul><li><a target="_blank" href="http://www.joomlart.com/forums">JA Bulletin Module Forum</a></li><li><a target="_blank" href="http://pm.joomlart.com/browse/JAECMODBULLETINJIVI">Report Bug</a></li><li><a target="_blank" href="http://update.joomlart.com/#products.list/JA%20Bulletin%20module%20for%20Joomla%201.6/">Updates &amp; Versions</a></li></ul>\n	   <p>Copyright 2004 - 2010 <a href="http://www.joomlart.com/" title="Visit Joomlart.com!">JoomlArt.com</a>.</p>\n	\n	";s:5:"group";s:0:"";}', '{"moduleclass_sfx":"","content_setting":"","type":"latest","category":"","count":"5","show_featured":"1","show_date":"1","image_setting":"","show_image":"1","thumbnail_mode":"crop","use_ratio":"1","width":"40","height":"40","cache":"1","cache_time":"30"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10007, 'JA Side News Module', 'module', 'mod_jasidenews', '', 0, 1, 0, 0, 'a:11:{s:6:"legacy";b:0;s:4:"name";s:19:"JA Side News Module";s:4:"type";s:6:"module";s:12:"creationDate";s:8:"Oct 2010";s:6:"author";s:12:"Joomlart.com";s:9:"copyright";s:27:"J.O.O.M Solutions Co., Ltd.";s:11:"authorEmail";s:22:"webmaster@joomlart.com";s:9:"authorUrl";s:23:"http://www.joomlart.com";s:7:"version";s:5:"1.0.0";s:11:"description";s:319:"\n		\n			JA Side News module allows your website to display a list of articles with meta keyword ''''Featured'''' (this word is declared in the ''''Keyword'''' param inside the Metadata Information of each article). Otherwise, it displays articles from one or many categories. The list can be sorted by Date, Order or Hits.	\n		\n	";s:5:"group";s:0:"";}', '{"moduleclass_sfx":"","settingcontent":"","display_model-modcats-category":"","show_featured":"1","sort_order_field":"created","sort_order":"DESC","max_items":"5","title_max_chars":"200","maxchars":"60","settingimg":"","thumbnail_mode":"crop","thumbnail_mode-resize-use_ratio":"1","iwidth":"152","iheight":"200","image_alignment":"left","settinglayout":"","layout":"default","layout-default-showdate":"1","layout-default-show_moredetail":"1","layout-default-showimage":"1","layout-sidenews-height":"200","layout-sidenews-textcolor":"FFFFFF","layout-sidenews-bgcolor":"4F4F4F","layout-sidenews-transparent":"80","layout-sidenews-element_apply_side":"content","layout-sidenews-play_mode":"caption","layout-sidenews-play_mode-caption-expandheight":"150","layout-sidenews-play_mode-caption-collapseheight":"30","layout-sidenews-animation_transition":"Fx.Transitions.Expo.easeOut","enable_cache":"1","cache_time":"30"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10011, 'JA Slideshow Module', 'module', 'mod_jaslideshow', '', 0, 1, 0, 0, 'a:11:{s:6:"legacy";b:0;s:4:"name";s:19:"JA Slideshow Module";s:4:"type";s:6:"module";s:12:"creationDate";s:8:"Oct 2010";s:6:"author";s:12:"JoomlArt.com";s:9:"copyright";s:27:"J.O.O.M Solutions Co., Ltd.";s:11:"authorEmail";s:22:"webmaster@joomlart.com";s:9:"authorUrl";s:16:"www.joomlart.com";s:7:"version";s:5:"1.0.0";s:11:"description";s:705:"\n\n<h3 style="color:#008000">The JA Slideshow module</h3>The JA Slideshow module allows to display a list of articles with meta keyword "Featured"(this word is declared in the "Keyword" param inside the Metadata Information of each article). Otherwise, it displays artiles from one or many categories. The list can be sorted by Date, Order or Hits.<br><br><b style="color:#FF6600">Features:</b><ol><li>Support many Animations in the sildeshow playing</li><li>Allow display image and thumbnail via two options: <br> a) from the image inside the article''s content <br> b) from folders image</li><li>....</li></ol><br><br><b style="color:#FF6600">Requirements:</b><br> <ol><li>Joomla! 1.6.x site.</li></ol>\n\n	";s:5:"group";s:0:"";}', '{"moduleclass_sfx":"","source_settings":"","source":"images","source-articles-display_model":"0","source-articles-display_model-modcats-category":"","source-articles-sort_order_field":"created","source-articles-sort_order":"DESC","source-articles-max_items":"5","source-images-orderby":"0","source-images-sort":"0","folder":"images\\/sampledata\\/fruitshop","description":"","profile_settings":"","profile":"default","enable_cache":"1","cache_time":"30","open_target":"parent","source-articles-images-thumbnail_mode":"crop","source-articles-images-thumbnail_mode-resize-use_ratio":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10009, 'JA Twitter Module', 'module', 'mod_jatwitter', '', 0, 1, 0, 0, 'a:11:{s:6:"legacy";b:0;s:4:"name";s:17:"JA Twitter Module";s:4:"type";s:6:"module";s:12:"creationDate";s:8:"Oct 2010";s:6:"author";s:12:"Joomlart.com";s:9:"copyright";s:27:"J.O.O.M Solutions Co., Ltd.";s:11:"authorEmail";s:22:"webmaster@joomlart.com";s:9:"authorUrl";s:23:"http://www.joomlart.com";s:7:"version";s:5:"1.0.0";s:11:"description";s:155:"JA Twitter is a Twitter module that let you display twittes from User or both User and Friends, allow display twitter account information, display friends.";s:5:"group";s:0:"";}', '{"moduleclass_sfx":"","content_setting":"","taccount":"JoomlartDemo","use_display_taccount":"0","size_iconaccount":"48","settingcontent":"","show_tweet":"1","show_limit":"5","show_icon":"1","icon_size":"30","show_username":"1","show_source":"1","showtextheading":"1","headingtext":"My Twitter Updates","friend_setting":"","use_friends":"0","size_iconfriend":"24","max_friends":"10","settingfollowbutton":"","showfollowlink":"1","typefollowbutton":"apiconnect","style_of_follow_button":"follow_me-a.png","apikey":"","enable_cache":"1","cache_time":"5"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10012, 'JA Contentslider', 'module', 'mod_jacontentslider', '', 0, 1, 0, 0, 'a:11:{s:6:"legacy";b:0;s:4:"name";s:16:"JA Contentslider";s:4:"type";s:6:"module";s:12:"creationDate";s:8:"Nov 2010";s:6:"author";s:12:"JoomlArt.com";s:9:"copyright";s:63:"Copyright (C), J.O.O.M Solutions Co., Ltd. All Rights Reserved.";s:11:"authorEmail";s:22:"webmaster@joomlart.com";s:9:"authorUrl";s:16:"www.joomlart.com";s:7:"version";s:5:"1.0.0";s:11:"description";s:1504:"\n		\n			<h3>JA Content Slider</h3><br />\n			Slide your contents with category or many categories. <br>\n			<h3><font color="blue">Feature:</font></h3>\n			<p style="font-weight:normal">This module will display your content in a slide. Its will slide one per one content with your direction.When you move your mouse over the image beside slide, The slide''s direction will change with that direction in image and slide will move faster. Then, when you move your mouse out the image, the slide will keep new direction and the slide will move with old speed.</p>\n			<h3><font color="blue">You can:</font></h3>\n			<ul style="font-weight:normal">\n			<li>- Slide your content with your width and height properties.</li>\n			<li>- You can set the number of content will display in a tab.</li>\n			<li>- You can set the categories contents will display.</li>\n			<li>- You can set display title, link title, introtext, read more text links or not.</li>\n			<li>- You can set the slide to auto run or not. Default is yes.</li>\n			<li>- Set direction of slide. Default is left.</li>\n			<li>- Set to use zip javascript file or not. You should chose yes for this option.</li>\n			<li>- And the last is set time for rolling delay time and animation time.</li>\n			</ul>\n			<br /> \n			<font > <strong>Note</strong> </font>: <span style="font-weight:normal">			\n			check in your configuration in your site if there isn''t this line "var $absolute_path by ''your absulute path'';" you have to add its there to run.</span><br /> \n		\n	";s:5:"group";s:0:"";}', '{"moduleclass_sfx":"","settingcontent":"","source":"content","folder_images":"","catid":"","text_heading":"","showTab":"1","sort_order_field":"created","sort_order":"DESC","numElem":"3","maxitems":"10","link_titles":"1","numchar":"50","showimages":"1","iwidth":"130","iheight":"90","showreadmore":"0","showintrotext":"1","settingdisplay":"","xwidth":"140","xheight":"170","auto":"0","direction":"left","mode":"horizontal","delaytime":"5000","animationtime":"1000","showtitle":"1","showbutton":"1","scroll_when":"click","enable_cache":"1","cache_time":"300","source-articles-images-thumbnail_mode":"crop","source-articles-images-thumbnail_mode-resize-use_ratio":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10018, 'Button - JA Typography', 'plugin', 'jatypo', 'system', 0, 1, 1, 0, '{"legacy":true,"name":"Button - JA Typography","type":"plugin","creationDate":"Sep 2010","author":"JoomlArt","copyright":"Copyright (C), J.O.O.M Solutions Co., Ltd. All Rights Reserved.","authorEmail":"webmaster@joomlart.com","authorUrl":"http:\\/\\/www.joomlart.com","version":"1.0.0","description":"JA_TYPO_GRAPHY_PLUGIN","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10020, 'ArabicUnitag', 'language', 'ar-AA', '', 1, 1, 0, 0, '{"legacy":true,"name":"Arabic Unitag (\\u0627\\u0644\\u0639\\u0631\\u0628\\u064a\\u0629 \\u0627\\u0644\\u0645\\u0648\\u062d\\u062f\\u0629)","type":"language","creationDate":"2011-07-19","author":"Mahmood Alhaj Kassem\\/suneye","copyright":"Copyright (C) 2005 - 2011 Mahmood Alhaj Kassem\\/suneye and Open Source Matters. All rights reserved.","authorEmail":"suneye3@gmail.com","authorUrl":"http:\\/\\/www.joomlaarabschool.com","version":"1.7.0","description":"Arabic Unitag Administrator language 1.7.0 \\u062d\\u0632\\u0645\\u0629 \\u0627\\u0644\\u0644\\u063a\\u0629 \\u0627\\u0644\\u0639\\u0631\\u0628\\u064a\\u0629 \\u0627\\u0644\\u0645\\u0648\\u062d\\u062f\\u0629\\/\\u0627\\u0644\\u0625\\u062f\\u0627\\u0631\\u0629","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10021, 'ar-AA', 'package', 'pkg_ar-AA', '', 0, 1, 1, 0, '{"legacy":false,"name":"Arabic Unitag Language Package - \\u062d\\u0632\\u0645\\u0629 \\u0627\\u0644\\u0644\\u063a\\u0629 \\u0627\\u0644\\u0639\\u0631\\u0628\\u064a\\u0629 \\u0627\\u0644\\u0645\\u0648\\u062d\\u062f\\u0629","type":"package","creationDate":"2011-07-20 ","author":"Mahmood Alhaj Kassem\\/suneye","copyright":"","authorEmail":"","authorUrl":"","version":"1.7.0","description":"Arabic Unitag Language Package for Joomla! 1.7.0 has been Successful Installed - \\u0644\\u0642\\u062f \\u062a\\u0645 \\u062a\\u0646\\u0635\\u064a\\u0628 \\u062d\\u0632\\u0645\\u0629 \\u0627\\u0644\\u0644\\u063a\\u0629 \\u0627\\u0644\\u0639\\u0631\\u0628\\u064a\\u0629 \\u0627\\u0644\\u0645\\u0648\\u062d\\u062f\\u0629 \\u0644\\u0646\\u0638\\u0627\\u0645 \\u062c\\u0648\\u0645\\u0644\\u0627! 1.7.0 \\u0628\\u0646\\u062c\\u0627\\u062d","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10022, 'com_finder', 'component', 'com_finder', '', 1, 1, 1, 0, '{"legacy":false,"name":"com_finder","type":"component","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_FINDER_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10023, 'mod_finder', 'module', 'mod_finder', '', 0, 1, 1, 0, '{"legacy":false,"name":"mod_finder","type":"module","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_FINDER_XML_DESCRIPTION","group":""}', '{"searchfilter":"","show_autosuggest":"1","show_advanced":"0","moduleclass_sfx":"","field_size":"25","show_label":"1","label_pos":"top","show_button":"0","button_pos":"right","opensearch":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10024, 'mod_version', 'module', 'mod_version', '', 1, 1, 1, 0, '{"legacy":false,"name":"mod_version","type":"module","creationDate":"January 2012","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_VERSION_XML_DESCRIPTION","group":""}', '{"format":"short","product":"1","cache":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10025, 'plg_captcha_recaptcha', 'plugin', 'recaptcha', 'captcha', 0, 1, 1, 0, '{"legacy":false,"name":"plg_captcha_recaptcha","type":"plugin","creationDate":"December 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_CAPTCHA_RECAPTCHA_XML_DESCRIPTION","group":""}', '{"public_key":"","private_key":"","theme":"clean"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10026, 'plg_content_finder', 'plugin', 'finder', 'content', 0, 0, 1, 0, '{"legacy":false,"name":"plg_content_finder","type":"plugin","creationDate":"December 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_CONTENT_FINDER_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10027, 'plg_finder_categories', 'plugin', 'categories', 'finder', 0, 1, 1, 0, '{"legacy":false,"name":"plg_finder_categories","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_FINDER_CATEGORIES_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10028, 'plg_finder_contacts', 'plugin', 'contacts', 'finder', 0, 1, 1, 0, '{"legacy":false,"name":"plg_finder_contacts","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_FINDER_CONTACTS_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10029, 'plg_finder_content', 'plugin', 'content', 'finder', 0, 1, 1, 0, '{"legacy":false,"name":"plg_finder_content","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_FINDER_CONTENT_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0);
INSERT INTO `#__extensions` (`extension_id`, `name`, `type`, `element`, `folder`, `client_id`, `enabled`, `access`, `protected`, `manifest_cache`, `params`, `custom_data`, `system_data`, `checked_out`, `checked_out_time`, `ordering`, `state`) VALUES
(10030, 'plg_finder_newsfeeds', 'plugin', 'newsfeeds', 'finder', 0, 1, 1, 0, '{"legacy":false,"name":"plg_finder_newsfeeds","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_FINDER_NEWSFEEDS_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10031, 'plg_finder_weblinks', 'plugin', 'weblinks', 'finder', 0, 1, 1, 0, '{"legacy":false,"name":"plg_finder_weblinks","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_FINDER_WEBLINKS_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10032, 'plg_quickicon_extensionupdate', 'plugin', 'extensionupdate', 'quickicon', 0, 1, 1, 0, '{"legacy":false,"name":"plg_quickicon_extensionupdate","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_QUICKICON_EXTENSIONUPDATE_XML_DESCRIPTION","group":""}', '{"context":"mod_quickicon"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10033, 'plg_quickicon_joomlaupdate', 'plugin', 'joomlaupdate', 'quickicon', 0, 1, 1, 0, '{"legacy":false,"name":"plg_quickicon_joomlaupdate","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_QUICKICON_JOOMLAUPDATE_XML_DESCRIPTION","group":""}', '{"context":"mod_quickicon"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10034, 'plg_system_highlight', 'plugin', 'highlight', 'system', 0, 1, 1, 0, '{"legacy":false,"name":"plg_system_highlight","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_SYSTEM_HIGHLIGHT_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10035, 'plg_system_languagecode', 'plugin', 'languagecode', 'system', 0, 0, 1, 0, '{"legacy":false,"name":"plg_system_languagecode","type":"plugin","creationDate":"November 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_SYSTEM_LANGUAGECODE_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10036, 'System - JA Comment', 'plugin', 'system_jacomment', 'system', 0, 1, 1, 0, '{"legacy":false,"name":"System - JA Comment","type":"plugin","creationDate":"December 2011","author":"JoomlArt.com","copyright":"Copyright (C), J.O.O.M Solutions Co., Ltd. All Rights Reserved.","authorEmail":"webmaster@joomlart.com","authorUrl":"www.joomlart.com","version":"1.1.1","description":"System JA Comment","group":""}', '{"display_comment_link":"1","display_comment_count":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10037, 'ArabicUnitag', 'language', 'ar-AA', '', 1, 1, 0, 0, '{"legacy":true,"name":"Arabic Unitag (\\u0627\\u0644\\u0639\\u0631\\u0628\\u064a\\u0629 \\u0627\\u0644\\u0645\\u0648\\u062d\\u062f\\u0629)","type":"language","creationDate":"2011-07-19","author":"Mahmood Alhaj Kassem\\/suneye","copyright":"Copyright (C) 2005 - 2011 Mahmood Alhaj Kassem\\/suneye and Open Source Matters. All rights reserved.","authorEmail":"suneye3@gmail.com","authorUrl":"http:\\/\\/www.joomlaarabschool.com","version":"1.7.0","description":"Arabic Unitag Administrator language 1.7.0 \\u062d\\u0632\\u0645\\u0629 \\u0627\\u0644\\u0644\\u063a\\u0629 \\u0627\\u0644\\u0639\\u0631\\u0628\\u064a\\u0629 \\u0627\\u0644\\u0645\\u0648\\u062d\\u062f\\u0629\\/\\u0627\\u0644\\u0625\\u062f\\u0627\\u0631\\u0629","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0);

DROP TABLE IF EXISTS `#__finder_filters`;
CREATE TABLE `#__finder_filters` (
  `filter_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) NOT NULL,
  `state` tinyint(1) NOT NULL DEFAULT '1',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL,
  `created_by_alias` varchar(255) NOT NULL,
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `map_count` int(10) unsigned NOT NULL DEFAULT '0',
  `data` text NOT NULL,
  `params` mediumtext,
  PRIMARY KEY (`filter_id`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__finder_links`;
CREATE TABLE `#__finder_links` (
  `link_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `url` varchar(255) NOT NULL,
  `route` varchar(255) NOT NULL,
  `title` varchar(255) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL,
  `indexdate` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `md5sum` varchar(32) DEFAULT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '1',
  `state` int(5) DEFAULT '1',
  `access` int(5) DEFAULT '0',
  `language` varchar(8) NOT NULL,
  `publish_start_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_end_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `start_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `end_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `list_price` double unsigned NOT NULL DEFAULT '0',
  `sale_price` double unsigned NOT NULL DEFAULT '0',
  `type_id` int(11) NOT NULL,
  `object` mediumblob NOT NULL,
  PRIMARY KEY (`link_id`),
  KEY `idx_type` (`type_id`),
  KEY `idx_title` (`title`),
  KEY `idx_md5` (`md5sum`),
  KEY `idx_url` (`url`(75)),
  KEY `idx_published_list` (`published`,`state`,`access`,`publish_start_date`,`publish_end_date`,`list_price`),
  KEY `idx_published_sale` (`published`,`state`,`access`,`publish_start_date`,`publish_end_date`,`sale_price`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__finder_links_terms0`;
CREATE TABLE `#__finder_links_terms0` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__finder_links_terms1`;
CREATE TABLE `#__finder_links_terms1` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__finder_links_terms2`;
CREATE TABLE `#__finder_links_terms2` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__finder_links_terms3`;
CREATE TABLE `#__finder_links_terms3` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__finder_links_terms4`;
CREATE TABLE `#__finder_links_terms4` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__finder_links_terms5`;
CREATE TABLE `#__finder_links_terms5` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__finder_links_terms6`;
CREATE TABLE `#__finder_links_terms6` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__finder_links_terms7`;
CREATE TABLE `#__finder_links_terms7` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__finder_links_terms8`;
CREATE TABLE `#__finder_links_terms8` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__finder_links_terms9`;
CREATE TABLE `#__finder_links_terms9` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__finder_links_termsa`;
CREATE TABLE `#__finder_links_termsa` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__finder_links_termsb`;
CREATE TABLE `#__finder_links_termsb` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__finder_links_termsc`;
CREATE TABLE `#__finder_links_termsc` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__finder_links_termsd`;
CREATE TABLE `#__finder_links_termsd` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__finder_links_termse`;
CREATE TABLE `#__finder_links_termse` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__finder_links_termsf`;
CREATE TABLE `#__finder_links_termsf` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__finder_taxonomy`;
CREATE TABLE `#__finder_taxonomy` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0',
  `title` varchar(255) NOT NULL,
  `state` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `access` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `ordering` tinyint(1) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `parent_id` (`parent_id`),
  KEY `state` (`state`),
  KEY `ordering` (`ordering`),
  KEY `access` (`access`),
  KEY `idx_parent_published` (`parent_id`,`state`,`access`)
) ENGINE=MyISAM ;

INSERT INTO `#__finder_taxonomy` (`id`, `parent_id`, `title`, `state`, `access`, `ordering`) VALUES
(1, 0, 'ROOT', 0, 0, 0);

DROP TABLE IF EXISTS `#__finder_taxonomy_map`;
CREATE TABLE `#__finder_taxonomy_map` (
  `link_id` int(10) unsigned NOT NULL,
  `node_id` int(10) unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`node_id`),
  KEY `link_id` (`link_id`),
  KEY `node_id` (`node_id`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__finder_terms`;
CREATE TABLE `#__finder_terms` (
  `term_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `term` varchar(75) NOT NULL,
  `stem` varchar(75) NOT NULL,
  `common` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `phrase` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `weight` float unsigned NOT NULL DEFAULT '0',
  `soundex` varchar(75) NOT NULL,
  `links` int(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_id`),
  UNIQUE KEY `idx_term` (`term`),
  KEY `idx_term_phrase` (`term`,`phrase`),
  KEY `idx_stem_phrase` (`stem`,`phrase`),
  KEY `idx_soundex_phrase` (`soundex`,`phrase`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__finder_terms_common`;
CREATE TABLE `#__finder_terms_common` (
  `term` varchar(75) NOT NULL,
  `language` varchar(3) NOT NULL,
  KEY `idx_word_lang` (`term`,`language`),
  KEY `idx_lang` (`language`)
) ENGINE=MyISAM;

INSERT INTO `#__finder_terms_common` (`term`, `language`) VALUES
('a', 'en'),
('about', 'en'),
('after', 'en'),
('ago', 'en'),
('all', 'en'),
('am', 'en'),
('an', 'en'),
('and', 'en'),
('ani', 'en'),
('any', 'en'),
('are', 'en'),
('aren''t', 'en'),
('as', 'en'),
('at', 'en'),
('be', 'en'),
('but', 'en'),
('by', 'en'),
('for', 'en'),
('from', 'en'),
('get', 'en'),
('go', 'en'),
('how', 'en'),
('if', 'en'),
('in', 'en'),
('into', 'en'),
('is', 'en'),
('isn''t', 'en'),
('it', 'en'),
('its', 'en'),
('me', 'en'),
('more', 'en'),
('most', 'en'),
('must', 'en'),
('my', 'en'),
('new', 'en'),
('no', 'en'),
('none', 'en'),
('not', 'en'),
('noth', 'en'),
('nothing', 'en'),
('of', 'en'),
('off', 'en'),
('often', 'en'),
('old', 'en'),
('on', 'en'),
('onc', 'en'),
('once', 'en'),
('onli', 'en'),
('only', 'en'),
('or', 'en'),
('other', 'en'),
('our', 'en'),
('ours', 'en'),
('out', 'en'),
('over', 'en'),
('page', 'en'),
('she', 'en'),
('should', 'en'),
('small', 'en'),
('so', 'en'),
('some', 'en'),
('than', 'en'),
('thank', 'en'),
('that', 'en'),
('the', 'en'),
('their', 'en'),
('theirs', 'en'),
('them', 'en'),
('then', 'en'),
('there', 'en'),
('these', 'en'),
('they', 'en'),
('this', 'en'),
('those', 'en'),
('thus', 'en'),
('time', 'en'),
('times', 'en'),
('to', 'en'),
('too', 'en'),
('true', 'en'),
('under', 'en'),
('until', 'en'),
('up', 'en'),
('upon', 'en'),
('use', 'en'),
('user', 'en'),
('users', 'en'),
('veri', 'en'),
('version', 'en'),
('very', 'en'),
('via', 'en'),
('want', 'en'),
('was', 'en'),
('way', 'en'),
('were', 'en'),
('what', 'en'),
('when', 'en'),
('where', 'en'),
('whi', 'en'),
('which', 'en'),
('who', 'en'),
('whom', 'en'),
('whose', 'en'),
('why', 'en'),
('wide', 'en'),
('will', 'en'),
('with', 'en'),
('within', 'en'),
('without', 'en'),
('would', 'en'),
('yes', 'en'),
('yet', 'en'),
('you', 'en'),
('your', 'en'),
('yours', 'en');

DROP TABLE IF EXISTS `#__finder_tokens`;
CREATE TABLE `#__finder_tokens` (
  `term` varchar(75) NOT NULL,
  `stem` varchar(75) NOT NULL,
  `common` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `phrase` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `weight` float unsigned NOT NULL DEFAULT '1',
  `context` tinyint(1) unsigned NOT NULL DEFAULT '2',
  KEY `idx_word` (`term`),
  KEY `idx_context` (`context`)
) ENGINE=MEMORY;


DROP TABLE IF EXISTS `#__finder_tokens_aggregate`;
CREATE TABLE `#__finder_tokens_aggregate` (
  `term_id` int(10) unsigned NOT NULL,
  `map_suffix` char(1) NOT NULL,
  `term` varchar(75) NOT NULL,
  `stem` varchar(75) NOT NULL,
  `common` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `phrase` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `term_weight` float unsigned NOT NULL,
  `context` tinyint(1) unsigned NOT NULL DEFAULT '2',
  `context_weight` float unsigned NOT NULL,
  `total_weight` float unsigned NOT NULL,
  KEY `token` (`term`),
  KEY `keyword_id` (`term_id`)
) ENGINE=MEMORY;


DROP TABLE IF EXISTS `#__finder_types`;
CREATE TABLE `#__finder_types` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(100) NOT NULL,
  `mime` varchar(100) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `title` (`title`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__jaem_log`;
CREATE TABLE `#__jaem_log` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ext_id` varchar(50) DEFAULT NULL,
  `service_id` int(11) DEFAULT NULL,
  `check_date` datetime DEFAULT NULL,
  `check_info` text,
  PRIMARY KEY (`id`),
  UNIQUE KEY `ext_id` (`ext_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__jaem_services`;
CREATE TABLE `#__jaem_services` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ws_name` varchar(255) NOT NULL,
  `ws_mode` varchar(50) NOT NULL DEFAULT 'local',
  `ws_uri` varchar(255) NOT NULL,
  `ws_user` varchar(100) NOT NULL,
  `ws_pass` varchar(100) NOT NULL,
  `ws_default` tinyint(1) NOT NULL DEFAULT '0',
  `ws_core` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM ;

INSERT INTO `#__jaem_services` (`id`, `ws_name`, `ws_mode`, `ws_uri`, `ws_user`, `ws_pass`, `ws_default`, `ws_core`) VALUES
(1, 'Local Service', 'local', '', '', '', 1, 1),
(2, 'JoomlArt Updates', 'remote', 'http://update.joomlart.com/service/', '', '', 0, 1);

DROP TABLE IF EXISTS `#__jarpx_mapid`;
CREATE TABLE `#__jarpx_mapid` (
  `user_id` int(11) NOT NULL,
  `rpxid` varchar(50) NOT NULL
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__languages`;
CREATE TABLE `#__languages` (
  `lang_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `lang_code` char(7) NOT NULL,
  `title` varchar(50) NOT NULL,
  `title_native` varchar(50) NOT NULL,
  `sef` varchar(50) NOT NULL,
  `image` varchar(50) NOT NULL,
  `description` varchar(512) NOT NULL,
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `sitename` varchar(1024) NOT NULL,
  `published` int(11) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`lang_id`),
  UNIQUE KEY `idx_sef` (`sef`),
  UNIQUE KEY `idx_image` (`image`),
  UNIQUE KEY `idx_langcode` (`lang_code`),
  KEY `idx_ordering` (`ordering`)
) ENGINE=MyISAM ;

INSERT INTO `#__languages` (`lang_id`, `lang_code`, `title`, `title_native`, `sef`, `image`, `description`, `metakey`, `metadesc`, `sitename`, `published`, `ordering`) VALUES
(1, 'en-GB', 'English (UK)', 'English (UK)', 'en', 'en', '', '', '', '', 1, 0),
(3, 'xx-XX', 'xx (Test)', 'xx (Test)', 'xx', 'br', '', '', '', '', 1, 0);

DROP TABLE IF EXISTS `#__menu`;
CREATE TABLE `#__menu` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `menutype` varchar(24) NOT NULL COMMENT 'The type of menu this item belongs to. FK to #__menu_types.menutype',
  `title` varchar(255) NOT NULL COMMENT 'The display title of the menu item.',
  `alias` varchar(255) binary NOT NULL COMMENT 'The SEF alias of the menu item.',
  `note` varchar(255) NOT NULL DEFAULT '',
  `path` varchar(1024) NOT NULL COMMENT 'The computed path of the menu item based on the alias field.',
  `link` varchar(1024) NOT NULL COMMENT 'The actually link the menu item refers to.',
  `type` varchar(16) NOT NULL COMMENT 'The type of link: Component, URL, Alias, Separator',
  `published` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'The published state of the menu link.',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '1' COMMENT 'The parent menu item in the menu tree.',
  `level` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The relative level in the tree.',
  `component_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to #__extensions.id',
  `ordering` int(11) NOT NULL DEFAULT '0' COMMENT 'The relative ordering of the menu item in the tree.',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to #__users.id',
  `checked_out_time` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'The time the menu item was checked out.',
  `browserNav` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'The click behaviour of the link.',
  `access` int(10) unsigned DEFAULT NULL,
  `img` varchar(255) NOT NULL COMMENT 'The image of the menu item.',
  `template_style_id` int(10) unsigned NOT NULL DEFAULT '0',
  `params` text COMMENT 'JSON encoded data for the menu item.',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `home` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Indicates if this menu item is the home or default page.',
  `language` char(7) NOT NULL DEFAULT '',
  `client_id` tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_client_id_parent_id_alias_language` (`client_id`,`parent_id`,`alias`,`language`),
  KEY `idx_componentid` (`component_id`,`menutype`,`published`,`access`),
  KEY `idx_menutype` (`menutype`),
  KEY `idx_left_right` (`lft`,`rgt`),
  KEY `idx_alias` (`alias`),
  KEY `idx_path` (`path`(333)),
  KEY `idx_language` (`language`)
) ENGINE=MyISAM ;

INSERT INTO `#__menu` (`id`, `menutype`, `title`, `alias`, `note`, `path`, `link`, `type`, `published`, `parent_id`, `level`, `component_id`, `ordering`, `checked_out`, `checked_out_time`, `browserNav`, `access`, `img`, `template_style_id`, `params`, `lft`, `rgt`, `home`, `language`, `client_id`) VALUES
(1, '', 'Menu_Item_Root', 'root', '', '', '', '', 1, 0, 0, 0, 0, 0, '0000-00-00 00:00:00', 0, 0, '', 0, '', 0, 399, 0, '*', 0),
(2, 'menu', 'com_banners', 'Banners', '', 'Banners', 'index.php?option=com_banners', 'component', 0, 1, 1, 4, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:banners', 0, '', 65, 74, 0, '*', 1),
(3, 'menu', 'com_banners', 'Banners', '', 'Banners/Banners', 'index.php?option=com_banners', 'component', 0, 2, 2, 4, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:banners', 0, '', 66, 67, 0, '*', 1),
(4, 'menu', 'com_banners_categories', 'Categories', '', 'Banners/Categories', 'index.php?option=com_categories&extension=com_banners', 'component', 0, 2, 2, 6, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:banners-cat', 0, '', 68, 69, 0, '*', 1),
(5, 'menu', 'com_banners_clients', 'Clients', '', 'Banners/Clients', 'index.php?option=com_banners&view=clients', 'component', 0, 2, 2, 4, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:banners-clients', 0, '', 70, 71, 0, '*', 1),
(6, 'menu', 'com_banners_tracks', 'Tracks', '', 'Banners/Tracks', 'index.php?option=com_banners&view=tracks', 'component', 0, 2, 2, 4, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:banners-tracks', 0, '', 72, 73, 0, '*', 1),
(7, 'menu', 'com_contact', 'Contacts', '', 'Contacts', 'index.php?option=com_contact', 'component', 0, 1, 1, 8, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:contact', 0, '', 75, 80, 0, '*', 1),
(8, 'menu', 'com_contact', 'Contacts', '', 'Contacts/Contacts', 'index.php?option=com_contact', 'component', 0, 7, 2, 8, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:contact', 0, '', 76, 77, 0, '*', 1),
(9, 'menu', 'com_contact_categories', 'Categories', '', 'Contacts/Categories', 'index.php?option=com_categories&extension=com_contact', 'component', 0, 7, 2, 6, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:contact-cat', 0, '', 78, 79, 0, '*', 1),
(10, 'menu', 'com_messages', 'Messaging', '', 'Messaging', 'index.php?option=com_messages', 'component', 0, 1, 1, 15, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:messages', 0, '', 81, 86, 0, '*', 1),
(11, 'menu', 'com_messages_add', 'New Private Message', '', 'Messaging/New Private Message', 'index.php?option=com_messages&task=message.add', 'component', 0, 10, 2, 15, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:messages-add', 0, '', 82, 83, 0, '*', 1),
(12, 'menu', 'com_messages_read', 'Read Private Message', '', 'Messaging/Read Private Message', 'index.php?option=com_messages', 'component', 0, 10, 2, 15, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:messages-read', 0, '', 84, 85, 0, '*', 1),
(13, 'menu', 'com_newsfeeds', 'News Feeds', '', 'News Feeds', 'index.php?option=com_newsfeeds', 'component', 0, 1, 1, 17, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:newsfeeds', 0, '', 87, 92, 0, '*', 1),
(14, 'menu', 'com_newsfeeds_feeds', 'Feeds', '', 'News Feeds/Feeds', 'index.php?option=com_newsfeeds', 'component', 0, 13, 2, 17, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:newsfeeds', 0, '', 88, 89, 0, '*', 1),
(15, 'menu', 'com_newsfeeds_categories', 'Categories', '', 'News Feeds/Categories', 'index.php?option=com_categories&extension=com_newsfeeds', 'component', 0, 13, 2, 6, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:newsfeeds-cat', 0, '', 90, 91, 0, '*', 1),
(16, 'menu', 'com_redirect', 'Redirect', '', 'Redirect', 'index.php?option=com_redirect', 'component', 0, 1, 1, 24, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:redirect', 0, '', 103, 104, 0, '*', 1),
(17, 'menu', 'com_search', 'Search', '', 'Search', 'index.php?option=com_search', 'component', 0, 1, 1, 19, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:search', 0, '', 93, 94, 0, '*', 1),
(18, 'menu', 'com_weblinks', 'Weblinks', '', 'Weblinks', 'index.php?option=com_weblinks', 'component', 0, 1, 1, 21, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:weblinks', 0, '', 97, 102, 0, '*', 1),
(19, 'menu', 'com_weblinks_links', 'Links', '', 'Weblinks/Links', 'index.php?option=com_weblinks', 'component', 0, 18, 2, 21, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:weblinks', 0, '', 98, 99, 0, '*', 1),
(20, 'menu', 'com_weblinks_categories', 'Categories', '', 'Weblinks/Categories', 'index.php?option=com_categories&extension=com_weblinks', 'component', 0, 18, 2, 6, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:weblinks-cat', 0, '', 100, 101, 0, '*', 1),
(464, 'top', 'Home', 'home', '', 'home', 'index.php?Itemid=', 'alias', 1, 1, 1, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"435","menu-anchor_title":"","menu-anchor_css":"","menu_image":""}', 279, 280, 0, '*', 0),
(227, 'aboutjoomla', 'Weblinks Categories', 'weblinks-categories', '', 'using-joomla/extensions/components/weblinks-component/weblinks-categories', 'index.php?option=com_weblinks&view=categories&id=18', 'component', 1, 265, 5, 21, 6, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_base_description":"","categories_description":"","maxLevelcat":"-1","show_empty_categories_cat":"","show_subcat_desc_cat":"","show_cat_num_links_cat":"","show_category_title":"","show_description":"","show_description_image":"","maxLevel":"-1","show_empty_categories":"","show_subcat_desc":"","show_cat_num_links":"","show_pagination_limit":"","show_headings":"","show_link_description":"","show_link_hits":"","show_pagination":"","show_pagination_results":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 139, 140, 0, '*', 0),
(233, 'mainmenu', 'Login', 'login', '', 'login', 'index.php?option=com_users&view=login', 'component', -2, 1, 1, 25, -3, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 7, 8, 0, '*', 0),
(229, 'aboutjoomla', 'Single Contact', 'single-contact', '', 'using-joomla/extensions/components/contact-component/single-contact', 'index.php?option=com_contact&view=contact&id=1', 'component', 1, 270, 5, 8, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_category_crumb":"","presentation_style":"","show_contact_category":"","show_contact_list":"","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_links":"","linka_name":"","linkb_name":"","linkc_name":"","linkd_name":"","linke_name":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 129, 130, 0, '*', 0),
(201, 'usermenu', 'Your Profile', 'your-profile', '', 'your-profile', 'index.php?option=com_users&view=profile', 'component', 1, 1, 1, 25, 0, 0, '0000-00-00 00:00:00', 0, 2, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":1,"page_heading":"Your Profile","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 289, 290, 0, '*', 0),
(296, 'parks', 'Park Links', 'park-links', '', 'park-links', 'index.php?option=com_weblinks&view=category&id=31', 'component', 1, 1, 1, 21, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 114, '{"maxLevel":"-1","show_empty_categories":"","show_description":"1","show_description_image":"1","show_cat_num_articles":"","display_num":"","show_headings":"0","orderby_pri":"","show_pagination":"","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 303, 304, 0, 'en-GB', 0),
(234, 'parks', 'Park Blog', 'park-blog', '', 'park-blog', 'index.php?option=com_content&view=category&layout=blog&id=27', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 114, '{"maxLevel":"","show_empty_categories":"","show_description":"1","show_description_image":"1","show_category_title":"","show_cat_num_articles":"","num_leading_articles":"1","num_intro_articles":"4","num_columns":"1","num_links":"4","multi_column_order":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 293, 294, 0, 'en-GB', 0),
(238, 'mainmenu', 'Sample Sites', 'sample-sites', '', 'sample-sites', 'index.php?option=com_content&view=article&id=38', 'component', -2, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"0","link_category":"","show_parent_category":"0","link_parent_category":"","show_author":"0","link_author":"","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"0","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"200","mega_colw":"200","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 23, 28, 0, '*', 0),
(207, 'top', 'Joomla.org', 'joomlaorg', '', 'joomlaorg', 'http://joomla.org', 'url', 1, 1, 1, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":""}', 287, 288, 0, '*', 0),
(242, 'parks', 'Write a Blog Post', 'write-a-blog-post', '', 'write-a-blog-post', 'index.php?option=com_content&view=form&layout=edit', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 3, '', 114, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 295, 296, 0, 'en-GB', 0),
(243, 'parks', 'Parks Home', 'parks-home', '', 'parks-home', 'index.php?option=com_content&view=article&id=6', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 114, '{"show_noauth":"","show_title":"0","link_titles":"","show_intro":"","show_category":"0","link_category":"0","show_parent_category":"","link_parent_category":"","show_author":"0","link_author":"","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_icons":"","show_print_icon":"0","show_email_icon":"0","show_hits":"0","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 291, 292, 0, 'en-GB', 0),
(244, 'parks', 'Image Gallery', 'image-gallery', '', 'image-gallery', 'index.php?option=com_content&view=categories&id=28', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 114, '{"show_base_description":"1","categories_description":"","maxLevelcat":"","show_empty_categories_cat":"","show_subcat_desc_cat":"","show_cat_num_articles_cat":"","drill_down_layout":"1","show_category_title":"","show_description":"1","show_description_image":"1","maxLevel":"-1","show_empty_categories":"","show_subcat_desc":"","show_cat_num_articles":"","num_leading_articles":"1","num_intro_articles":"4","num_columns":"2","num_links":"4","multi_column_order":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_results":"","show_pagination_limit":"","filter_field":"","show_headings":"","list_show_date":"","date_format":"","list_show_hits":"","list_show_author":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 297, 302, 0, 'en-GB', 0),
(270, 'aboutjoomla', 'Contact Component', 'contact-component', '', 'using-joomla/extensions/components/contact-component', 'index.php?option=com_content&view=article&id=9', 'component', 1, 268, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 124, 133, 0, '*', 0),
(279, 'aboutjoomla', 'The Joomla! Community', 'the-joomla-community', '', 'the-joomla-community', 'index.php?option=com_content&view=article&id=47', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"0","show_intro":"","show_category":"0","link_category":"","show_parent_category":"0","link_parent_category":"","show_author":"0","link_author":"","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"0","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 283, 284, 0, '*', 0),
(249, 'aboutjoomla', 'Submit a Weblink', 'submit-a-weblink', '', 'using-joomla/extensions/components/weblinks-component/submit-a-weblink', 'index.php?option=com_weblinks&view=form&layout=edit', 'component', 1, 265, 5, 21, 0, 0, '0000-00-00 00:00:00', 0, 3, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 135, 136, 0, '*', 0),
(251, 'aboutjoomla', 'Contact Categories', 'contact-categories', '', 'using-joomla/extensions/components/contact-component/contact-categories', 'index.php?option=com_contact&view=categories&id=16', 'component', 1, 270, 5, 8, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_base_description":"","categories_description":"","maxLevel":"-1","show_empty_categories":"","show_description":"","show_description_image":"","show_cat_num_articles":"","display_num":"","show_headings":"","filter_field":"","show_pagination":"","show_noauth":"","presentation_style":"sliders","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_links":"1","linka_name":"","linkb_name":"","linkc_name":"","linkd_name":"","linke_name":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 125, 126, 0, '*', 0),
(252, 'aboutjoomla', 'News Feed Categories', 'new-feed-categories', '', 'using-joomla/extensions/components/news-feeds-component/new-feed-categories', 'index.php?option=com_newsfeeds&view=categories&id=0', 'component', 1, 267, 5, 17, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_base_description":"1","categories_description":"Because this links to the root category the \\"uncategorised\\" category is displayed. ","maxLevel":"-1","show_empty_categories":"1","show_description":"1","show_description_image":"1","show_cat_num_articles":"1","display_num":"","show_headings":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_noauth":"","show_feed_image":"","show_feed_description":"","show_item_description":"","feed_character_count":"0","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 143, 144, 0, '*', 0),
(253, 'aboutjoomla', 'News Feed Category', 'news-feed-category', '', 'using-joomla/extensions/components/news-feeds-component/news-feed-category', 'index.php?option=com_newsfeeds&view=category&id=17', 'component', 1, 267, 5, 17, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"-1","show_empty_categories":"","show_description":"","show_description_image":"","show_cat_num_articles":"","display_num":"","show_headings":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_noauth":"","show_feed_image":"","show_feed_description":"","show_item_description":"","feed_character_count":"0","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 147, 148, 0, '*', 0),
(254, 'aboutjoomla', 'Single News Feed', 'single-news-feed', '', 'using-joomla/extensions/components/news-feeds-component/single-news-feed', 'index.php?option=com_newsfeeds&view=newsfeed&id=4', 'component', 1, 267, 5, 17, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_feed_image":"","show_feed_description":"","show_item_description":"","feed_character_count":"0","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 145, 146, 0, '*', 0),
(255, 'aboutjoomla', 'Search', 'search', '', 'using-joomla/extensions/components/search-component/search', 'index.php?option=com_search&view=search', 'component', 1, 276, 5, 19, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"search_areas":"1","show_date":"1","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 165, 166, 0, '*', 0),
(256, 'aboutjoomla', 'Archived articles', 'archived-articles', '', 'using-joomla/extensions/components/content-component/archived-articles', 'index.php?option=com_content&view=archive', 'component', 1, 266, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"orderby_sec":"","order_date":"","display_num":"","filter_field":"","show_category":"1","link_category":"1","show_title":"1","link_titles":"1","show_intro":"1","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_hits":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 119, 120, 0, '*', 0),
(257, 'aboutjoomla', 'Single Article', 'single-article', '', 'using-joomla/extensions/components/content-component/single-article', 'index.php?option=com_content&view=article&id=6', 'component', 1, 266, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 109, 110, 0, '*', 0),
(278, 'aboutjoomla', 'The Joomla! Project', 'the-joomla-project', '', 'the-joomla-project', 'index.php?option=com_content&view=article&id=48', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"1","link_titles":"","show_intro":"","show_category":"0","link_category":"","show_parent_category":"0","link_parent_category":"","show_author":"0","link_author":"","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_icons":"1","show_print_icon":"","show_email_icon":"","show_hits":"0","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 281, 282, 0, '*', 0),
(259, 'aboutjoomla', 'Article Category Blog', 'article-category-blog', '', 'using-joomla/extensions/components/content-component/article-category-blog', 'index.php?option=com_content&view=category&layout=blog&id=27', 'component', 1, 266, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"","show_empty_categories":"","show_description":"0","show_description_image":"0","show_category_title":"","show_cat_num_articles":"","num_leading_articles":"1","num_intro_articles":"4","num_columns":"2","num_links":"4","multi_column_order":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 113, 114, 0, '*', 0),
(260, 'aboutjoomla', 'Article Category List', 'article-category-list', '', 'using-joomla/extensions/components/content-component/article-category-list', 'index.php?option=com_content&view=category&id=19', 'component', 1, 266, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"","show_category_title":"","page_subheading":"","show_empty_categories":"","show_description":"","show_description_image":"","show_cat_num_articles":"","display_num":"","show_headings":"","list_show_title":"","list_show_date":"","date_format":"","list_show_hits":"","list_show_author":"","filter_field":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_limit":"","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","article-allow_ratings":"","article-allow_comments":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 115, 116, 0, '*', 0),
(262, 'aboutjoomla', 'Featured Articles', 'featured-articles', '', 'using-joomla/extensions/components/content-component/featured-articles', 'index.php?option=com_content&view=featured', 'component', 1, 266, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"","show_empty_categories":"","show_description":"","show_description_image":"","show_cat_num_articles":"","num_leading_articles":"1","num_intro_articles":"4","num_columns":"2","num_links":"4","multi_column_order":"1","orderby_pri":"","orderby_sec":"front","order_date":"","show_pagination":"2","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 117, 118, 0, '*', 0),
(263, 'aboutjoomla', 'Submit Article', 'submit-article', '', 'using-joomla/extensions/components/content-component/submit-article', 'index.php?option=com_content&view=form&layout=edit', 'component', 1, 266, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 3, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 121, 122, 0, '*', 0),
(265, 'aboutjoomla', 'Weblinks Component', 'weblinks-component', '', 'using-joomla/extensions/components/weblinks-component', 'index.php?option=com_content&view=article&id=54', 'component', 1, 268, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 134, 141, 0, '*', 0),
(266, 'aboutjoomla', 'Content Component', 'content-component', '', 'using-joomla/extensions/components/content-component', 'index.php?option=com_content&view=article&id=10', 'component', 1, 268, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"article-allow_ratings":"","article-allow_comments":"","show_category":"","link_category":"","show_title":"","link_titles":"","show_intro":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 108, 123, 0, '*', 0),
(267, 'aboutjoomla', 'News Feeds Component', 'news-feeds-component', '', 'using-joomla/extensions/components/news-feeds-component', 'index.php?option=com_content&view=article&id=60', 'component', 1, 268, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":1,"page_title":"Newsfeeds Categories View ","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 142, 149, 0, '*', 0),
(268, 'aboutjoomla', 'Components', 'components', '', 'using-joomla/extensions/components', 'index.php?option=com_content&view=category&layout=blog&id=21', 'component', 1, 277, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_category_title":"","show_description":"1","show_description_image":"","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"1","num_intro_articles":"77","num_columns":"1","num_links":"0","multi_column_order":"","orderby_pri":"","orderby_sec":"order","order_date":"","show_pagination":"0","show_pagination_results":"","show_title":"","link_titles":"","show_intro":"","show_category":"0","link_category":"","show_parent_category":"0","link_parent_category":"","show_author":"0","link_author":"0","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"","show_readmore":"","show_icons":"0","show_print_icon":"0","show_email_icon":"0","show_hits":"0","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 107, 170, 0, '*', 0),
(277, 'aboutjoomla', 'Using Extensions', 'extensions', '', 'using-joomla/extensions', 'index.php?option=com_content&view=categories&id=20', 'component', 1, 280, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_base_description":"1","categories_description":"","maxLevelcat":"1","show_empty_categories_cat":"1","show_subcat_desc_cat":"1","show_cat_num_articles_cat":"0","drill_down_layout":"0","show_category_title":"","show_description":"1","show_description_image":"1","maxLevel":"1","show_empty_categories":"1","show_subcat_desc":"","show_cat_num_articles":"","num_leading_articles":"1","num_intro_articles":"4","num_columns":"2","num_links":"4","multi_column_order":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_results":"","show_pagination_limit":"","filter_field":"","show_headings":"","list_show_date":"","date_format":"","list_show_hits":"","list_show_author":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 106, 273, 0, '*', 0),
(271, 'aboutjoomla', 'Users Component', 'users-component', '', 'using-joomla/extensions/components/users-component', 'index.php?option=com_content&view=article&id=52', 'component', 1, 268, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 150, 163, 0, '*', 0),
(272, 'aboutjoomla', 'Article Categories', 'article-categories', '', 'using-joomla/extensions/components/content-component/article-categories', 'index.php?option=com_content&view=categories&id=14', 'component', 1, 266, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_base_description":"","categories_description":"","maxLevel":"-1","show_empty_categories":"","show_description":"","show_description_image":"","show_cat_num_articles":"","display_num":"","category_layout":"","show_headings":"","show_date":"","date_format":"","filter_field":"","num_leading_articles":"1","num_intro_articles":"4","num_columns":"2","num_links":"4","multi_column_order":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 111, 112, 0, '*', 0),
(273, 'aboutjoomla', 'Administrator Components', 'administrator-components', '', 'using-joomla/extensions/components/administrator-components', 'index.php?option=com_content&view=article&id=1', 'component', 1, 268, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 168, 169, 0, '*', 0),
(274, 'aboutjoomla', 'Weblinks Single Category', 'weblinks-single-category', '', 'using-joomla/extensions/components/weblinks-component/weblinks-single-category', 'index.php?option=com_weblinks&view=category&id=32', 'component', 1, 265, 5, 21, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"-1","show_empty_categories":"","show_description":"","show_description_image":"","show_cat_num_articles":"","display_num":"","show_headings":"","orderby_pri":"","show_pagination":"","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 137, 138, 0, '*', 0),
(275, 'aboutjoomla', 'Contact Single Category', 'contact-single-category', '', 'using-joomla/extensions/components/contact-component/contact-single-category', 'index.php?option=com_contact&view=category&catid=26&id=36', 'component', 1, 270, 5, 8, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"-1","show_empty_categories":"","show_description":"","show_description_image":"","show_cat_num_articles":"","display_num":"20","show_headings":"","filter_field":"","show_pagination":"","show_noauth":"","presentation_style":"sliders","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_links":"1","linka_name":"","linkb_name":"","linkc_name":"","linkd_name":"","linke_name":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 127, 128, 0, '*', 0),
(276, 'aboutjoomla', 'Search Component', 'search-component', '', 'using-joomla/extensions/components/search-component', 'index.php?option=com_content&view=article&id=39', 'component', 1, 268, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 164, 167, 0, '*', 0),
(280, 'aboutjoomla', 'Using Joomla!', 'using-joomla', '', 'using-joomla', 'index.php?option=com_content&view=article&id=53', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"1","link_titles":"0","show_intro":"1","show_category":"0","link_category":"","show_parent_category":"0","link_parent_category":"","show_author":"0","link_author":"","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"0","show_noauth":"0","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 105, 278, 0, '*', 0),
(281, 'aboutjoomla', 'Modules', 'modules', '', 'using-joomla/extensions/modules', 'index.php?option=com_content&view=category&id=22', 'component', 1, 277, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_category_title":"","show_description":"1","show_description_image":"1","maxLevel":"1","show_empty_categories":"1","show_no_articles":"0","show_subcat_desc":"1","show_cat_num_articles":"","page_subheading":"","show_pagination_limit":"","filter_field":"","show_headings":"","list_show_date":"","date_format":"","list_show_hits":"","list_show_author":"","show_pagination":"","show_pagination_results":"","show_title":"1","link_titles":"","show_intro":"","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"","show_author":"0","link_author":"0","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"","show_readmore":"0","show_icons":"0","show_print_icon":"0","show_email_icon":"0","show_hits":"0","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 171, 228, 0, '*', 0),
(282, 'aboutjoomla', 'Templates', 'templates', '', 'using-joomla/extensions/templates', 'index.php?option=com_content&view=category&id=23', 'component', 1, 277, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_category_title":"","show_description":"1","show_description_image":"","maxLevel":"2","show_empty_categories":"1","show_no_articles":"0","show_subcat_desc":"1","show_cat_num_articles":"","page_subheading":"","show_pagination_limit":"0","filter_field":"hide","show_headings":"0","list_show_date":"0","date_format":"","list_show_hits":"0","list_show_author":"0","show_pagination":"0","show_pagination_results":"","show_title":"1","link_titles":"1","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"Templates","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 229, 254, 0, '*', 0),
(283, 'aboutjoomla', 'Languages', 'languages', '', 'using-joomla/extensions/languages', 'index.php?option=com_content&view=category&layout=blog&id=24', 'component', 1, 277, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"","show_empty_categories":"","show_description":"1","show_description_image":"1","show_category_title":"1","show_cat_num_articles":"","num_leading_articles":"1","num_intro_articles":"4","num_columns":"2","num_links":"4","multi_column_order":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 255, 256, 0, '*', 0),
(284, 'aboutjoomla', 'Plugins', 'plugins', '', 'using-joomla/extensions/plugins', 'index.php?option=com_content&view=category&layout=blog&id=25', 'component', 1, 277, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"","show_empty_categories":"","show_description":"1","show_description_image":"","show_category_title":"1","show_cat_num_articles":"","num_leading_articles":"0","num_intro_articles":"7","num_columns":"1","num_links":"0","multi_column_order":"","orderby_pri":"","orderby_sec":"order","order_date":"","show_pagination":"","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"0","link_author":"","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"","show_readmore":"","show_icons":"0","show_print_icon":"0","show_email_icon":"0","show_hits":"0","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 257, 272, 0, '*', 0),
(285, 'aboutjoomla', 'Typography Atomic', 'typography-atomic', '', 'using-joomla/extensions/templates/atomic/typography-atomic', 'index.php?option=com_content&view=article&id=49', 'component', 1, 422, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 3, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 243, 244, 0, '*', 0),
(286, 'aboutjoomla', 'Typography Milky Way', 'typography-milky-way', '', 'using-joomla/extensions/templates/milky-way/typography-milky-way', 'index.php?option=com_content&view=article&id=49', 'component', 1, 421, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 1, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"0","link_category":"0","show_parent_category":"","link_parent_category":"","show_author":"0","link_author":"","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 249, 250, 0, '*', 0),
(290, 'mainmenu', 'Demo Content', 'articles', '', 'articles', 'index.php?option=com_content&view=categories&id=84', 'component', 0, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_base_description":"1","categories_description":"","maxLevelcat":"","show_empty_categories_cat":"","show_subcat_desc_cat":"1","show_cat_num_articles_cat":"","show_category_title":"","show_description":"","show_description_image":"","maxLevel":"-1","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","num_leading_articles":"0","num_intro_articles":"3","num_columns":"1","num_links":"0","multi_column_order":"","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_results":"","show_pagination_limit":"","filter_field":"","show_headings":"","list_show_date":"","date_format":"","list_show_hits":"","list_show_author":"","display_num":"10","show_title":"1","link_titles":"1","show_intro":"1","show_category":"1","link_category":"1","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"1","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"0","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":1,"page_heading":"All Categories","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 369, 372, 0, '*', 0),
(294, 'mainmenu', 'Site Map', 'site-map', '', 'site-map', 'index.php?option=com_content&view=article&id=42', 'component', -2, 1, 1, 22, -4, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"0","link_category":"","show_parent_category":"0","link_parent_category":"","show_author":"0","link_author":"","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"0","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 5, 6, 0, '*', 0),
(445, 'mainmenu', 'Parks', 'parks', '', 'sample-sites/parks', 'index.php?Itemid=', 'alias', -2, 238, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"243","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 24, 25, 0, '*', 0);
INSERT INTO `#__menu` (`id`, `menutype`, `title`, `alias`, `note`, `path`, `link`, `type`, `published`, `parent_id`, `level`, `component_id`, `ordering`, `checked_out`, `checked_out_time`, `browserNav`, `access`, `img`, `template_style_id`, `params`, `lft`, `rgt`, `home`, `language`, `client_id`) VALUES
(300, 'aboutjoomla', 'Latest Users', 'latest-users', '', 'using-joomla/extensions/modules/user-modules/latest-users', 'index.php?option=com_content&view=article&id=66', 'component', 1, 412, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 193, 194, 0, '*', 0),
(301, 'aboutjoomla', 'Who''s Online', 'whos-online', '', 'using-joomla/extensions/modules/user-modules/whos-online', 'index.php?option=com_content&view=article&id=56', 'component', 1, 412, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 195, 196, 0, '*', 0),
(302, 'aboutjoomla', 'Most Read', 'most-read', '', 'using-joomla/extensions/modules/content-modules/most-read', 'index.php?option=com_content&view=article&id=30', 'component', 1, 411, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 177, 178, 0, '*', 0),
(303, 'aboutjoomla', 'Menu', 'menu', '', 'using-joomla/extensions/modules/menu-modules/menu', 'index.php?option=com_content&view=article&id=29', 'component', 1, 415, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 173, 174, 0, '*', 0),
(304, 'aboutjoomla', 'Statistics', 'statistics', '', 'using-joomla/extensions/modules/utility-modules/statistics', 'index.php?option=com_content&view=article&id=44', 'component', 1, 414, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 219, 220, 0, '*', 0),
(305, 'aboutjoomla', 'Banner', 'banner', '', 'using-joomla/extensions/modules/display-modules/banner', 'index.php?option=com_content&view=article&id=7', 'component', 1, 413, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 203, 204, 0, '*', 0),
(306, 'aboutjoomla', 'Search', 'search', '', 'using-joomla/extensions/modules/utility-modules/search', 'index.php?option=com_content&view=article&id=40', 'component', 1, 414, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 221, 222, 0, '*', 0),
(307, 'aboutjoomla', 'Random Image', 'random-image', '', 'using-joomla/extensions/modules/display-modules/random-image', 'index.php?option=com_content&view=article&id=36', 'component', 1, 413, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 201, 202, 0, '*', 0),
(309, 'aboutjoomla', 'News Flash', 'news-flash', '', 'using-joomla/extensions/modules/content-modules/news-flash', 'index.php?option=com_content&view=article&id=31', 'component', 1, 411, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 179, 180, 0, '*', 0),
(310, 'aboutjoomla', 'Latest Articles', 'latest-articles', '', 'using-joomla/extensions/modules/content-modules/latest-articles', 'index.php?option=com_content&view=article&id=27', 'component', 1, 411, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 181, 182, 0, '*', 0),
(311, 'aboutjoomla', 'Syndicate', 'syndicate', '', 'using-joomla/extensions/modules/utility-modules/syndicate', 'index.php?option=com_content&view=article&id=45', 'component', 1, 414, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 217, 218, 0, '*', 0),
(312, 'aboutjoomla', 'Login', 'login', '', 'using-joomla/extensions/modules/user-modules/login', 'index.php?option=com_content&view=article&id=28', 'component', 1, 412, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 197, 198, 0, '*', 0),
(313, 'aboutjoomla', 'Wrapper', 'wrapper', '', 'using-joomla/extensions/modules/display-modules/wrapper', 'index.php?option=com_content&view=article&id=59', 'component', 1, 413, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 209, 210, 0, '*', 0),
(451, 'aboutjoomla', 'Milky Way Home', 'milky-way-home', '', 'using-joomla/extensions/templates/milky-way/milky-way-home', 'index.php?option=com_content&view=featured', 'component', 1, 421, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 1, '{"maxLevel":"","show_empty_categories":"","show_description":"","show_description_image":"","show_cat_num_articles":"","num_leading_articles":"1","num_intro_articles":"3","num_columns":"3","num_links":"0","multi_column_order":"","orderby_pri":"","orderby_sec":"front","order_date":"","show_pagination":"","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 251, 252, 0, '*', 0),
(316, 'aboutjoomla', 'Home Page Atomic', 'home-page-atomic', '', 'using-joomla/extensions/templates/atomic/home-page-atomic', 'index.php?option=com_content&view=featured', 'component', 1, 422, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 3, '{"maxLevel":"","show_empty_categories":"","show_description":"","show_description_image":"","show_cat_num_articles":"","num_leading_articles":"1","num_intro_articles":"3","num_columns":"3","num_links":"0","multi_column_order":"1","orderby_pri":"","orderby_sec":"front","order_date":"","show_pagination":"2","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 245, 246, 0, '*', 0),
(317, 'aboutjoomla', 'System', 'system', '', 'using-joomla/extensions/plugins/system', 'index.php?option=com_content&view=article&id=46', 'component', 1, 284, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 270, 271, 0, '*', 0),
(318, 'aboutjoomla', 'Authentication', 'authentication', '', 'using-joomla/extensions/plugins/authentication', 'index.php?option=com_content&view=article&id=5', 'component', 1, 284, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 258, 259, 0, '*', 0),
(319, 'aboutjoomla', 'Content', 'content', '', 'using-joomla/extensions/plugins/content', 'index.php?option=com_content&view=article&id=62', 'component', 1, 284, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 260, 261, 0, '*', 0),
(320, 'aboutjoomla', 'Editors', 'editors', '', 'using-joomla/extensions/plugins/editors', 'index.php?option=com_content&view=article&id=14', 'component', 1, 284, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 262, 263, 0, '*', 0),
(321, 'aboutjoomla', 'Editors Extended', 'editors-extended', '', 'using-joomla/extensions/plugins/editors-extended', 'index.php?option=com_content&view=article&id=15', 'component', 1, 284, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 264, 265, 0, '*', 0),
(322, 'aboutjoomla', 'Search', 'search', '', 'using-joomla/extensions/plugins/search', 'index.php?option=com_content&view=article&id=41', 'component', 1, 284, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 266, 267, 0, '*', 0),
(323, 'aboutjoomla', 'User', 'user', '', 'using-joomla/extensions/plugins/user', 'index.php?option=com_content&view=article&id=51', 'component', 1, 284, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 268, 269, 0, '*', 0),
(324, 'aboutjoomla', 'Footer', 'footer', '', 'using-joomla/extensions/modules/display-modules/footer', 'index.php?option=com_content&view=article&id=19', 'component', 1, 413, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 207, 208, 0, '*', 0),
(325, 'aboutjoomla', 'Archive', 'archive', '', 'using-joomla/extensions/modules/content-modules/archive', 'index.php?option=com_content&view=article&id=2', 'component', 1, 411, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 183, 184, 0, '*', 0),
(326, 'aboutjoomla', 'Related Items', 'related-items', '', 'using-joomla/extensions/modules/content-modules/related-items', 'index.php?option=com_content&view=article&id=37', 'component', 1, 411, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 185, 186, 0, '*', 0),
(399, 'parks', 'Animals', 'animals', '', 'image-gallery/animals', 'index.php?option=com_content&view=category&layout=blog&id=72', 'component', 1, 244, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 114, '{"maxLevel":"","show_empty_categories":"","show_description":"1","show_description_image":"0","show_category_title":"","show_cat_num_articles":"","num_leading_articles":"0","num_intro_articles":"6","num_columns":"2","num_links":"4","multi_column_order":"1","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_noauth":"","show_title":"","link_titles":"","show_intro":"0","show_category":"1","link_category":"1","show_parent_category":"","link_parent_category":"","show_author":"0","link_author":"","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"1","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 298, 299, 0, 'en-GB', 0),
(400, 'parks', 'Scenery', 'scenery', '', 'image-gallery/scenery', 'index.php?option=com_content&view=category&layout=blog&id=73', 'component', 1, 244, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 114, '{"maxLevel":"","show_empty_categories":"","show_description":"0","show_description_image":"0","show_category_title":"","show_cat_num_articles":"","num_leading_articles":"0","num_intro_articles":"4","num_columns":"2","num_links":"4","multi_column_order":"1","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_noauth":"","show_title":"","link_titles":"","show_intro":"0","show_category":"1","link_category":"","show_parent_category":"0","link_parent_category":"0","show_author":"0","link_author":"0","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"1","show_readmore":"1","show_icons":"0","show_print_icon":"0","show_email_icon":"0","show_hits":"0","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 300, 301, 0, 'en-GB', 0),
(402, 'aboutjoomla', 'Login Form', 'login-form', '', 'using-joomla/extensions/components/users-component/login-form', 'index.php?option=com_users&view=login', 'component', 1, 271, 5, 25, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"login_redirect_url":"","logindescription_show":"1","login_description":"","login_image":"","logout_redirect_url":"","logoutdescription_show":"1","logout_description":"","logout_image":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":1,"page_heading":"Login Form","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 151, 152, 0, '*', 0),
(403, 'aboutjoomla', 'User Profile', 'user-profile', '', 'using-joomla/extensions/components/users-component/user-profile', 'index.php?option=com_users&view=profile', 'component', 1, 271, 5, 25, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":1,"page_heading":"User Profile","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 153, 154, 0, '*', 0),
(404, 'aboutjoomla', 'Edit User Profile', 'edit-user-profile', '', 'using-joomla/extensions/components/users-component/edit-user-profile', 'index.php?option=com_users&view=profile&layout=edit', 'component', 1, 271, 5, 25, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":1,"page_heading":"Edit User Profile","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 155, 156, 0, '*', 0),
(405, 'aboutjoomla', 'Registration Form', 'registration-form', '', 'using-joomla/extensions/components/users-component/registration-form', 'index.php?option=com_users&view=registration', 'component', 1, 271, 5, 25, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":1,"page_heading":"Registration Form","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 157, 158, 0, '*', 0),
(406, 'aboutjoomla', 'Username Reminder Request', 'username-reminder', '', 'using-joomla/extensions/components/users-component/username-reminder', 'index.php?option=com_users&view=remind', 'component', 1, 271, 5, 25, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":1,"page_heading":"Username Reminder Request","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 159, 160, 0, '*', 0),
(409, 'aboutjoomla', 'Password Reset', 'password-reset', '', 'using-joomla/extensions/components/users-component/password-reset', 'index.php?option=com_users&view=reset', 'component', 1, 271, 5, 25, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":1,"page_heading":"Password Reset","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 161, 162, 0, '*', 0),
(410, 'aboutjoomla', 'Feed Display', 'feed-display', '', 'using-joomla/extensions/modules/display-modules/feed-display', 'index.php?option=com_content&view=article&id=16', 'component', 1, 413, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 205, 206, 0, '*', 0),
(411, 'aboutjoomla', 'Content Modules', 'content-modules', '', 'using-joomla/extensions/modules/content-modules', 'index.php?option=com_content&view=category&id=64', 'component', 1, 281, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"0","show_category_title":"1","page_subheading":"","show_empty_categories":"1","show_description":"1","show_description_image":"","show_cat_num_articles":"","display_num":"0","show_headings":"0","list_show_title":"1","list_show_date":"0","date_format":"","list_show_hits":"0","list_show_author":"0","filter_field":"hide","orderby_pri":"","orderby_sec":"order","order_date":"","show_pagination":"","show_pagination_limit":"0","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"1","link_category":"1","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 176, 191, 0, '*', 0),
(412, 'aboutjoomla', 'User Modules', 'user-modules', '', 'using-joomla/extensions/modules/user-modules', 'index.php?option=com_content&view=category&id=65', 'component', 1, 281, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"0","show_category_title":"1","page_subheading":"","show_empty_categories":"","show_description":"1","show_description_image":"","show_cat_num_articles":"","display_num":"0","show_headings":"0","list_show_title":"1","list_show_date":"","date_format":"","list_show_hits":"0","list_show_author":"0","filter_field":"hide","orderby_pri":"","orderby_sec":"order","order_date":"","show_pagination":"","show_pagination_limit":"0","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"1","link_category":"1","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 192, 199, 0, '*', 0),
(413, 'aboutjoomla', 'Display Modules', 'display-modules', '', 'using-joomla/extensions/modules/display-modules', 'index.php?option=com_content&view=category&id=66', 'component', 1, 281, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"0","show_category_title":"1","page_subheading":"","show_empty_categories":"","show_description":"1","show_description_image":"1","show_cat_num_articles":"","display_num":"0","show_headings":"0","list_show_title":"1","list_show_date":"","date_format":"","list_show_hits":"0","list_show_author":"0","filter_field":"hide","orderby_pri":"","orderby_sec":"order","order_date":"","show_pagination":"","show_pagination_limit":"0","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"1","link_category":"1","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 200, 215, 0, '*', 0),
(414, 'aboutjoomla', 'Utility Modules', 'utility-modules', '', 'using-joomla/extensions/modules/utility-modules', 'index.php?option=com_content&view=category&id=67', 'component', 1, 281, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"0","show_category_title":"1","page_subheading":"","show_empty_categories":"","show_description":"1","show_description_image":"1","show_cat_num_articles":"","display_num":"0","show_headings":"0","list_show_title":"0","list_show_date":"0","date_format":"","list_show_hits":"0","list_show_author":"0","filter_field":"","orderby_pri":"","orderby_sec":"order","order_date":"","show_pagination":"","show_pagination_limit":"0","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"1","link_category":"1","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 216, 227, 0, '*', 0),
(415, 'aboutjoomla', 'Menu Module', 'menu-modules', '', 'using-joomla/extensions/modules/menu-modules', 'index.php?option=com_content&view=category&id=75', 'component', 1, 281, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"","show_category_title":"","page_subheading":"","show_empty_categories":"","show_description":"","show_description_image":"","show_cat_num_articles":"","display_num":"","show_headings":"","list_show_title":"","list_show_date":"","date_format":"","list_show_hits":"","list_show_author":"","filter_field":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_limit":"","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 172, 175, 0, '*', 0),
(416, 'aboutjoomla', 'Breadcrumbs', 'breadcrumbs', '', 'using-joomla/extensions/modules/utility-modules/breadcrumbs', 'index.php?option=com_content&view=article&id=61', 'component', 1, 414, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 223, 224, 0, '*', 0),
(417, 'aboutjoomla', 'Weblinks', 'weblinks', '', 'using-joomla/extensions/modules/display-modules/weblinks', 'index.php?option=com_content&view=article&id=55', 'component', 1, 413, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 211, 212, 0, '*', 0),
(418, 'aboutjoomla', 'Custom HTML', 'custom-html', '', 'using-joomla/extensions/modules/display-modules/custom-html', 'index.php?option=com_content&view=article&id=12', 'component', 1, 413, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 213, 214, 0, '*', 0),
(419, 'aboutjoomla', 'Beez 2', 'beez-2', '', 'using-joomla/extensions/templates/beez-2', 'index.php?option=com_content&view=category&layout=blog&id=69', 'component', 1, 282, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"","show_empty_categories":"","show_description":"1","show_description_image":"","show_category_title":"","show_cat_num_articles":"","num_leading_articles":"1","num_intro_articles":"4","num_columns":"2","num_links":"4","multi_column_order":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 230, 235, 0, '*', 0),
(421, 'aboutjoomla', 'Milky Way', 'milky-way', '', 'using-joomla/extensions/templates/milky-way', 'index.php?option=com_content&view=category&layout=blog&id=71', 'component', 1, 282, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"","show_empty_categories":"","show_description":"1","show_description_image":"","show_category_title":"1","show_cat_num_articles":"","num_leading_articles":"1","num_intro_articles":"4","num_columns":"2","num_links":"4","multi_column_order":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 248, 253, 0, '*', 0),
(422, 'aboutjoomla', 'Atomic', 'atomic', '', 'using-joomla/extensions/templates/atomic', 'index.php?option=com_content&view=category&layout=blog&id=68', 'component', 1, 282, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"","show_empty_categories":"","show_description":"1","show_description_image":"","show_category_title":"","show_cat_num_articles":"","num_leading_articles":"2","num_intro_articles":"4","num_columns":"2","num_links":"4","multi_column_order":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 242, 247, 0, '*', 0),
(423, 'aboutjoomla', 'Typography Beez 2', 'typography-beez-2', '', 'using-joomla/extensions/templates/beez-2/typography-beez-2', 'index.php?option=com_content&view=article&id=49', 'component', 1, 419, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 4, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 231, 232, 0, '*', 0),
(424, 'aboutjoomla', 'Home Page Beez 2', 'home-page-beez-2', '', 'using-joomla/extensions/templates/beez-2/home-page-beez-2', 'index.php?option=com_content&view=featured', 'component', 1, 419, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 4, '{"maxLevel":"","show_empty_categories":"","show_description":"","show_description_image":"","show_cat_num_articles":"","num_leading_articles":"1","num_intro_articles":"3","num_columns":"3","num_links":"0","multi_column_order":"1","orderby_pri":"","orderby_sec":"front","order_date":"","show_pagination":"2","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 233, 234, 0, '*', 0),
(430, 'fruitshop', 'Contact Us', 'contact-us', '', 'contact-us', 'index.php?option=com_contact&view=category&catid=47&id=36', 'component', 1, 1, 1, 8, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 6, '{"maxLevel":"-1","show_empty_categories":"","show_description":"","show_description_image":"","show_cat_num_articles":"","display_num":"20","show_headings":"0","filter_field":"hide","show_pagination":"","show_noauth":"","presentation_style":"","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_links":"1","linka_name":"","linkb_name":"","linkc_name":"","linkd_name":"","linke_name":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 311, 312, 0, '*', 0),
(427, 'fruitshop', 'Fruit Encyclopedia', 'fruit-encyclopedia', '', 'fruit-encyclopedia', 'index.php?option=com_contact&view=categories&id=37', 'component', 1, 1, 1, 8, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 6, '{"show_base_description":"1","categories_description":"","maxLevel":"-1","show_empty_categories":"1","show_description":"1","show_description_image":"1","show_cat_num_articles":"1","display_num":"","show_headings":"0","filter_field":"hide","show_pagination":"","show_noauth":"","presentation_style":"","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_links":"1","linka_name":"","linkb_name":"","linkc_name":"","linkd_name":"","linke_name":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":" categories-listalphabet","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 307, 308, 0, '*', 0),
(429, 'fruitshop', 'Welcome', 'welcome', 'Fruit store front page', 'welcome', 'index.php?option=com_content&view=article&id=20', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 6, '{"show_noauth":"","show_title":"0","link_titles":"0","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"","link_parent_category":"","show_author":"0","link_author":"","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_icons":"0","show_print_icon":"0","show_email_icon":"0","show_hits":"0","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 305, 306, 0, '*', 0),
(431, 'fruitshop', 'Growers', 'growers', '', 'growers', 'index.php?option=com_content&view=category&layout=blog&id=30', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 6, '{"maxLevel":"0","show_empty_categories":"","show_description":"1","show_description_image":"","show_category_title":"1","show_cat_num_articles":"","num_leading_articles":"5","num_intro_articles":"0","num_columns":"1","num_links":"4","multi_column_order":"","orderby_pri":"","orderby_sec":"alpha","order_date":"","show_pagination":"","show_noauth":"","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"","show_parent_category":"0","link_parent_category":"0","show_author":"0","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"0","show_item_navigation":"","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"0","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 309, 310, 0, '*', 0),
(432, 'fruitshop', 'Login ', 'shop-login', '', 'shop-login', 'index.php?option=com_users&view=login', 'component', 1, 1, 1, 25, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 6, '{"login_redirect_url":"","logindescription_show":"1","login_description":"","login_image":"","logout_redirect_url":"","logoutdescription_show":"1","logout_description":"","logout_image":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 313, 314, 0, '*', 0),
(433, 'fruitshop', 'Directions', 'directions', '', 'directions', 'index.php?option=com_content&view=article&id=13', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 6, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 315, 316, 0, '*', 0);
INSERT INTO `#__menu` (`id`, `menutype`, `title`, `alias`, `note`, `path`, `link`, `type`, `published`, `parent_id`, `level`, `component_id`, `ordering`, `checked_out`, `checked_out_time`, `browserNav`, `access`, `img`, `template_style_id`, `params`, `lft`, `rgt`, `home`, `language`, `client_id`) VALUES
(435, 'mainmenu', 'Home', 'ja-anion-joomla-2-5-template', '', 'ja-anion-joomla-2-5-template', 'index.php?option=com_content&view=featured', 'component', 1, 1, 1, 22, -5, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"featured_categories":[""],"layout_type":"blog","num_leading_articles":"0","num_intro_articles":"3","num_columns":"1","num_links":"0","multi_column_order":"0","orderby_pri":"none","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"","show_title":"1","link_titles":"","show_intro":"","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"0","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"","show_readmore":"1","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"JA Anion Joomla 2.5 Template","show_page_heading":1,"page_heading":"","pageclass_sfx":"","menu-meta_description":"Template Joomla 2.5 for movie and film","menu-meta_keywords":"film template Joomla 2.5, template movie Joomla 2.5, DVD Joomla template 2.5, actor template Joomla 2.5 template, trailer Joomla 2.5 template","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 1, 2, 1, '*', 0),
(444, 'top', 'Contact', 'contact', '', 'contact', 'index.php?option=com_contact&view=contact&id=1', 'component', 1, 1, 1, 8, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"presentation_style":"","show_contact_category":"","show_contact_list":"","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_links":"","linka_name":"","linkb_name":"","linkc_name":"","linkd_name":"","linke_name":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 285, 286, 0, '*', 0),
(436, 'aboutjoomla', 'Getting Help', 'getting-help', '', 'using-joomla/getting-help', 'index.php?option=com_content&view=article&id=21', 'component', 1, 280, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"0","link_category":"","show_parent_category":"0","link_parent_category":"","show_author":"0","link_author":"","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"0","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 276, 277, 0, '*', 0),
(437, 'aboutjoomla', 'Getting Started', 'getting-started', '', 'getting-started', 'index.php?option=com_content&view=article&id=22', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"1","link_titles":"0","show_intro":"","show_category":"0","link_category":"","show_parent_category":"0","link_parent_category":"","show_author":"0","link_author":"","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"0","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 95, 96, 0, '*', 0),
(455, 'mainmenu', 'Example Pages', 'example-pages', '', 'example-pages', 'index.php?Itemid=', 'alias', -2, 1, 1, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"268","menu-anchor_title":"","menu-anchor_css":"","menu_image":""}', 31, 32, 0, '*', 0),
(438, 'mainmenu', 'Actions ', 'actions', '', 'articles/actions', 'index.php?option=com_content&view=category&layout=blog&id=85', 'component', 0, 290, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"layout_type":"blog","show_category_title":"","show_description":"","show_description_image":"","maxLevel":"-1","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"3","num_columns":"1","num_links":"0","multi_column_order":"","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_results":"","show_title":"1","link_titles":"1","show_intro":"1","show_category":"1","link_category":"1","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"1","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"1","show_noauth":"0","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 370, 371, 0, '*', 0),
(439, 'mainmenu', 'Contacts', 'contacts', '', 'contacts', 'index.php?option=com_contact&view=categories&id=0', 'component', -2, 1, 1, 8, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_base_description":"","categories_description":"","maxLevelcat":"","show_empty_categories_cat":"","show_subcat_desc_cat":"","show_cat_items_cat":"","show_category_title":"","show_description":"","show_description_image":"","maxLevel":"-1","show_empty_categories":"","show_subcat_desc":"","show_cat_items":"","show_pagination_limit":"","show_headings":"","show_position_headings":"","show_email_headings":"","show_telephone_headings":"","show_mobile_headings":"","show_fax_headings":"","show_suburb_headings":"","show_state_headings":"","show_country_headings":"","show_pagination":"","show_pagination_results":"","presentation_style":"","show_contact_category":"","show_contact_list":"","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_links":"1","linka_name":"","linkb_name":"","linkc_name":"","linkd_name":"","linke_name":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 395, 396, 0, '*', 0),
(443, 'aboutjoomla', 'Article Categories', 'article-categories-view', '', 'using-joomla/extensions/modules/content-modules/article-categories-view', 'index.php?option=com_content&view=article&id=3', 'component', 1, 411, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 187, 188, 0, '*', 0),
(446, 'mainmenu', 'Shop', 'shop', '', 'sample-sites/shop', 'index.php?Itemid=', 'alias', -2, 238, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"429","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 26, 27, 0, '*', 0),
(447, 'aboutjoomla', 'Language Switcher', 'language-switcher', '', 'using-joomla/extensions/modules/utility-modules/language-switcher', 'index.php?option=com_content&view=article&id=26', 'component', 1, 414, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 225, 226, 0, '*', 0),
(448, 'mainmenu', 'Site Administrator', 'site-administrator', '', 'site-administrator', 'administrator', 'url', -2, 1, 1, 0, 0, 0, '0000-00-00 00:00:00', 1, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":""}', 29, 30, 0, '*', 0),
(449, 'usermenu', 'Submit an Article', 'submit-an-article', '', 'submit-an-article', 'index.php?option=com_content&view=form&layout=edit', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 3, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 317, 318, 0, '*', 0),
(450, 'usermenu', 'Submit a Web Link', 'submit-a-web-link', '', 'submit-a-web-link', 'index.php?option=com_weblinks&view=form&layout=edit', 'component', 1, 1, 1, 21, 0, 0, '0000-00-00 00:00:00', 0, 3, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 319, 320, 0, '*', 0),
(452, 'aboutjoomla', 'Featured Contacts', 'featured-contacts', '', 'using-joomla/extensions/components/contact-component/featured-contacts', 'index.php?option=com_contact&view=featured&id=16', 'component', 1, 270, 5, 8, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"-1","show_empty_categories":"","show_description":"","show_description_image":"","show_cat_num_articles":"","display_num":"","show_headings":"","filter_field":"","show_pagination":"","show_noauth":"","presentation_style":"sliders","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_links":"1","linka_name":"","linkb_name":"","linkc_name":"","linkd_name":"","linke_name":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":1,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 131, 132, 0, '*', 0),
(453, 'aboutjoomla', 'Parameters', 'parameters', '', 'using-joomla/parameters', 'index.php?option=com_content&view=article&id=32', 'component', 1, 280, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"1","link_category":"1","show_parent_category":"1","link_parent_category":"1","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"1","show_publish_date":"1","show_item_navigation":"1","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"1","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 274, 275, 0, '*', 0),
(456, 'aboutjoomla', 'Beez5', 'beez5', '', 'using-joomla/extensions/templates/beez5', 'index.php?option=com_content&view=category&layout=blog&id=70', 'component', 1, 282, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"","show_empty_categories":"","show_description":"1","show_description_image":"","show_category_title":"","show_cat_num_articles":"","num_leading_articles":"1","num_intro_articles":"4","num_columns":"2","num_links":"4","multi_column_order":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":1,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 236, 241, 0, '*', 0),
(457, 'aboutjoomla', 'Typography Beez5', 'typography-beez-5', '', 'using-joomla/extensions/templates/beez5/typography-beez-5', 'index.php?option=com_content&view=article&id=49', 'component', 1, 456, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":1,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 237, 238, 0, '*', 0),
(458, 'aboutjoomla', 'Home Page Beez5', 'home-page-beez5', '', 'using-joomla/extensions/templates/beez5/home-page-beez5', 'index.php?option=com_content&view=featured', 'component', 1, 456, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"","show_empty_categories":"","show_description":"","show_description_image":"","show_cat_num_articles":"","num_leading_articles":"1","num_intro_articles":"3","num_columns":"3","num_links":"0","multi_column_order":"","orderby_pri":"","orderby_sec":"front","order_date":"","show_pagination":"","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":1,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 239, 240, 0, '*', 0),
(459, 'aboutjoomla', 'Article Category', 'article-category', '', 'using-joomla/extensions/modules/content-modules/article-category', 'index.php?option=com_content&view=article&id=4', 'component', 1, 411, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":1,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 189, 190, 0, '*', 0),
(462, 'fruitshop', 'Add a recipe', 'add-a-recipe', '', 'add-a-recipe', 'index.php?option=com_content&view=form&layout=edit', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 4, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":1,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 321, 322, 0, '*', 0),
(463, 'fruitshop', 'Recipes', 'recipes', '', 'recipes', 'index.php?option=com_content&view=category&id=76', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 6, '{"maxLevel":"0","show_category_title":"1","page_subheading":"","show_empty_categories":"0","show_description":"1","show_description_image":"","show_cat_num_articles":"","display_num":"","show_headings":"","list_show_title":"","list_show_date":"","date_format":"","list_show_hits":"","list_show_author":"","filter_field":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_limit":"","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 323, 324, 0, '*', 0),
(465, 'main', 'com_jaextmanager', 'ja-extensions-manager', '', 'ja-extensions-manager', 'index.php?option=com_jaextmanager', 'component', 0, 1, 1, 10004, 0, 0, '0000-00-00 00:00:00', 0, 1, 'components/com_jaextmanager/assets/images/jauc.png', 0, '', 325, 326, 0, '', 1),
(466, 'mainmenu', 'Typography', 'typography', '', 'typography', 'index.php?option=com_content&view=article&id=94', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 9, 10, 0, '*', 0),
(467, 'mainmenu', 'Menu showcase', 'menu-showcase', '', 'menu-showcase', 'index.php?option=com_content&view=article&id=47', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"200","mega_colw":"200","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 13, 22, 0, '*', 0),
(468, 'mainmenu', 'Split Menu', 'split-menu', '', 'menu-showcase/split-menu', '?menu=split', 'url', 1, 467, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 14, 15, 0, '*', 0),
(469, 'mainmenu', 'CSS Menu', 'css-menu', '', 'menu-showcase/css-menu', '?menu=css', 'url', 1, 467, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 16, 17, 0, '*', 0),
(470, 'mainmenu', 'Dropline menu', 'dropline-menu', '', 'menu-showcase/dropline-menu', '?menu=dropline', 'url', 1, 467, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 18, 19, 0, '*', 0),
(471, 'mainmenu', 'Mega menu', 'mega-menu', '', 'menu-showcase/mega-menu', '?menu=mega', 'url', 1, 467, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 20, 21, 0, '*', 0),
(474, 'mainmenu', 'Blog layout', 'blog-layout', '', 'blog-layout', 'index.php?option=com_content&view=category&layout=blog&id=80', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"layout_type":"blog","show_category_title":"","show_description":"","show_description_image":"","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"4","num_columns":"1","num_links":"0","multi_column_order":"","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_results":"","show_title":"1","link_titles":"1","show_intro":"1","show_category":"1","link_category":"1","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"1","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"0","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":" blogpage","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 11, 12, 0, '*', 0),
(473, 'mainmenu', 'Blog layout', 'bloglayout', '', 'bloglayout', 'index.php?option=com_content&view=category&layout=blog&id=21', 'component', -2, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_category_title":"","show_description":"","show_description_image":"","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"1","num_intro_articles":"4","num_columns":"1","num_links":"0","multi_column_order":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_results":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 63, 64, 0, '*', 0),
(475, 'mainmenu', 'About Joomla', 'about-joomla', '', 'about-joomla', 'index.php?option=com_content&view=article&id=95', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"1","link_titles":"1","show_intro":"1","show_category":"1","link_category":"1","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"1","show_noauth":"0","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"2","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 33, 62, 0, '*', 0),
(476, 'mainmenu', 'Layouts', 'layouts', '', 'about-joomla/layouts', 'index.php?option=com_content&view=article&id=95', 'component', 1, 475, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"1","mega_width":"0","mega_colw":"0","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 34, 45, 0, '*', 0),
(477, 'mainmenu', 'What''s New in J! 2.5?', 'what-s-new-in-j-2-5', '', 'about-joomla/what-s-new-in-j-2-5', 'index.php?option=com_content&view=category&layout=blog&id=19', 'component', 1, 475, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"layout_type":"blog","show_category_title":"","show_description":"","show_description_image":"","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"","num_intro_articles":"","num_columns":"","num_links":"","multi_column_order":"","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_results":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_readmore":"","show_readmore_title":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"Template 2.5 Joomla for films and trailers. ","menu-meta_keywords":"film template Joomla 2.5, template movie Joomla 2.5, DVD Joomla template 2.5, actor template Joomla 2.5 template, trailer Joomla 2.5 template","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"1","mega_width":"200","mega_colw":"200","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 46, 55, 0, '*', 0),
(478, 'mainmenu', 'Polls', 'polls', '', 'about-joomla/polls', 'index.php?option=com_content&view=article&id=8', 'component', -2, 475, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"1","mega_width":"200","mega_colw":"200","mega_colxw":"","mega_class":"","mega_subcontent":"mod","mega_subcontent_mod_modules":["208"],"mega_subcontent_pos_positions":["ja-tabs"]}', 56, 59, 0, '*', 0),
(479, 'mainmenu', 'Left + Main+ Right (Default)', 'left-main-right', '', 'about-joomla/layouts/left-main-right', '?layouts=default', 'url', 1, 476, 3, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 35, 36, 0, '*', 0),
(480, 'mainmenu', 'Layouts (2)', 'layouts-2', '', 'about-joomla/layouts-2', 'index.php?option=com_content&view=article&id=95', 'component', -2, 475, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"1","mega_width":"200","mega_colw":"200","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 60, 61, 0, '*', 0),
(481, 'mainmenu', 'Contact', 'contact', '', 'about-joomla/what-s-new-in-j-2-5/contact', 'index.php?option=com_contact&view=contact&id=1', 'component', 1, 477, 3, 8, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"presentation_style":"tabs","show_contact_category":"","show_contact_list":"","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_links":"","linka_name":"","linkb_name":"","linkc_name":"","linkd_name":"","linke_name":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":1,"page_heading":"Contact us","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 47, 48, 0, '*', 0),
(482, 'mainmenu', 'test', 'test', '', 'about-joomla/polls/test', 'index.php?option=com_content&view=article&id=64', 'component', -2, 478, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 57, 58, 0, '*', 0),
(483, 'mainmenu', 'Right + Main+ Left', 'right-main-left', '', 'about-joomla/layouts/right-main-left', '?layouts=right-main-left', 'url', 1, 476, 3, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 37, 38, 0, '*', 0),
(484, 'mainmenu', 'Main + Left + Right', 'main-left-right', '', 'about-joomla/layouts/main-left-right', '?layouts=main-left-right', 'url', 1, 476, 3, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 39, 40, 0, '*', 0),
(485, 'mainmenu', 'Right + Left + Main', 'right-left-main', '', 'about-joomla/layouts/right-left-main', '?layouts=right-left-main', 'url', 1, 476, 3, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 41, 42, 0, '*', 0),
(486, 'mainmenu', 'Wrapper (full width)', 'wrapper-full-width', '', 'about-joomla/layouts/wrapper-full-width', 'index.php?option=com_wrapper&view=wrapper', 'component', 1, 476, 3, 2, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"url":"www.google.com","scrolling":"auto","width":"100%","height":"500","height_auto":"0","add_scheme":"1","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 43, 44, 0, '*', 0),
(487, 'mainmenu', 'Contact Category', 'contact-category', '', 'about-joomla/what-s-new-in-j-2-5/contact-category', 'index.php?option=com_contact&view=category&id=36', 'component', 1, 477, 3, 8, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_category_title":"","show_description":"","show_description_image":"","maxLevel":"","show_empty_categories":"","show_subcat_desc":"","show_cat_items":"","show_pagination_limit":"","show_headings":"","show_position_headings":"","show_email_headings":"","show_telephone_headings":"","show_mobile_headings":"","show_fax_headings":"","show_suburb_headings":"","show_state_headings":"","show_country_headings":"","show_pagination":"","show_pagination_results":"","presentation_style":"","show_contact_category":"","show_contact_list":"","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_links":"","linka_name":"","linkb_name":"","linkc_name":"","linkd_name":"","linke_name":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 49, 50, 0, '*', 0),
(488, 'mainmenu', 'Web Links', 'web-links', '', 'about-joomla/what-s-new-in-j-2-5/web-links', 'index.php?option=com_weblinks&view=category&id=18', 'component', 1, 477, 3, 21, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_category_title":"","show_description":"","show_description_image":"","maxLevel":"","show_empty_categories":"","show_subcat_desc":"","show_cat_num_links":"","show_pagination_limit":"","show_headings":"","show_link_description":"","show_link_hits":"","show_pagination":"","show_pagination_results":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 51, 52, 0, '*', 0),
(489, 'mainmenu', 'Who we are?', 'who-we-are', '', 'about-joomla/what-s-new-in-j-2-5/who-we-are', 'index.php?option=com_content&view=article&id=69', 'component', 1, 477, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 53, 54, 0, '*', 0),
(490, 'mainmenu', 'Explore', 'explore', '', 'explore', 'index.php?option=com_content&view=article&id=68', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"3","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 327, 366, 0, '*', 0),
(491, 'mainmenu', 'Dark', 'dark', '', 'explore/dark', 'index.php?option=com_content&view=archive', 'component', 1, 490, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"orderby_sec":"alpha","order_date":"created","display_num":"5","filter_field":"hide","introtext_limit":"100","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_title":"","link_titles":"","show_intro":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_hits":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"1","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 328, 341, 0, '*', 0),
(492, 'mainmenu', 'Light', 'light', '', 'explore/light', 'index.php?option=com_content&view=article&id=64', 'component', 1, 490, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"1","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 342, 355, 0, '*', 0),
(493, 'mainmenu', 'Default color', 'default-color', '', 'explore/dark/default-color', '?profile=default', 'url', 1, 491, 3, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 329, 330, 0, '*', 0),
(494, 'mainmenu', 'Blue Color', 'blue-color', '', 'explore/dark/blue-color', '?profile=dark-blue', 'url', 1, 491, 3, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 331, 332, 0, '*', 0),
(495, 'mainmenu', 'Brown Color', 'brown-color', '', 'explore/dark/brown-color', '?profile=dark-brown', 'url', 1, 491, 3, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 333, 334, 0, '*', 0),
(496, 'mainmenu', 'Green Color', 'green-color', '', 'explore/dark/green-color', '?profile=dark-green', 'url', 1, 491, 3, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 335, 336, 0, '*', 0),
(497, 'mainmenu', 'Orange Color', 'orange-color', '', 'explore/dark/orange-color', '?profile=dark-orange', 'url', 1, 491, 3, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 337, 338, 0, '*', 0),
(498, 'mainmenu', 'Red Color', 'red-color', '', 'explore/dark/red-color', '?profile=dark-red', 'url', 1, 491, 3, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 339, 340, 0, '*', 0),
(499, 'mainmenu', 'Light Color', 'light-color', '', 'explore/light/light-color', '?profile=light-color', 'url', 1, 492, 3, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 343, 344, 0, '*', 0),
(500, 'mainmenu', 'Blue Color', 'blue-color', '', 'explore/light/blue-color', '?profile=light-blue', 'url', 1, 492, 3, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 345, 346, 0, '*', 0),
(501, 'mainmenu', 'Brown Color', 'brown-color', '', 'explore/light/brown-color', '?profile=light-brown', 'url', 1, 492, 3, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 347, 348, 0, '*', 0),
(502, 'mainmenu', 'Green Color', 'green-color', '', 'explore/light/green-color', '?profile=light-green', 'url', 1, 492, 3, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 349, 350, 0, '*', 0),
(503, 'mainmenu', 'Orange Color', 'orange-color', '', 'explore/light/orange-color', '?profile=light-orange', 'url', 1, 492, 3, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 351, 352, 0, '*', 0),
(504, 'mainmenu', 'Red Color', 'red-color', '', 'explore/light/red-color', '?profile=light-red', 'url', 1, 492, 3, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 353, 354, 0, '*', 0),
(505, 'mainmenu', 'RTL Languages', 'rtl-languages', '', 'rtl-languages', 'index.php?option=com_content&view=article&id=17', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 373, 378, 0, '*', 0),
(506, 'mainmenu', 'RTL Languages Demo!', 'rtl-languages-demo', '', 'rtl-languages/rtl-languages-demo', '?direction=rtl', 'url', 1, 505, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 374, 375, 0, '*', 0);
INSERT INTO `#__menu` (`id`, `menutype`, `title`, `alias`, `note`, `path`, `link`, `type`, `published`, `parent_id`, `level`, `component_id`, `ordering`, `checked_out`, `checked_out_time`, `browserNav`, `access`, `img`, `template_style_id`, `params`, `lft`, `rgt`, `home`, `language`, `client_id`) VALUES
(507, 'mainmenu', 'LTR Languages Demo!', 'ltr-languages-demo', '', 'rtl-languages/ltr-languages-demo', '?direction=ltr', 'url', 1, 505, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 376, 377, 0, '*', 0),
(508, 'top', 'Search', 'search', '', 'search', 'index.php?option=com_search&view=search', 'component', 1, 1, 1, 19, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"search_areas":"","show_date":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"Search","show_page_heading":1,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 367, 368, 0, '*', 0),
(509, 'mainmenu', 'Portfolio Category', 'portfolio-category', '', 'portfolio-category', 'index.php?option=com_content&view=category&layout=blog&id=78', 'component', -2, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_category_title":"","show_description":"","show_description_image":"","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"","num_intro_articles":"","num_columns":"","num_links":"","multi_column_order":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_results":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_readmore":"","show_readmore_title":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 379, 380, 0, '*', 0),
(510, 'mainmenu', 'test', 'test', '', 'test', 'index.php?option=com_content&view=form&layout=edit', 'component', -2, 1, 1, 22, -5, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":0,"page_title":"Latest Reviews","show_page_heading":1,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 3, 4, 0, '*', 0),
(511, 'mainmenu', 'Joomla!', 'joomla', '', 'joomla', 'index.php?option=com_content&view=article&id=24', 'component', -2, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 381, 382, 0, '*', 0),
(512, 'bottom-menu', 'Joomla!', 'joomla-16', '', 'joomla-16', 'http://www.joomla.org', 'url', 1, 1, 1, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 383, 384, 0, '*', 0),
(513, 'link-resources', 'Forum', 'forum', '', 'forum', 'http://www.joomlart.com/forums', 'url', 1, 1, 1, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 385, 386, 0, '*', 0),
(514, 'link-resources', 'Tutorials', 'tutorials', '', 'tutorials', 'http://www.joomlart.com/tutorials/joomla16-video-tutorial/', 'url', 1, 1, 1, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 387, 388, 0, '*', 0),
(515, 'link-resources', 'T3 Framework', 't3-framwork', '', 't3-framwork', 'http://www.joomlart.com/joomla/t3-framework-and-ja-purity-templates', 'url', 1, 1, 1, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 389, 390, 0, '*', 0),
(516, 'link-resources', 'Club', 'club', '', 'club', 'http://www.joomlart.com/joomla/templates-club', 'url', 1, 1, 1, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 391, 392, 0, '*', 0),
(518, 'mainmenu', 'More info', 'more-info', '', 'explore/more-info', '', 'separator', 1, 490, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"1","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 356, 365, 0, '*', 0),
(519, 'mainmenu', 'Template info', 'template-info', '', 'explore/more-info/template-info', 'http://www.joomlart.com/joomla/templates/ja-anion', 'url', 1, 518, 3, 0, 0, 0, '0000-00-00 00:00:00', 1, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 357, 358, 0, '*', 0),
(520, 'mainmenu', 'Module Positions', 'module-positions', '', 'explore/more-info/module-positions', 'http://joomla16-templates.joomlart.com/ja_anion/?tp=1\r\n', 'url', 1, 518, 3, 0, 0, 0, '0000-00-00 00:00:00', 1, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 359, 360, 0, '*', 0),
(521, 'mainmenu', 'Userguide', 'userguide', '', 'explore/more-info/userguide', 'http://www.joomlart.com/forums/forumdisplay.php?10205-JA-Anion-Guides-Tutorials-Tips', 'url', 1, 518, 3, 0, 0, 0, '0000-00-00 00:00:00', 1, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 361, 362, 0, '*', 0),
(522, 'mainmenu', 'Extensions', 'extensions', '', 'explore/more-info/extensions', 'http://www.joomlart.com/joomla/templates/ja-anion', 'url', 1, 518, 3, 0, 0, 0, '0000-00-00 00:00:00', 1, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 363, 364, 0, '*', 0),
(524, 'main', 'COM_FINDER', 'com-finder', '', 'com-finder', 'index.php?option=com_finder', 'component', 0, 1, 1, 10022, 0, 0, '0000-00-00 00:00:00', 0, 1, 'class:finder', 0, NULL, 397, 398, 0, '', 1),
(525, 'menu', 'com_finder', 'Smart Search', '', 'Smart Search', 'index.php?option=com_finder', 'component', 0, 1, 1, 27, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:finder', 0, '', 41, 42, 0, '*', 1);

DROP TABLE IF EXISTS `#__menu_types`;
CREATE TABLE `#__menu_types` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `menutype` varchar(24) NOT NULL,
  `title` varchar(48) NOT NULL,
  `description` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_menutype` (`menutype`)
) ENGINE=MyISAM ;

INSERT INTO `#__menu_types` (`id`, `menutype`, `title`, `description`) VALUES
(2, 'usermenu', 'User Menu', 'A Menu for logged in Users'),
(3, 'top', 'Top', 'Links for major types of users'),
(4, 'aboutjoomla', 'About Joomla', 'All about Joomla!'),
(5, 'parks', 'Australian Parks', 'Main menu for a site about Australian  parks'),
(6, 'mainmenu', 'Main Menu', 'Simple Home Menu'),
(7, 'fruitshop', 'Fruit Shop', 'Menu for the sample shop site.'),
(8, 'link-resources', 'Link Resources', ''),
(9, 'bottom-menu', 'Bottom menu', 'Bottom menu');

DROP TABLE IF EXISTS `#__messages`;
CREATE TABLE `#__messages` (
  `message_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_id_from` int(10) unsigned NOT NULL DEFAULT '0',
  `user_id_to` int(10) unsigned NOT NULL DEFAULT '0',
  `folder_id` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `date_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `state` tinyint(1) NOT NULL DEFAULT '0',
  `priority` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `subject` varchar(255) NOT NULL DEFAULT '',
  `message` text NOT NULL,
  PRIMARY KEY (`message_id`),
  KEY `useridto_state` (`user_id_to`,`state`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__messages_cfg`;
CREATE TABLE `#__messages_cfg` (
  `user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `cfg_name` varchar(100) NOT NULL DEFAULT '',
  `cfg_value` varchar(255) NOT NULL DEFAULT '',
  UNIQUE KEY `idx_user_var_name` (`user_id`,`cfg_name`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__modules`;
CREATE TABLE `#__modules` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(100) NOT NULL DEFAULT '',
  `note` varchar(255) NOT NULL DEFAULT '',
  `content` text NOT NULL,
  `ordering` int(11) NOT NULL DEFAULT '0',
  `position` varchar(50) NOT NULL DEFAULT '',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `module` varchar(50) DEFAULT NULL,
  `access` int(10) unsigned DEFAULT NULL,
  `showtitle` tinyint(3) unsigned NOT NULL DEFAULT '1',
  `params` text,
  `client_id` tinyint(4) NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `published` (`published`,`access`),
  KEY `newsfeeds` (`module`,`published`),
  KEY `idx_language` (`language`)
) ENGINE=MyISAM ;

INSERT INTO `#__modules` (`id`, `title`, `note`, `content`, `ordering`, `position`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `published`, `module`, `access`, `showtitle`, `params`, `client_id`, `language`) VALUES
(1, 'Main Menu', '', '', 1, 'left', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_menu', 1, 1, '{"menutype":"mainmenu","startLevel":"1","endLevel":"0","showAllChildren":"0","tag_id":"","class_sfx":"","window_open":"","layout":"_:default","moduleclass_sfx":"_menu moduletable_hilite","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(2, 'Login', '', '', 1, 'login', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_login', 1, 1, '', 1, '*'),
(3, 'Popular Articles', '', '', 3, 'cpanel', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_popular', 3, 1, '{"count":"5","catid":"","user_id":"0","layout":"","moduleclass_sfx":"","cache":"0"}', 1, '*'),
(4, 'Recently Added Articles', '', '', 4, 'cpanel', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_latest', 3, 1, '{"count":"5","ordering":"c_dsc","catid":"","user_id":"0","layout":"","moduleclass_sfx":"","cache":"0"}', 1, '*'),
(6, 'Unread Messages', '', '', 1, 'header', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_unread', 3, 1, '', 1, '*'),
(7, 'Online Users', '', '', 2, 'header', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_online', 3, 1, '', 1, '*'),
(8, 'Toolbar', '', '', 1, 'toolbar', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_toolbar', 3, 1, '', 1, '*'),
(9, 'Quick Icons', '', '', 1, 'icon', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_quickicon', 3, 1, '', 1, '*'),
(10, 'Logged-in Users', '', '', 2, 'cpanel', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_logged', 3, 1, '', 1, '*'),
(12, 'Admin Menu', '', '', 1, 'menu', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_menu', 3, 1, '{"layout":"","moduleclass_sfx":"","shownew":"1","showhelp":"1","cache":"0"}', 1, '*'),
(13, 'Admin Submenu', '', '', 1, 'submenu', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_submenu', 3, 1, '', 1, '*'),
(14, 'User Status', '', '', 2, 'status', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_status', 3, 1, '', 1, '*'),
(15, 'Title', '', '', 1, 'title', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_title', 3, 1, '', 1, '*'),
(16, 'Login Form', '', '', 4, 'left', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_login', 1, 1, '{"pretext":"","posttext":"","login":"","logout":"","greeting":"1","name":"0","usesecure":"0","layout":"_:default","moduleclass_sfx":"","cache":"0"}', 0, '*'),
(17, 'Breadcrumbs', '', '', 1, 'position-2', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_breadcrumbs', 1, 1, '{"moduleclass_sfx":"","showHome":"1","homeText":"Home","showComponent":"1","separator":"","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(18, 'Banners', '', '', 1, 'position-5', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_banners', 1, 1, '{"target":"1","count":"1","cid":"1","catid":["27"],"tag_search":"0","ordering":"0","header_text":"","footer_text":"","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900"}', 0, '*'),
(19, 'User Menu', '', '', 3, 'position-7', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_menu', 2, 1, '{"menutype":"usermenu","startLevel":"1","endLevel":"0","showAllChildren":"0","tag_id":"","class_sfx":"","window_open":"","layout":"","moduleclass_sfx":"_menu","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(20, 'Top', '', '', 1, 'topnav', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_menu', 1, 1, '{"menutype":"top","startLevel":"1","endLevel":"0","showAllChildren":"0","tag_id":"","class_sfx":"","window_open":"","layout":"_:default","moduleclass_sfx":"","cache":"0","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(22, 'About Joomla', '', '', 2, 'left', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_menu', 1, 1, '{"menutype":"aboutjoomla","startLevel":"1","endLevel":"0","showAllChildren":"0","tag_id":"","class_sfx":"","window_open":"","layout":"_:default","moduleclass_sfx":"","cache":"0","cache_time":"900","cachemode":"itemid"}', 0, 'en-GB'),
(23, 'About Joomla!', '', '', 1, 'footnav', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_menu', 1, 1, '{"menutype":"link-resources","startLevel":"1","endLevel":"0","showAllChildren":"0","tag_id":"","class_sfx":"","window_open":"","layout":"_:default","moduleclass_sfx":"_menu","cache":"0","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(68, 'About Parks', '', '<p>The Parks sample site is designed as a simple site that can be routinely updated from the front end of Joomla!.</p><p>As a site, it is largely focused on a blog which can be updated using the front end article submission.</p><p>New weblinks can also be added through the front end.</p><p>A simple image gallery uses com_content with thumbnails displayed in a blog layout and full size images shown in article layout.</p><p>The Parks site features the language switch module. All of the content and modules are tagged as English (en-GB). If a second language pack is added with sample data this can be filtered using the language switch.</p><p>Parks uses HTML5 which is a major web standard (along with XHTML which is used in other areas of sample data).</p>', 2, 'position-4', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(67, 'Extensions', '', '', 2, 'position-7', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_menu', 1, 1, '{"menutype":"aboutjoomla","startLevel":"1","endLevel":"6","showAllChildren":"0","tag_id":"","class_sfx":"-menu","window_open":"","layout":"","moduleclass_sfx":"","cache":"0","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(25, 'Site Map', '', '', 1, 'sitemapload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_menu', 1, 0, '{"menutype":"mainmenu","startLevel":"2","endLevel":"3","showAllChildren":"1","tag_id":"","class_sfx":"sitemap","window_open":"","layout":"","moduleclass_sfx":"","cache":"0","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(26, 'This Site', '', '', 5, 'position-7', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_menu', 1, 1, '{"menutype":"mainmenu","startLevel":"1","endLevel":"1","showAllChildren":"0","tag_id":"","class_sfx":"","window_open":"","layout":"","moduleclass_sfx":"_menu","cache":"0","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(27, 'Archived Articles', '', '', 1, 'archiveload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_articles_archive', 1, 1, '{"count":"10","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(28, 'Latest News', '', '', 1, 'articleslatestload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_articles_latest', 1, 1, '{"catid":["19"],"count":"5","ordering":"c_dsc","user_id":"0","show_featured":"","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(29, 'Articles Most Read', '', '', 1, 'articlespopularload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_articles_popular', 1, 1, '{"show_front":"1","count":"5","catid":["26","29"],"layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(30, 'Feed Display', '', '', 1, 'feeddisplayload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_feed', 1, 1, '{"rssurl":"http:\\/\\/community.joomla.org\\/blogs\\/community.feed?type=rss","rssrtl":"0","rsstitle":"1","rssdesc":"1","rssimage":"1","rssitems":"3","rssitemdesc":"1","word_count":"0","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900"}', 0, '*'),
(31, 'News Flash: Latest', '', '', 1, 'newsflashload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_articles_news', 1, 1, '{"catid":["20"],"image":"0","item_title":"0","link_titles":"","item_heading":"h4","showLastSeparator":"1","readmore":"1","count":"1","ordering":"a.publish_up","layout":"horizontal","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(32, 'News Flash: Random', '', '', 1, 'newsflashload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_articles_news', 1, 1, '{"catid":["19"],"image":"0","item_title":"0","link_titles":"","item_heading":"h4","showLastSeparator":"1","readmore":"0","count":"1","ordering":"rand()","layout":"vertical","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(33, 'Random Image', '', '', 1, 'randomimageload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_random_image', 1, 1, '{"type":"jpg","folder":"images\\/sampledata\\/parks\\/animals","link":"","width":"180","height":"","layout":"","moduleclass_sfx":"","cache":"0"}', 0, '*'),
(34, 'Articles Related Items', '', '', 1, 'relateditemsload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_related_items', 1, 1, '{"showDate":"0","layout":"","moduleclass_sfx":"","owncache":"1"}', 0, '*'),
(35, 'Search', '', '', 1, 'searchload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_search', 1, 1, '{"width":"20","text":"","button":"","button_pos":"right","imagebutton":"","button_text":"","set_itemid":"","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(36, 'Statistics', '', '', 1, 'statisticsload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_stats', 1, 1, '{"serverinfo":"1","siteinfo":"1","counter":"1","increase":"0","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(37, 'Syndicate Feeds', '', '', 1, 'syndicateload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_syndicate', 1, 1, '{"text":"Feed Entries","format":"rss","layout":"","moduleclass_sfx":"","cache":"0"}', 0, '*'),
(38, 'Users Latest', '', '', 1, 'userslatestload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_users_latest', 1, 1, '{"shownumber":"5","linknames":"0","linktowhat":"0","layout":"","moduleclass_sfx":"","cache":"0","cache_time":"900","cachemode":"static"}', 0, '*'),
(39, 'Who''s Online', '', '', 6, 'right', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_whosonline', 1, 1, '{"showmode":"2","linknames":"0","linktowhat":"0","layout":"_:default","moduleclass_sfx":"","cache":"0"}', 0, '*'),
(40, 'Wrapper', '', '', 1, 'wrapperload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_wrapper', 1, 1, '{"url":"http:\\/\\/fsf.org","add":"1","scrolling":"auto","width":"100%","height":"200","height_auto":"1","target":"","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(41, 'Footer', '', '', 1, 'Footer', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_footer', 1, 1, '{"layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(44, 'Login', '', '', 1, 'loginload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_login', 1, 1, '{"pretext":"","posttext":"","login":"280","logout":"280","greeting":"1","name":"0","usesecure":"0","layout":"","moduleclass_sfx":"","cache":"0"}', 0, '*'),
(45, 'Menu', '', '', 1, 'menuload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_menu', 1, 1, '{"menutype":"mainmenu","startLevel":"1","endLevel":"0","showAllChildren":"0","tag_id":"","class_sfx":"","window_open":"","layout":"","moduleclass_sfx":"","cache":"0","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(47, 'Latest Park Blogs', '', '', 6, 'position-7', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_articles_latest', 1, 1, '{"count":"5","ordering":"c_dsc","user_id":"0","show_front":"1","catid":"35","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900"}', 0, 'en-GB'),
(48, 'Custom HTML', '', '<p>This is a custom html module. That means you can enter whatever content you want.</p>', 1, 'customload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(49, 'Weblinks', '', '', 1, 'weblinksload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_weblinks', 1, 1, '{"catid":"32","count":"5","ordering":"title","direction":"asc","target":"3","description":"0","hits":"0","count_clicks":"0","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(52, 'Breadcrumbs', '', '', 1, 'breadcrumbsload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_breadcrumbs', 1, 1, '{"showHome":"1","homeText":"Home","showLast":"1","separator":"","layout":"","moduleclass_sfx":"","cache":"0","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(61, 'Articles Categories', '', '', 1, 'articlescategoriesload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_articles_categories', 1, 1, '{"parent":"29","show_description":"0","show_children":"0","maxlevel":"0","count":"0","layout":"","moduleclass_sfx":"","owncache":"1","cache_time":"900"}', 0, '*'),
(56, 'Banners', '', '', 1, 'bannersload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_banners', 1, 1, '{"target":"1","count":"1","cid":"1","catid":["15"],"tag_search":"0","ordering":"random","header_text":"","footer_text":"","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900"}', 0, '*'),
(57, 'Fruit Shop', '', '', 3, 'position-5', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_menu', 1, 1, '{"menutype":"fruitshop","startLevel":"1","endLevel":"0","showAllChildren":"0","tag_id":"","class_sfx":"","window_open":"","layout":"","moduleclass_sfx":"","cache":"0","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(58, 'Special!', '', '<h1>This week we have a special, half price on delicious oranges!</h1><div>Only for our special customers!</div><div>Use the code: Joomla! when ordering</div><p><em>This module can only be seen by people in the customers group or higher.</em></p>', 1, 'position-12', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_custom', 4, 1, '{"prepare_content":"1","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(62, 'Language Switcher', '', '', 3, 'position-4', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_languages', 1, 1, '{"header_text":"","footer_text":"","image":"1","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(63, 'Search', '', '', 1, 'search', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_search', 1, 1, '{"label":"","width":"20","text":"","button":"","button_pos":"right","imagebutton":"1","button_text":"","set_itemid":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(64, 'Language Switcher', '', '', 1, 'languageswitcherload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 0, 'mod_languages', 1, 1, '{"header_text":"","footer_text":"","image":"1","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(65, 'About Fruit Shop', '', '<p>The Fruit Shop site shows a number of Joomla! features.</p><p>The template uses classes in cascading style sheets to change the layout of items, such as creating the horizontal alphabetical list in the Fruit Encyclopedia.</p><p> </p>', 1, 'position-4', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(69, 'Articles Category', '', '', 1, 'articlescategoryload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_articles_category', 1, 1, '{"mode":"normal","show_on_article_page":"1","show_front":"show","count":"0","category_filtering_type":"1","catid":["72"],"show_child_category_articles":"0","levels":"1","author_filtering_type":"1","created_by":[""],"author_alias_filtering_type":"1","created_by_alias":[""],"excluded_articles":"","date_filtering":"off","date_field":"a.created","start_date_range":"","end_date_range":"","relative_date":"30","article_ordering":"a.title","article_ordering_direction":"ASC","article_grouping":"none","article_grouping_direction":"ksort","month_year_format":"F Y","item_heading":"4","show_date":"0","show_date_field":"created","show_date_format":"Y-m-d H:i:s","show_category":"0","show_hits":"0","show_author":"0","show_introtext":"0","introtext_limit":"100","layout":"","moduleclass_sfx":"","owncache":"1","cache_time":"900"}', 0, '*'),
(70, 'Search (Atomic Template)', '', '', 1, 'atomic-search', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_search', 1, 0, '{"width":"20","text":"","button":"","button_pos":"right","imagebutton":"","button_text":"","set_itemid":"","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(71, 'Top Menu (Atomic Template)', '', '', 1, 'atomic-topmenu', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_menu', 1, 0, '{"menutype":"aboutjoomla","startLevel":"1","endLevel":"0","showAllChildren":"0","tag_id":"","class_sfx":"","window_open":"","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(72, 'Top Quote (Atomic Template)', '', '<hr />\r\n<h2 class="alt">Powerful Content Management and a Simple Extensible Framework.</h2>\r\n<hr />', 1, 'atomic-topquote', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_custom', 1, 0, '{"prepare_content":"1","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(73, 'Bottom Left Column (Atomic Template)', '', '<h6>This is a nested column</h6>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>', 1, 'atomic-bottomleft', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_custom', 1, 0, '{"prepare_content":"1","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(74, 'Bottom Middle Column (Atomic Template)', '', '<h6>This is another nested column</h6>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>', 1, 'atomic-bottommiddle', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_custom', 1, 0, '{"prepare_content":"1","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(75, 'Sidebar (Atomic Template)', '', '<h3>A <span class="alt">Simple</span> Sidebar</h3>\r\n<p>Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Cras ornare mattis nunc. Mauris venenatis, pede sed aliquet vehicula, lectus tellus pulvinar neque, non cursus sem nisi vel augue.</p>\r\n<p class="quiet">Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Cras ornare mattis nunc. Mauris venenatis, pede sed aliquet vehicula, lectus tellus pulvinar neque, non cursus sem nisi vel augue.</p>\r\n<h5>Incremental leading</h5>\r\n<p class="incr">Vestibulum ante ipsum primis in faucibus orci luctus vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Cras ornare mattis nunc. Mauris venenatis, pede sed aliquet vehicula, lectus tellus pulvinar neque, non cursus sem nisi vel augue. sed aliquet vehicula, lectus tellus.</p>\r\n<p class="incr">Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Cras ornare mattis nunc. Mauris venenatis, pede sed aliquet vehicula, lectus tellus pulvinar neque, non cursus sem nisi vel augue. sed aliquet vehicula, lectus tellus pulvinar neque, non cursus sem nisi vel augue. ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Cras ornare mattis nunc. Mauris venenatis, pede sed aliquet vehicula, lectus tellus pulvinar neque, non cursus sem nisi vel augue. sed aliquet vehicula, lectus tellus pulvinar neque, non cursus sem nisi vel augue.</p>', 1, 'atomic-sidebar', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_custom', 1, 0, '{"prepare_content":"1","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(76, 'Login (Atomic Template)', '', '', 2, 'atomic-sidebar', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_login', 1, 0, '{"pretext":"","posttext":"","login":"","logout":"","greeting":"1","name":"0","usesecure":"0","layout":"","moduleclass_sfx":"","cache":"0"}', 0, '*'),
(78, 'Popular', '', '', 1, 'ja-tabs', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_jabulletin', 1, 1, '{"moduleclass_sfx":"","type":"mostread","category":["78"],"count":"5","show_featured":"1","show_date":"1","show_author":"0","show_readmore":"0","show_hits":"0","use_custom_text":"1","custom_text":"Hits:","show_image":"1","thumbnail_mode":"crop","use_ratio":"1","width":"40","height":"40","cache":"1","cache_time":"30"}', 0, '*'),
(79, 'Movie news', '', '', 5, 'right', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_jasidenews', 1, 1, '{"moduleclass_sfx":"","display_model-modcats-category":["82"],"show_featured":"0","sort_order_field":"created","sort_order":"ASC","max_items":"2","title_max_chars":"200","maxchars":"150","thumbnail_mode":"crop","thumbnail_mode-resize-use_ratio":"1","iwidth":"38","iheight":"38","image_alignment":"left","layout":"default","layout-default-showdate":"1","layout-default-show_moredetail":"0","layout-default-showimage":"1","layout-sidenews-height":"200","layout-sidenews-textcolor":"FFFFFF","layout-sidenews-bgcolor":"4F4F4F","layout-sidenews-transparent":"80","layout-sidenews-element_apply_side":"content","layout-sidenews-play_mode":"caption","layout-sidenews-play_mode-caption-expandheight":"150","layout-sidenews-play_mode-caption-collapseheight":"30","layout-sidenews-animation_transition":"Fx.Transitions.Expo.easeOut","enable_cache":"0","cache_time":"30"}', 0, '*'),
(81, 'Twitter', '', '', 3, 'left', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_jatwitter', 1, 1, '{"moduleclass_sfx":"","taccount":"JoomlartDemo","use_display_taccount":"0","size_iconaccount":"48","show_tweet":"1","show_limit":"2","show_icon":"0","icon_size":"30","show_username":"1","show_source":"1","showtextheading":"1","headingtext":"My Twitter Updates","use_friends":"0","size_iconfriend":"24","max_friends":"10","showfollowlink":"0","typefollowbutton":"apiconnect","style_of_follow_button":"follow_me-a.png","apikey":"imiZ52v2MXH6Czt4fK0cFw","enable_cache":"1","cache_time":"5"}', 0, '*'),
(91, 'JA Slideshow Module', '', '', 1, 'content-mass-top', 42, '2012-02-10 05:06:15', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_jaslideshow', 1, 1, '{"moduleclass_sfx":"","source":"images","source-articles-display_model":"0","source-articles-display_model-modcats-category":["79"],"source-articles-sort_order_field":"created","source-articles-sort_order":"DESC","source-articles-max_items":"5","source-images-orderby":"0","source-images-sort":"0","folder":"images\\/stories\\/slideshow","description":"","profile":"anion","enable_cache":"0","cache_time":"30","open_target":"parent","source-articles-images-thumbnail_mode":"crop","source-articles-images-thumbnail_mode-resize-use_ratio":"1"}', 0, '*'),
(82, 'Latest', '', '', 1, 'ja-tabs', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_jabulletin', 1, 1, '{"moduleclass_sfx":"","type":"latest","category":["80"],"count":"5","show_featured":"1","show_date":"1","show_image":"1","thumbnail_mode":"crop","use_ratio":"1","width":"40","height":"40","cache":"1","cache_time":"30"}', 0, '*'),
(83, 'JA Tabs', '', '<div>{jatabs type="modules" animType="animNone" style="anion" position="top" widthTabs="120" heightTabs="30" width="100%" height="auto" mouseType="click" duration="1000" colors="10" module="ja-tabs" }{/jatabs}</div>', 1, 'right', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"_hilite moduletable_tab","cache":"0","cache_time":"900","cachemode":"static"}', 0, '*'),
(84, 'test', '', '', 2, 'right', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_jabulletin', 1, 1, '{"moduleclass_sfx":"","type":"latest","category":["80"],"count":"5","show_featured":"1","show_date":"1","show_image":"1","thumbnail_mode":"crop","use_ratio":"1","width":"40","height":"40","cache":"1","cache_time":"30"}', 0, '*'),
(85, 'Who we are?', '', '<div class="ja-innerdiv"><img src="images/stories/demo/sam-1.png" border="0" alt="JoomlArt.com" align="right" />\r\n<p>Ante at metus vitae vitae habitant In justo Pellentesque sapien ipsum. Ipsum Pellentesque Donec fermentum feugiat gravida</p>\r\n<a href="index.php?option=com_content&amp;view=article&amp;id=69&amp;Itemid=489" title="Who we are ?">Read more About us...</a></div>', 3, 'right', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"0","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(86, 'Video of the day', '', '<p><img src="images/stories/demo/video.jpg" border="0" alt="sample video" /></p>\r\n<p><a class="ja-title" href="#"><strong>New High-Definition Trailer</strong></a></p>\r\n<p>Universal Studios resurrects the classic lycanthrope with this tale of a man who experiences an unse...</p>', 4, 'right', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"0","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(87, 'T3 Framework', '', '<p>In at tortor eget purus commodo aliquet eget non tortor. In consequat, ante id placerat iaculis, nunc erat pretium neque, at venenati...</p>', 1, 'user5', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(88, '6 Preset Styles', '', '<p>Rhoncus sed. Lectus vitae augue, mauris tincidunt. Ut nec fermentum, dolor vestibulum.</p>\r\n<div class="text-note">Black, Blue, Brown, Green, Orange, Red</div>', 1, 'user6', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(89, 'Multi Menu', '', '<p>Nunc erat pretium neque, at venenatis arcu ipsum ac metus. Aliquam pharetra dapibus blandit.</p>\r\n<ul class="two-cols clearfix">\r\n<li><a href="?ja_menu=split">Split Menu</a></li>\r\n<li><a href="?ja_menu=dropline">Dropline Menu</a></li>\r\n<li><a href="?ja_menu=css">CSS Menu</a></li>\r\n<li><a href="?ja_menu=mega">Mega Menu</a></li>\r\n</ul>', 1, 'user7', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(90, 'What is Joomla?', '', '<p>Joomla is an award-winning content management system (CMS), which enables you to...</p>\r\n<div class="text-note">Praesent lacus convallis urna vel incidunt pellentesque...</div>', 1, 'user8', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(92, 'Editor pick', '', '', 1, 'content-top', 42, '2011-08-25 07:44:02', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_jacontentslider', 1, 1, '{"moduleclass_sfx":"","source":"content","folder_images":"","catid":["83"],"text_heading":"","showTab":"0","sort_order_field":"ordering","sort_order":"ASC","numElem":"3","maxitems":"10","link_titles":"1","showimages":"1","iwidth":"132","iheight":"182","showreadmore":"1","showintrotext":"1","numchar":"50","xwidth":"148","xheight":"300","auto":"0","direction":"left","mode":"horizontal","delaytime":"5000","animationtime":"1000","showtitle":"1","showbutton":"1","scroll_when":"hover","enable_cache":"1","cache_time":"300","source-articles-images-thumbnail_mode":"crop","source-articles-images-thumbnail_mode-resize-use_ratio":"0"}', 0, '*'),
(93, 'Login Form (copy)', '', '', 4, 'left', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_login', 1, 1, '{"pretext":"","posttext":"","login":"","logout":"","greeting":"1","name":"0","usesecure":"0","layout":"_:default","moduleclass_sfx":"","cache":"0"}', 0, '*'),
(94, 'User Menu', '', '', 0, 'left', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_menu', 2, 1, '{"menutype":"usermenu","startLevel":"1","endLevel":"1","showAllChildren":"1","tag_id":"","class_sfx":"","window_open":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(95, 'Module Breadcrumbs', '', '', 0, 'breadcrumbs', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_breadcrumbs', 1, 0, '{"showHere":"1","showHome":"1","homeText":"","showLast":"1","separator":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(96, 'Multilanguage status', '', '', 1, 'status', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 0, 'mod_multilangstatus', 3, 1, '{"layout":"_:default","moduleclass_sfx":"","cache":"0"}', 1, '*'),
(97, 'Joomla Version', '', '', 1, 'footer', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_version', 3, 1, '{"format":"short","product":"1","layout":"_:default","moduleclass_sfx":"","cache":"0"}', 1, '*');

DROP TABLE IF EXISTS `#__modules_menu`;
CREATE TABLE `#__modules_menu` (
  `moduleid` int(11) NOT NULL DEFAULT '0',
  `menuid` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`moduleid`,`menuid`)
) ENGINE=MyISAM;

INSERT INTO `#__modules_menu` (`moduleid`, `menuid`) VALUES
(1, 435),
(2, 0),
(3, 0),
(4, 0),
(6, 0),
(7, 0),
(8, 0),
(9, 0),
(10, 0),
(12, 0),
(13, 0),
(14, 0),
(15, 0),
(16, 435),
(17, 0),
(18, 0),
(19, -463),
(19, -462),
(19, -433),
(19, -432),
(19, -431),
(19, -430),
(19, -429),
(19, -427),
(19, -400),
(19, -399),
(19, -296),
(19, -244),
(19, -243),
(19, -242),
(19, -234),
(20, 0),
(22, 435),
(23, -516),
(23, -515),
(23, -514),
(23, -513),
(23, -463),
(23, -462),
(23, -433),
(23, -432),
(23, -431),
(23, -430),
(23, -429),
(23, -427),
(23, -400),
(23, -399),
(23, -296),
(23, -244),
(23, -243),
(23, -242),
(23, -234),
(25, 294),
(26, -463),
(26, -462),
(26, -433),
(26, -432),
(26, -431),
(26, -430),
(26, -429),
(26, -427),
(26, -400),
(26, -399),
(26, -296),
(26, -244),
(26, -243),
(26, -242),
(26, -238),
(26, -234),
(27, 325),
(28, 310),
(29, 302),
(30, 410),
(31, 309),
(32, 309),
(33, 307),
(34, 326),
(35, 306),
(36, 304),
(37, 311),
(38, 300),
(39, 435),
(40, 313),
(41, 0),
(44, 312),
(45, 303),
(47, 231),
(47, 234),
(47, 242),
(47, 243),
(47, 244),
(47, 296),
(47, 399),
(47, 400),
(48, 418),
(49, 417),
(52, 294),
(52, 416),
(56, 305),
(57, 238),
(57, 427),
(57, 429),
(57, 430),
(57, 431),
(57, 432),
(57, 433),
(57, 462),
(57, 463),
(58, 427),
(58, 429),
(58, 430),
(58, 431),
(58, 432),
(58, 433),
(58, 462),
(58, 463),
(60, 227),
(60, 229),
(60, 249),
(60, 251),
(60, 252),
(60, 253),
(60, 254),
(60, 255),
(60, 256),
(60, 257),
(60, 259),
(60, 260),
(60, 262),
(60, 263),
(60, 265),
(60, 266),
(60, 267),
(60, 270),
(60, 271),
(60, 272),
(60, 273),
(60, 274),
(60, 275),
(60, 276),
(60, 281),
(60, 282),
(60, 283),
(60, 284),
(60, 285),
(60, 286),
(60, 300),
(60, 301),
(60, 302),
(60, 303),
(60, 304),
(60, 305),
(60, 306),
(60, 307),
(60, 309),
(60, 310),
(60, 311),
(60, 312),
(60, 313),
(60, 314),
(60, 316),
(60, 317),
(60, 318),
(60, 319),
(60, 320),
(60, 321),
(60, 322),
(60, 323),
(60, 324),
(60, 325),
(60, 326),
(60, 402),
(60, 403),
(60, 404),
(60, 405),
(60, 406),
(60, 409),
(60, 410),
(60, 411),
(60, 412),
(60, 413),
(60, 414),
(60, 415),
(60, 416),
(60, 417),
(60, 418),
(60, 419),
(60, 420),
(60, 421),
(60, 422),
(60, 423),
(60, 424),
(60, 425),
(60, 426),
(61, 443),
(62, 231),
(62, 234),
(62, 242),
(62, 243),
(62, 244),
(62, 296),
(62, 399),
(62, 400),
(63, 0),
(64, 447),
(65, 427),
(65, 429),
(65, 430),
(65, 431),
(65, 432),
(65, 433),
(65, 462),
(65, 463),
(68, 243),
(69, 459),
(70, 285),
(70, 316),
(71, 285),
(71, 316),
(72, 285),
(72, 316),
(73, 285),
(73, 316),
(74, 285),
(74, 316),
(75, 285),
(75, 316),
(76, 285),
(76, 316),
(78, 0),
(79, 290),
(79, 435),
(79, 438),
(79, 439),
(79, 467),
(79, 475),
(79, 477),
(79, 481),
(79, 487),
(81, 435),
(82, 0),
(83, 435),
(83, 474),
(84, 0),
(85, 271),
(85, 402),
(85, 403),
(85, 404),
(85, 405),
(85, 406),
(85, 409),
(85, 435),
(85, 474),
(86, 271),
(86, 402),
(86, 403),
(86, 404),
(86, 405),
(86, 406),
(86, 409),
(86, 435),
(87, 201),
(87, 207),
(87, 227),
(87, 229),
(87, 233),
(87, 234),
(87, 238),
(87, 242),
(87, 243),
(87, 244),
(87, 249),
(87, 251),
(87, 252),
(87, 253),
(87, 254),
(87, 255),
(87, 256),
(87, 257),
(87, 259),
(87, 260),
(87, 262),
(87, 263),
(87, 265),
(87, 266),
(87, 267),
(87, 268),
(87, 270),
(87, 271),
(87, 272),
(87, 273),
(87, 274),
(87, 275),
(87, 276),
(87, 277),
(87, 278),
(87, 279),
(87, 280),
(87, 281),
(87, 282),
(87, 283),
(87, 284),
(87, 285),
(87, 286),
(87, 290),
(87, 294),
(87, 296),
(87, 300),
(87, 301),
(87, 302),
(87, 303),
(87, 304),
(87, 305),
(87, 306),
(87, 307),
(87, 309),
(87, 310),
(87, 311),
(87, 312),
(87, 313),
(87, 316),
(87, 317),
(87, 318),
(87, 319),
(87, 320),
(87, 321),
(87, 322),
(87, 323),
(87, 324),
(87, 325),
(87, 326),
(87, 399),
(87, 400),
(87, 402),
(87, 403),
(87, 404),
(87, 405),
(87, 406),
(87, 409),
(87, 410),
(87, 411),
(87, 412),
(87, 413),
(87, 414),
(87, 415),
(87, 416),
(87, 417),
(87, 418),
(87, 419),
(87, 421),
(87, 422),
(87, 423),
(87, 424),
(87, 427),
(87, 429),
(87, 430),
(87, 431),
(87, 432),
(87, 433),
(87, 435),
(87, 436),
(87, 437),
(87, 438),
(87, 439),
(87, 443),
(87, 444),
(87, 445),
(87, 446),
(87, 447),
(87, 448),
(87, 449),
(87, 450),
(87, 451),
(87, 452),
(87, 453),
(87, 455),
(87, 456),
(87, 457),
(87, 458),
(87, 459),
(87, 462),
(87, 463),
(87, 464),
(87, 466),
(87, 467),
(87, 468),
(87, 469),
(87, 470),
(87, 471),
(87, 473),
(87, 474),
(87, 475),
(87, 476),
(87, 477),
(87, 478),
(87, 479),
(87, 480),
(87, 481),
(87, 482),
(87, 483),
(87, 484),
(87, 485),
(87, 487),
(87, 488),
(87, 489),
(87, 490),
(87, 491),
(87, 492),
(87, 493),
(87, 494),
(87, 495),
(87, 496),
(87, 497),
(87, 498),
(87, 499),
(87, 500),
(87, 501),
(87, 502),
(87, 503),
(87, 504),
(87, 505),
(87, 506),
(87, 507),
(88, 201),
(88, 207),
(88, 227),
(88, 229),
(88, 233),
(88, 234),
(88, 238),
(88, 242),
(88, 243),
(88, 244),
(88, 249),
(88, 251),
(88, 252),
(88, 253),
(88, 254),
(88, 255),
(88, 256),
(88, 257),
(88, 259),
(88, 260),
(88, 262),
(88, 263),
(88, 265),
(88, 266),
(88, 267),
(88, 268),
(88, 270),
(88, 271),
(88, 272),
(88, 273),
(88, 274),
(88, 275),
(88, 276),
(88, 277),
(88, 278),
(88, 279),
(88, 280),
(88, 281),
(88, 282),
(88, 283),
(88, 284),
(88, 285),
(88, 286),
(88, 290),
(88, 294),
(88, 296),
(88, 300),
(88, 301),
(88, 302),
(88, 303),
(88, 304),
(88, 305),
(88, 306),
(88, 307),
(88, 309),
(88, 310),
(88, 311),
(88, 312),
(88, 313),
(88, 316),
(88, 317),
(88, 318),
(88, 319),
(88, 320),
(88, 321),
(88, 322),
(88, 323),
(88, 324),
(88, 325),
(88, 326),
(88, 399),
(88, 400),
(88, 402),
(88, 403),
(88, 404),
(88, 405),
(88, 406),
(88, 409),
(88, 410),
(88, 411),
(88, 412),
(88, 413),
(88, 414),
(88, 415),
(88, 416),
(88, 417),
(88, 418),
(88, 419),
(88, 421),
(88, 422),
(88, 423),
(88, 424),
(88, 427),
(88, 429),
(88, 430),
(88, 431),
(88, 432),
(88, 433),
(88, 435),
(88, 436),
(88, 437),
(88, 438),
(88, 439),
(88, 443),
(88, 444),
(88, 445),
(88, 446),
(88, 447),
(88, 448),
(88, 449),
(88, 450),
(88, 451),
(88, 452),
(88, 453),
(88, 455),
(88, 456),
(88, 457),
(88, 458),
(88, 459),
(88, 462),
(88, 463),
(88, 464),
(88, 466),
(88, 467),
(88, 468),
(88, 469),
(88, 470),
(88, 471),
(88, 473),
(88, 474),
(88, 475),
(88, 476),
(88, 477),
(88, 478),
(88, 479),
(88, 480),
(88, 481),
(88, 482),
(88, 483),
(88, 484),
(88, 485),
(88, 487),
(88, 488),
(88, 489),
(88, 490),
(88, 491),
(88, 492),
(88, 493),
(88, 494),
(88, 495),
(88, 496),
(88, 497),
(88, 498),
(88, 499),
(88, 500),
(88, 501),
(88, 502),
(88, 503),
(88, 504),
(88, 505),
(88, 506),
(88, 507),
(89, 201),
(89, 207),
(89, 227),
(89, 229),
(89, 233),
(89, 234),
(89, 238),
(89, 242),
(89, 243),
(89, 244),
(89, 249),
(89, 251),
(89, 252),
(89, 253),
(89, 254),
(89, 255),
(89, 256),
(89, 257),
(89, 259),
(89, 260),
(89, 262),
(89, 263),
(89, 265),
(89, 266),
(89, 267),
(89, 268),
(89, 270),
(89, 271),
(89, 272),
(89, 273),
(89, 274),
(89, 275),
(89, 276),
(89, 277),
(89, 278),
(89, 279),
(89, 280),
(89, 281),
(89, 282),
(89, 283),
(89, 284),
(89, 285),
(89, 286),
(89, 290),
(89, 294),
(89, 296),
(89, 300),
(89, 301),
(89, 302),
(89, 303),
(89, 304),
(89, 305),
(89, 306),
(89, 307),
(89, 309),
(89, 310),
(89, 311),
(89, 312),
(89, 313),
(89, 316),
(89, 317),
(89, 318),
(89, 319),
(89, 320),
(89, 321),
(89, 322),
(89, 323),
(89, 324),
(89, 325),
(89, 326),
(89, 399),
(89, 400),
(89, 402),
(89, 403),
(89, 404),
(89, 405),
(89, 406),
(89, 409),
(89, 410),
(89, 411),
(89, 412),
(89, 413),
(89, 414),
(89, 415),
(89, 416),
(89, 417),
(89, 418),
(89, 419),
(89, 421),
(89, 422),
(89, 423),
(89, 424),
(89, 427),
(89, 429),
(89, 430),
(89, 431),
(89, 432),
(89, 433),
(89, 435),
(89, 436),
(89, 437),
(89, 438),
(89, 439),
(89, 443),
(89, 444),
(89, 445),
(89, 446),
(89, 447),
(89, 448),
(89, 449),
(89, 450),
(89, 451),
(89, 452),
(89, 453),
(89, 455),
(89, 456),
(89, 457),
(89, 458),
(89, 459),
(89, 462),
(89, 463),
(89, 464),
(89, 466),
(89, 467),
(89, 468),
(89, 469),
(89, 470),
(89, 471),
(89, 473),
(89, 474),
(89, 475),
(89, 476),
(89, 477),
(89, 478),
(89, 479),
(89, 480),
(89, 481),
(89, 482),
(89, 483),
(89, 484),
(89, 485),
(89, 487),
(89, 488),
(89, 489),
(89, 490),
(89, 491),
(89, 492),
(89, 493),
(89, 494),
(89, 495),
(89, 496),
(89, 497),
(89, 498),
(89, 499),
(89, 500),
(89, 501),
(89, 502),
(89, 503),
(89, 504),
(89, 505),
(89, 506),
(89, 507),
(90, 201),
(90, 207),
(90, 227),
(90, 229),
(90, 233),
(90, 234),
(90, 238),
(90, 242),
(90, 243),
(90, 244),
(90, 249),
(90, 251),
(90, 252),
(90, 253),
(90, 254),
(90, 255),
(90, 256),
(90, 257),
(90, 259),
(90, 260),
(90, 262),
(90, 263),
(90, 265),
(90, 266),
(90, 267),
(90, 268),
(90, 270),
(90, 271),
(90, 272),
(90, 273),
(90, 274),
(90, 275),
(90, 276),
(90, 277),
(90, 278),
(90, 279),
(90, 280),
(90, 281),
(90, 282),
(90, 283),
(90, 284),
(90, 285),
(90, 286),
(90, 290),
(90, 294),
(90, 296),
(90, 300),
(90, 301),
(90, 302),
(90, 303),
(90, 304),
(90, 305),
(90, 306),
(90, 307),
(90, 309),
(90, 310),
(90, 311),
(90, 312),
(90, 313),
(90, 316),
(90, 317),
(90, 318),
(90, 319),
(90, 320),
(90, 321),
(90, 322),
(90, 323),
(90, 324),
(90, 325),
(90, 326),
(90, 399),
(90, 400),
(90, 402),
(90, 403),
(90, 404),
(90, 405),
(90, 406),
(90, 409),
(90, 410),
(90, 411),
(90, 412),
(90, 413),
(90, 414),
(90, 415),
(90, 416),
(90, 417),
(90, 418),
(90, 419),
(90, 421),
(90, 422),
(90, 423),
(90, 424),
(90, 427),
(90, 429),
(90, 430),
(90, 431),
(90, 432),
(90, 433),
(90, 435),
(90, 436),
(90, 437),
(90, 438),
(90, 439),
(90, 443),
(90, 444),
(90, 445),
(90, 446),
(90, 447),
(90, 448),
(90, 449),
(90, 450),
(90, 451),
(90, 452),
(90, 453),
(90, 455),
(90, 456),
(90, 457),
(90, 458),
(90, 459),
(90, 462),
(90, 463),
(90, 464),
(90, 466),
(90, 467),
(90, 468),
(90, 469),
(90, 470),
(90, 471),
(90, 473),
(90, 474),
(90, 475),
(90, 476),
(90, 477),
(90, 478),
(90, 479),
(90, 480),
(90, 481),
(90, 482),
(90, 483),
(90, 484),
(90, 485),
(90, 487),
(90, 488),
(90, 489),
(90, 490),
(90, 491),
(90, 492),
(90, 493),
(90, 494),
(90, 495),
(90, 496),
(90, 497),
(90, 498),
(90, 499),
(90, 500),
(90, 501),
(90, 502),
(90, 503),
(90, 504),
(90, 505),
(90, 506),
(90, 507),
(91, 290),
(91, 435),
(91, 438),
(91, 475),
(91, 476),
(92, 435),
(93, 435),
(94, 435),
(95, 0),
(96, 0),
(97, 0);

DROP TABLE IF EXISTS `#__newsfeeds`;
CREATE TABLE `#__newsfeeds` (
  `catid` int(11) NOT NULL DEFAULT '0',
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL DEFAULT '',
  `alias` varchar(255) binary NOT NULL DEFAULT '',
  `link` varchar(200) NOT NULL DEFAULT '',
  `filename` varchar(200) DEFAULT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `numarticles` int(10) unsigned NOT NULL DEFAULT '1',
  `cache_time` int(10) unsigned NOT NULL DEFAULT '3600',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `rtl` tinyint(4) NOT NULL DEFAULT '0',
  `access` int(10) unsigned DEFAULT NULL,
  `language` char(7) NOT NULL DEFAULT '',
  `params` text NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`published`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=MyISAM ;

INSERT INTO `#__newsfeeds` (`catid`, `id`, `name`, `alias`, `link`, `filename`, `published`, `numarticles`, `cache_time`, `checked_out`, `checked_out_time`, `ordering`, `rtl`, `access`, `language`, `params`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `metakey`, `metadesc`, `metadata`, `xreference`, `publish_up`, `publish_down`) VALUES
(17, 1, 'Joomla! Announcements', 'joomla-announcements', 'http://www.joomla.org/announcements.feed?type=rss', NULL, 1, 5, 3600, 0, '0000-00-00 00:00:00', 1, 0, 1, 'en-GB', '{"show_feed_image":"","show_feed_description":"","show_item_description":"","feed_character_count":"0"}', '0000-00-00 00:00:00', 0, '', '2010-07-10 23:40:09', 42, '', '', '{"robots":"","author":"","rights":""}', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(17, 2, 'New Joomla! Extensions', 'new-joomla-extensions', 'http://feeds.joomla.org/JoomlaExtensions', NULL, 1, 5, 3600, 0, '0000-00-00 00:00:00', 4, 0, 1, 'en-GB', '{"show_feed_image":"","show_feed_description":"","show_item_description":"","feed_character_count":"0"}', '0000-00-00 00:00:00', 0, '', '2010-08-23 02:49:21', 42, '', '', '{"robots":"","author":"","rights":""}', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(17, 3, 'Joomla! Security News', 'joomla-security-news', 'http://feeds.joomla.org/JoomlaSecurityNews', NULL, 1, 5, 3600, 0, '0000-00-00 00:00:00', 2, 0, 1, 'en-GB', '{"show_feed_image":"","show_feed_description":"","show_item_description":"","feed_character_count":"0"}', '0000-00-00 00:00:00', 0, '', '2010-08-23 02:49:21', 42, '', '', '{"robots":"","author":"","rights":""}', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(17, 4, 'Joomla! Connect', 'joomla-connect', 'http://feeds.joomla.org/JoomlaConnect', NULL, 1, 5, 3600, 0, '0000-00-00 00:00:00', 3, 0, 1, 'en-GB', '{"show_feed_image":"","show_feed_description":"","show_item_description":"","feed_character_count":"0"}', '0000-00-00 00:00:00', 0, '', '2010-08-23 02:49:21', 42, '', '', '{"robots":"","author":"","rights":""}', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00');

DROP TABLE IF EXISTS `#__overrider`;
CREATE TABLE `#__overrider` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `constant` varchar(255) NOT NULL,
  `string` text NOT NULL,
  `file` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__redirect_links`;
CREATE TABLE `#__redirect_links` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `old_url` varchar(255) DEFAULT NULL,
  `new_url` varchar(255) DEFAULT NULL,
  `referer` varchar(150) NOT NULL,
  `comment` varchar(255) NOT NULL,
  `published` tinyint(4) NOT NULL,
  `created_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_link_old` (`old_url`),
  KEY `idx_link_modifed` (`modified_date`)
) ENGINE=MyISAM ;

INSERT INTO `#__redirect_links` (`id`, `old_url`, `new_url`, `referer`, `comment`, `published`, `created_date`, `modified_date`) VALUES
(1, 'http://sg.dev.joomlart.com/jadev2_data/sites/auto/qs.anionj25.1328849694/index.php/about-joomla/whats-new-in-17', '', 'http://sg.dev.joomlart.com/jadev2_data/sites/auto/qs.anionj25.1328849694/', '', 0, '2012-02-10 06:48:49', '0000-00-00 00:00:00');

DROP TABLE IF EXISTS `#__schemas`;
CREATE TABLE `#__schemas` (
  `extension_id` int(11) NOT NULL,
  `version_id` varchar(20) NOT NULL,
  PRIMARY KEY (`extension_id`,`version_id`)
) ENGINE=MyISAM;

INSERT INTO `#__schemas` (`extension_id`, `version_id`) VALUES
(700, '2.5.1-2012-01-26');

DROP TABLE IF EXISTS `#__session`;
CREATE TABLE `#__session` (
  `session_id` varchar(200) NOT NULL DEFAULT '',
  `client_id` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `guest` tinyint(4) unsigned DEFAULT '1',
  `time` varchar(14) DEFAULT '',
  `data` mediumtext,
  `userid` int(11) DEFAULT '0',
  `username` varchar(150) DEFAULT '',
  `usertype` varchar(50) DEFAULT '',
  PRIMARY KEY (`session_id`),
  KEY `whosonline` (`guest`,`usertype`),
  KEY `userid` (`userid`),
  KEY `time` (`time`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__template_styles`;
CREATE TABLE `#__template_styles` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `template` varchar(50) NOT NULL DEFAULT '',
  `client_id` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `home` char(7) NOT NULL DEFAULT '0',
  `title` varchar(255) NOT NULL DEFAULT '',
  `params` text,
  PRIMARY KEY (`id`),
  KEY `idx_template` (`template`),
  KEY `idx_home` (`home`)
) ENGINE=MyISAM ;

INSERT INTO `#__template_styles` (`id`, `template`, `client_id`, `home`, `title`, `params`) VALUES
(1, 'rhuk_milkyway', 0, '0', 'Milkyway - Default', '{"colorVariation":"blue","backgroundVariation":"blue","widthStyle":"fmax"}'),
(2, 'bluestork', 1, '1', 'Bluestork - Default', '{"useRoundedCorners":"1","showSiteName":"0"}'),
(3, 'atomic', 0, '0', 'Atomic - Default', '{}'),
(4, 'beez_20', 0, '0', 'Beez2 - Default', '{"wrapperSmall":"53","wrapperLarge":"72","logo":"images\\/joomla_black.gif","sitetitle":"Joomla!","sitedescription":"Open Source Content Management Beta","navposition":"left","templatecolor":"personal","html5":"0"}'),
(5, 'hathor', 1, '0', 'Hathor - Default', '{"showSiteName":"0","highContrast":"0","boldText":"0","altMenu":"0"}'),
(6, 'beez5', 0, '0', 'Beez5 - Default-Fruit Shop', '{"wrapperSmall":"53","wrapperLarge":"72","logo":"images\\/sampledata\\/fruitshop\\/fruits.gif","sitetitle":"Matuna Market ","sitedescription":"Fruit Shop Sample Site","navposition":"left","html5":"0"}'),
(114, 'beez_20', 0, '0', 'Beez2 - Parks Site', '{"wrapperSmall":"53","wrapperLarge":"72","logo":"","sitetitle":"Australian Parks","sitedescription":"Parks Sample Site","navposition":"center","templatecolor":"nature"}'),
(117, 'ja_anion', 0, '1', 'JA_ANION - Default', '{}');

DROP TABLE IF EXISTS `#__update_categories`;
CREATE TABLE `#__update_categories` (
  `categoryid` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(20) DEFAULT '',
  `description` text NOT NULL,
  `parent` int(11) DEFAULT '0',
  `updatesite` int(11) DEFAULT '0',
  PRIMARY KEY (`categoryid`)
) ENGINE=MyISAM COMMENT='Update Categories';


DROP TABLE IF EXISTS `#__update_sites`;
CREATE TABLE `#__update_sites` (
  `update_site_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) DEFAULT '',
  `type` varchar(20) DEFAULT '',
  `location` text NOT NULL,
  `enabled` int(11) DEFAULT '0',
  `last_check_timestamp` bigint(20) DEFAULT '0',
  PRIMARY KEY (`update_site_id`)
) ENGINE=MyISAM  COMMENT='Update Sites';

INSERT INTO `#__update_sites` (`update_site_id`, `name`, `type`, `location`, `enabled`, `last_check_timestamp`) VALUES
(1, 'Joomla Core', 'collection', 'http://update.joomla.org/core/list.xml', 1, 1328953586),
(2, 'Joomla Extension Directory', 'collection', 'http://update.joomla.org/jed/list.xml', 1, 1328953586),
(3, '', 'collection', 'http://update.joomlart.com/service/tracking/list.xml', 1, 1328953586);

DROP TABLE IF EXISTS `#__update_sites_extensions`;
CREATE TABLE `#__update_sites_extensions` (
  `update_site_id` int(11) NOT NULL DEFAULT '0',
  `extension_id` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`update_site_id`,`extension_id`)
) ENGINE=MyISAM COMMENT='Links extensions to update sites';

INSERT INTO `#__update_sites_extensions` (`update_site_id`, `extension_id`) VALUES
(1, 700),
(2, 700),
(3, 10013),
(3, 10014),
(3, 10015),
(3, 10016),
(3, 10017),
(3, 10018);

DROP TABLE IF EXISTS `#__updates`;
CREATE TABLE `#__updates` (
  `update_id` int(11) NOT NULL AUTO_INCREMENT,
  `update_site_id` int(11) DEFAULT '0',
  `extension_id` int(11) DEFAULT '0',
  `categoryid` int(11) DEFAULT '0',
  `name` varchar(100) DEFAULT '',
  `description` text NOT NULL,
  `element` varchar(100) DEFAULT '',
  `type` varchar(20) DEFAULT '',
  `folder` varchar(20) DEFAULT '',
  `client_id` tinyint(3) DEFAULT '0',
  `version` varchar(10) DEFAULT '',
  `data` text NOT NULL,
  `detailsurl` text NOT NULL,
  `infourl` text NOT NULL,
  PRIMARY KEY (`update_id`)
) ENGINE=MyISAM  COMMENT='Available Updates';

INSERT INTO `#__updates` (`update_id`, `update_site_id`, `extension_id`, `categoryid`, `name`, `description`, `element`, `type`, `folder`, `client_id`, `version`, `data`, `detailsurl`, `infourl`) VALUES
(1, 3, 0, 0, '', '', '', 'file', '', 0, '', '', 'http://update.joomlart.com/service/tracking/j16/.xml', ''),
(2, 3, 0, 0, 'JA Amazon S3 for joomla 16', '', 'com_com_jaamazons3', 'file', '', 0, '1.0.0', '', 'http://update.joomlart.com/service/tracking/j16/com_com_jaamazons3.xml', ''),
(3, 3, 0, 0, 'JA Extenstion Manager Component j16', '', 'com_com_jaextmanager', 'file', '', 0, '1.0.1', '', 'http://update.joomlart.com/service/tracking/j16/com_com_jaextmanager.xml', ''),
(4, 3, 0, 0, 'JA Amazon S3 for joomla 17', '', 'com_jaamazons3', 'file', '', 0, '1.0.2', '', 'http://update.joomlart.com/service/tracking/j16/com_jaamazons3.xml', ''),
(5, 3, 0, 0, 'JA Comment Component j17', '', 'com_jacomment', 'file', '', 0, '1.1.1', '', 'http://update.joomlart.com/service/tracking/j16/com_jacomment.xml', ''),
(6, 3, 0, 0, 'JA Extenstion Manager Component for Joomla 1.7', '', 'com_jaextmanager', 'file', '', 0, '1.1.3', '', 'http://update.joomlart.com/service/tracking/j16/com_jaextmanager.xml', ''),
(7, 3, 0, 0, 'JA Showcase component for Joomla 1.7', '', 'com_jashowcase', 'file', '', 0, '1.1.0', '', 'http://update.joomlart.com/service/tracking/j16/com_jashowcase.xml', ''),
(8, 3, 0, 0, 'JA Voice component for Joomla 1.7', '', 'com_javoice', 'file', '', 0, '1.0.0', '', 'http://update.joomlart.com/service/tracking/j16/com_javoice.xml', ''),
(9, 3, 0, 0, 'JA Anion template for Joomla 1.7', '', 'ja_anion', 'file', '', 0, '1.2.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_anion.xml', ''),
(10, 3, 0, 0, 'JA Bistro Template for J17', '', 'ja_bistro', 'file', '', 0, '1.1.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_bistro.xml', ''),
(11, 3, 0, 0, 'JA Blazes Template J17', '', 'ja_blazes', 'file', '', 0, '1.0.1', '', 'http://update.joomlart.com/service/tracking/j16/ja_blazes.xml', ''),
(12, 3, 0, 0, 'JA Business Template for Joomla 1.7.x', '', 'ja_business', 'file', '', 0, '1.3.1', '', 'http://update.joomlart.com/service/tracking/j16/ja_business.xml', ''),
(13, 3, 0, 0, 'JA Cloris Template for Joomla 1.7', '', 'ja_cloris', 'file', '', 0, '1.2.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_cloris.xml', ''),
(14, 3, 0, 0, 'JA Community PLus Template for Joomla 1.7.x', '', 'ja_community_plus', 'file', '', 0, '1.3.2', '', 'http://update.joomlart.com/service/tracking/j16/ja_community_plus.xml', ''),
(15, 3, 0, 0, 'JA Droid Template for Joomla 1.7.x', '', 'ja_droid', 'file', '', 0, '1.2.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_droid.xml', ''),
(16, 3, 0, 0, 'JA Edenite Template for Joomla 1.7', '', 'ja_edenite', 'file', '', 0, '1.1.1', '', 'http://update.joomlart.com/service/tracking/j16/ja_edenite.xml', ''),
(17, 3, 0, 0, 'JA Elastica Template for Joomla 1.7', '', 'ja_elastica', 'file', '', 0, '1.0.0 Beta', '', 'http://update.joomlart.com/service/tracking/j16/ja_elastica.xml', ''),
(18, 3, 0, 0, 'JA Erio Template for Joomla 1.7', '', 'ja_erio', 'file', '', 0, '1.0.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_erio.xml', ''),
(19, 3, 0, 0, 'Ja Events Template for Joomla 1.7', '', 'ja_events', 'file', '', 0, '1.2.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_events.xml', ''),
(20, 3, 0, 0, 'JA Graphite J17 - April 2011 JA Template', '', 'ja_graphite', 'file', '', 0, '1.1.1', '', 'http://update.joomlart.com/service/tracking/j16/ja_graphite.xml', ''),
(21, 3, 0, 0, 'JA Ironis 1.7 Template', '', 'ja_ironis', 'file', '', 0, '1.0.1', '', 'http://update.joomlart.com/service/tracking/j16/ja_ironis.xml', ''),
(22, 3, 0, 0, 'JA KranosTemplate J17', '', 'ja_kranos', 'file', '', 0, '1.0.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_kranos.xml', ''),
(23, 3, 0, 0, 'Ja Lime Template for Joomla 1.7', '', 'ja_lime', 'file', '', 0, '1.1.2', '', 'http://update.joomlart.com/service/tracking/j16/ja_lime.xml', ''),
(24, 3, 0, 0, 'JA Mers Template J25', '', 'ja_mers', 'file', '', 0, '1.0.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_mers.xml', ''),
(25, 3, 0, 0, 'JA Methys Template for Joomla 1.7', '', 'ja_methys', 'file', '', 0, '1.2.2', '', 'http://update.joomlart.com/service/tracking/j16/ja_methys.xml', ''),
(26, 3, 0, 0, 'Ja Minisite Template for Joomla 1.7', '', 'ja_minisite', 'file', '', 0, '1.1.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_minisite.xml', ''),
(27, 3, 0, 0, 'JA Nex Template J2.5', '', 'ja_nex', 'file', '', 0, '1.0.1', '', 'http://update.joomlart.com/service/tracking/j16/ja_nex.xml', ''),
(28, 3, 0, 0, 'JA Norite Template for Joomla 1.7', '', 'ja_norite', 'file', '', 0, '1.2.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_norite.xml', ''),
(29, 3, 0, 0, 'JA ores template for Joomla 1.7', '', 'ja_ores', 'file', '', 0, '1.1.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_ores.xml', ''),
(30, 3, 0, 0, 'JA Portfolio Real Estate template for Joomla 1.6.x', '', 'ja_portfolio', 'file', '', 0, '1.0.0 beta', '', 'http://update.joomlart.com/service/tracking/j16/ja_portfolio.xml', ''),
(31, 3, 0, 0, 'JA Portfolio template for Joomla 1.7.x', '', 'ja_portfolio_real_estate', 'file', '', 0, '1.2.1', '', 'http://update.joomlart.com/service/tracking/j16/ja_portfolio_real_estate.xml', ''),
(32, 3, 0, 0, 'JA Purity II template for Joomla 1.7', '', 'ja_purity_ii', 'file', '', 0, '1.2.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_purity_ii.xml', ''),
(33, 3, 0, 0, 'JA Pyro Template for Joomla 1.7', '', 'ja_pyro', 'file', '', 0, '1.2.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_pyro.xml', ''),
(34, 3, 0, 0, 'JA Rasite Template for Joomla 1.7', '', 'ja_rasite', 'file', '', 0, '1.2.1', '', 'http://update.joomlart.com/service/tracking/j16/ja_rasite.xml', ''),
(35, 3, 0, 0, 'JA Rave Template for Joomla 1.7', '', 'ja_rave', 'file', '', 0, '1.2.1', '', 'http://update.joomlart.com/service/tracking/j16/ja_rave.xml', ''),
(36, 3, 0, 0, 'JA Social Template for J17', '', 'ja_social', 'file', '', 0, '1.2.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_social.xml', ''),
(37, 3, 0, 0, 'JA T3 Blank template for joomla 1.7', '', 'ja_t3_blank', 'file', '', 0, '1.0.8', '', 'http://update.joomlart.com/service/tracking/j16/ja_t3_blank.xml', ''),
(38, 3, 0, 0, 'JA Teline III  Template for Joomla 1.6', '', 'ja_teline_iii', 'file', '', 0, '1.0.0 Beta', '', 'http://update.joomlart.com/service/tracking/j16/ja_teline_iii.xml', ''),
(39, 3, 0, 0, 'JA Teline IV', '', 'ja_teline_iv', 'file', '', 0, '1.2.2', '', 'http://update.joomlart.com/service/tracking/j16/ja_teline_iv.xml', ''),
(40, 3, 0, 0, 'JA Tiris Template J17', '', 'ja_tiris', 'file', '', 0, '1.1.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_tiris.xml', ''),
(41, 3, 0, 0, 'JA Travel Template for Joomla 1.7', '', 'ja_travel', 'file', '', 0, '1.1.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_travel.xml', ''),
(42, 3, 0, 0, 'JA Bookmark plugin for Joomla 1.6.x', '', 'jabookmark', 'file', '', 0, '1.0.0', '', 'http://update.joomlart.com/service/tracking/j16/jabookmark.xml', ''),
(43, 3, 0, 0, 'JA Comment plugin for Joomla 1.6.x', '', 'jacomment', 'file', '', 0, '1.0.0', '', 'http://update.joomlart.com/service/tracking/j16/jacomment.xml', ''),
(44, 3, 0, 0, 'JA Comment Off Plugin for Joomla 1.6', '', 'jacommentoff', 'file', '', 0, '1.0.1', '', 'http://update.joomlart.com/service/tracking/j16/jacommentoff.xml', ''),
(45, 3, 0, 0, 'JA Comment On Plugin for Joomla 1.6', '', 'jacommenton', 'file', '', 0, '1.0.1', '', 'http://update.joomlart.com/service/tracking/j16/jacommenton.xml', ''),
(46, 3, 0, 0, 'JA Content Extra Fields for Joomla 1.6', '', 'jacontentextrafields', 'file', '', 0, '1.0.0', '', 'http://update.joomlart.com/service/tracking/j16/jacontentextrafields.xml', ''),
(47, 3, 0, 0, 'JA Disqus Debate Echo plugin for Joomla 1.6.x', '', 'jadisqus_debate_echo', 'file', '', 0, '1.0.0', '', 'http://update.joomlart.com/service/tracking/j16/jadisqus_debate_echo.xml', ''),
(48, 3, 0, 0, 'JA System Google Map plugin for Joomla 1.6.x', '', 'jagooglemap', 'file', '', 0, '1.0.0', '', 'http://update.joomlart.com/service/tracking/j16/jagooglemap.xml', ''),
(49, 3, 0, 0, 'JA Google Translate plugin for Joomla 1.6.x', '', 'jagoogletranslate', 'file', '', 0, '1.0.0', '', 'http://update.joomlart.com/service/tracking/j16/jagoogletranslate.xml', ''),
(50, 3, 0, 0, 'JA Highslide plugin for Joomla 1.6.x', '', 'jahighslide', 'file', '', 0, '1.0.0', '', 'http://update.joomlart.com/service/tracking/j16/jahighslide.xml', ''),
(51, 3, 0, 0, 'JA Load module Plugin for Joomla 1.7.x', '', 'jaloadmodule', 'file', '', 0, '1.1.0', '', 'http://update.joomlart.com/service/tracking/j16/jaloadmodule.xml', ''),
(52, 3, 0, 0, 'JA System Nrain plugin for Joomla 1.6.x', '', 'janrain', 'file', '', 0, '1.0.0', '', 'http://update.joomlart.com/service/tracking/j16/janrain.xml', ''),
(53, 3, 0, 0, 'JA Popup plugin for Joomla 1.6', '', 'japopup', 'file', '', 0, '1.0.1', '', 'http://update.joomlart.com/service/tracking/j16/japopup.xml', ''),
(54, 3, 0, 0, 'JA System Social plugin for Joomla 1.7', '', 'jasocial', 'file', '', 0, '1.0.4', '', 'http://update.joomlart.com/service/tracking/j16/jasocial.xml', ''),
(55, 3, 0, 0, 'JA T3 System plugin for Joomla 1.6', '', 'jat3', 'file', '', 0, '1.2.3', '', 'http://update.joomlart.com/service/tracking/j16/jat3.xml', ''),
(56, 3, 0, 0, 'JA Tabs plugin for Joomla 2.5', '', 'jatabs', 'file', '', 0, '1.2.0', '', 'http://update.joomlart.com/service/tracking/j16/jatabs.xml', ''),
(57, 3, 0, 0, 'JA Typo plugin For Joomla 1.7', '', 'jatypo', 'file', '', 0, '1.1.0', '', 'http://update.joomlart.com/service/tracking/j16/jatypo.xml', ''),
(58, 3, 0, 0, 'JA Jomsocial theme J17', '', 'jomsocial_theme_social_j16', 'file', '', 0, '1.2.0', '', 'http://update.joomlart.com/service/tracking/j16/jomsocial_theme_social_j16.xml', ''),
(59, 3, 0, 0, 'Theme for Jshopping j17', '', 'jshopping_theme_tiris_j17', 'file', '', 0, '1.0.0', '', 'http://update.joomlart.com/service/tracking/j16/jshopping_theme_tiris_j17.xml', ''),
(60, 3, 0, 0, 'JA Kranos kunena theme for Joomla 17', '', 'kunena_theme_kranos_j17', 'file', '', 0, '1.0.0', '', 'http://update.joomlart.com/service/tracking/j16/kunena_theme_kranos_j17.xml', ''),
(61, 3, 0, 0, 'Kunena theme for JA Nex 2.5', '', 'kunena_theme_nex_j17', 'file', '', 0, '1.0.0', '', 'http://update.joomlart.com/service/tracking/j16/kunena_theme_nex_j17.xml', ''),
(62, 3, 0, 0, 'Kunena theme for JA Social 1.7', '', 'kunena_theme_social_j16', 'file', '', 0, '1.2.0', '', 'http://update.joomlart.com/service/tracking/j16/kunena_theme_social_j16.xml', ''),
(63, 3, 0, 0, 'JA Tiris kunena theme for Joomla 17', '', 'kunena_theme_tiris_j16', 'file', '', 0, '1.0.0', '', 'http://update.joomlart.com/service/tracking/j16/kunena_theme_tiris_j16.xml', ''),
(64, 3, 0, 0, 'JA Accordion module for Joomla 1.7', '', 'mod_jaaccordion', 'file', '', 0, '1.0.2', '', 'http://update.joomlart.com/service/tracking/j16/mod_jaaccordion.xml', ''),
(65, 3, 0, 0, 'JA Animation module for Joomla 1.7.x', '', 'mod_jaanimation', 'file', '', 0, '1.1.0', '', 'http://update.joomlart.com/service/tracking/j16/mod_jaanimation.xml', ''),
(66, 3, 0, 0, 'JA Bulletin Module for Joomla 2.5', '', 'mod_jabulletin', 'file', '', 0, '1.2.0', '', 'http://update.joomlart.com/service/tracking/j16/mod_jabulletin.xml', ''),
(67, 3, 0, 0, 'JA Latest Comment module for Joomla 1.7.x', '', 'mod_jaclatest_comments', 'file', '', 0, '1.1.1', '', 'http://update.joomlart.com/service/tracking/j16/mod_jaclatest_comments.xml', ''),
(68, 3, 0, 0, 'JA Content Scroll module for Joomla 1.6', '', 'mod_jacontentscroll', 'file', '', 0, '1.0.0', '', 'http://update.joomlart.com/service/tracking/j16/mod_jacontentscroll.xml', ''),
(69, 3, 0, 0, 'JA Contenslider module for Joomla 1.6', '', 'mod_jacontentslide', 'file', '', 0, '1.0.0', '', 'http://update.joomlart.com/service/tracking/j16/mod_jacontentslide.xml', ''),
(70, 3, 0, 0, 'JA Contenslider module for Joomla 2.5', '', 'mod_jacontentslider', 'file', '', 0, '1.2.1', '', 'http://update.joomlart.com/service/tracking/j16/mod_jacontentslider.xml', ''),
(71, 3, 0, 0, 'JA facebookactivity module for Joomla 1.7', '', 'mod_jafacebookactivity', 'file', '', 0, '1.1.2', '', 'http://update.joomlart.com/service/tracking/j16/mod_jafacebookactivity.xml', ''),
(72, 3, 0, 0, 'JA facebook like box module for Joomla 1.7', '', 'mod_jafacebooklikebox', 'file', '', 0, '1.1.2', '', 'http://update.joomlart.com/service/tracking/j16/mod_jafacebooklikebox.xml', ''),
(73, 3, 0, 0, 'JA flowlist module for Joomla 1.6.x', '', 'mod_jaflowlist', 'file', '', 0, '1.0.0', '', 'http://update.joomlart.com/service/tracking/j16/mod_jaflowlist.xml', ''),
(74, 3, 0, 0, 'JA Login module for Joomla 1.7', '', 'mod_jalogin', 'file', '', 0, '1.1.3', '', 'http://update.joomlart.com/service/tracking/j16/mod_jalogin.xml', ''),
(75, 3, 0, 0, 'JA Masshead module for Joomla 1.7.x', '', 'mod_jamasshead', 'file', '', 0, '1.0.0', '', 'http://update.joomlart.com/service/tracking/j16/mod_jamasshead.xml', ''),
(76, 3, 0, 0, 'JA News Featured module for Joomla 2.5', '', 'mod_janews_featured', 'file', '', 0, '1.1.3', '', 'http://update.joomlart.com/service/tracking/j16/mod_janews_featured.xml', ''),
(77, 3, 0, 0, 'JA Newsflash module for Joomla 1.6.x', '', 'mod_janewsflash', 'file', '', 0, '1.0.0', '', 'http://update.joomlart.com/service/tracking/j16/mod_janewsflash.xml', ''),
(78, 3, 0, 0, 'JA Newsmoo module for Joomla 1.6.x', '', 'mod_janewsmoo', 'file', '', 0, '1.0.0', '', 'http://update.joomlart.com/service/tracking/j16/mod_janewsmoo.xml', ''),
(79, 3, 0, 0, 'JA News Pro module for Joomla 2.5', '', 'mod_janewspro', 'file', '', 0, '1.1.4', '', 'http://update.joomlart.com/service/tracking/j16/mod_janewspro.xml', ''),
(80, 3, 0, 0, 'JA Newsticker module for Joomla 2.5', '', 'mod_janewsticker', 'file', '', 0, '1.1.4', '', 'http://update.joomlart.com/service/tracking/j16/mod_janewsticker.xml', ''),
(81, 3, 0, 0, 'JA Quick Contact module for Joomla 2.5', '', 'mod_jaquickcontact', 'file', '', 0, '1.1.4', '', 'http://update.joomlart.com/service/tracking/j16/mod_jaquickcontact.xml', ''),
(82, 3, 0, 0, 'JA SideNews Module for Joomla 2.5', '', 'mod_jasidenews', 'file', '', 0, '1.2.6', '', 'http://update.joomlart.com/service/tracking/j16/mod_jasidenews.xml', ''),
(83, 3, 0, 0, 'JA Slideshow module for Joomla 1.7', '', 'mod_jaslideshow', 'file', '', 0, '2.2.2', '', 'http://update.joomlart.com/service/tracking/j16/mod_jaslideshow.xml', ''),
(84, 3, 0, 0, 'JA Toppanel module for Joomla 1.7.x', '', 'mod_jatoppanel', 'file', '', 0, '1.1.2', '', 'http://update.joomlart.com/service/tracking/j16/mod_jatoppanel.xml', ''),
(85, 3, 0, 0, 'JA Twitter module for joomla 2.5', '', 'mod_jatwitter', 'file', '', 0, '1.1.4', '', 'http://update.joomlart.com/service/tracking/j16/mod_jatwitter.xml', ''),
(86, 3, 0, 0, 'JA Voice: Module List of Voices J17', '', 'mod_javlist_voices', 'file', '', 0, '1.0.0', '', 'http://update.joomlart.com/service/tracking/j16/mod_javlist_voices.xml', ''),
(87, 3, 0, 0, 'JA Voice: Module Work Flow J17', '', 'mod_javwork_flow', 'file', '', 0, '1.0.0', '', 'http://update.joomlart.com/service/tracking/j16/mod_javwork_flow.xml', ''),
(88, 3, 0, 0, 'JA Comment Off Plugin for Joomla 1.7', '', 'plg_button_jacommentoff', 'file', '', 0, '1.1.1', '', 'http://update.joomlart.com/service/tracking/j16/plg_button_jacommentoff.xml', ''),
(89, 3, 0, 0, 'JA Comment On Plugin for Joomla 1.7', '', 'plg_button_jacommenton', 'file', '', 0, '1.1.1', '', 'http://update.joomlart.com/service/tracking/j16/plg_button_jacommenton.xml', ''),
(90, 3, 0, 0, 'JA Bookmark plugin for Joomla 1.7.x', '', 'plg_jabookmark', 'file', '', 0, '1.0.1', '', 'http://update.joomlart.com/service/tracking/j16/plg_jabookmark.xml', ''),
(91, 3, 0, 0, 'JA Comment plugin for Joomla 1.7.x', '', 'plg_jacomment', 'file', '', 0, '1.1.1', '', 'http://update.joomlart.com/service/tracking/j16/plg_jacomment.xml', ''),
(92, 3, 0, 0, 'JA Disqus Debate Echo plugin for Joomla 1.7.x', '', 'plg_jadisqus_debate_echo', 'file', '', 0, '1.1.0', '', 'http://update.joomlart.com/service/tracking/j16/plg_jadisqus_debate_echo.xml', ''),
(93, 3, 0, 0, 'JA Translate plugin for Joomla 1.6.x', '', 'plg_jagoogletranslate', 'file', '', 0, '1.0.0', '', 'http://update.joomlart.com/service/tracking/j16/plg_jagoogletranslate.xml', ''),
(94, 3, 0, 0, 'JA Thumbnail plugin for Joomla 2.5', '', 'plg_jathumbnail', 'file', '', 0, '1.1.4', '', 'http://update.joomlart.com/service/tracking/j16/plg_jathumbnail.xml', ''),
(95, 3, 0, 0, 'JA Tooltips plugin for Joomla 1.6.x', '', 'plg_jatooltips', 'file', '', 0, '1.0.0', '', 'http://update.joomlart.com/service/tracking/j16/plg_jatooltips.xml', ''),
(96, 3, 0, 0, 'JA Typo Button J2.5', '', 'plg_jatypobutton', 'file', '', 0, '1.0.2', '', 'http://update.joomlart.com/service/tracking/j16/plg_jatypobutton.xml', ''),
(97, 3, 0, 0, 'JA Multi Capcha Engine PLG J25', '', 'plg_multiple_captcha_engine', 'file', '', 0, '1.1.1', '', 'http://update.joomlart.com/service/tracking/j16/plg_multiple_captcha_engine.xml', ''),
(98, 3, 0, 0, 'JA Search Comment plugin for Joomla J17', '', 'plg_search_jacomment', 'file', '', 0, '1.1.1', '', 'http://update.joomlart.com/service/tracking/j16/plg_search_jacomment.xml', ''),
(99, 3, 0, 0, 'JA System Comment plugin for Joomla 1.7', '', 'plg_system_jacomment', 'file', '', 0, '1.1.1', '', 'http://update.joomlart.com/service/tracking/j16/plg_system_jacomment.xml', ''),
(100, 3, 0, 0, 'JA Content Extra Fields for Joomla 1.7', '', 'plg_system_jacontentextrafields', 'file', '', 0, '1.1.1', '', 'http://update.joomlart.com/service/tracking/j16/plg_system_jacontentextrafields.xml', ''),
(101, 3, 0, 0, 'JA System Google Map plugin for Joomla 1.7.x', '', 'plg_system_jagooglemap', 'file', '', 0, '1.1.2', '', 'http://update.joomlart.com/service/tracking/j16/plg_system_jagooglemap.xml', ''),
(102, 3, 0, 0, 'JA System Nrain plugin for Joomla 1.7.x', '', 'plg_system_janrain', 'file', '', 0, '1.1.1', '', 'http://update.joomlart.com/service/tracking/j16/plg_system_janrain.xml', ''),
(103, 3, 0, 0, 'JA Popup plugin for Joomla 2.5', '', 'plg_system_japopup', 'file', '', 0, '1.1.6', '', 'http://update.joomlart.com/service/tracking/j16/plg_system_japopup.xml', ''),
(104, 3, 0, 0, 'JA System Social plugin for Joomla 1.7', '', 'plg_system_jasocial', 'file', '', 0, '1.1.1', '', 'http://update.joomlart.com/service/tracking/j16/plg_system_jasocial.xml', ''),
(105, 3, 0, 0, 'JA T3 System plugin for Joomla 1.7', '', 'plg_system_jat3', 'file', '', 0, '1.6.1', '', 'http://update.joomlart.com/service/tracking/j16/plg_system_jat3.xml', ''),
(106, 3, 0, 0, 'JA Typo plugin For Joomla 2.5', '', 'plg_system_jatypo', 'file', '', 0, '1.1.6', '', 'http://update.joomlart.com/service/tracking/j16/plg_system_jatypo.xml', ''),
(107, 3, 0, 0, 'JA Teline III  Template for Joomla 1.7', '', 'teline_iii', 'file', '', 0, '1.2.0', '', 'http://update.joomlart.com/service/tracking/j16/teline_iii.xml', ''),
(108, 3, 0, 0, 'JA Extenstion Manager Component for Joomla 2.5', '', 'com_jaextmanager', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/com_jaextmanager.xml', ''),
(109, 3, 0, 0, 'JA Bistro Template for Joomla 2.5', '', 'ja_bistro', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_bistro.xml', ''),
(110, 3, 0, 0, 'JA Blazes Template for Joomla 2.5', '', 'ja_blazes', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_blazes.xml', ''),
(111, 3, 0, 0, 'JA Business Template for Joomla 2.5', '', 'ja_business', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_business.xml', ''),
(112, 3, 0, 0, 'JA Cloris Template for Joomla 2.5.x', '', 'ja_cloris', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_cloris.xml', ''),
(113, 3, 0, 0, 'JA Droid Template for Joomla 2.5', '', 'ja_droid', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_droid.xml', ''),
(114, 3, 0, 0, 'JA Elastica Template for Joomla 2.5', '', 'ja_elastica', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_elastica.xml', ''),
(115, 3, 0, 0, 'Ja Events Template for Joomla 2.5', '', 'ja_events', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_events.xml', ''),
(116, 3, 0, 0, 'JA Graphite Template for Joomla 2.5', '', 'ja_graphite', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_graphite.xml', ''),
(117, 3, 0, 0, 'JA Ironis Template for Joomla 2.5', '', 'ja_ironis', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_ironis.xml', ''),
(118, 3, 0, 0, 'JA KranosTemplate for Joomla 2.5', '', 'ja_kranos', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_kranos.xml', ''),
(119, 3, 0, 0, 'Ja Lime Template for Joomla 2.5', '', 'ja_lime', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_lime.xml', ''),
(120, 3, 0, 0, 'JA Methys Template for Joomla 2.5', '', 'ja_methys', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_methys.xml', ''),
(121, 3, 0, 0, 'Ja Minisite Template for Joomla 2.5', '', 'ja_minisite', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_minisite.xml', ''),
(122, 3, 0, 0, 'JA Nex Template for Joomla 2.5', '', 'ja_nex', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_nex.xml', ''),
(123, 3, 0, 0, 'JA Purity II template for Joomla 2.5', '', 'ja_purity_ii', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_purity_ii.xml', ''),
(124, 3, 0, 0, 'JA Pyro Template for Joomla 2.5', '', 'ja_pyro', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_pyro.xml', ''),
(125, 3, 0, 0, 'JA Rasite Template for Joomla 2.5', '', 'ja_rasite', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_rasite.xml', ''),
(126, 3, 0, 0, 'JA Rave Template for Joomla 2.5', '', 'ja_rave', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_rave.xml', ''),
(127, 3, 0, 0, 'JA T3 Blank template for joomla 2.5', '', 'ja_t3_blank', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_t3_blank.xml', ''),
(128, 3, 0, 0, 'JA Travel Template for Joomla 2.5', '', 'ja_travel', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_travel.xml', ''),
(129, 3, 0, 0, 'JA Tabs Plugin for Joomla 2.5', '', 'jatabs', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/jatabs.xml', ''),
(130, 3, 0, 0, 'JA Accordion Module for Joomla 2.5', '', 'mod_jaaccordion', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/mod_jaaccordion.xml', ''),
(131, 3, 0, 0, 'JA Animation module for Joomla 1.7.x', '', 'mod_jaanimation', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/mod_jaanimation.xml', ''),
(132, 3, 0, 0, 'JA Bulletin Module for Joomla 2.5', '', 'mod_jabulletin', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/mod_jabulletin.xml', ''),
(133, 3, 0, 0, 'JA Contenslider Module for Joomla 2.5', '', 'mod_jacontentslider', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/mod_jacontentslider.xml', ''),
(134, 3, 0, 0, 'JA FacebookActivity Module for Joomla 2.5', '', 'mod_jafacebookactivity', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/mod_jafacebookactivity.xml', ''),
(135, 3, 0, 0, 'JA Facebook Like Box Module for Joomla 2.5', '', 'mod_jafacebooklikebox', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/mod_jafacebooklikebox.xml', ''),
(136, 3, 0, 0, 'JA Login module for Joomla 2.5', '', 'mod_jalogin', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/mod_jalogin.xml', ''),
(137, 3, 0, 0, 'JA Masshead module for Joomla 2.5', '', 'mod_jamasshead', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/mod_jamasshead.xml', ''),
(138, 3, 0, 0, 'JA News Featured Module for Joomla 2.5', '', 'mod_janews_featured', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/mod_janews_featured.xml', ''),
(139, 3, 0, 0, 'JA News Pro Module for Joomla 2.5', '', 'mod_janewspro', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/mod_janewspro.xml', ''),
(140, 3, 0, 0, 'JA Newsticker Module for Joomla 2.5', '', 'mod_janewsticker', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/mod_janewsticker.xml', ''),
(141, 3, 0, 0, 'JA Quick Contact module for Joomla 2.5', '', 'mod_jaquickcontact', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/mod_jaquickcontact.xml', ''),
(142, 3, 0, 0, 'JA SideNews Module for Joomla 2.5', '', 'mod_jasidenews', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/mod_jasidenews.xml', ''),
(143, 3, 0, 0, 'JA Slideshow Module for Joomla 2.5', '', 'mod_jaslideshow', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/mod_jaslideshow.xml', ''),
(144, 3, 0, 0, 'JA Toppanel Module for Joomla 2.5', '', 'mod_jatoppanel', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/mod_jatoppanel.xml', ''),
(145, 3, 0, 0, 'JA Twitter Module for Joomla 2.5', '', 'mod_jatwitter', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/mod_jatwitter.xml', ''),
(146, 3, 0, 0, 'JA Disqus Debate Echo plugin for Joomla 1.7.x', '', 'plg_jadisqus_debate_echo', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/plg_jadisqus_debate_echo.xml', ''),
(147, 3, 0, 0, 'JA Thumbnail Plugin for Joomla 2.5', '', 'plg_jathumbnail', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/plg_jathumbnail.xml', ''),
(148, 3, 0, 0, 'JA Typo Button Plugin for Joomla 2.5', '', 'plg_jatypobutton', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/plg_jatypobutton.xml', ''),
(149, 3, 0, 0, 'JA Multi Capcha Engine Plugin for Joomla 2.5', '', 'plg_multiple_captcha_engine', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/plg_multiple_captcha_engine.xml', ''),
(150, 3, 0, 0, 'JA Content Extra Fields for Joomla 2.5', '', 'plg_system_jacontentextrafields', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/plg_system_jacontentextrafields.xml', ''),
(151, 3, 0, 0, 'JA System Google Map plugin for Joomla 2.5', '', 'plg_system_jagooglemap', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/plg_system_jagooglemap.xml', ''),
(152, 3, 0, 0, 'JA Popup Plugin for Joomla 2.5', '', 'plg_system_japopup', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/plg_system_japopup.xml', ''),
(153, 3, 0, 0, 'JA System Social Plugin for Joomla 2.5', '', 'plg_system_jasocial', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/plg_system_jasocial.xml', ''),
(154, 3, 0, 0, 'JA T3 System Plugin for Joomla 2.5', '', 'plg_system_jat3', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/plg_system_jat3.xml', ''),
(155, 3, 0, 0, 'JA Typo Plugin for Joomla 2.5', '', 'plg_system_jatypo', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/plg_system_jatypo.xml', ''),
(156, 3, 0, 0, 'JA Extenstion Manager Component for Joomla 2.5', '', 'com_jaextmanager', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/com_jaextmanager.xml', ''),
(157, 3, 0, 0, 'JA Bistro Template for Joomla 2.5', '', 'ja_bistro', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_bistro.xml', ''),
(158, 3, 0, 0, 'JA Blazes Template for Joomla 2.5', '', 'ja_blazes', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_blazes.xml', ''),
(159, 3, 0, 0, 'JA Business Template for Joomla 2.5', '', 'ja_business', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_business.xml', ''),
(160, 3, 0, 0, 'JA Cloris Template for Joomla 2.5.x', '', 'ja_cloris', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_cloris.xml', ''),
(161, 3, 0, 0, 'JA Droid Template for Joomla 2.5', '', 'ja_droid', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_droid.xml', ''),
(162, 3, 0, 0, 'JA Elastica Template for Joomla 2.5', '', 'ja_elastica', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_elastica.xml', ''),
(163, 3, 0, 0, 'Ja Events Template for Joomla 2.5', '', 'ja_events', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_events.xml', ''),
(164, 3, 0, 0, 'JA Graphite Template for Joomla 2.5', '', 'ja_graphite', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_graphite.xml', ''),
(165, 3, 0, 0, 'JA Ironis Template for Joomla 2.5', '', 'ja_ironis', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_ironis.xml', ''),
(166, 3, 0, 0, 'JA KranosTemplate for Joomla 2.5', '', 'ja_kranos', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_kranos.xml', ''),
(167, 3, 0, 0, 'Ja Lime Template for Joomla 2.5', '', 'ja_lime', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_lime.xml', ''),
(168, 3, 0, 0, 'JA Methys Template for Joomla 2.5', '', 'ja_methys', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_methys.xml', ''),
(169, 3, 0, 0, 'Ja Minisite Template for Joomla 2.5', '', 'ja_minisite', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_minisite.xml', ''),
(170, 3, 0, 0, 'JA Nex Template for Joomla 2.5', '', 'ja_nex', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_nex.xml', ''),
(171, 3, 0, 0, 'JA Purity II template for Joomla 2.5', '', 'ja_purity_ii', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_purity_ii.xml', ''),
(172, 3, 0, 0, 'JA Pyro Template for Joomla 2.5', '', 'ja_pyro', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_pyro.xml', ''),
(173, 3, 0, 0, 'JA Rasite Template for Joomla 2.5', '', 'ja_rasite', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_rasite.xml', ''),
(174, 3, 0, 0, 'JA Rave Template for Joomla 2.5', '', 'ja_rave', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_rave.xml', ''),
(175, 3, 0, 0, 'JA T3 Blank template for joomla 2.5', '', 'ja_t3_blank', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_t3_blank.xml', ''),
(176, 3, 0, 0, 'JA Travel Template for Joomla 2.5', '', 'ja_travel', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/ja_travel.xml', ''),
(177, 3, 0, 0, 'JA Tabs Plugin for Joomla 2.5', '', 'jatabs', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/jatabs.xml', ''),
(178, 3, 0, 0, 'JA Accordion Module for Joomla 2.5', '', 'mod_jaaccordion', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/mod_jaaccordion.xml', ''),
(179, 3, 0, 0, 'JA Animation module for Joomla 1.7.x', '', 'mod_jaanimation', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/mod_jaanimation.xml', ''),
(180, 3, 0, 0, 'JA Bulletin Module for Joomla 2.5', '', 'mod_jabulletin', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/mod_jabulletin.xml', ''),
(181, 3, 0, 0, 'JA Contenslider Module for Joomla 2.5', '', 'mod_jacontentslider', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/mod_jacontentslider.xml', ''),
(182, 3, 0, 0, 'JA FacebookActivity Module for Joomla 2.5', '', 'mod_jafacebookactivity', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/mod_jafacebookactivity.xml', ''),
(183, 3, 0, 0, 'JA Facebook Like Box Module for Joomla 2.5', '', 'mod_jafacebooklikebox', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/mod_jafacebooklikebox.xml', ''),
(184, 3, 0, 0, 'JA Login module for Joomla 2.5', '', 'mod_jalogin', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/mod_jalogin.xml', ''),
(185, 3, 0, 0, 'JA Masshead module for Joomla 2.5', '', 'mod_jamasshead', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/mod_jamasshead.xml', ''),
(186, 3, 0, 0, 'JA News Featured Module for Joomla 2.5', '', 'mod_janews_featured', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/mod_janews_featured.xml', ''),
(187, 3, 0, 0, 'JA News Pro Module for Joomla 2.5', '', 'mod_janewspro', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/mod_janewspro.xml', ''),
(188, 3, 0, 0, 'JA Newsticker Module for Joomla 2.5', '', 'mod_janewsticker', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/mod_janewsticker.xml', ''),
(189, 3, 0, 0, 'JA Quick Contact module for Joomla 2.5', '', 'mod_jaquickcontact', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/mod_jaquickcontact.xml', ''),
(190, 3, 0, 0, 'JA SideNews Module for Joomla 2.5', '', 'mod_jasidenews', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/mod_jasidenews.xml', ''),
(191, 3, 0, 0, 'JA Slideshow Module for Joomla 2.5', '', 'mod_jaslideshow', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/mod_jaslideshow.xml', ''),
(192, 3, 0, 0, 'JA Toppanel Module for Joomla 2.5', '', 'mod_jatoppanel', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/mod_jatoppanel.xml', ''),
(193, 3, 0, 0, 'JA Twitter Module for Joomla 2.5', '', 'mod_jatwitter', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/mod_jatwitter.xml', ''),
(194, 3, 0, 0, 'JA Disqus Debate Echo plugin for Joomla 1.7.x', '', 'plg_jadisqus_debate_echo', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/plg_jadisqus_debate_echo.xml', ''),
(195, 3, 0, 0, 'JA Thumbnail Plugin for Joomla 2.5', '', 'plg_jathumbnail', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/plg_jathumbnail.xml', ''),
(196, 3, 0, 0, 'JA Typo Button Plugin for Joomla 2.5', '', 'plg_jatypobutton', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/plg_jatypobutton.xml', ''),
(197, 3, 0, 0, 'JA Multi Capcha Engine Plugin for Joomla 2.5', '', 'plg_multiple_captcha_engine', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/plg_multiple_captcha_engine.xml', ''),
(198, 3, 0, 0, 'JA Content Extra Fields for Joomla 2.5', '', 'plg_system_jacontentextrafields', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/plg_system_jacontentextrafields.xml', ''),
(199, 3, 0, 0, 'JA System Google Map plugin for Joomla 2.5', '', 'plg_system_jagooglemap', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/plg_system_jagooglemap.xml', ''),
(200, 3, 0, 0, 'JA Popup Plugin for Joomla 2.5', '', 'plg_system_japopup', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/plg_system_japopup.xml', ''),
(201, 3, 0, 0, 'JA System Social Plugin for Joomla 2.5', '', 'plg_system_jasocial', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/plg_system_jasocial.xml', ''),
(202, 3, 0, 0, 'JA T3 System Plugin for Joomla 2.5', '', 'plg_system_jat3', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/plg_system_jat3.xml', ''),
(203, 3, 0, 0, 'JA Typo Plugin for Joomla 2.5', '', 'plg_system_jatypo', 'file', '', 0, '2.5.0', '', 'http://update.joomlart.com/service/tracking/j16/plg_system_jatypo.xml', '');

DROP TABLE IF EXISTS `#__user_notes`;
CREATE TABLE `#__user_notes` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `subject` varchar(100) NOT NULL DEFAULT '',
  `body` text NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `created_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_user_id` int(10) unsigned NOT NULL,
  `modified_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `review_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `idx_user_id` (`user_id`),
  KEY `idx_category_id` (`catid`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__user_profiles`;
CREATE TABLE `#__user_profiles` (
  `user_id` int(11) NOT NULL,
  `profile_key` varchar(100) NOT NULL,
  `profile_value` varchar(255) NOT NULL,
  `ordering` int(11) NOT NULL DEFAULT '0',
  UNIQUE KEY `idx_user_id_profile_key` (`user_id`,`profile_key`)
) ENGINE=MyISAM COMMENT='Simple user profile storage table';

DROP TABLE IF EXISTS `#__user_usergroup_map`;
CREATE TABLE `#__user_usergroup_map` (
  `user_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Foreign Key to #__users.id',
  `group_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Foreign Key to #__usergroups.id',
  PRIMARY KEY (`user_id`,`group_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__usergroups`;
CREATE TABLE `#__usergroups` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Adjacency List Reference Id',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `title` varchar(100) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_usergroup_parent_title_lookup` (`parent_id`,`title`),
  KEY `idx_usergroup_title_lookup` (`title`),
  KEY `idx_usergroup_adjacency_lookup` (`parent_id`),
  KEY `idx_usergroup_nested_set_lookup` (`lft`,`rgt`)
) ENGINE=MyISAM ;

INSERT INTO `#__usergroups` (`id`, `parent_id`, `lft`, `rgt`, `title`) VALUES
(1, 0, 1, 20, 'Public'),
(2, 1, 6, 17, 'Registered'),
(3, 2, 7, 14, 'Author'),
(4, 3, 8, 11, 'Editor'),
(5, 4, 9, 10, 'Publisher'),
(6, 1, 2, 5, 'Manager'),
(7, 6, 3, 4, 'Administrator'),
(8, 1, 18, 19, 'Super Users');

DROP TABLE IF EXISTS `#__users`;
CREATE TABLE `#__users` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `username` varchar(150) NOT NULL DEFAULT '',
  `email` varchar(100) NOT NULL DEFAULT '',
  `password` varchar(100) NOT NULL DEFAULT '',
  `usertype` varchar(25) NOT NULL DEFAULT '',
  `block` tinyint(4) NOT NULL DEFAULT '0',
  `sendEmail` tinyint(4) DEFAULT '0',
  `registerDate` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `lastvisitDate` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `activation` varchar(100) NOT NULL DEFAULT '',
  `params` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `usertype` (`usertype`),
  KEY `idx_name` (`name`),
  KEY `idx_block` (`block`),
  KEY `username` (`username`),
  KEY `email` (`email`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `#__viewlevels`;
CREATE TABLE `#__viewlevels` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `title` varchar(100) NOT NULL DEFAULT '',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `rules` varchar(5120) NOT NULL COMMENT 'JSON encoded access control.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_assetgroup_title_lookup` (`title`)
) ENGINE=MyISAM ;

INSERT INTO `#__viewlevels` (`id`, `title`, `ordering`, `rules`) VALUES
(1, 'Public', 0, '[]'),
(2, 'Registered', 1, '[6,2,8]'),
(3, 'Special', 2, '[6,3,8]'),
(4, 'Customer Access Level', 3, '[6,3,12]');

DROP TABLE IF EXISTS `#__weblinks`;
CREATE TABLE `#__weblinks` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `catid` int(11) NOT NULL DEFAULT '0',
  `sid` int(11) NOT NULL DEFAULT '0',
  `title` varchar(250) NOT NULL DEFAULT '',
  `alias` varchar(255) binary NOT NULL DEFAULT '',
  `url` varchar(250) NOT NULL DEFAULT '',
  `description` text NOT NULL,
  `date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `hits` int(11) NOT NULL DEFAULT '0',
  `state` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `archived` tinyint(1) NOT NULL DEFAULT '0',
  `approved` tinyint(1) NOT NULL DEFAULT '1',
  `access` int(11) NOT NULL DEFAULT '1',
  `params` text NOT NULL,
  `language` char(7) NOT NULL DEFAULT '',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if link is featured.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`state`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=MyISAM ;

INSERT INTO `#__weblinks` (`id`, `catid`, `sid`, `title`, `alias`, `url`, `description`, `date`, `hits`, `state`, `checked_out`, `checked_out_time`, `ordering`, `archived`, `approved`, `access`, `params`, `language`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `metakey`, `metadesc`, `metadata`, `featured`, `xreference`, `publish_up`, `publish_down`) VALUES
(1, 32, 0, 'Joomla!', 'joomla', 'http://www.joomla.org', '<p>Home of Joomla!</p>', '0000-00-00 00:00:00', 3, 1, 0, '0000-00-00 00:00:00', 1, 0, 1, 1, '{"target":"0","count_clicks":""}', 'en-GB', '2005-02-14 15:19:02', 0, '', '2010-07-10 23:41:06', 42, '', '', '{"robots":"","author":"","rights":""}', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(2, 33, 0, 'php.net', 'php', 'http://www.php.net', '<p>The language that Joomla! is developed in</p>', '0000-00-00 00:00:00', 6, 1, 0, '0000-00-00 00:00:00', 1, 0, 1, 1, '{"target":"","count_clicks":""}', 'en-GB', '2004-07-07 11:33:24', 0, '', '2010-07-10 23:44:03', 42, '', '', '{"robots":"","author":"","rights":""}', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(3, 33, 0, 'MySQL', 'mysql', 'http://www.mysql.com', '<p>The database that Joomla! uses</p>', '0000-00-00 00:00:00', 1, 1, 0, '0000-00-00 00:00:00', 2, 0, 1, 1, '{"target":"","count_clicks":""}', 'en-GB', '2004-07-07 10:18:31', 0, '', '2010-07-10 23:44:03', 42, '', '', '{"robots":"","author":"","rights":""}', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(4, 32, 0, 'OpenSourceMatters', 'opensourcematters', 'http://www.opensourcematters.org', '<p>Home of OSM</p>', '0000-00-00 00:00:00', 11, 1, 0, '0000-00-00 00:00:00', 3, 0, 1, 1, '{"target":"0","count_clicks":""}', 'en-GB', '2004-07-07 10:18:31', 0, '', '2010-07-10 23:44:03', 42, '', '', '{"robots":"","author":"","rights":""}', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(5, 32, 0, 'Joomla! - Forums', 'joomla-forums', 'http://forum.joomla.org', '<p>Joomla! Forums</p>', '0000-00-00 00:00:00', 4, 1, 0, '0000-00-00 00:00:00', 2, 0, 1, 1, '{"target":"0","count_clicks":""}', 'en-GB', '2005-02-14 15:19:02', 0, '', '2010-07-10 23:41:15', 42, '', '', '{"robots":"","author":"","rights":""}', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(6, 33, 0, 'Ohloh Tracking of Joomla!', 'ohloh-tracking-of-joomla', 'http://www.ohloh.net/projects/20', '<p>Objective reports from Ohloh about Joomla''s development activity. Joomla! has some star developers with serious kudos.</p>', '0000-00-00 00:00:00', 1, 1, 0, '0000-00-00 00:00:00', 3, 0, 1, 1, '{"target":"0","count_clicks":""}', 'en-GB', '2007-07-19 09:28:31', 0, '', '2010-07-10 23:44:03', 42, '', '', '{"robots":"","author":"","rights":""}', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(7, 31, 0, 'Baw Baw National Park', 'baw-baw-national-park', 'http://www.parkweb.vic.gov.au/1park_display.cfm?park=44', '<p>Park of the Austalian Alps National Parks system, Baw Baw  features sub alpine vegetation, beautiful views, and opportunities for hiking, skiing and other outdoor activities.</p>', '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 1, 0, 1, 1, '{"target":"0","count_clicks":""}', 'en-GB', '2010-07-10 23:44:03', 0, '', '2010-07-10 23:44:03', 42, '', '', '{"robots":"","author":"","rights":""}', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(8, 31, 0, 'Kakadu', 'kakadu', 'http://www.environment.gov.au/parks/kakadu/index.html', '<p>Kakadu is known for both its cultural heritage and its natural features. It is one of a small number of places listed as World Heritage Places for both reasons. Extensive rock art is found there.</p>', '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 2, 0, 1, 1, '{"target":"0","count_clicks":""}', 'en-GB', '2010-07-10 23:44:03', 0, '', '2010-07-10 23:44:03', 42, '', '', '{"robots":"","author":"","rights":""}', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(9, 31, 0, 'Pulu Keeling', 'pulu-keeling', 'http://www.environment.gov.au/parks/cocos/index.html', '<p>Located on an atoll 2000 kilometers north of Perth, Pulu Keeling is Australia''s smallest national park.</p>', '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 3, 0, 1, 1, '{"target":"0","count_clicks":""}', 'en-GB', '0000-00-00 00:00:00', 0, '', '2010-07-10 23:44:03', 42, '', '', '{"robots":"","author":"","rights":""}', 0, '', '2010-07-10 23:44:03', '0000-00-00 00:00:00');
